// FUNCION ADMIN MPLAY
var MPlayAdmin = function () {
	var attrMapaAdmin = '[data-mplay-admin-mapa]';
	
	var bounds = [];
	
	var center = [];
	
	var config = [];
			
    return {
        init: function (contenedor) {
			MPlayAdmin.load_config(false, contenedor);
        },
        reload: function (contenedor) {
			var contenedor_jq = $(contenedor);
			
			MPlayAdmin.init_admin_mapa(contenedor_jq);
			
        },
		load: function (contenedor) {
			var contenedor_jq = $(contenedor);
			
			MPlayAdmin.init_admin_mapa(contenedor_jq);
		},
		load_config: function(force, contenedor){
			if (MPlayAdmin.config == undefined || MPlayAdmin.config.base_url == undefined || MPlayAdmin.config.base_url == '' || force == true){
				$.get('/api/mplay/general/config.json', {}, function(data){
					if (data.data != undefined && data.data != ''){
						MPlayAdmin.config = data.data;
						MPlayAdmin.load(contenedor);
						return true;
					} else {
						bootbox.alert('No se ha encontrado la configuración general de mPlay');
						return false;
					}
				});
			} else if (MPlayAdmin.config.base_url != undefined) {
				MPlayAdmin.load(contenedor);
				return true;
			} else {
				bootbox.alert('No se ha encontrado la configuración general de mPlay');
				return false;
			}
		},
		init_admin_mapa: function (contenedor_jq){
			L.Icon.Default.imagePath = 'http://api.tiles.mapbox.com/mapbox.js/v1.0.0beta0.0/images';
			
			var jElement = contenedor_jq.find(attrMapaAdmin);
			
            if (jElement.length > 0) {
                jElement.each(function (idx, ele) {
					var longitud_map_sitio = $(ele).data("longitud");
					var latitud_map_sitio = $(ele).data("latitud");
					var zoom_map_sitio = $(ele).data("zoom");
					var estilo_mapa = $(ele).data("estilo-mapa");
					
					if (typeof L == "undefined") {
						bootbox.alert("¡Es necesario el plugin Leaflet!");
						return false;
					}
					
					if (estilo_mapa == undefined || estilo_mapa == '') {
						estilo_mapa = 'http://{s}.tile.cloudmade.com/1a1b06b230af4efdbb989ea99e9841af/998/256/{z}/{x}/{y}.png';
					}
					
					if (zoom_map_sitio == undefined || zoom_map_sitio == '') {
						zoom_map_sitio = 10;
					}
										
					var opts_map = {center: [latitud_map_sitio, longitud_map_sitio], zoom: zoom_map_sitio};
					
					map = L.map($(ele).attr("id"), opts_map);
					
					var ggls = new L.Google('HYBRID');
					
					if (estilo_mapa.substr(0, 16) == "http://oatile{s}") {
						var layer_default = L.tileLayer(estilo_mapa, {
							subdomains: '1234',
							attribution: '',
							//maxZoom: zoom_map_sitio
						});
					} else {
						var layer_default = L.tileLayer(estilo_mapa, {
							attribution: ''
						});
					}
					
					var baseMaps = {
						"Defecto": layer_default,
						"Google Hybrid": ggls
					};
					
					L.control.layers(baseMaps).addTo(map);
					
					map.addLayer(layer_default, ggls);
					
					var ce = map.getCenter();
					MPlayAdmin.center = [ ce.lat, ce.lng ];
					
					var bo = map.getBounds();
					var bone = bo.getNorthEast();
					var bosw = bo.getSouthWest();
					MPlayAdmin.bounds = { ne: [ bone.lat, bone.lng ], sw: [ bosw.lat, bosw.lng ] };
					
					map.on("moveend", function (e){
						realtime.stop();
						
						var c = map.getCenter();
						MPlayAdmin.center = [ c.lat, c.lng ];
					
						var b = map.getBounds();
						var bne = b.getNorthEast();
						var bsw = b.getSouthWest();
						MPlayAdmin.bounds = { ne: [ bne.lat, bne.lng ], sw: [ bsw.lat, bsw.lng ] };	
						
						realtime.start();					
					});
					
					var realtime = L.realtime({
						url: MPlayAdmin.config.base_url + 'api/mplay/admin/main.json',
						method: 'post',
						data: { bounds: MPlayAdmin.bounds, center: MPlayAdmin.center  },
						type: 'json'
					}, {
						pointToLayer: function (feature, latlng) {
							console.debug(feature);
							if (feature.properties.tipo == 'item'){
								var MyIconCustom = L.icon({
									iconUrl: feature.properties.imagen,
									iconSize: [32, 32],
									iconAnchor: [16, 32],
									popupAnchor: [0, -32],
									labelAnchor: [18, -16],
									className: 'mplay-ui-iconmap-item'
								});
							} else {
								var MyIconCustom = L.icon({
									iconUrl: feature.properties.imagen,
									iconSize: [32, 32],
									iconAnchor: [16, 32],
									popupAnchor: [0, -32],
									labelAnchor: [18, -16],
									className: 'mplay-ui-iconmap-friend'
								});
							}
							
							return L.marker(feature.geometry.coordinates, {icon: MyIconCustom});
						},
						interval: 5 * 1000,
						getFeatureId: function(f) { return f.id; }
					}).addTo(map);
					
					realtime.on('update', function(e) {
						var popupContent = function(fId) {
								var feature = e.features[fId];
								return feature.properties.content;
							},
							bindFeaturePopup = function(fId) {
								realtime.getLayer(fId).bindPopup(popupContent(fId), { className: 'mplay-popup' });
							},
							updateFeaturePopup = function(fId) {
								realtime.getLayer(fId).getPopup().setContent(popupContent(fId));
							};
							
						var labelContent = function(fId) {
								var feature = e.features[fId];
								return feature.properties.nombre + ' - ' +
									feature.properties.distancia;
							},
							bindFeatureLabel = function(fId) {
								realtime.getLayer(fId).bindLabel(labelContent(fId));
							},
							updateFeatureLabel = function(fId) {
								realtime.getLayer(fId).getLabel().setContent(labelContent(fId));
							};
					
						Object.keys(e.enter).forEach(bindFeaturePopup);
						Object.keys(e.update).forEach(updateFeaturePopup);
						
						Object.keys(e.enter).forEach(bindFeatureLabel);
						Object.keys(e.update).forEach(updateFeatureLabel);
					});
				});
			}
		}
	};
}();

$(document).ready(function () {
    MPlayAdmin.init('body');
});