<?php
c_include('forms/formField');

/**
 * Form Field class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Form
 * @since		1.6
 */
class FormFieldMplayaudiolist extends FormField
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'mplayaudiolist';

	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	public function getInput($valor=null)
	{
		// Initialize variables.
		$html = array();
		$attr = '';
		$rand = rand();

		// Initialize some field attributes.
		$attr .= $this->element['class'] ? ' class="select2 '.(string) $this->element['class'].'"' : ' class="select2"';

		// To avoid user's confusion, readonly="true" should imply disabled="true".
		if ( (string) $this->element['readonly'] == 'true' || (string) $this->element['disabled'] == 'true') {
			$attr .= ' disabled="disabled"';
		}

		$attr .= $this->element['size'] ? ' size="'.(int) $this->element['size'].'"' : '';
		$attr .= $this->element['multiple'] ? ' multiple="multiple"' : '';

		// Initialize JavaScript field attributes.
		$attr .= $this->element['onchange'] ? ' onchange="'.(string) $this->element['onchange'].'"' : '';
		
		$tipo_audio = (string) $this->element['tipo'] == 'fx' ? 'fx' : 'musica';
		$multiple = $this->element['multiple'] ? true : false;
				
		$presel = $this->element['preseleccionar'] == 'false' ? false : true;
		
		$mult_attr = '';
		if ($multiple && substr($this->name, strlen($this->name) - 2) != '[]')
			$mult_attr = '[]';
			
		global $AppTpl;
		
		c_include('usuario');
			
		$is_admin = false;
		if (Usuario::isLoged(true) && is_object($GLOBALS['AppAdminTpl'])){
			$is_admin = true;
		}

		// Get the field options.
		$options = (array) $this->getOptions($valor, $multiple, $tipo_audio);
		
		$output = '';
		
		$output .= '<select'.$attr.' name="'.$this->name.$mult_attr.'" id="'.$this->id.'_'.$rand.'">';
		
		foreach ($options as $option){
			$output .= $option;
		}
		
		$output .= '</select>';
		
		//$html[] = JHtml::_('select.genericlist', $options, $this->name, trim($attr), 'value', 'text', $this->value, $this->id);

		return $output;
	}

	/**
	 * Method to get the field options.
	 *
	 * @return	array	The field option objects.
	 * @since	1.6
	 */
	protected function getOptions($valor=null, $multiple=false, $tipo_audio='musica')
	{
		$options = array();
		
		$opciones = $GLOBALS['opciones']['ext_mplay']['audio'][$tipo_audio];
		
		$blank_selected = '';
		if ($valor == 0 || $valor == '')
			$blank_selected = ' selected="selected"';
		
		if (is_array($opciones) && sizeof($opciones) > 0){
			if ($multiple == false){
				$options[] = '<option'.$blank_selected.' value="">'.__('Sin audio').'</option>';
			}
			
			foreach ($opciones as $kopc=>$opc){
				$opc = (array) $opc;
				
				$output = '';
				
				$output .= '<option value="'.$kopc.'"';
				if ($valor != null){
					if ($multiple && is_array($valor)){
						if (in_array($kopc, $valor)){
							$output .= ' selected="selected"';
						}
					} else {
						if ($valor == $kopc){
							$output .= ' selected="selected"';
						}
					}
				}
				
				$output .='>'.$opc['titulo'] . ' ('.$opc['img'].')</option>';
				
				$options[] = $output;
			}
			
			reset($options);
		} else {
			if ($multiple == false){
				$options[] = '<option'.$blank_selected.' value="">'.__('No hay audios').'</option>';
			}
		}
		
		return $options;
	}
	
	function init_extra_form_fields() {
        parent::init_extra_form_fields();

        $extra_form_fields = array(
            'text' => array(
                'nombre' => __('Campo: Lista de usuarios'),
                'campos' => array(
                    'multiple' => array(
                        'type' => 'list',
                        'label' => __('Selección múltiple'),
                        'description' => __('Permite seleccionar varios usuarios de la lista'),
                        'default' => 'false',
                        'params' => array('button-group' => 'true', 'class_div' => 'col-xs-4'),
                        'options' => array('true' => __('Sí'), 'false' => __('No'))
                    ),
					'admin_only' => array(
                        'type' => 'list',
                        'label' => __('Sólo administradores'),
                        'description' => __('Sólo se mostrarán los usuarios que sean administradores'),
                        'default' => 'false',
                        'params' => array('button-group' => 'true', 'class_div' => 'col-xs-4'),
                        'options' => array('true' => __('Sí'), 'false' => __('No'))
                    ),
					'solo_seguidores' => array(
                        'type' => 'list',
                        'label' => __('Sólo seguidores del usuario actual'),
                        'description' => __('Sólo se mostrarán los seguidores del usuario actual'),
                        'default' => 'false',
                        'params' => array('button-group' => 'true', 'class_div' => 'col-xs-4'),
                        'options' => array('true' => __('Sí'), 'false' => __('No'))
                    )
                )
            )
        );

        $this->extra_form_fields = array_merge($this->extra_form_fields, $extra_form_fields);
    }
}
