<?php
c_include('forms/formField');
e_include('ext_mplay/class/mplayBot','ext_mplay/class/mplayBotTipo');

/**
 * Form Field class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Form
 * @since		1.6
 */
class FormFieldMplaydialogosbot extends FormField
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'mplaydialogosbot';

	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	public function getInput($valor=null)
	{
			
		// Initialize variables.
		$html = array();
		$attr = '';

		// Initialize some field attributes.
		$attr .= $this->element['class'] ? ' class="form-control '.(string) $this->element['class'].'"' : ' class="form-control"';

		// To avoid user's confusion, readonly="true" should imply disabled="true".
		if ( (string) $this->element['readonly'] == 'true' || (string) $this->element['disabled'] == 'true') {
			$attr .= ' disabled="disabled"';
		}

		$attr .= $this->element['size'] ? ' size="'.(int) $this->element['size'].'"' : '';
		$attr .= $this->element['multicheck'] != 'false' ? ' multiple="multiple"' : '';

		// Initialize JavaScript field attributes.
		$attr .= $this->element['onchange'] ? ' onchange="'.(string) $this->element['onchange'].'"' : '';
		
		$output = '';
		
		if ($_GET['extension'] != 'ext_mplay' || $_GET['vista'] != 'editar_bot' || empty($_GET['id'])){
			if ($_GET['extension'] == 'ext_mplay' && $_GET['vista'] == 'nuevo_bot'){
				$output = '<div class="alert alert-info">'.__('Debes guardar el bot para poder agregar un diálogo').'</div>';
			}
			return $output;
		}
		
		$output .= $this->getTablaDialogos($valor, $attr);
		
		return $output;
	}
	
	function getTablaDialogos($valor, $attr){
		$bot = new MplayBot();
		$bot->setid($_GET['id']);
		$bot = $bot->BuscarId();
		
		$html = '';
		
		if (!empty($bot->id)){
			$items_bot = $bot->getitems(false, true);
			
			$tipo_bot = MplayBotTipo::getInstance($bot->tipo, Helpers::toArray(json_decode($bot->propiedades)));
			$propiedades_bot = $tipo_bot->propiedades;
			
			$rand = rand();
			
			$cm_txt = '';
			if (!empty($_GET['custom_menu']))
				$cm_txt = '&custom_menu='.$_GET['custom_menu'];
				
			$html .= '<div class="modal fade" id="modal-nuevo-dialogo-'.$rand.'">
		<div class="modal-dialog modal-lg">
      <div class="modal-content">
            <div class="modal-header">
              <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
              <h4 class="modal-title">'.__('Nueva línea de diálogo').'</h4>
            </div>
            <div class="modal-body">
              <div class="row">
                <div class="col-md-12">
                  <div id="frmNuevoDialogo-'.$rand.'" class="form-validate">
                   <div class="row">
				   <div class="form-group col-sm-6">
				   <label>'.__('Texto').'</label>
				   <textarea class="form-control" id="'.$this->id.'_inp_texto_'.$rand.'"></textarea>
				   </div>
				   
				   
				   <div class="form-group col-sm-3">
				   <label>'.__('Habla').'</label>
				   <select class="select2" id="'.$this->id.'_inp_narrador_'.$rand.'">
				   	<option value="jugador">'.__('Jugador').'</option>
					<option value="bot">'.__('Bot').'</option>
				   </select>
				   </div>
				   
				   
				   <div class="form-group col-sm-3">
				   <label>'.__('Tipo').'</label>
				   <select class="select2" id="'.$this->id.'_inp_tipo_'.$rand.'">
				   	<option value="opcion">'.__('Opción de diálogo').'</option>
					<option value="linea">'.__('Línea de diálogo').'</option>
					<option value="evento">'.__('Evento de diálogo').'</option>
				   </select>
				   </div>
				   
				   
				   
				   </div>
				   
				   <h5>'.__('Ajustes de diálogo').'</h5>
				   
				   <div class="row" id="ajustes_dialogo_'.$rand.'">
				   
				   <div class="form-group col-sm-3">
				   <label>'.__('Padre').'</label>
				   <select class="select2" id="'.$this->id.'_inp_padre_'.$rand.'">
				   <option value="">'.__('Raíz').'</option>
				   </select>
				   </div>
				   
				   <div class="form-group col-sm-3">
				   <label>'.__('Siguiente').'</label>
				   <select class="select2" id="'.$this->id.'_inp_siguiente_'.$rand.'">
				   <option value="0">'.__('Volver al inicio').'</option>
				   <option value="-1">'.__('Finalizar diálogo').'</option>
				   </select>
				   </div>
				   
				   
				   
				   </div>
				   
				   
				   </div>
                </div>
              </div>
            </div>
            <div class="modal-footer"> <a href="javascript:;" id="aceptar_crear_dialogo-'.$rand.'" class="btn btn-primary">'.__('Crear').'</a> <a href="javascript:;" class="btn close-modal-'.$rand.'" data-dimiss="modal">'.__('Cancelar').'</a> </div>
			</div>
			</div>
          </div>';
		  
$GLOBALS['AppDoc']->AddScriptDeclaration('//<![CDATA[
$(document).ready(function(){
	var idx_dlg_'.$rand.' = 0;
	
	$("#dialogos_bot_list_'.$bot->id.' tr.dlg_tr").each(function(idx, ele){
		$(ele).data("idx", idx_dlg_'.$rand.');
		idx_dlg_'.$rand.' = idx_dlg_'.$rand.' + 1;
	});
	
	function refreshPadres(){
		var select_padres = $("#'.$this->id.'_inp_padre_'.$rand.'");
		var select_siguiente = $("#'.$this->id.'_inp_siguiente_'.$rand.'");
		
		select_padres.html("<option value=\'\'>'.__('Raíz').'</option>");
		select_siguiente.html("<option value=\'0\'>'.__('Volver al inicio').'</option>");
		select_siguiente.append("<option value=\'-1\'>'.__('Finalizar diálogo').'</option>");
		$("#dialogos_bot_list_'.$bot->id.' tr.dlg_tr").each(function(idx, ele){
			var val_opt = $(ele).data("idx");
			var txt_opt = $(ele).find("#'.$this->id.'_inp_txt_"+val_opt+"").val();
			select_padres.append("<option value=\'"+val_opt+"\'>"+txt_opt+"</option>");
			select_siguiente.append("<option value=\'"+val_opt+"\'>"+txt_opt+"</option>");
		});
				
		$(".mplay-inp-dialog-narrador").each(function(idx,sel){
			var value_sel = $(sel).data("value");
			
			if (value_sel == "jugador"){
				$(sel).html("<option selected=\'selected\' value=\'jugador\'>'.__('Jugador').'</option>");
				$(sel).append("<option value=\'bot\'>'.__('Bot').'</option>");
			} else if (value_sel == "bot"){
				$(sel).html("<option value=\'jugador\'>'.__('Jugador').'</option>");
				$(sel).append("<option selected=\'selected\' value=\'bot\'>'.__('Bot').'</option>");
			} else {
				$(sel).html("<option value=\'jugador\'>'.__('Jugador').'</option>");
				$(sel).append("<option value=\'bot\'>'.__('Bot').'</option>");
			}
		});
		
		$(".mplay-inp-dialog-tipo").each(function(idx,sel){
			var value_sel = $(sel).data("value");
			
			if (value_sel == "opcion"){
				$(sel).html("<option selected=\'selected\' value=\'opcion\'>'.__('Opción de diálogo').'</option>");
				$(sel).append("<option value=\'linea\'>'.__('Línea de diálogo').'</option>");
				$(sel).append("<option value=\'evento\'>'.__('Evento de diálogo').'</option>");
			} else if (value_sel == "linea"){
				$(sel).html("<option value=\'opcion\'>'.__('Opción de diálogo').'</option>");
				$(sel).append("<option selected=\'selected\' value=\'linea\'>'.__('Línea de diálogo').'</option>");
				$(sel).append("<option value=\'evento\'>'.__('Evento de diálogo').'</option>");
			} else if (value_sel == "evento"){
				$(sel).html("<option value=\'opcion\'>'.__('Opción de diálogo').'</option>");
				$(sel).append("<option value=\'linea\'>'.__('Línea de diálogo').'</option>");
				$(sel).append("<option selected=\'selected\' value=\'evento\'>'.__('Evento de diálogo').'</option>");
			} else {
				$(sel).html("<option value=\'opcion\'>'.__('Opción de diálogo').'</option>");
				$(sel).append("<option value=\'linea\'>'.__('Línea de diálogo').'</option>");
				$(sel).append("<option value=\'evento\'>'.__('Evento de diálogo').'</option>");
			}
		});
		
		$(".mplay-inp-dialog-padre").each(function(idx,sel){
			var value_sel = $(sel).data("value");
			
			if (value_sel == ""){
				$(sel).html("<option selected=\'selected\' value=\'\'>'.__('Raíz').'</option>");
			} else {
				$(sel).html("<option value=\'\'>'.__('Raíz').'</option>");
			}
			$("#dialogos_bot_list_'.$bot->id.' tr.dlg_tr").each(function(idx, ele){
				var val_opt = $(ele).data("idx").toString();
				var txt_opt = $(ele).find("#'.$this->id.'_inp_txt_"+val_opt+"").val();
				
				if (value_sel.toString() == val_opt){
					$(sel).append("<option selected=\'selected\' value=\'"+val_opt+"\'>"+txt_opt+"</option>");
				} else {
					$(sel).append("<option value=\'"+val_opt+"\'>"+txt_opt+"</option>");
				}
			});
		});
		
		$(".mplay-inp-dialog-siguiente").each(function(idx,sel){
			var value_sel = $(sel).data("value").toString();
			
			if (value_sel == "0"){
				$(sel).html("<option selected=\'selected\' value=\'0\'>'.__('Volver al inicio').'</option>");
				$(sel).append("<option value=\'-1\'>'.__('Finalizar diálogo').'</option>");
			} else if (value_sel == "-1") {
				$(sel).html("<option value=\'0\'>'.__('Volver al inicio').'</option>");
				$(sel).append("<option selected=\'selected\' value=\'-1\'>'.__('Finalizar diálogo').'</option>");
			}
			$("#dialogos_bot_list_'.$bot->id.' tr.dlg_tr").each(function(idx, ele){
				var val_opt = $(ele).data("idx").toString();
				var txt_opt = $(ele).find("#'.$this->id.'_inp_txt_"+val_opt+"").val();
				
				if (val_opt != "0"){				
					if (value_sel == val_opt){
						$(sel).append("<option selected=\'selected\' value=\'"+val_opt+"\'>"+txt_opt+"</option>");
					} else {
						$(sel).append("<option value=\'"+val_opt+"\'>"+txt_opt+"</option>");
					}
				}
			});
		});
		
		//select_padres.select2();
	}
	
	refreshPadres();
	
	function update_idx_tr_dialogo(){
		$("#dialogos_bot_list_'.$bot->id.' body tr").each(function(idx, trDialog){
			var input_name = trDialog.data("input-name");
			var txt_name = input_name+"["+idx+"][txt]";
			var narrador_name = input_name+"["+idx+"][narrador]";
			var tipo_name = input_name+"["+idx+"][tipo]";
			var padre_name = input_name+"["+idx+"][padre]";
			var siguiente_name = input_name+"["+idx+"][siguiente]";
			
			trDialog.data("idx", idx).attr("id", "listItem_"+idx);
			trDialog.find(".mplay-inp-dialog-txt").attr("name", txt_name);
			trDialog.find(".mplay-inp-dialog-narrador").attr("name", narrador_name);
			trDialog.find(".mplay-inp-dialog-tipo").attr("name", tipo_name);
			trDialog.find(".mplay-inp-dialog-padre").attr("name", padre_name);
			trDialog.find(".mplay-inp-dialog-siguiente").attr("name", siguiente_name);
		});
	}
	
	$("#aceptar_crear_dialogo-'.$rand.'").on("click", function(){
		var cont = $("#dialogos_bot_list_'.$bot->id.' tbody");
		
		var txt_dlg = $("#'.$this->id.'_inp_texto_'.$rand.'").val();
		var narrador_dlg = $("#'.$this->id.'_inp_narrador_'.$rand.'").val();
		var tipo_dlg = $("#'.$this->id.'_inp_tipo_'.$rand.'").val();
		
		var padre_dlg = $("#'.$this->id.'_inp_padre_'.$rand.'").val();
		var siguiente_dlg = $("#'.$this->id.'_inp_siguiente_'.$rand.'").val();
		
		if (txt_dlg == "" || narrador_dlg == "" || tipo_dlg == ""){
			Utilidades.Notificar("'.__('Debes rellenar todos los campos').'","error");
			return false;
		}
		
		var model_obj = {};
		var html= "";
		
		if (tipo_dlg == "opcion" || tipo_dlg == "linea" || tipo_dlg == "evento"){
			if (narrador_dlg != "jugador" && tipo_dlg == "opcion"){
				Utilidades.Notificar("'.__('Las opciones de diálogo solo se pueden asociar al jugador').'","error");
				return false;
			}
			
			model_obj.txt = txt_dlg;
			model_obj.narrador = narrador_dlg;
			model_obj.tipo = tipo_dlg;
			model_obj.padre = padre_dlg;
			model_obj.siguiente = siguiente_dlg;
			
			html = "<tr id=\'listItem_"+idx_dlg_'.$rand.'+"\' class=\'dlg_tr\' data-idx=\'"+idx_dlg_'.$rand.'+"\' data-input-name=\''.$this->name.'\'><td><a href=\'javascript:;\' onClick=\'$(this).parent().parent().remove();idx_dlg_'.$rand.' = idx_dlg_'.$rand.' + 1;update_idx_tr_dialogo();refreshPadres();\'><i class=\'fa fa-times\'></i></a></td><td><textarea class=\'mplay-inp-dialog-txt form-control\' name=\''.$this->name.'["+idx_dlg_'.$rand.'+"][txt]\' id=\''.$this->id.'_inp_txt_"+idx_dlg_'.$rand.'+"\'>"+model_obj.txt+"</textarea></td><td><select class=\'mplay-inp-dialog-narrador form-control\' name=\''.$this->name.'["+idx_dlg_'.$rand.'+"][narrador]\' data-value=\'"+model_obj.narrador+"\' id=\''.$this->id.'_inp_narrador_"+idx_dlg_'.$rand.'+"\'></select></td><td><select name=\''.$this->name.'["+idx_dlg_'.$rand.'+"][tipo]\' class=\'mplay-inp-dialog-tipo form-control\' data-value=\'"+model_obj.tipo+"\' id=\''.$this->id.'_inp_tipo_"+idx_dlg_'.$rand.'+"\'></select></td><td><select name=\''.$this->name.'["+idx_dlg_'.$rand.'+"][padre]\' class=\'mplay-inp-dialog-padre form-control\' data-value=\'"+model_obj.padre+"\' id=\''.$this->id.'_inp_padre_"+idx_dlg_'.$rand.'+"\'></select></td><td><select name=\''.$this->name.'["+idx_dlg_'.$rand.'+"][siguiente]\' class=\'mplay-inp-dialog-siguiente form-control\' data-value=\'"+model_obj.siguiente+"\' id=\''.$this->id.'_inp_siguiente_"+idx_dlg_'.$rand.'+"\'></select></td></tr>";
			
			cont.append(html);
			idx_dlg_'.$rand.' = idx_dlg_'.$rand.' + 1;
			
			update_idx_tr_dialogo();
			refreshPadres();
			
			$(".modal").modal("hide");
		}
		
	});
});
//]]>');
				
			$html .= '<div class="pull-right btn-toolbar"><a class="btn btn-sm btn-primary nuevo-dialogo-form-'.$rand.'" href="#modal-nuevo-dialogo-'.$rand.'" data-toggle="modal" ><i class="fa fa-plus fa fa-white"> </i> '.__('Añadir línea de diálogo').'</a></div>';

						$html .= '<table class="table table-striped" id="dialogos_bot_list_'.$bot->id.'">';
						$html .= '<thead><tr>';
						$html .= '<th width="1%"></th>';
						$html .= '<th width="40%">'.__('Texto').'</th>';
						$html .= '<th width="10%">'.__('Narrador').'</th>';
						$html .= '<th width="10%">'.__('Tipo').'</th>';
						$html .= '<th width="20%">'.__('Padre').'</th>';
						$html .= '<th width="20%">'.__('Siguiente').'</th>';
						$html .= '</tr></thead>';
						
						$html .= '<tbody>';
						
						if (is_array($valor) && sizeof($valor) > 0){
						$c = 0;
						foreach ($valor as $val){
							$val = (array) $val;
							$html .= '<tr id="listItem_'.$c.'" class="dlg_tr" data-idx="'.$c.'" data-input-name="'.$this->name.'">';
							$html .= '<td><a href="javascript:;" onClick="$(this).parent().parent().remove();update_idx_tr_dialogo();refreshPadres();"><i class="fa fa-times"></i></a></td><td><textarea class="mplay-inp-dialog-txt form-control" name="'.$this->name.'['.$c.'][txt]" id="'.$this->id.'_inp_txt_'.$c.'">'.$val['txt'].'</textarea></td><td><select class="mplay-inp-dialog-narrador form-control" name="'.$this->name.'['.$c.'][narrador]" data-value="'.$val['narrador'].'" id="'.$this->id.'_inp_narrador_'.$c.'"></select></td><td><select name="'.$this->name.'['.$c.'][tipo]" class="mplay-inp-dialog-tipo form-control" data-value="'.$val['tipo'].'" id="'.$this->id.'_inp_tipo_'.$c.'"></select></td><td><select name="'.$this->name.'['.$c.'][padre]" class="mplay-inp-dialog-padre form-control" data-value="'.$val['padre'].'" id="'.$this->id.'_inp_padre_'.$c.'"></select></td><td><select name="'.$this->name.'['.$c.'][siguiente]" class="mplay-inp-dialog-siguiente form-control" data-value="'.$val['siguiente'].'" id="'.$this->id.'_inp_siguiente_'.$c.'"></select></td>';
							$html .= '</tr>';  
							$c ++;                  
						}
			}
						
						$html .= '</tbody></table>';
						
						$html .= '<div id="modal-from-dom-'.$rand.'" class="modal fade">
						<div class="modal-dialog">
						<div class="modal-content">
					  <div class="modal-header">
						<button onclick="$(\'#modal-from-dom-'.$rand.'\').modal(\'hide\');return false;" class="close">&times;</button>
						<h4 class="modal-title">'.__('Borrar Misión').'</h4>
					  </div>
					  <div class="modal-body">
						<p>'.__('Va a eliminar permanentemente una misión del juego. Este proceso es irreversible.').'</p>
						<p>'.__('¿Quiere continuar con la eliminación de la misión?').'</p>
					  </div>
					  <div class="modal-footer"> <a href="javascript:;" id="yes-btn-del-field-'.$rand.'" class="btn btn-danger">'.__('Sí').'</a> <a href="javascript:$(\'#modal-from-dom-'.$rand.'\').modal(\'hide\')" class="btn secondary">'.__("No").'</a> </div>
					  </div>
					  </div>
					</div>';
					
					$last_url = Helpers::getSesion()->get('lastURL', null, 'admin');
						
					$GLOBALS['AppDoc']->AddScriptDeclaration('//<![CDATA[ 
		$(window).load(function(){
			var fixHelperModified = function(e, tr) {
				var $originals = tr.children();
				var $helper = tr.clone();
				$helper.children().each(function(index)
				{
				  $(this).width($originals.eq(index).width())
				});
				return $helper;
			};
		
			$("#dialogos_bot_list_'.$bot->id.' tbody").sortable({
				helper: fixHelperModified,
				update : function () {
					var idsOrder = $(this).sortable("toArray");
					$.each(idsOrder, function(idx, idDialog){
						var trDialog = $("#"+idDialog);
						var input_name = trDialog.data("input-name");
						var txt_name = input_name+"["+idx+"][txt]";
						var narrador_name = input_name+"["+idx+"][narrador]";
						var tipo_name = input_name+"["+idx+"][tipo]";
						var padre_name = input_name+"["+idx+"][padre]";
						var siguiente_name = input_name+"["+idx+"][siguiente]";
						
						trDialog.data("idx", idx).attr("id", "listItem_"+idx);
						trDialog.find(".mplay-inp-dialog-txt").attr("name", txt_name);
						trDialog.find(".mplay-inp-dialog-narrador").attr("name", narrador_name);
						trDialog.find(".mplay-inp-dialog-tipo").attr("name", tipo_name);
						trDialog.find(".mplay-inp-dialog-padre").attr("name", padre_name);
						trDialog.find(".mplay-inp-dialog-siguiente").attr("name", siguiente_name);
					});
				}
			}).disableSelection();
		
			var removeBtn = $("#yes-btn-del-field-'.$rand.'");
				
			removeBtn.click(function(){
				var id = $("#modal-from-dom-'.$rand.'").data("id");
				
				$("#modal-from-dom-'.$rand.'").modal("hide");
				var este_elem = $("#modal-from-dom-'.$rand.'");
				
				$.post("'.CONF_URL_APP_ADMIN.'?extension=ext_mplay&vista=editar_mision&id="+id+"'.$cm_txt.'", { borrar: "true", id: id }, function (data){
					if ($.trim(data) === "ok") { 
						Utilidades.Notificar("'.__('Borrado con éxito').'", { position: "center" });
						window.location.reload();
						return false;
					} else { 
						Utilidades.Notificar(data, { position: "center" }); 
						return false;
					}
				});
			});
		
		$(".confirm-delete-'.$rand.'").click(function(e) {
			e.preventDefault();
			
			var id = $(this).data("id");
			$("#modal-from-dom-'.$rand.'").data("id", id).modal("show");
		});
		});//]]>');
					
					
			
		}
		
		return $html;
	}
	
	
}
