<?php
c_include('forms/formField');

/**
 * Form Field class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Form
 * @since		1.6
 */
class FormFieldMplayinventariobot extends FormField
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'mplayinventariobot';

	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	public function getInput($valor=null)
	{
		// Initialize variables.
		$html = array();
		$attr = '';

		// Initialize some field attributes.
		$attr .= $this->element['class'] ? ' class="'.(string) $this->element['class'].'"' : '';

		// To avoid user's confusion, readonly="true" should imply disabled="true".
		if ( (string) $this->element['readonly'] == 'true' || (string) $this->element['disabled'] == 'true') {
			$attr .= ' disabled="disabled"';
		}

		$attr .= $this->element['size'] ? ' size="'.(int) $this->element['size'].'"' : '';

		// Initialize JavaScript field attributes.
		$attr .= $this->element['onchange'] ? ' onchange="'.(string) $this->element['onchange'].'"' : '';

		if (!is_array($valor) && !empty($valor))
			$valor = Helpers::toArray(json_decode($valor));
		
		$output = '';
		
		if ($_GET['extension'] != 'ext_mplay' || $_GET['vista'] != 'editar_bot' || empty($_GET['id'])){
			if ($_GET['extension'] == 'ext_mplay' && $_GET['vista'] == 'nuevo_bot'){
				$output = '<div class="alert alert-info">'.__('Debes guardar el bot para poder configurar su inventario').'</div>';
			}
			return $output;
		}
		
		e_include('ext_mplay/class/mplayBot');
		
		if (!class_exists('MplayBot')){
			return '';
		}
		
		$item = new MplayBot();
		$item->setid($_GET['id']);
		
		if ($item = $item->BuscarId()){
		} else {
			return '';
		}
		
		// Get the field options.
		$options = $this->getOptions($valor, $item, $attr);
		
		$output .= '<div class="mplay-inventario-bot-form row" data-accion-item="sortable" data-sortable-handle=".handle">';
		
		$output .= $options;
		
		$output .= '</div>';
		
		$output .= '<div class="dropdown"><a href="#" class="btn btn-primary" data-toggle="dropdown"><i class="fa fa-plus"></i> '.__('Añadir item').' <span class="caret"></span></a><ul class="dropdown-menu" role="menu"><li><a class="iframe-config" href="'.CONF_URL_APP_ADMIN.'?extension=ext_mplay&vista=nuevo_item&bot='.$item->id.'&popup=1'.$cm_txt.'">'.__('Nuevo').'</a></li></ul></div>';

		
		//$html[] = JHtml::_('select.genericlist', $options, $this->name, trim($attr), 'value', 'text', $this->value, $this->id);

		return $output;
	}

	/**
	 * Method to get the field options.
	 *
	 * @return	array	The field option objects.
	 * @since	1.6
	 */
	protected function getOptions($valor=null, $item, $attr)
	{
		if (!$item instanceof MplayBot)
			return false;
			
		$inventario_html = $item->printInventarioForm($this->name, $attr);
					
		return $inventario_html;

	}
}
