<?php
c_include('forms/formField');
e_include('ext_mplay/class/juego','ext_mplay/class/misionJuegoMplay');

/**
 * Form Field class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Form
 * @since		1.6
 */
class FormFieldMplaymisionesjuego extends FormField
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'mplaymisionesjuego';

	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	public function getInput($valor=null)
	{
		if ($_GET['extension'] != 'ext_mplay' || $_GET['vista'] != 'editar' || empty($_GET['id']))
			return false;
			
		// Initialize variables.
		$html = array();
		$attr = '';

		// Initialize some field attributes.
		$attr .= $this->element['class'] ? ' class="form-control '.(string) $this->element['class'].'"' : ' class="form-control"';

		// To avoid user's confusion, readonly="true" should imply disabled="true".
		if ( (string) $this->element['readonly'] == 'true' || (string) $this->element['disabled'] == 'true') {
			$attr .= ' disabled="disabled"';
		}

		$attr .= $this->element['size'] ? ' size="'.(int) $this->element['size'].'"' : '';
		$attr .= $this->element['multicheck'] != 'false' ? ' multiple="multiple"' : '';

		// Initialize JavaScript field attributes.
		$attr .= $this->element['onchange'] ? ' onchange="'.(string) $this->element['onchange'].'"' : '';
		
		$output = '';
		
		$output .= $this->getTablaMisiones($valor, $attr);
		
		return $output;
	}
	
	function getTablaMisiones($valor, $attr){
		$juego = new Juego();
		$juego->setid($_GET['id']);
		$juego = $juego->BuscarId();
		
		$html = '';
		
		if (!empty($juego)){
			$misiones = $juego->getMisiones(false);
			
			$rand = rand();
			
			$cm_txt = '';
			if (!empty($_GET['custom_menu']))
				$cm_txt = '&custom_menu='.$_GET['custom_menu'];
				
			$html .= '<div class="modal fade" id="modal-nueva-mision-'.$rand.'">
		<div class="modal-dialog modal-lg">
      <div class="modal-content">
            <div class="modal-header">
              <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
              <h4 class="modal-title">'.__('Nueva Misión de Juego').'</h4>
            </div>
            <div class="modal-body">
              <div class="row">
                <div class="col-md-12">
                  <div id="frmNuevaMision-'.$rand.'" class="form-validate">
                    ';
					
	  $mision_nueva = new MisionJuegoMplay();
	  
	  $mision_nueva->setjuego($juego->id);
	  
  	  if (isset($GLOBALS['custom_menu']) && file_exists(dirname(__FILE__) . '/xml/nuevo_mision_ext_mplay_'.$GLOBALS['custom_menu']->id.'.xml')){
		  $path1 = dirname(__FILE__) . '/xml/nuevo_mision_ext_mplay_'.$GLOBALS['custom_menu']->id.'.xml';
	  } else {
		  $path1 =CONF_REALPATH_APP. CONF_DIR_EXTENSIONS . '/ext_mplay/admin/xml/nuevo_mision_ext_mplay.xml';
	  }
	  $html .= LayoutBootstrap::renderFormXML($path1,'ext_misiones', $mision_nueva->getDataArray('nuevo'));
      
                 $html .=' </div>
                </div>
              </div>
            </div>
            <div class="modal-footer"> <a href="javascript:;" id="aceptar_crear_mision-'.$rand.'" class="btn btn-primary">'.__('Crear').'</a> <a href="javascript:;" class="btn close-modal-'.$rand.'">'.__('Cancelar').'</a> </div>
			</div>
			</div>
          </div>';
		  
$GLOBALS['AppDoc']->AddScriptDeclaration('//<![CDATA[ 
$(document).ready(function(){
	var this_el = $(\'#modal-nueva-mision-'.$rand.'\');
	
	var removeBtn = $(\'#aceptar_crear_mision-'.$rand.'\');
	var closeBtn = this_el.find(\'.close-modal-'.$rand.'\');
		
	removeBtn.click(function(){
		$(\'#modal-nueva-mision-'.$rand.'\').modal(\'hide\');
		var este_elem = this_el;
		
		$.post(\''.CONF_URL_APP_ADMIN.'?extension=ext_mplay&vista=nuevo_mision'.$cm_txt.'\', $(\'div#frmNuevaMision-'.$rand.' :input\').serialize(), function (data){
			if ($.trim(data) === "ok") { 
				MideasFunciones.Notificar(\''.__('Misión creada con éxito').'\', { position: \'center\'});
				document.location.reload();;
				return true;
			} else { 
				bootbox.alert(data); 
				return false;
			}
		});
	});
	closeBtn.click(function(){
		$(\'#modal-nueva-mision-'.$rand.'\').modal(\'hide\');
	});

$(\'.nueva-mision-form-'.$rand.'\').click(function(e) {
    e.preventDefault();
    
    $(\'#modal-nueva-mision-'.$rand.'\').modal(\'show\');
});
});//]]>');
				
			$html .= '<div class="pull-right btn-toolbar"><a class="btn btn-sm btn-primary nueva-mision-form-'.$rand.'" href="?extension=ext_mplay&amp;vista=nuevo_mision'.$cm_txt.'" ><i class="fa fa-plus fa fa-white"> </i> '.__('Añadir misión').'</a></div>';

			if (!empty($misiones)){
					
				
						$html .= '<table class="table table-striped" id="misiones_juego_list_'.$juego->id.'">';
						$html .= '<thead><tr>';
						$html .= '<th>'.__('Misión').'</th>';
						$html .= '<th>'.__('Contenido').'</th>';
						$html .= '<th>'.__('Fecha').'</th>';
						$html .= '<th>'.__('ID').'</th>';
						$html .= '</tr></thead>';
						
						$html .= '<tbody>';
						
						foreach ($misiones as $mision){
							$html .= '<tr id="listItem_'.$mision->id.'">';
							$html .= '<td class="nowrap has-context"><div class="pull-left" style="width:100%;">
							<div class="pull-left">
							  <div class="btn-group" style="margin-right: 6px; "> <a href="#" data-toggle="dropdown" class="dropdown-toggle btn btn-default btn-xs"> <i class="fa fa-caret-down"></i> </a>
								<ul class="dropdown-menu">
								  <li class=""><a class="iframe-config" href="?extension=ext_mplay&amp;vista=editar_mision&amp;id='.$mision->id.'&popup=1'.$cm_txt.'">'.__('Editar').'</a></li>
								  <li class="divider"></li>
								  <li class=""><a href="javascript:;" class="confirm-delete-'.$rand.'" data-id="'.$mision->id.$cm_txt.'">'.__('Borrar misión').'</a></li>
								</ul>
							  </div>
							</div>
							<a class="iframe-config" href="?extension=ext_mplay&amp;vista=editar_mision&amp;id='.$mision->id.'&popup=1'.$cm_txt.'" title="'.__('Editar').'">'.SistemaIdioma::Imprimir($mision->titulo).'</a></div>
							</td>';
							
							$html .= '<td class="small hidden-phone">'.Helpers::recortarTexto(strip_tags(SistemaIdioma::Imprimir($mision->descripcion)), 150).'</td>';
							$html .= '<td class="small hidden-phone">'.strftime("%Y-%m-%d", strtotime($mision->fecha)).'</td>';
							$html .= '<td class="small hidden-phone">'.$mision->id.'</td>';
							$html .= '</tr>';                    
						}
						
						$html .= '</tbody></table>';
						
						$html .= '<div id="modal-from-dom-'.$rand.'" class="modal fade">
						<div class="modal-dialog">
						<div class="modal-content">
					  <div class="modal-header">
						<button onclick="$(\'#modal-from-dom-'.$rand.'\').modal(\'hide\');return false;" class="close">&times;</button>
						<h4 class="modal-title">'.__('Borrar Misión').'</h4>
					  </div>
					  <div class="modal-body">
						<p>'.__('Va a eliminar permanentemente una misión del juego. Este proceso es irreversible.').'</p>
						<p>'.__('¿Quiere continuar con la eliminación de la misión?').'</p>
					  </div>
					  <div class="modal-footer"> <a href="javascript:;" id="yes-btn-del-field-'.$rand.'" class="btn btn-danger">'.__('Sí').'</a> <a href="javascript:$(\'#modal-from-dom-'.$rand.'\').modal(\'hide\')" class="btn secondary">'.__("No").'</a> </div>
					  </div>
					  </div>
					</div>';
					
					$last_url = Helpers::getSesion()->get('lastURL', null, 'admin');
						
						$GLOBALS['AppDoc']->AddScriptDeclaration('//<![CDATA[ 
		$(window).load(function(){
			var fixHelperModified = function(e, tr) {
			var $originals = tr.children();
			var $helper = tr.clone();
			$helper.children().each(function(index)
			{
			  $(this).width($originals.eq(index).width())
			});
			return $helper;
		};
		
		$("#misiones_juego_list_'.$juego->id.' tbody").sortable({
			helper: fixHelperModified,
			update : function () { 
				  var order = $(this).sortable("serialize");
				  $.post("'.$last_url.'", order, function(data){
					  if ($.trim(data) != "ok"){
						Utilidades.Notificar($.trim(data));
					  }
					  return false;
				  });		  
				} 
			
		}).disableSelection();
		
			
			var removeBtn = $("#yes-btn-del-field-'.$rand.'");
				
			removeBtn.click(function(){
				var id = $("#modal-from-dom-'.$rand.'").data("id");
				
				$("#modal-from-dom-'.$rand.'").modal("hide");
				var este_elem = $("#modal-from-dom-'.$rand.'");
				
				$.post("'.CONF_URL_APP_ADMIN.'?extension=ext_mplay&vista=editar_mision&id="+id+"'.$cm_txt.'", { borrar: "true", id: id }, function (data){
					if ($.trim(data) === "ok") { 
						Utilidades.Notificar("'.__('Borrado con éxito').'", { position: "center" });
						window.location.reload();
						return false;
					} else { 
						Utilidades.Notificar(data, { position: "center" }); 
						return false;
					}
				});
			});
		
		$(".confirm-delete-'.$rand.'").click(function(e) {
			e.preventDefault();
			
			var id = $(this).data("id");
			$("#modal-from-dom-'.$rand.'").data("id", id).modal("show");
		});
		});//]]>');
					
					
			}
		}
		
		return $html;
	}
	
	
}
