<?php
c_include('forms/formField');

/**
 * Form Field class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Form
 * @since		1.6
 */
class FormFieldMplaymodulos extends FormField
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'mplaymodulos';

	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	public function getInput($valor=null)
	{
		// Initialize variables.
		$html = array();
		$attr = '';

		// Initialize some field attributes.
		$attr .= $this->element['class'] ? ' class="'.(string) $this->element['class'].'"' : '';
				
		e_include('ext_mplay/class/mplayModulo');
		if (!class_exists("MplayModulo"))
			return false;
			
		$modulos = MplayModulo::getAllModules();
		
		$output = '';
		
		$output .= '<div class="row_mplay_modulos_'.$this->id.' row">
		';
		
		foreach ($modulos as $modulo=>$path_modulo){
			$inst = MplayModulo::getInstance($modulo);
			
			if (!$inst instanceof MplayModulo)
				continue;
				
			$imodulo = $inst->getIcono();
			if (!empty($imodulo))
				$imodulo = '<i class="'.$imodulo.'"></i> ';
			
			$nmodulo = $inst->getNombre();
			
			$checked_1 = '';
			$checked_1_cls = ' btn-default';
			$checked_0 = '';
			$checked_0_cls = ' btn-default';
			
			if (is_array($valor) && isset($valor[$modulo]['activo'])){
				if ($valor[$modulo]['activo'] == '1'){
					$checked_1 = ' checked="checked"';
					$checked_0 = '';
					
					$checked_1_cls = ' btn-success';
					$checked_0_cls = ' btn-default';
				} else {
					$checked_1 = '';
					$checked_0 = ' checked="checked"';
					
					$checked_1_cls = ' btn-default';
					$checked_0_cls = ' btn-danger';
				}
			}
			
			$frm_inst = $inst->printAdminForm($this->name, false, $valor[$modulo], $inst->getId(), "LayoutBootstrap", CONF_REALPATH_APP . 'templates/bootstrap_admin/class/layoutBootstrap.class.php', false, '');
			
			
			$output .= '<div class="col-md-4">
			<div class="panel-body bg-info">
				<div id="buttongrouplist_'.$this->id.'_'.$modulo.'" class="btn-group btn-group-list pull-right" data-toggle="buttons" style="margin-left: 10px;">
					<label class="btn'.$checked_1_cls.'" data-class=" btn-success" id="lbl_'.$this->id.'_'.$modulo.'_1">
						<input type="radio" name="'.$this->name.'['.$modulo.'][activo]" id="'.$this->id.'_'.$modulo.'_1" value="1"'.$checked_1.'> <i class="fa fa-check"></i>
					</label>
					<label class="btn'.$checked_0_cls.'" data-class=" btn-danger" id="lbl_'.$this->id.'_'.$modulo.'_0">
						<input type="radio" name="'.$this->name.'['.$modulo.'][activo]" id="'.$this->id.'_'.$modulo.'_0" value="0"'.$checked_0.'> <i class="fa fa-times"></i>
					</label>
				</div>
				
				<a class="btn btn-info pull-right" href="#mdl_mplay_modulo_'.$this->id.'_'.$modulo.'" data-toggle="modal"><i class="fa fa-cog"></i></a>

				<span style="padding-top: 7px;display: inline-block;">'.$imodulo.$nmodulo.'</span>
			</div>
			
			
			<div class="modal fade" tabindex="-1" role="dialog" id="mdl_mplay_modulo_'.$this->id.'_'.$modulo.'">
			  <div class="modal-dialog modal-lg">
				<div class="modal-content">
				  <div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
					<h4 class="modal-title">'.sprintf(__("Configuración del módulo %s"), $nmodulo).'</h4>
				  </div>
				  <div class="modal-body">
					'.$frm_inst.'
				  </div>
				  <div class="modal-footer">
					<button type="button" class="btn btn-default" data-dismiss="modal">'.__('Cerrar').'</button>
				  </div>
				</div><!-- /.modal-content -->
			  </div><!-- /.modal-dialog -->
			</div><!-- /.modal -->
			
			
			</div>';
		}
		
		$output .= '</div>';		

		return $output;
	}
}
