<?php
c_include('forms/formField');

/**
 * Form Field class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Form
 * @since		1.6
 */
class FormFieldMplaypropiedadeshabilidad extends FormField
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'mplaypropiedadeshabilidad';

	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	public function getInput($valor=null)
	{
		// Initialize variables.
		$html = array();
		$attr = '';

		// Initialize some field attributes.
		$attr .= $this->element['class'] ? ' class="'.(string) $this->element['class'].'"' : '';

		// To avoid user's confusion, readonly="true" should imply disabled="true".
		if ( (string) $this->element['readonly'] == 'true' || (string) $this->element['disabled'] == 'true') {
			$attr .= ' disabled="disabled"';
		}

		$attr .= $this->element['size'] ? ' size="'.(int) $this->element['size'].'"' : '';

		// Initialize JavaScript field attributes.
		$attr .= $this->element['onchange'] ? ' onchange="'.(string) $this->element['onchange'].'"' : '';

		if (!is_array($valor) && !empty($valor))
			$valor = Helpers::toArray(json_decode($valor));
		
		$output = '';
		
		if ($_GET['extension'] != 'ext_mplay' || $_GET['vista'] != 'editar_habilidad' || empty($_GET['id'])){
			if ($_GET['extension'] == 'ext_mplay' && $_GET['vista'] == 'nuevo_habilidad'){
				$output = '<div class="alert alert-info">'.__('Debes guardar la habilidad para poder editar sus propiedades').'</div>';
			}
			return $output;
		}
		
		e_include('ext_mplay/class/mplayHabilidadUsuario');
		
		if (!class_exists('MplayHabilidadUsuario')){
			return '';
		}
		
		$item = new MplayHabilidadUsuario();
		$item->setid($_GET['id']);
		
		if ($item = $item->BuscarId()){
		} else {
			return '';
		}
		
		// Get the field options.
		$options = $this->getOptions($valor, $item->tipo, $attr);
		
		$output .= '<div class="mplay-propiedades-oficio-form">';
		
		$output .= $options;
		
		$output .= '</div>';

		
		//$html[] = JHtml::_('select.genericlist', $options, $this->name, trim($attr), 'value', 'text', $this->value, $this->id);

		return $output;
	}

	/**
	 * Method to get the field options.
	 *
	 * @return	array	The field option objects.
	 * @since	1.6
	 */
	protected function getOptions($valor=null, $tipo = 'default', $attr)
	{
		if (empty($tipo))
			$tipo = 'default';
			
		$tipo_obj = MplayHabilidadTipo::getInstance($tipo, $valor);
		
		$propiedades_html = $tipo_obj->printPropiedadesForm($this->name, $attr);
		
		return $propiedades_html;

	}
}
