<?php
c_include('forms/formField');

/**
 * Form Field class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Form
 * @since		1.6
 */
class FormFieldMplayrecompensatiposhandler extends FormField
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'mplayrecompensatiposhandler';

	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	public function getInput($valor=null)
	{
		// Initialize variables.
		$html = array();
		$attr = '';

		// Initialize some field attributes.
		$attr .= $this->element['class'] ? ' class="select2 '.(string) $this->element['class'].'"' : ' class="select2"';

		// To avoid user's confusion, readonly="true" should imply disabled="true".
		if ( (string) $this->element['readonly'] == 'true' || (string) $this->element['disabled'] == 'true') {
			$attr .= ' disabled="disabled"';
		}

		$attr .= $this->element['size'] ? ' size="'.(int) $this->element['size'].'"' : '';
		$attr .= $this->multiple ? ' multiple="multiple"' : '';
		
		$multi = $this->multiple ? true : false;

		// Initialize JavaScript field attributes.
		$attr .= $this->element['onchange'] ? ' onchange="'.(string) $this->element['onchange'].'"' : '';
		
		e_include('ext_mplay/class/mplayRecompensa','ext_mplay/class/mplayRecompensaTipo');
		
		if (!class_exists('MplayRecompensa') || !class_exists('MplayRecompensaTipo'))
			return false;
			
		$tipo_recompensa = MplayRecompensaTipo::getInstance($valor['tipo']);

		$output = '<div class="row">
		<div class="col-md-6">
		<label>'.__('Tipo de recompensa').'</label>';

		// Get the field options.
		$options = (array) $this->getOptions($valor['tipo'], $multi);
		
		$output .= '<select'.$attr.' name="'.$this->name.'[tipo]" id="'.$this->id.'">';
		
		foreach ($options as $option){
			$output .= $option;
		}
		
		$output .= '</select>';
		
		$output .= '</div>
		<div class="col-md-6">
		<label>'.__('Valor de recompensa').'</label>
		'.$tipo_recompensa->printInput($this->name.'[valor]', $valor['valor']).'
		</div>
		</div>';

		return $output;
	}

	/**
	 * Method to get the field options.
	 *
	 * @return	array	The field option objects.
	 * @since	1.6
	 */
	protected function getOptions($valor=null, $multi=false)
	{
		// Initialize variables.
		$options = array();

		// Initialize variables.
		$options = array();
		
		$options[] = '<option value="">'.__('Sin recompensa').'</option>';
		
		$recompensas = MplayRecompensa::getAdaptadores();
		
		// Convert to name => name array.
		foreach (MplayRecompensa::getAdaptadores() as $store)
		{
			$output = '';
			
			if ($multi == false){
				$output .= '<option value="'.$store.'"';
				
				if ($valor != null){
					 if ((string) $valor == (string) $store){
						$output .= ' selected="selected"';
					 }
				} elseif ((string) $this->element['default'] == (string) $store){
					$output .= ' selected="selected"';
				}
				
				if ((string) $option['disabled']=='true')
					$output .= ' disabled="disabled"';
				
				$output .='>'. $store . '</option>';
			} else {
				$selected='';
				if ($valor != null){
					 if (in_array((string) $store, $valor)){
						$selected = ' checked="checked"';
					 }
				} elseif ((string) $this->element['default'] == (string) $store){
					$selected = ' checked="checked"';
				}
				
				$disabled='';
				if ((string) $option['disabled']=='true')
					$disabled = ' disabled="disabled"';
				
				$output .= "<li><input ".$selected." ".$disabled." type='checkbox' value='".$store."' name='".$this->name."[]' id='".$this->id.'_'.$store."' /> <span>".$store."</span></li>";
				
			}
			
			$options[] = $output;
		}

		reset($options);

		return $options;

	}
}
