<?php
c_include('forms/formField');

/**
 * Form Field class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Form
 * @since		1.6
 */
class FormFieldMplaytipooficios extends FormField
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'mplaytipooficios';

	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	public function getInput($valor=null)
	{
		// Initialize variables.
		$html = array();
		$attr = '';

		// Initialize some field attributes.
		$attr .= $this->element['class'] ? ' class="select2 '.(string) $this->element['class'].'"' : ' class="select2"';

		// To avoid user's confusion, readonly="true" should imply disabled="true".
		if ( (string) $this->element['readonly'] == 'true' || (string) $this->element['disabled'] == 'true') {
			$attr .= ' disabled="disabled"';
		}

		$attr .= $this->element['size'] ? ' size="'.(int) $this->element['size'].'"' : '';
		$attr .= $this->multiple ? ' multiple="multiple"' : '';

		// Initialize JavaScript field attributes.
		$attr .= $this->element['onchange'] ? ' onchange="'.(string) $this->element['onchange'].'"' : '';

		
		
		$output = '';
		
		if ($this->element['multicheck'] == 'true'){
			// Get the field options.
			$options = (array) $this->getOptions($valor, true);
			
			$output .= '<ul'.$attr.'>';
			foreach ($options as $option){
				$output .= $option;
			}
			$output .= '</ul>';
		} else {
			// Get the field options.
			$options = (array) $this->getOptions($valor);
			
			$output .= '<select'.$attr.' name="'.$this->name.'" id="'.$this->id.'">';
			
			foreach ($options as $option){
				$output .= $option;
			}
			
			$output .= '</select>';
		}
		
		//$html[] = JHtml::_('select.genericlist', $options, $this->name, trim($attr), 'value', 'text', $this->value, $this->id);

		return $output;
	}

	/**
	 * Method to get the field options.
	 *
	 * @return	array	The field option objects.
	 * @since	1.6
	 */
	protected function getOptions($valor=null, $multi=false)
	{
		e_include('ext_mplay/class/mplayOficioUsuario');
		
		// Initialize variables.
		$options = array();
		
		if (!class_exists('MplayOficioUsuario')){
			return $options;
		}

		// Convert to name => name array.
		foreach (MplayOficioUsuario::getTypes() as $type)
		{
			$output = '';
			
			if ($multi == false){
				$output .= '<option value="'.$type.'"';
				
				if ($valor != null){
					 if ((string) $valor == (string) $type){
						$output .= ' selected="selected"';
					 }
				} elseif ((string) $this->element['default'] == (string) $type){
					$output .= ' selected="selected"';
				}
				
				if ((string) $option['disabled']=='true')
					$output .= ' disabled="disabled"';
				
				$output .='>'. $type . '</option>';
			} else {
				$selected='';
				if ($valor != null){
					 if (in_array((string) $type, $valor)){
						$selected = ' checked="checked"';
					 }
				} elseif ((string) $this->element['default'] == (string) $type){
					$selected = ' checked="checked"';
				}
				
				$disabled='';
				if ((string) $option['disabled']=='true')
					$disabled = ' disabled="disabled"';
				
				$output .= "<li><input ".$selected." ".$disabled." type='checkbox' value='".$type."' name='".$this->name."[]' id='".$this->id.'_'.$type."' /> <span>".$type."</span></li>";
				
			}
			
			$options[] = $output;
		}

		reset($options);

		return $options;

	}
}
