var MPlayBotDialog = {
  dialogo_activo: {},
  attrHablarBot: '[data-mplay-dialogobot]',
  clsLinkHablarBot: '.mplay-popup-optbtn-hablarbot',
  createAndAddNode: function (textLines) {
    var resultNode = MPlayBotDialog.createNode(textLines);
    MPlayBotDialog.addNode(resultNode);
    return resultNode;
  },
  createNode: function (textLines) {
    var lineObjects = [];
    var lineId;
    textLines.forEach(function (textLine, index) {
      lineId = index;
      lineObjects.push({ id: lineId, text: textLine });
    });
    return {
      id: null,
      speaker: null,
      type: textLines.length === 1 ? 'inactive' : 'interactive',
      lines: lineObjects
    };
  },
  addNode: function (node) {
    node.id = MPlayBotDialog.nodes.length;
    MPlayBotDialog.nodes.push(node);
  },
  getNode: function (nodeId) {
    var foundNode = null;
	if (nodeId != undefined){
		$.each(this.nodes, function(idxn, node){
			if (node.id.toString() === nodeId.toString()) {
				foundNode = node;
			}
		});
	}
    return foundNode;
  },
  displayDialog: function (dialogNode) {
	var container = document.getElementById('mplay-ui-dialogo-screen');
	var isInteractive = (dialogNode.type === 'interactive');
	var lines = document.createElement(isInteractive ? 'ol' : 'div');
	lines.className = "mplay-habla-"+dialogNode.speaker+" mplay-dialogo-"+dialogNode.action;
	if (dialogNode && dialogNode.lines) {
	  dialogNode.lines.forEach(function (line) {
		var newLine = document.createElement(isInteractive ? 'li' : 'div');
		newLine.innerHTML = line.text;
		newLine.addEventListener('click', function () {
		  MPlayBotDialog.displayDialog(dialogNode.next(line));
		});
		if (line.url) {
		  var link = document.createElement('a');
		  link.href = line.url;
		  link.innerHTML = line.urlText || line.url;
		  newLine.appendChild(document.createElement('br'));
		  newLine.appendChild(link);
		}
		lines.appendChild(newLine);
	  });
	}
	container.innerHTML = '';
	container.appendChild(lines);
  },
  nodes: [],
  init_hablar_bot: function (contenedor_jq, onEnd){
	var map = $("[data-mplay-mapa]");
				
	map.off("click", this.clsLinkHablarBot);
	map.on("click", this.clsLinkHablarBot, function(){
		var este = $(this);
		var id_bot = este.data("botid");
		
		var este = $(this);
		var old_html = este.html();
		
		este.addClass("disabled").html('<div id="loading_ta" style="position: relative;display: block;top: auto;right: auto;z-index: 0;"><i class="fa fa-spin fa-circle-o-notch"></i></div>');
		
		MPlayBotDialog.update_hablar_bot(contenedor_jq, id_bot, este, old_html);
		
		return false;
	});
	if (MideasFunciones.isFunction(onEnd)){
		$('body').fadeIn(0, onEnd);
	}
  },
  reset_hablar_bot: function (contenedor_jq){
	var jElementBot = contenedor_jq.find(this.attrHablarBot);
	if (jElementBot.length > 0) {
		jElementBot.each(function(idx, ele){
			$(ele).hide();
			
			var img_bot = $(ele).find('.mplay-ui-hablarbot-botavatar');
			var nombre_bot = $(ele).find('[data-mplay-hablarbot-name]');
			var props_bot = $(ele).find('[data-mplay-hablarbot-propiedades]');
			var screen_dialogo = $(ele).find("[data-mplay-hablarbot-dialogo]");
			
			img_bot.find("img").attr("src", "");
			nombre_bot.html("");
			
			props_bot.html("");
			screen_dialogo.hide();
		});
	}
  },
  update_hablar_bot: function (contenedor_jq, id_bot, but, html_but){
	MPlayBotDialog.reset_hablar_bot(contenedor_jq);
	
	var jElementRetarBot = contenedor_jq.find(this.attrHablarBot);
	if (jElementRetarBot.length > 0) {
		jElementRetarBot.each(function(idx, ele){
			$.get(MPlay.config.base_url + 'api/mplay/usuario/rellenarDialogoBot.json/', {id_bot: id_bot }, function(data){
				if (data.response == 'ok'){
					var img_bot = $(ele).find('.mplay-ui-hablarbot-botavatar');
					var nombre_bot = $(ele).find('[data-mplay-hablarbot-name]');
					var props_bot = $(ele).find('[data-mplay-hablarbot-propiedades]');
					var screen_dialogo = $(ele).find("[data-mplay-hablarbot-dialogo]");
					var close_dialogo = $(ele).find("[data-mplay-dialogo-cancelar]");
																					
					img_bot.find("img").attr("src", data.data.icono_big);
					nombre_bot.html(data.data.nombre);
					props_bot.html(data.data.propiedades_html);
					
					close_dialogo.off("click");
					close_dialogo.on("click", function(){
						MPlayBotDialog.finalizar_hablar_bot();
						return false;
					});
					
					screen_dialogo.show();

					if (data.data.propiedades.dialogos.valor == undefined){
						MPlayUI.Notificar("Diálogo no disponible","El diálogo con el personaje no está disponible");
						return false;
					}
					MPlayBotDialog.dialogo_activo = data.data.propiedades.dialogos.valor;
					  
					var opciones_por_padre = [];
					
					if (Object.keys(MPlayBotDialog.dialogo_activo).length > 0){
						for (i in MPlayBotDialog.dialogo_activo) {
							if (MPlayBotDialog.dialogo_activo.hasOwnProperty(i)) {
								if (MPlayBotDialog.dialogo_activo[i]['tipo'] == 'opcion'){
									if (MPlayBotDialog.dialogo_activo[i]['padre'] == ""){
										MPlayBotDialog.dialogo_activo[i]['padre'] = 0;
									}
									var idx = MPlayBotDialog.dialogo_activo[i]['padre'];
									var model = {};
									model.lines = [];
									if (opciones_por_padre[idx] == undefined || opciones_por_padre[idx]['lines'] == undefined){
										var num_lineas = 0;
									} else {
										var num_lineas = opciones_por_padre[idx]['lines'].length;
										model = opciones_por_padre[idx];
									}
									
									model.id = idx;
									model.lines.push({"id": idx+'.'+num_lineas, "text": MPlayBotDialog.dialogo_activo[i]['txt'], "next_id": MPlayBotDialog.dialogo_activo[i]['siguiente']});
									model.lines = $.makeArray(model.lines);
									model.speaker = MPlayBotDialog.dialogo_activo[i]['narrador'];
									model.action = MPlayBotDialog.dialogo_activo[i]['tipo'];
									model.type = "interactive";

									if (opciones_por_padre[idx] == undefined || opciones_por_padre[idx]['lines'] == undefined){
										opciones_por_padre.push(model);
										var tmp_t = $.makeArray(opciones_por_padre);
										var tmp_idx = tmp_t.length - 1;
									} else {
										opciones_por_padre[idx] = model;
										var tmp_idx = idx;
									}
									
									opciones_por_padre[tmp_idx]['next'] = function (linePicked) {
																				if (linePicked.next_id == '-1'){
																					MPlayBotDialog.finalizar_hablar_bot();
																					return false;
																				} else {
																					return MPlayBotDialog.getNode(linePicked.next_id);
																				}
																			};
									
								} else if (MPlayBotDialog.dialogo_activo[i]['tipo'] == 'linea'){
									if (MPlayBotDialog.dialogo_activo[i]['padre'] == ""){
										MPlayBotDialog.dialogo_activo[i]['padre'] = 0;
									}
									var idx = i;
									
									var model = {};
									model.lines = [];
									if (opciones_por_padre[idx] == undefined || opciones_por_padre[idx]['lines'] == undefined){
										var num_lineas = 0;
									} else {
										var num_lineas = opciones_por_padre[idx]['lines'].length;
										model = opciones_por_padre[idx];
									}
									
									model.id = idx;
									model.lines.push({"id": idx+'.'+num_lineas, "text": MPlayBotDialog.dialogo_activo[i]['txt'], "next_id": MPlayBotDialog.dialogo_activo[i]['siguiente']});
									model.lines = $.makeArray(model.lines);
									model.speaker = MPlayBotDialog.dialogo_activo[i]['narrador'];
									model.action = MPlayBotDialog.dialogo_activo[i]['tipo'];
									model.type = "inactive";
									
									if (opciones_por_padre[idx] == undefined || opciones_por_padre[idx]['lines'] == undefined){
										opciones_por_padre[idx] = model;
										var tmp_idx = idx;
									} else {
										opciones_por_padre[idx] = model;
										var tmp_idx = idx;
									}
									var padre = MPlayBotDialog.dialogo_activo[i]['padre'];
									if (opciones_por_padre[padre] != undefined && opciones_por_padre[padre]['id'] != undefined){
										opciones_por_padre[padre]['next_id'] = idx;
									}
									opciones_por_padre[tmp_idx]['next'] = function (linePicked) {
																				if (linePicked.next_id == '-1'){
																					MPlayBotDialog.finalizar_hablar_bot();
																					return false;
																				} else {
																					return MPlayBotDialog.getNode(linePicked.next_id);
																				}
																			};
								} else if (MPlayBotDialog.dialogo_activo[i]['tipo'] == 'evento'){
									if (MPlayBotDialog.dialogo_activo[i]['padre'] == ""){
										MPlayBotDialog.dialogo_activo[i]['padre'] = 0;
									}
									var idx = i;
									
									var model = {};
									model.lines = [];
									if (opciones_por_padre[idx] == undefined || opciones_por_padre[idx]['lines'] == undefined){
										var num_lineas = 0;
									} else {
										var num_lineas = opciones_por_padre[idx]['lines'].length;
										model = opciones_por_padre[idx];
									}
									
									model.id = idx;
									model.lines.push({"id": idx+'.'+num_lineas, "text": MPlayBotDialog.dialogo_activo[i]['mensaje_evento'], "next_id": MPlayBotDialog.dialogo_activo[i]['siguiente']});
									model.lines = $.makeArray(model.lines);
									model.speaker = MPlayBotDialog.dialogo_activo[i]['narrador'];
									model.action = MPlayBotDialog.dialogo_activo[i]['tipo'];
									model.type = "inactive";
									
									if (opciones_por_padre[idx] == undefined || opciones_por_padre[idx]['lines'] == undefined){
										opciones_por_padre[idx] = model;
										var tmp_idx = idx;
									} else {
										opciones_por_padre[idx] = model;
										var tmp_idx = idx;
									}
									var padre = MPlayBotDialog.dialogo_activo[i]['padre'];
									if (opciones_por_padre[padre] != undefined && opciones_por_padre[padre]['id'] != undefined){
										opciones_por_padre[padre]['next_id'] = idx;
									}
									opciones_por_padre[tmp_idx]['next'] = function (linePicked) {
																				if (linePicked.next_id == '-1'){
																					MPlayBotDialog.finalizar_hablar_bot();
																					return false;
																				} else {
																					return MPlayBotDialog.getNode(linePicked.next_id);
																				}
																			};
								}
							}
						}
					}
					
					var opciones_arr = $.makeArray(opciones_por_padre);
					var opciones_parsed = [];
					$.each(opciones_arr, function(idxn, nod){
						if (nod != undefined){
							opciones_parsed.push(nod);
						}
					});
					opciones_parsed = $.makeArray(opciones_parsed);
					MPlayBotDialog.nodes = opciones_parsed;
					
					var currentNode = MPlayBotDialog.getNode('0');
					MPlayBotDialog.displayDialog(currentNode);
													
					$(ele).fadeIn(200);
					
					but.html(html_but).removeClass("disabled");
				} else {
					MPlayUI.Notificar("Error", data.response_text, 'error');
					but.html(html_but).removeClass("disabled");
				}
			});
		});
	} else {
		but.html(html_but).removeClass("disabled");
	}
	MPlayUI.buttonEvents();
  },
  finalizar_hablar_bot: function(){
	MPlayBotDialog.nodes = [];
	MPlayBotDialog.dialogo_activo = [];
	
	var jElementBot = $(this.attrHablarBot);
	if (jElementBot.length > 0) {
		jElementBot.each(function(idx, ele){
			var img_bot = $(ele).find('.mplay-ui-hablarbot-botavatar');
			var nombre_bot = $(ele).find('[data-mplay-hablarbot-name]');
			var props_bot = $(ele).find('[data-mplay-hablarbot-propiedades]');
			var screen_dialogo = $(ele).find("[data-mplay-hablarbot-dialogo]");
			
			$(ele).fadeOut(200, function(){
				MPlayUsuario.update_status_user(null, null, function(){
					MPlayMap.realtime.update();
				  });
				screen_dialogo.hide().html("");
			});
		});
	}
  }
};