var MPlayJuegos = {
	juegos_activos: {},
	juegos_completados: [],
	misiones_activas: {},
	misiones: {},
	init: function(){
		$.post(MPlay.config.base_url+"api/mplay/usuario/todosLosJuegos.json", { }, function(data){
			if (data.response == 'ok'){
				if ($.isArray(data.data.juegos)){
					$.each(data.data.juegos, function(idx, juego){
						if (juego.estado_juego == 'activo'){
							MPlayJuegos.start_game(juego);
							MPlayUI.Notificar("Juego iniciado", "Has comenzado el juego " + juego.nombre_juego, "info");
						} else if (juego.estado_juego == 'finalizado'){
							MPlayJuegos.add_completed_game(juego);
						}
					});
				}
				return false;
			} else {
				MPlayUI.Notificar("Error", data.response_text, 'error');
				return false;
			}
		});
	},
	update_active_games: function(){
		var juegos_ids = {};
		if (Object.keys(MPlayJuegos.juegos_activos).length > 0){
			for (i in MPlayJuegos.juegos_activos) {
				if (MPlayJuegos.juegos_activos.hasOwnProperty(i)) {
					juegos_ids[MPlayJuegos.juegos_activos[i]['timestamp_inicio']] = MPlayJuegos.juegos_activos[i]['id'];
				}
			}
		}
		var misiones_ids = {};
		if (Object.keys(MPlayJuegos.misiones_activas).length > 0){
			for (i in MPlayJuegos.misiones_activas) {
				if (MPlayJuegos.misiones_activas.hasOwnProperty(i)) {
					misiones_ids[MPlayJuegos.misiones_activas[i]['timestamp_inicio_mision']] = MPlayJuegos.misiones_activas[i]['id_mision'];
				}
			}
		}

		$.post(MPlay.config.base_url+"api/mplay/usuario/actualizarJuegosActivos.json", { ids: juegos_ids, ids_misiones: misiones_ids }, function(data){
			if (data.response == 'ok'){
				MPlayUsuario.update_status_user(null, null, function(){
					MPlayMap.realtime.update();
				  });
				return false;
			} else {
				MPlayUI.Notificar("Error", data.response_text, 'error');
				return false;
			}
		});
	},
	update_completed_games: function(){
		var juegos_ids = {};
		if (Object.keys(MPlayJuegos.juegos_completados).length > 0){
			for (i in MPlayJuegos.juegos_completados) {
				if (MPlayJuegos.juegos_completados.hasOwnProperty(i)) {
					juegos_ids[MPlayJuegos.juegos_completados[i]['timestamp_inicio']] = MPlayJuegos.juegos_completados[i]['id'];
				}
			}
		}

		$.post(MPlay.config.base_url+"api/mplay/usuario/actualizarJuegosCompletados.json", { ids: juegos_ids }, function(data){
			if (data.response == 'ok'){
				MPlayUsuario.update_status_user(null, null, function(){
					MPlayMap.realtime.update();
				  });
				return false;
			} else {
				MPlayUI.Notificar("Error", data.response_text, 'error');
				return false;
			}
		});
	},
	start_game: function(datos){
		if (datos.id_juego == undefined || datos.id_juego == ''){
			MPlayUI.Notificar("Datos de juego incorrectos","El juego no se puede iniciar porque los datos del juego no son correctos","error");
			return false;
		}
		if (MPlayJuegos.juegos_activos == undefined || MPlayJuegos.juegos_activos.length == 0){
			if (MPlayJuegos.juegos_activos == undefined){
				MPlayJuegos.juegos_activos = {};
			}
			if (MPlayJuegos.misiones_activas == undefined){
				MPlayJuegos.misiones_activas = {};
			}
			var modelo_juego = { id: datos.id_juego, nombre: datos.nombre_juego, descripcion: datos.descripcion_juego, icono: datos.icono_juego, tipo: datos.tipo_juego, estado: datos.estado_juego, instrucciones: datos.instrucciones_juego, propiedades: datos.propiedades_juego, misiones: datos.misiones_juego, mision_activa: datos.mision_activa, timestamp_inicio: datos.timestamp_inicio_juego };
			var id_juego = datos.id_juego;
			
			MPlayJuegos.juegos_activos[id_juego] = modelo_juego;
			MPlayJuegos.misiones_activas[modelo_juego.mision_activa.id_mision] = modelo_juego.mision_activa;
		} else {
			$.each(MPlayJuegos.juegos_activos, function(idx_j, ele_j){
				if (ele_j.id == datos.id_juego){
					MPlayUI.Notificar("Juego ya iniciado","Ya has comenzado a jugar a este juego","error");
					return false;
				}
			});
			if (MPlayJuegos.misiones_activas == undefined){
				MPlayJuegos.misiones_activas = {};
			}
			
			var modelo_juego = { id: datos.id_juego, nombre: datos.nombre_juego, descripcion: datos.descripcion_juego, icono: datos.icono_juego, tipo: datos.tipo_juego, estado: datos.estado_juego, instrucciones: datos.instrucciones_juego, propiedades: datos.propiedades_juego, misiones: datos.misiones_juego, mision_activa: datos.mision_activa, timestamp_inicio: datos.timestamp_inicio_juego };
			
			var id_juego = datos.id_juego;
			
			MPlayJuegos.juegos_activos[id_juego] = modelo_juego;
			MPlayJuegos.misiones_activas[modelo_juego.mision_activa.id_mision] = modelo_juego.mision_activa;
		}
		
		MPlayJuegos.update_active_games();
		
		MPlayJuegos.open_modal_game(modelo_juego);
		MPlayUI.add_to_missions(modelo_juego);
		
		MPlayJuegos.start_current_mission(modelo_juego.mision_activa);
	},
	add_completed_game: function(datos){
		if (datos.id_juego == undefined || datos.id_juego == ''){
			MPlayUI.Notificar("Datos de juego incorrectos","El juego no se puede añadir porque los datos del juego no son correctos","error");
			return false;
		}
		if (MPlayJuegos.juegos_completados == undefined || MPlayJuegos.juegos_completados.length == 0){
			if (MPlayJuegos.juegos_completados == undefined){
				MPlayJuegos.juegos_completados = {};
			}
			var modelo_juego = { id: datos.id_juego, nombre: datos.nombre_juego, descripcion: datos.descripcion_juego, icono: datos.icono_juego, tipo: datos.tipo_juego, estado: datos.estado_juego, instrucciones: datos.instrucciones_juego, propiedades: datos.propiedades_juego, misiones: datos.misiones_juego, timestamp_inicio: datos.timestamp_inicio_juego };
			var id_juego = datos.id_juego;
			
			MPlayJuegos.juegos_completados[id_juego] = modelo_juego;
		} else {
			$.each(MPlayJuegos.juegos_completados, function(idx_j, ele_j){
				if (ele_j != undefined && ele_j.id != undefined){
					if (ele_j.id == datos.id_juego){
						MPlayUI.Notificar("Juego ya añadido","Ya has añadido este juego","error");
						return false;
					}
				}
			});
			
			var modelo_juego = { id: datos.id_juego, nombre: datos.nombre_juego, descripcion: datos.descripcion_juego, icono: datos.icono_juego, tipo: datos.tipo_juego, estado: datos.estado_juego, instrucciones: datos.instrucciones_juego, propiedades: datos.propiedades_juego, misiones: datos.misiones_juego, timestamp_inicio: datos.timestamp_inicio_juego };
			
			var id_juego = datos.id_juego;
			
			MPlayJuegos.juegos_completados[id_juego] = modelo_juego;
		}
		
		MPlayJuegos.update_completed_games();
		
		MPlayUI.add_to_missions(modelo_juego);
		
	},
	game_completed: function(datos){
		if (datos.id_juego == undefined || datos.id_juego == ''){
			MPlayUI.Notificar("Datos de juego incorrectos","No se puede completar el juego porque los datos no son correctos","error");
			return false;
		}
		if (MPlayJuegos.juegos_activos[datos.id_juego] == undefined){
			MPlayUI.Notificar("Juego sin activar","No se puede completar el juego porque no está activo","error");
			return false;
		}
		
		$.post(MPlay.config.base_url+"api/mplay/usuario/juegoCompletado.json", { id_juego: datos.id_juego }, function(data){
			if (data.response == 'ok'){
				var respuesta = data.response_text;
				
				if (MPlayJuegos.juegos_completados == undefined){
					MPlayJuegos.juegos_completados = {};
				}
				
				MPlayJuegos.juegos_completados[datos.id_juego] = MPlayJuegos.juegos_activos[datos.id_juego];
				delete MPlayJuegos.juegos_activos[datos.id_juego];
				MPlayJuegos.update_active_games();
				MPlayJuegos.update_completed_games();
				MPlayUI.del_from_missions(datos.id_juego);
				MPlayUsuario.init_inventario($('body'));
				//MPlayUI.Notificar("Juego completado",respuesta, "success");
				MPlayJuegos.open_modal_game(data.data);
				return false;
			} else {
				MPlayUI.Notificar("Error", data.response_text, 'error');
				return false;
			}
		});
	},
	start_current_mission: function(datos){
		if (datos.id_mision == undefined || datos.id_mision == ''){
			MPlayUI.Notificar("Datos de misión incorrectos","La misión no se puede iniciar porque los datos de la misión no son correctos","error");
			return false;
		}
		
		$.post(MPlay.config.base_url+"api/mplay/usuario/comenzarMision.json", { datos: datos }, function(data){
			if (data.response == 'ok'){
				var datos_proc = data.data;
				var jsfunc = datos_proc.propiedades_mision.jsfunc + '(datos_proc);';
				
				if (jsfunc == undefined || jsfunc == ' (datos_proc);'){
					MPlayUI.Notificar("Función incorrecta","La función JS de la misión no existe","error");
					return false;
				}
				eval(jsfunc);
				MPlayUsuario.update_status_user(null, null, function(){
					MPlayMap.realtime.update();
				  });
				return false;
			} else {
				MPlayUI.Notificar("Error", data.response_text, 'error');
				return false;
			}
		});
	},
	start_next_mission: function(datos){
		if (datos.id_mision == undefined || datos.id_mision == '' || datos.id_juego == undefined || datos.id_juego == ''){
			MPlayUI.Notificar("Datos de misión incorrectos","No se puede cargar la siguiente misión porque los datos no son correctos","error");
			return false;
		}
		if (MPlayJuegos.misiones_activas[datos.id_mision] == undefined){
			MPlayUI.Notificar("Misión sin activar","No se puede cargar la siguiente misión porque la misión actual no está activa","error");
			return false;
		}
		if (MPlayJuegos.juegos_activos[datos.id_juego] == undefined){
			MPlayUI.Notificar("Juego sin activar","No se puede cargar la siguiente misión porque el juego actual no está activo","error");
			return false;
		}
		var new_mission = {};
		var next = false;
		$.each(MPlayJuegos.juegos_activos[datos.id_juego]['misiones'], function(key, value){
			if (next == true){
				new_mission = value;
				new_mission.timestamp_inicio_mision = Math.floor(Date.now() / 1000);
				return false;
			}
			if (value.id_mision == datos.id_mision){
				next = true;
			}
		});
		delete MPlayJuegos.misiones_activas[datos.id_mision];
		if (new_mission.id_mision == undefined){
			MPlayJuegos.juegos_activos[datos.id_juego]['mision_activa'] = false;
			MPlayJuegos.game_completed(datos);
			if (MPlayMap.marker_missions[datos.id_mision] != undefined){
				MPlayMap.map.removeLayer(MPlayMap.marker_missions[datos.id_mision]);
				delete MPlayMap.marker_missions[datos.id_mision];
			}
			MPlayJuegos.update_active_games();
			MPlayJuegos.update_completed_games();
			return false;
		} else {
			MPlayJuegos.juegos_activos[datos.id_juego]['mision_activa'] = new_mission;
			MPlayJuegos.misiones_activas[new_mission.id_mision] = new_mission;
			if (MPlayMap.marker_missions[datos.id_mision] != undefined){
				MPlayMap.map.removeLayer(MPlayMap.marker_missions[datos.id_mision]);
				delete MPlayMap.marker_missions[datos.id_mision];
			}
		}
					
		MPlayJuegos.update_active_games();
		MPlayJuegos.update_completed_games();
		
		MPlayUI.add_to_missions(MPlayJuegos.juegos_activos[datos.id_juego]);
		
		MPlayJuegos.start_current_mission(new_mission);
	},
	mission_completed: function(datos){
		if (datos.id_mision == undefined || datos.id_mision == ''){
			MPlayUI.Notificar("Datos de misión incorrectos","La misión no se puede completar porque los datos de la misión no son correctos","error");
			return false;
		}
		
		$.post(MPlay.config.base_url+"api/mplay/usuario/misionCompletada.json", { id_mision: datos.id_mision, fecha_inicio_mision: datos.timestamp_inicio_mision }, function(data){
			if (data.response == 'ok'){
				MPlayJuegos.start_next_mission(data.data);
				MPlayUsuario.init_inventario($('body'));
				MPlayUsuario.update_status_user(null, null, function(){
					MPlayMap.realtime.update();
				  });
				MPlayUI.Notificar("Misión completada","Enhorabuena, has completado la misión "+datos.nombre_mision, "success");
				return false;
			} else {
				MPlayUI.Notificar("Error", data.response_text, 'error');
				return false;
			}
		});
	},
	mission_expired: function(datos){
		if (datos.id_mision == undefined || datos.id_mision == ''){
			MPlayUI.Notificar("Datos de misión incorrectos","La misión no se puede completar porque los datos de la misión no son correctos","error");
			return false;
		}
		
		MPlayJuegos.cancel_game(datos.juego_mision);
		
		MPlayUI.Notificar("Se acabó el tiempo","No te ha dado tiempo a completar la misión "+datos.nombre_mision, "error");
	},
	stop_current_mission: function(idm, func){
		if (idm == undefined || idm == ''){
			MPlayUI.Notificar("Datos de misión incorrectos","La misión no se puede cancelar porque los datos de la misión no son correctos","error");
			return false;
		}
		
		var jsfunc = func + 'Del(idm);';
		if (jsfunc == undefined || jsfunc == ' Del(idm);'){
			MPlayUI.Notificar("Función incorrecta","La función JS de la misión no existe","error");
			return false;
		}
		
		eval(jsfunc);
		
		MPlayUsuario.update_status_user(null, null, function(){
			MPlayMap.realtime.update();
		  });
		
		if (MPlayJuegos.misiones_activas[idm] != undefined){
			delete MPlayJuegos.misiones_activas[idm];
		}
	},
	cancel_game: function(idj){
		if (idj == undefined || idj == ''){
			MPlayUI.Notificar("Datos de juego incorrectos","El juego no se puede cancelar porque los datos del juego no son correctos","error");
			return false;
		}
		
		if (MPlayJuegos.juegos_activos == undefined || MPlayJuegos.juegos_activos.length == 0){
			MPlayUI.Notificar("Juego no iniciado","El juego no se puede cancelar porque aun no has empezado a jugarlo","error");
			return false;
		} else {
			if (MPlayJuegos.juegos_activos[idj] != undefined){
				MPlayJuegos.stop_current_mission(MPlayJuegos.juegos_activos[idj]['mision_activa']['id_mision'], MPlayJuegos.juegos_activos[idj]['mision_activa']['propiedades_mision']['jsfunc']);
				
				if (MPlayMap.marker_missions[MPlayJuegos.juegos_activos[idj]['mision_activa']['id_mision']] != undefined){
					MPlayMap.map.removeLayer(MPlayMap.marker_missions[MPlayJuegos.juegos_activos[idj]['mision_activa']['id_mision']]);
					delete MPlayMap.marker_missions[MPlayJuegos.juegos_activos[idj]['mision_activa']['id_mision']];
				}
				
				delete MPlayJuegos.juegos_activos[idj];
				MPlayUI.del_from_missions(idj);
				MPlayJuegos.update_active_games();
				MPlayJuegos.update_completed_games();
				return false;
			} else {
				MPlayUI.Notificar("Juego no encontrado","No hemos encontrado el juego que quieres cancelar","error");
				return false;
			}				
		}
	},
	open_modal_game: function(datos){
		if (datos.id == undefined || datos.id == ''){
			MPlayUI.Notificar("Datos de juego incorrectos","El juego no se puede iniciar porque los datos del juego no son correctos","error");
			return false;
		}
		
		var mdl_game = $('#mdl-info-game');
		mdl_game.find('[data-mplay-gameinfo-recompensas]').hide();
		mdl_game.find('[data-mplay-gameinfo-nombre]').html(datos.nombre);
		mdl_game.find('[data-mplay-gameinfo-descripcion]').html(datos.descripcion);
		mdl_game.find('[data-mplay-gameinfo-icono]').attr("src",datos.icono);
		mdl_game.find('[data-mplay-gameinfo-instrucciones]').html(datos.instrucciones);
		
		mdl_game.find('[data-mplay-gameinfo-misiones]').html('');
		
		var mision_encontrada = false;
		
		$.each(datos.misiones, function(idx_m, ele_m){
			if (mision_encontrada == false){
				if (datos.mision_activa != undefined && datos.mision_activa.id_mision != undefined && ele_m.id_mision == datos.mision_activa.id_mision){
					mision_encontrada = true;
					var cls_mision = 'mplay-mision-activa';
				} else {
					var cls_mision = 'mplay-mision-completada';
				}
				
				mdl_game.find('[data-mplay-gameinfo-misiones]').append('<div data-mplay-gameinfo-mision><h6 class="'+cls_mision+'"><a href="javascript:;">'+ele_m.descripcion_corta_mision+'</a></h6></div>');
			} else {
				var cls_mision = 'mplay-mision-pendiente';
				
				mdl_game.find('[data-mplay-gameinfo-misiones]').append('<div data-mplay-gameinfo-mision><h6 class="'+cls_mision+'">'+ele_m.descripcion_corta_mision+'</h6></div>');
			}
		});
		
		if (datos.recompensas != undefined && datos.recompensas != ''){
			mdl_game.find('[data-mplay-gameinfo-recompensas]').find('.mplay-recompensas-cont').html(datos.recompensas);
			mdl_game.find('[data-mplay-gameinfo-recompensas]').show();
		}
		
		MPlayUI.buttonEvents();
		
		mdl_game.modal('show');
	}
};