// MPlay Map
var MPlayMap = {
	map: "",
	marker: "",
	icon: "",
	icon_walk: "",
	viewRange: "",
	interactRange: "",
	checkboxes_filtro: [],
	en_camino: false,
	destino_lat: null,
	destino_lng: null,
	destino_distancia: null,
	destino_velocidad: null,
	destino_tiempo: null,
	realtime: null,
	maxBounds: null,
	maxZoom: null,
	minZoom: null,
	marker_missions: [],
	destinationPoint: function(mk, brng, dist) {
	   dist = ( dist * 0.001 ) / 6371;  
	   brng = parseInt(brng).toRad();  
	
	   var lat1 = mk.lat.toRad(), lon1 = mk.lng.toRad();
	
	   var lat2 = Math.asin(Math.sin(lat1) * Math.cos(dist) + 
							Math.cos(lat1) * Math.sin(dist) * Math.cos(brng));
	
	   var lon2 = lon1 + Math.atan2(Math.sin(brng) * Math.sin(dist) *
									Math.cos(lat1), 
									Math.cos(dist) - Math.sin(lat1) *
									Math.sin(lat2));
	
	   if (isNaN(lat2) || isNaN(lon2)) return null;
	
	   return new L.LatLng(lat2.toDeg(), lon2.toDeg());
	},
	timer: function(){
		if(MPlayMap.destino_tiempo_restante > 0) {
			MPlayMap.destino_tiempo_restante = MPlayMap.destino_tiempo_restante - 1;

			 var date = new Date(null);
			 date.setSeconds(MPlayMap.destino_tiempo_restante); 
			 $('[data-mplay-encamino-tiempo]').html(date.toISOString().substr(11, 8));
		}
	  else
		{
		  $('.mplay-ui-encamino').fadeOut(200);
		  $("#mplay-ui-btn-geolocation").removeClass("disabled");
		  MPlayUI.Notificar("Viaje completado", "Has llegado al destino", "info");
		  clearInterval(MPlayMap.timerEnCamino);
		}
	},
	mover_jugador: function(e){
		if (MPlayMap.en_camino == true){
			return false;
		}
		
		var orig_coords = L.latLng(parseFloat(MPlayUsuario.lat), parseFloat(MPlayUsuario.lng));
				
		var bounds = MPlayMap.maxBounds;
		if (bounds != undefined && bounds != null & bounds != ''){
			if (!bounds.contains(e)){
				MPlayMap.marker.setLatLng(orig_coords);
				MPlayUI.Notificar("Fuera de los límites", "No puedes moverte a ese punto porque está fuera de los límites del juego");
				return false;
			}
		}
		
		var velocidad_movimiento = MPlayUsuario.usuario_activo.velocidad;
		
		var loadIcon = L.AwesomeMarkers.icon({
			icon: 'spinner fa-spin',
			markerColor: 'yellow',
			prefix: 'fa',
			className: 'awesome-marker mplay-ui-iconmap-destination animated flash'
		});
		
		var loadMarker = L.marker(e, {
			icon: loadIcon,
			draggable: false,
			clickable: false
		}).addTo(MPlayMap.map);
		
		$.post(MPlay.config.base_url + "api/mplay/usuario/rutaOSRM.json", { lat1: MPlayUsuario.lat, lng1: MPlayUsuario.lng, lat2: e.lat, lng2: e.lng }, function (data1){
			if (!data1.data){
				MPlayMap.map.removeLayer(loadMarker);
				MPlayUI.Notificar("Error al calcular la ruta", "No se ha encontrado un sistema de cálculo de rutas.", "error");
				return false;
			}
			var data = $.parseJSON(data1.data);
			
			if (data.route_instructions == undefined){
				MPlayMap.map.removeLayer(loadMarker);
				MPlayUI.Notificar("Error al calcular la ruta", data.message, "error");
				return false;
			}
		  MPlayMap.en_camino = true;
		  MPlayMap.destino_lat = e.lat;
		  MPlayMap.destino_lng = e.lng;
		  
		  var distancia_total = 0;
		  $.each(data.route_instructions, function(idx, ele){
			  distancia_total = distancia_total + ele[2];
		  });
		  
		  MPlayMap.map.removeLayer(loadMarker);
		  
		  var destIcon = L.AwesomeMarkers.icon({
			icon: 'map-marker',
			markerColor: 'green',
			prefix: 'fa',
			className: 'awesome-marker mplay-ui-iconmap-destination animated flash'
		});
		
		var destMarker = L.marker([MPlayMap.destino_lat, MPlayMap.destino_lng], {
			icon: destIcon,
			draggable: false,
			clickable: false
		}).addTo(MPlayMap.map);

		  // OSRM polyline decoding w/ https://github.com/jieter/Leaflet.encoded
		  route = new L.Polyline(L.PolylineUtil.decode(data.route_geometry, 6), {
			  color: 'green',
			  weight: 5,
			  opacity: 1,
			  smoothFactor: 1
		  });
		  
		  MPlayMap.destino_distancia = data.route_summary.total_distance / 1000;
		  MPlayMap.destino_velocidad = (velocidad_movimiento * 3600) / 1000;
		
		  MPlayMap.destino_tiempo = MPlayMap.destino_distancia / MPlayMap.destino_velocidad;
					  
		  var animatedMarker = L.animatedMarker(route.getLatLngs(), { 
			distance: velocidad_movimiento, 
			interval: 1000, 
			icon: MPlayMap.icon_walk,
			autoStart: false,
			onAnimation: function(){
				MPlayMap.marker.setLatLng(this._latlng);
				MPlayMap.map.setView(this._latlng);
				
				if ($("#mplay-ui-btn-showvisiblerange").hasClass('active')){
					MPlayMap.viewRange.setLatLng(this._latlng);
				}
				
				if ($("#mplay-ui-btn-showinteractrange").hasClass('active')){
					MPlay.interactRange.setLatLng(this._latlng);
				}
				
				MPlayUsuario.geolocation_activa = 0;
				
				MPlayUsuario.update_status_user(this._latlng.lat, this._latlng.lng, function(){
					MPlayMap.realtime.update();
				});
				
				if ($("#mplay-ui-btn-geolocation").hasClass('active')){
					MPlayMap.map.stopLocate();
					$("#mplay-ui-btn-geolocation").removeClass('active');
				}
			},
			onEnd: function(){ 
				$(this._shadow).hide();
				$(this._icon).hide(function(){
				  MPlayMap.map.removeLayer(this);
				  MPlayMap.map.removeLayer(route);
				  MPlayMap.map.removeLayer(destMarker);
				  MPlayMap.marker.setLatLng(e);
				  MPlayMap.marker._icon.style.display="block";
				  MPlayUsuario.lat = e.lat;
				  MPlayUsuario.lng = e.lng;
				  MPlayMap.map.setView(e);
				  
				  if ($("#mplay-ui-btn-showvisiblerange").hasClass('active')){
					MPlayMap.viewRange.setLatLng(e);
				  }
					
				  if ($("#mplay-ui-btn-showinteractrange").hasClass('active')){
					MPlay.interactRange.setLatLng(e);
				  }
				  
				  MPlayUsuario.geolocation_activa = 0;
					
				  MPlayUsuario.update_status_user(e.lat, e.lng, function(){
					MPlayMap.realtime.update();
				  });
				  
				  MPlayMap.en_camino = false;
				  MPlayMap.destino_lat = null;
				  MPlayMap.destino_lng = null;
				  MPlayMap.destino_distancia = null;
				  MPlayMap.destino_velocidad = null;
				  MPlayMap.destino_tiempo = null;
				});
			}
		  });
		  
		  MPlayMap.map.addLayer(route);
		  
		  MPlayMap.map.addLayer(animatedMarker);
		  
		  MPlayMap.marker._icon.style.display="none";
		  
		  MPlayMap.init_encamino(MPlayMap.map, route, animatedMarker, MPlayMap.marker, destMarker);
		});
	},
	init_mapa: function (contenedor_jq, onEnd){
		if (MPlay.config.opciones.general.musica_inicial != ""){
			MPlayUI.playMusic(MPlay.config.opciones.general.musica_inicial);
		}
		
		L.Icon.Default.imagePath = 'http://api.tiles.mapbox.com/mapbox.js/v1.0.0beta0.0/images';
		
		var jElement = contenedor_jq.find("[data-mplay-mapa]");
		
		if (jElement.length > 0) {
			jElement.each(function (idx, ele) {
				var icono_map_sitio = $(ele).data("icono");
				var contenido_map_sitio = $(ele).data("contenido");
				var label_map_sitio = $(ele).data("label");
				var icono_color_map_sitio = $(ele).data("icono-color");
				var longitud_map_sitio = $(ele).data("longitud");
				var latitud_map_sitio = $(ele).data("latitud");
				var zoom_map_sitio = $(ele).data("zoom");
				var estilo_mapa = $(ele).data("estilo-mapa");
				var tipo_mapa = $(ele).data("tipo-mapa");
				var bounds_mapa = $(ele).data("bounds");
				var minzoom_mapa = $(ele).data("minzoom");
				var maxzoom_mapa = $(ele).data("maxzoom");
				var es_we = false;
				
				if(tipo_mapa == 'earth') {
					var base_var = WE;
					es_we = true;
				} else {
					var base_var = L;
				}
				
				if (estilo_mapa == undefined || estilo_mapa == '') {
					estilo_mapa = 'http://{s}.tile.cloudmade.com/1a1b06b230af4efdbb989ea99e9841af/998/256/{z}/{x}/{y}.png';
				}
				
				if (zoom_map_sitio == undefined || zoom_map_sitio == '') {
					zoom_map_sitio = 10;
				}
				
				var cm_items = [{ text: 'Moverse aquí', callback: moverjugador_context }];
				
				if (MPlayUsuario.usuario_activo.es_admin == "1"){
					cm_items.push({ text: 'Crear aquí', callback: crearelemento_context });
				}
				
				var opts_map = { zoomControl: false, contextmenu: true, contextmenuWidth: 140, contextmenuItems: cm_items};
				
				if (bounds_mapa != undefined && bounds_mapa != ''){
					var bounds_arr = bounds_mapa.split(',');
					if (bounds_arr.length == 4){
						var sw = L.latLng(bounds_arr[1], bounds_arr[0]),
							ne = L.latLng(bounds_arr[3], bounds_arr[2]);
							
						MPlayMap.maxBounds = L.latLngBounds(sw, ne);
						opts_map.maxBounds = MPlayMap.maxBounds;
						opts_map.center = MPlayMap.maxBounds.getCenter();
					}
				}
				
				if (maxzoom_mapa != undefined && maxzoom_mapa != ''){
					opts_map.maxZoom = maxzoom_mapa;
					MPlayMap.maxZoom = maxzoom_mapa;
				}
				
				if (minzoom_mapa != undefined && minzoom_mapa != ''){
					opts_map.minZoom = minzoom_mapa;
					MPlayMap.minZoom = minzoom_mapa;
				}
				
				if (tipo_mapa == 'earth'){
					var opts_map = {atmosphere:true, sky:true};
					MPlayMap.map = WE.map($(ele).attr("id"), opts_map);
					
					MPlayMap.map.on("load", function(ex) {
						if (MideasFunciones.isFunction(onEnd)){
							$('body').fadeIn(0, onEnd);
						}
						MPlayMap.after_map_loaded();
					});
					
					MPlayMap.map.setView(new L.LatLng(latitud_map_sitio, longitud_map_sitio), zoom_map_sitio);
				} else {
					MPlayMap.map = L.map($(ele).attr("id"), opts_map);
					
					MPlayMap.map.on("load", function(ex) {
						if (MideasFunciones.isFunction(onEnd)){
							$('body').fadeIn(0, onEnd);
						}
						MPlayMap.after_map_loaded();
					});
					
					MPlayMap.map.setView(new L.LatLng(latitud_map_sitio, longitud_map_sitio), zoom_map_sitio);
				}
				
				/*var ggls = new L.Google('ROADMAP');
				MPlayMap.map.addLayer(ggls);*/
				
				if (estilo_mapa.substr(0, 16) == "http://oatile{s}") {
					base_var.tileLayer(estilo_mapa, {
						subdomains: '1234',
						attribution: '',
						//maxZoom: zoom_map_sitio
					}).addTo(MPlayMap.map);
				} else {
					base_var.tileLayer(estilo_mapa, {
						attribution: ''
					}).addTo(MPlayMap.map);
				}
				
				if (MPlayMap.maxBounds != null){
					var rect_fog = L.rectangle(MPlayMap.maxBounds, {color: "red", weight: 5, stroke: true, opacity: 0.5, fillOpacity: 0, clickable: false, className: 'mplay-fogofwar'}).addTo(MPlayMap.map);
					rect_fog._path.id = "pathFog";
				}
				
				var ancho_icon = parseInt(MPlay.config.opciones.usuario.ancho_player);
				var alto_icon = parseInt(MPlay.config.opciones.usuario.alto_player);
				
				var ancho_icon_half = parseInt(ancho_icon / 2);
				var alto_icon_half = parseInt(alto_icon / 2);
								
				var clase_icon = MPlay.config.opciones.usuario.clase_img_player;
				var clase_icon_txt = '';
				if (clase_icon != undefined && clase_icon != ""){
					clase_icon_txt = ' class="'+clase_icon+'"';
				}
				
				MPlayMap.icon = L.divIcon({
					iconUrl: icono_map_sitio,
					iconSize: [ancho_icon, alto_icon],
					iconAnchor: [ancho_icon_half, alto_icon],
					popupAnchor: [0, -alto_icon],
					labelAnchor: [ancho_icon_half + 2, -alto_icon_half],
					html: '<div class="marker-img"><img'+clase_icon_txt+' src="'+icono_map_sitio+'" /></div>',
					className: 'mplay-ui-iconmap-user'
				});
				
				MPlayMap.icon_walk = L.divIcon({
					iconUrl: icono_map_sitio,
					iconSize: [ancho_icon, alto_icon],
					iconAnchor: [ancho_icon_half, alto_icon],
					popupAnchor: [0, -alto_icon],
					labelAnchor: [ancho_icon_half + 2, -alto_icon_half],
					html: '<div class="marker-img"><img'+clase_icon_txt+' src="'+icono_map_sitio+'" /></div>',
					className: 'mplay-ui-iconmap-user animated infinite flash'
				});
				
				var cutomMarker = L.AwesomeMarkers.icon({
							icon: icono_map_sitio,
							markerColor: icono_color_map_sitio
						});
				MPlayMap.marker = base_var.marker([latitud_map_sitio, longitud_map_sitio], {
							icon: MPlayMap.icon,
							draggable: true/*,
							bounceOnAdd: true,
							bounceOnAddOptions: {duration: 500, height: 100},
							bounceOnAddCallback: function() {console.log("done");}*/
						}).addTo(MPlayMap.map).bindPopup("" + contenido_map_sitio + "", { className: 'mplay-popup' });
						
				if (tipo_mapa != "earth"){
					MPlayMap.marker.bindLabel("" + label_map_sitio + "");
				}
				
				MPlay.init_functions(contenedor_jq);
				
				// every time the marker is dragged, update the coordinates container
				MPlayMap.marker.on('dragend', ondragend);
				
				// Set the initial marker coordinate on load.
				//ondragend();
				
				function ondragend() {
					var m = MPlayMap.marker.getLatLng();
					
					MPlayMap.mover_jugador(m);
				}
				
				function moverjugador_context(e){
					var m = new L.LatLng(e.latlng.lat, e.latlng.lng);
					
					MPlayMap.mover_jugador(m);
				}
				
				function crearelemento_context(e){
					console.debug(e);
					bootbox.alert("Coordenadas elegidas: "+e.latlng.lat+", "+e.latlng.lng+"<br>Continuar aquí con el desarrollo del admin");
				}
				
				var id_map = "#" + $(ele).attr("id");
				
				MPlayMap.map.on("locationfound", function(location) {
					if (!MPlayMap.marker)
						MPlayMap.marker = L.marker(location.latlng, {icon: MPlayMap.icon}).addTo(MPlayMap.map);
					
					MPlayMap.marker.setLatLng(location.latlng);
					
					if ($("#mplay-ui-btn-showvisiblerange").hasClass('active')){
						MPlayMap.viewRange.setLatLng(location.latlng);
					}
					
					if ($("#mplay-ui-btn-showinteractrange").hasClass('active')){
						MPlay.interactRange.setLatLng(location.latlng);
					}
					
					MPlayUsuario.geolocation_activa = 1;
										
					MPlayUsuario.update_status_user(location.latlng.lat, location.latlng.lng, function(){
						MPlayMap.realtime.update();
					  });
				});
				
				MPlayMap.map.on("locationerror", function(error){
					MPlayUI.Notificar("Error", "No se ha encontrado la geolocalización del jugador: " + error.message, "error");
				});
				
				if (!$("#mplay-ui-btn-geolocation").hasClass('active')){
					if (!MPlayMap.marker)
						MPlayMap.marker = L.marker( [ MPlayUsuario.usuario_activo.actividad.latitud, MPlayUsuario.usuario_activo.actividad.longitud ], {icon: MPlayMap.icon}).addTo(MPlayMap.map);
					
					MPlayMap.marker.setLatLng([ MPlayUsuario.usuario_activo.actividad.latitud, MPlayUsuario.usuario_activo.actividad.longitud ]);
					
					if ($("#mplay-ui-btn-showvisiblerange").hasClass('active')){
						MPlayMap.viewRange.setLatLng([ MPlayUsuario.usuario_activo.actividad.latitud, MPlayUsuario.usuario_activo.actividad.longitud ]);
					}
					
					if ($("#mplay-ui-btn-showinteractrange").hasClass('active')){
						MPlay.interactRange.setLatLng( [ MPlayUsuario.usuario_activo.actividad.latitud, MPlayUsuario.usuario_activo.actividad.longitud ] );
					}
					
					MPlayUsuario.geolocation_activa = 0;
					
					MPlayUsuario.update_status_user(MPlayUsuario.usuario_activo.actividad.latitud, MPlayUsuario.usuario_activo.actividad.longitud, function(){
						MPlayMap.realtime.update();
					});
				} else {
					MPlayMap.map.locate({
						watch: true,
						locate: true,
						setView: true,
						enableHighAccuracy: true
					});
					$("#mplay-ui-btn-geolocation").removeClass('active').addClass('active');
				}
				
				$("#mplay-ui-btn-geolocation").click(function() {
					var este = $(this);
					if (este.hasClass('active')){
						MPlayUsuario.geolocation_activa = 0;
						MPlayMap.map.stopLocate();
						este.removeClass('active');
					} else {
						MPlayMap.map.locate({
							watch: true,
							locate: true,
							setView: true,
							enableHighAccuracy: true
						});
						este.removeClass('active').addClass('active');
					}
					return false;
				});
				
				$("#mplay-ui-btn-showvisiblerange").click(function() {
					var este = $(this);
					if (este.hasClass('active')){
						MPlayMap.map.removeLayer(MPlayMap.viewRange);
						este.removeClass('active');
					} else {
						var m = MPlayMap.marker.getLatLng();
						MPlayMap.viewRange  = L.circle(m, MPlayUsuario.usuario_activo.rango_vision * 1000, { color: 'blue', fillColor: '#03f', fillOpacity: 0.5, clickable: false }).addTo(MPlayMap.map)
						este.removeClass('active').addClass('active');
					}
					return false;
				});
				
				$("#mplay-ui-btn-showinteractrange").click(function() {
					var este = $(this);
					if (este.hasClass('active')){
						MPlayMap.map.removeLayer(MPlay.interactRange);
						este.removeClass('active');
					} else {
						var m = MPlayMap.marker.getLatLng();
						MPlay.interactRange  = L.circle(m, MPlayUsuario.usuario_activo.rango_interaccion * 1000, { color: 'red', fillColor: '#f03', fillOpacity: 0.5, clickable: false }).addTo(MPlayMap.map)
						este.removeClass('active').addClass('active');
					}
					return false;
				});
				
				if (tipo_mapa != "earth"){						
					MPlayMap.realtime = L.realtime({
						url: MPlay.config.base_url + 'api/mplay/usuario/usuariosCercanos.json/',
						type: 'json'
					}, {
						pointToLayer: function (feature, latlng) {
							var ancho_icono = 64;
							var alto_icono = 64;
							if (feature.properties.ancho_icono != undefined && feature.properties.alto_icono != undefined){
								ancho_icono = feature.properties.ancho_icono;
								alto_icono = feature.properties.alto_icono;
							}
							var mitad_ancho_icono = parseInt(ancho_icono / 2);
							var mitad_alto_icono = parseInt(alto_icono / 2);
							
							if (feature.properties.tipo == 'item'){
								var MyIconCustom = L.divIcon({
									iconUrl: feature.properties.imagen,
									iconSize: [ancho_icono, alto_icono],
									iconAnchor: [mitad_ancho_icono, alto_icono],
									popupAnchor: [0, alto_icono * (-1)],
									labelAnchor: [mitad_ancho_icono + 2, mitad_alto_icono * (-1)],
									html: '<div class="marker-img"><img src="'+feature.properties.imagen+'" /></div>',
									className: 'mplay-ui-iconmap-item'
								});
							} else if (feature.properties.tipo == 'juego') {
								var MyIconCustom = L.divIcon({
									iconUrl: feature.properties.imagen,
									iconSize: [ancho_icono, alto_icono],
									iconAnchor: [mitad_ancho_icono, alto_icono],
									popupAnchor: [0, alto_icono * (-1)],
									labelAnchor: [mitad_ancho_icono + 2, mitad_alto_icono * (-1)],
									html: '<div class="marker-img"><img src="'+feature.properties.imagen+'" /></div>',
									className: 'mplay-ui-iconmap-game'
								});
							} else if (feature.properties.tipo == 'sitio') {													
								var MyIconCustom = L.divIcon({
									iconUrl: feature.properties.imagen,
									iconSize: [ancho_icono, alto_icono],
									iconAnchor: [mitad_ancho_icono, alto_icono],
									popupAnchor: [0, alto_icono * (-1)],
									labelAnchor: [mitad_ancho_icono + 2, mitad_alto_icono * (-1)],
									html: '<div class="marker-img"><img src="'+feature.properties.imagen+'" /></div>',
									className: 'mplay-ui-iconmap-place'
								});
							} else if (feature.properties.tipo == 'bot') {
								var MyIconCustom = L.divIcon({
									iconUrl: feature.properties.imagen,
									iconSize: [ancho_icono, alto_icono],
									iconAnchor: [mitad_ancho_icono, alto_icono],
									popupAnchor: [0, alto_icono * (-1)],
									labelAnchor: [mitad_ancho_icono + 2, mitad_alto_icono * (-1)],
									html: '<div class="marker-img"><img src="'+feature.properties.imagen+'" /></div>',
									className: 'mplay-ui-iconmap-bot'
								});
							} else if (feature.properties.tipo == 'casa') {
								var MyIconCustom = L.divIcon({
									iconUrl: feature.properties.imagen,
									iconSize: [ancho_icono, alto_icono],
									iconAnchor: [mitad_ancho_icono, alto_icono],
									popupAnchor: [0, alto_icono * (-1)],
									labelAnchor: [mitad_ancho_icono + 2, mitad_alto_icono * (-1)],
									html: '<div class="marker-img"><img src="'+feature.properties.imagen+'" /></div>',
									className: 'mplay-ui-iconmap-home'
								});
							} else {
								var MyIconCustom = L.divIcon({
									iconUrl: feature.properties.imagen,
									iconSize: [ancho_icono, alto_icono],
									iconAnchor: [mitad_ancho_icono, alto_icono],
									popupAnchor: [0, alto_icono * (-1)],
									labelAnchor: [mitad_ancho_icono + 2, mitad_alto_icono * (-1)],
									html: '<div class="marker-img"><img src="'+feature.properties.imagen+'" /></div>',
									className: 'mplay-ui-iconmap-friend'
								});
							}
							
							MPlayUI.buttonEvents();
							
							return L.marker(feature.geometry.coordinates, {icon: MyIconCustom});
						},
						interval: MPlay.config.opciones.mapa.tiempo_refresco * 1000,
						getFeatureId: function(f) { return f.id; }
					}).addTo(MPlayMap.map);
					
					MPlayMap.realtime.on('update', function(e) {
						var popupContent = function(fId) {
								var feature = e.features[fId];
								return feature.properties.content;
							},
							bindFeaturePopup = function(fId) {
								MPlayMap.realtime.getLayer(fId).bindPopup(popupContent(fId), { className: 'mplay-popup' });
							},
							updateFeaturePopup = function(fId) {
								MPlayMap.realtime.getLayer(fId).getPopup().setContent(popupContent(fId));
							};
							
						var labelContent = function(fId) {
								var feature = e.features[fId];
								return feature.properties.nombre + ' - ' +
									feature.properties.distancia;
							},
							bindFeatureLabel = function(fId) {
								MPlayMap.realtime.getLayer(fId).bindLabel(labelContent(fId));
							},
							updateFeatureLabel = function(fId) {
								MPlayMap.realtime.getLayer(fId).getLabel().setContent(labelContent(fId));
							};
							
						  $("#filters_map").html('');
						  MPlayMap.checkboxes_filtro = [];
						  
						  // Collect the types of symbols in this layer. you can also just
						  // hardcode an array of types if you know what you want to filter on,
						  // like var types = ['foo', 'bar'];
						  var typesObj = {}, types = [];
						  MPlayMap.features = [];
						  MPlayMap.featuresLayers = [];
						  $.each(e.enter, function(idx, elem){
							  MPlayMap.features.push(elem);
							  MPlayMap.featuresLayers.push(MPlayMap.realtime.getLayer(elem.id));
						  });
						  $.each(e.update, function(idx, elem){
							  MPlayMap.features.push(elem);
							  MPlayMap.featuresLayers.push(MPlayMap.realtime.getLayer(elem.id));
						  });
						  for (var i = 0; i < MPlayMap.features.length; i++) {
							typesObj[MPlayMap.features[i].properties['tipo']] = true;
						  }
						  for (var k in typesObj) types.push(k);
							
						  // Create a filter interface.
						  for (var i = 0; i < types.length; i++) {
							// Create an an input checkbox and label inside.
							if ($("#filters_map").find("#"+types[i]).length == 0){
								$("#filters_map").append('<label class="btn btn-primary btn-block active"><input type="checkbox" checked="checked" id="'+types[i]+'" /> '+types[i]+'</label>');
								var checkbox = $("#filters_map").find("#"+types[i]);
								// Whenever a person clicks on this checkbox, call the update().
								checkbox.on('change', update_filter);
								MPlayMap.checkboxes_filtro.push(checkbox);
							}
						  }
													
						  // This function is called whenever someone clicks on a checkbox and changes
						  // the selection of markers to be displayed.
						  function update_filter() {
							var enabled = {};
							// Run through each checkbox and record whether it is checked. If it is,
							// add it to the object of types to display, otherwise do not.
							for (var i = 0; i < MPlayMap.checkboxes_filtro.length; i++) {
							  if (MPlayMap.checkboxes_filtro[i].is(":checked")) enabled[MPlayMap.checkboxes_filtro[i].attr('id')] = true;
							}
							for (var i = 0; i < MPlayMap.features.length; i++){
								var feature = MPlayMap.features[i];
								if (feature.properties['tipo'] in enabled){
									MPlayMap.map.addLayer(MPlayMap.featuresLayers[i]);
								} else {
									MPlayMap.map.removeLayer(MPlayMap.featuresLayers[i]);
								}
							}
						  }
													  
						Object.keys(e.enter).forEach(bindFeaturePopup);
						Object.keys(e.update).forEach(updateFeaturePopup);
						
						Object.keys(e.enter).forEach(bindFeatureLabel);
						Object.keys(e.update).forEach(updateFeatureLabel);
						
						MPlaySitio.init_comerciar($('body'));
						
						if (MPlayUI.loader_max > 0){
							MPlayUI.inc_loader($('body'), 1);
						}
						
						$(id_map).off("click", ".mplay-popup-optbtn-getitem");
						$(id_map).on("click", ".mplay-popup-optbtn-getitem", function(){
							var id_item = $(this).data('itemid');
							var layer_item = MPlayMap.realtime.getLayer(id_item);
							var feature_item = e.features[id_item];
							
							var este = $(this);
								
							var actual_html = este.html();
							
							este.addClass("disabled").html('<i class="fa fa-cog fa-spin"></i>');
							
							$.post(MPlay.config.base_url + 'api/mplay/usuario/recogerItem.json', { id_item: id_item }, function(data){
								if (data.response == 'ok'){
									MPlayUsuario.init_inventario(contenedor_jq);
									MPlayMap.map.removeLayer(layer_item);
									MPlayUsuario.update_status_user(null, null, function(){
										MPlayMap.realtime.update();
									  });
									MPlayUI.Notificar("Item recogido", "Has recogido el item " + feature_item.properties.nombre, "info");
									este.removeClass('disabled').html(actual_html);
								} else {
									MPlayUI.Notificar("Error", data.response_text, 'error');
									este.removeClass('disabled').html(actual_html);
								}
							});							
						});
						
						$(id_map).off("click", ".mplay-popup-optbtn-startgame");
						$(id_map).on("click", ".mplay-popup-optbtn-startgame", function(){
							var id_juego = $(this).data('juegoid');
							var layer_item = MPlayMap.realtime.getLayer(id_juego);
							var feature_item = e.features[id_juego];
							
							var este = $(this);
								
							var actual_html = este.html();
							
							este.addClass("disabled").html('<i class="fa fa-cog fa-spin"></i>');
							
							$.post(MPlay.config.base_url + 'api/mplay/usuario/comenzarJuego.json', { id_juego: id_juego }, function(data){
								if (data.response == 'ok'){
									MPlayMap.map.closePopup();
									MPlayJuegos.start_game(data.data);
									MPlayUI.Notificar("Juego iniciado", "Has comenzado el juego " + feature_item.properties.nombre, "info");
									este.removeClass('disabled').html(actual_html);
								} else {
									MPlayUI.Notificar("Error", data.response_text, 'error');
									este.removeClass('disabled').html(actual_html);
								}
							});							
						});
						
						$(id_map).off("click", ".mplay-popup-optbtn-cancelgame");
						$(id_map).on("click", ".mplay-popup-optbtn-cancelgame", function(){
							var id_juego = $(this).data('juegoid');
							var layer_item = MPlayMap.realtime.getLayer(id_juego);
							var feature_item = e.features[id_juego];
							
							var este = $(this);
								
							var actual_html = este.html();
							
							este.addClass("disabled").html('<i class="fa fa-cog fa-spin"></i>');
							
							$.post(MPlay.config.base_url + 'api/mplay/usuario/cancelarJuego.json', { id_juego: id_juego }, function(data){
								if (data.response == 'ok'){
									MPlayMap.map.closePopup();
									MPlayJuegos.cancel_game(data.data.id_juego);
									MPlayUI.Notificar("Juego cancelado", "Has cancelado el juego " + feature_item.properties.nombre, "error");
									este.removeClass('disabled').html(actual_html);
								} else {
									MPlayUI.Notificar("Error", data.response_text, 'error');
									este.removeClass('disabled').html(actual_html);
								}
							});							
						});
						
						MPlayUI.buttonEvents();
												
					});
					
					//L.control.scale().addTo(MPlayMap.map);
					//L.control.locate().addTo(MPlayMap.map);
					MPlayMap.map.scrollWheelZoom.disable();				
				}
				
				$(id_map).off("click", ".mplay-popup-optbtn-go");
				$(id_map).on("click", ".mplay-popup-optbtn-go", function(){
					var lat = $(this).data('lat');
					var lng = $(this).data('lng');
					
					var m_usr = new L.LatLng(lat, lng);
				
					MPlayMap.mover_jugador(m_usr);
				});
				
			});
		}
		
		MPlayUI.buttonEvents();
	},
	after_map_loaded: function(){
		var init_loc = new L.latLng(MPlayUsuario.usuario_activo.actividad.latitud, MPlayUsuario.usuario_activo.actividad.longitud);
		MPlayMap.map.setView(init_loc);
		if (MPlay.tutorial != undefined && MPlay.tutorial.id_juego != undefined && MPlay.tutorial.id_juego != ''){
			MPlayJuegos.start_game(MPlay.tutorial);
			delete MPlay.tutorial;
		}
	},
	init_encamino: function (map, route, animatedMarker, marker, destMarker){
		if (MPlayMap.en_camino == true){
			var cont_encamino = $('.mplay-ui-encamino');
							
			cont_encamino.each(function(idx, ele){
				var btn_cancelar_encamino = $(ele).find('[data-mplay-encamino-cancelar]');
				var destino_encamino = $(ele).find('[data-mplay-encamino-destino]');
				var distancia_encamino = $(ele).find('[data-mplay-encamino-distancia]');
				var velocidad_encamino = $(ele).find('[data-mplay-encamino-velocidad]');
				var tiempo_encamino = $(ele).find('[data-mplay-encamino-tiempo]');
				$("#mplay-ui-btn-geolocation").addClass("disabled");

				destino_encamino.html('('+ MPlayMap.destino_lat + ', ' + MPlayMap.destino_lng +')');
				distancia_encamino.html((MPlayMap.destino_distancia * 1000) + ' metros');
				velocidad_encamino.html(MPlayMap.destino_velocidad + ' km/h');
				tiempo_encamino.html(MideasFunciones.formatoHora(MPlayMap.destino_tiempo * 3600));
				
				MPlayMap.destino_tiempo_restante = MPlayMap.destino_tiempo * 3600;
				
				MPlayMap.timerEnCamino=setInterval(MPlayMap.timer, 1000);
				
				btn_cancelar_encamino.unbind("click");
				btn_cancelar_encamino.on("click", function(){
					  animatedMarker.stop();
					  map.removeLayer(animatedMarker);
					  map.removeLayer(route);
					  map.removeLayer(destMarker);
					  
					  marker._icon.style.display="block";
					  MPlayUsuario.lat = marker._latlng.lat;
					  MPlayUsuario.lng = marker._latlng.lng;
					  map.setView(marker._latlng);
					  
					  tiempo_encamino.html('00:00:00');
					  distancia_encamino.html('0 metros');
					  
					  MPlayMap.destino_tiempo_restante = 0;
					  clearInterval(MPlayMap.timerEnCamino);
					  
					  $("#mplay-ui-btn-geolocation").removeClass("disabled");
					  
					  $('.mplay-ui-encamino').fadeOut(200);
					  
					  MPlayUI.Notificar("Viaje cancelado", "Has cancelado el viaje que habías programado", "warn");
					  
					  if ($("#mplay-ui-btn-showvisiblerange").hasClass('active')){
						MPlayMap.viewRange.setLatLng(marker._latlng);
					  }
						
					  if ($("#mplay-ui-btn-showinteractrange").hasClass('active')){
							MPlay.interactRange.setLatLng(marker._latlng);
					  }
					  
					  MPlayUsuario.geolocation_activa = 0;
						
					  MPlayUsuario.update_status_user(marker._latlng.lat, marker._latlng.lng, function(){
						  MPlayMap.realtime.update();
					  });
					  
					  MPlayMap.en_camino = false;
					  MPlayMap.destino_lat = null;
					  MPlayMap.destino_lng = null;
					  MPlayMap.destino_distancia = null;
					  MPlayMap.destino_velocidad = null;
					  MPlayMap.destino_tiempo = null;
				});
				
				$(ele).fadeIn(200);
				
				animatedMarker.start();
			});
		} else {
			$('.mplay-ui-encamino').fadeOut(200);
		}
	}
};