var MPlaySitio = {
	comercio_activo: null,
	nodos_aprender: [],
	attrComerciar: '[data-mplay-inventario-sitio]',
	clsLinkComerciar: '.mplay-popup-optbtn-comerciar',
	attrAprender: '[data-mplay-aprender-sitio]',
	clsLinkMejorarCasa: '.mplay-popup-optbtn-mejorar',
	attrMejorarCasa: '[data-mplay-mejorar-casa]',
	clsLinkAprender: '.mplay-popup-optbtn-aprender',
	update_status_comercio: function (id_sitio){
		var options = {};
		var append_opts = '';
		if (id_sitio != null){
			options.id_sitio = id_sitio;
			append_opts = '/';
		}
		$.get(MPlay.config.base_url + 'api/mplay/usuario/updateStatusComercio.json'+append_opts, options, function(data){
			if (data.response == 'ok'){
				MPlaySitio.comercio_activo = data.data.sitio;
				
				MPlaySitio.update_sell_items_comerciar($('body'));
				
				$("[data-mplay-sitio-name]").html(data.data.sitio.nombre);
				$("[data-mplay-sitio-money]").html(data.data.sitio.dinero);
				return true;
			} else {
				MPlayUI.Notificar("Error", data.response_text, "error");
				return false;
			}
		});
	},
	init_aprender: function (contenedor_jq, onEnd){
		var jElementInventario = contenedor_jq.find(this.clsLinkAprender);
		var map = $("[data-mplay-mapa]");
		
		map.off("click", this.clsLinkAprender);
		map.on("click", this.clsLinkAprender, function(){
			var este = $(this);
			var id_sitio = este.data("sitioid");
			var modal_id = este.attr("href");
			
			MPlaySitio.update_aprender(contenedor_jq, id_sitio);
			
			$(modal_id).modal({show: true});
			
			return false;
		});
		
		if (MideasFunciones.isFunction(onEnd)){
			$('body').fadeIn(0, onEnd);
		}
	},
	update_aprender_tree: function(){
		if (MPlaySitio.nodos_aprender == undefined || MPlaySitio.nodos_aprender.length == 0)
			return false;
			
		$(".mplay-ui-aprender-list").html("");	
		
		var tree = d3.layout.tree()
			.nodeSize([MPlayUsuarioSkillTree.tree_options.width, MPlayUsuarioSkillTree.tree_options.height]);
		
		var diagonal = d3.svg.diagonal()
			.projection(function(d) { return [d.x, d.y]; });
		
		var svg = d3.select(".mplay-ui-aprender-list").append("svg")
			.attr("width", '100%')
			.attr("height", '100%');
			
		var g =	svg.append("g")
			.attr("class", "node-root")
			.attr("transform", "translate(" + MPlayUsuarioSkillTree.tree_options.margin.left + "," + MPlayUsuarioSkillTree.tree_options.margin.top + ")");
		
		root = MPlaySitio.nodos_aprender[0];
		  
		MPlayUsuarioSkillTree.update_layout(root, tree, g, diagonal);
		
		MPlayUI.buttonEvents();
	},
	fill_nodes_aprender: function(data, onSuccess){
		MPlaySitio.nodos_aprender = [];
		
		var model_root = { id: '99999', name: MPlayUsuario.usuario_activo.nombre, description: "", properties: "", cost: "", icon: MPlayUsuario.usuario_activo.avatar, parent: null, aprendida: true };
		
		var children_root = [];		
		if (data != undefined && data.length > 0){
			
			$.each(data, function(idx, ele){
				if (ele.padre == '0' || ele.padre == ''){
					var padre = '99999';
				} else {
					var padre = ele.padre;
				}
				
				var model = MPlayUsuarioSkillTree.get_skill_model(ele.id, data, padre);
				
				if (model.id != undefined && model.id != 0){
					children_root.push(model);
				}
			});
			model_root.children = children_root;
			MPlaySitio.nodos_aprender.push(model_root);
			
			if (MideasFunciones.isFunction(onSuccess)){
				$('body').fadeIn(0, onSuccess);
			}
		}
	},
	reset_aprender: function (contenedor_jq){
		var jElementInventario = contenedor_jq.find(this.attrAprender);
		if (jElementInventario.length > 0) {
			jElementInventario.each(function(idx, ele){
				var contenedor_info_item = $(ele).find('.mplay-ui-aprender-info');
				var contenedor_list_item = $(ele).find('.mplay-ui-aprender-list');
				
				contenedor_list_item.html('');
				contenedor_info_item.html('');
			});
		}
	},
	update_aprender: function (contenedor_jq, id_sitio){
		MPlaySitio.reset_aprender(contenedor_jq);
		
		var jElementInventario = contenedor_jq.find(this.attrAprender);
		if (jElementInventario.length > 0) {

				$.get(MPlay.config.base_url + 'api/mplay/usuario/rellenarInventarioAprender.json/', {id_sitio: id_sitio }, function(data){
					if (data.response == 'ok'){
						MPlaySitio.fill_nodes_aprender(data.data, function(){
							MPlaySitio.update_aprender_tree();
						});
						
						jElementInventario.each(function(idx, ele){
						$.each(data.data, function(idx, elem){
							var active_cls = '';
							var hide_info_cls = ' style="display: none;"';
							if (idx == 0){
								active_cls = ' active';
								hide_info_cls = '';
							}
							var contenedor_info_item = $(ele).find('.mplay-ui-aprender-info');
							var tpl_inv_item_info = contenedor_info_item.data('mplay-tpl');
							var tpl_inv_item_prop = contenedor_info_item.data('mplay-tplpropiedad');
							var uid_cont = contenedor_info_item.data('mplay-uid');
							
							var idx_uid = idx + '-' + uid_cont;
																														
							var res_tpl_info = tpl_inv_item_info.replace("##IDX##", idx_uid);
							res_tpl_info = res_tpl_info.replace("##NOMBRE##", elem.nombre);
							res_tpl_info = res_tpl_info.replace("##TIPO##", elem.tipo);
							res_tpl_info = res_tpl_info.replace("##DESCRIPCION##", elem.descripcion);
							res_tpl_info = res_tpl_info.replace("##ACTIVECLASS##", hide_info_cls);
							res_tpl_info = res_tpl_info.replace("##PROPIEDADES##", elem.propiedades_html);
							res_tpl_info = res_tpl_info.replace("##OPCIONES##", elem.opciones);
														
							contenedor_info_item.append(res_tpl_info);
						});
						
						$(ele).find(".mplay-item-inv").off( "click" );
						$(ele).find(".mplay-item-inv").on("click", function(){
							var $href = $(this).attr('href');
							var $todos_contenedores = $(ele).find("[data-mplay-infoitem]");
							var $todos_items = $(ele).find("[data-mplay-toggleitems]");
							
							$todos_items.removeClass('active');
							$todos_contenedores.hide();
							
							$($href).show();
							$(this).addClass('active');
							
							return false;
						});
						
						$(ele).find(".mplay-popup-optbtn-learnskill").off("click");
						$(ele).find(".mplay-popup-optbtn-learnskill").on('click', function(){
							var id_skill = $(this).data('skillid');
							var nombre_skill =  $(this).data('skill-nombre');
							var precio =  $(this).data('valor');
							var este = $(this);
							
							var actual_html = este.html();
							
							este.addClass("disabled").html('<i class="fa fa-cog fa-spin"></i>');
							
							$.post(MPlay.config.base_url + 'api/mplay/usuario/comprarHabilidad.json', { id_skill: id_skill, precio: precio }, function(data){
								if (data.response == 'ok'){
									MPlaySitio.update_aprender(contenedor_jq,id_sitio);
									MPlayUsuario.update_status_user(null, null, function(){
										MPlayMap.realtime.update();
									  });
									
									MPlayUI.Notificar("Habilidad aprendida", "Has aprendido la habilidad " + nombre_skill + " por " + precio +" MO", "info");
									este.removeClass('disabled').html(actual_html);
								} else {
									MPlayUI.Notificar("Error", data.response_text, 'error');
									este.removeClass('disabled').html(actual_html);
								}
							});							
						});
						
						});
						
					} else {
						MPlayUI.Notificar("Error", data.response_text, 'error');
					}
				
			});
		}
		
		MPlayUI.buttonEvents();
	},
	init_mejorar_casa: function (contenedor_jq, onEnd){
		var jElementInventario = contenedor_jq.find(this.clsLinkMejorarCasa);
		var map = $("[data-mplay-mapa]");
		
		map.off("click", this.clsLinkMejorarCasa);
		map.on("click", this.clsLinkMejorarCasa, function(){
			var este = $(this);
			var id_sitio = este.data("sitioid");
			var modal_id = este.attr("href");
			
			MPlaySitio.update_mejorar_casa(contenedor_jq, id_sitio);
			
			$(modal_id).modal({show: true});
			
			return false;
		});
		
		if (MideasFunciones.isFunction(onEnd)){
			$('body').fadeIn(0, onEnd);
		}
	},
	update_mejorar_casa_tree: function(){
		if (MPlaySitio.nodos_mejorar_casa == undefined || MPlaySitio.nodos_mejorar_casa.length == 0)
			return false;
			
		$(".mplay-ui-mejorar-list").html("");	
		
		var tree = d3.layout.tree()
			.nodeSize([MPlayUsuarioSkillTree.tree_options.width, MPlayUsuarioSkillTree.tree_options.height]);
		
		var diagonal = d3.svg.diagonal()
			.projection(function(d) { return [d.x, d.y]; });
		
		var svg = d3.select(".mplay-ui-mejorar-list").append("svg")
			.attr("width", '100%')
			.attr("height", '100%');
			
		var g =	svg.append("g")
			.attr("class", "node-root")
			.attr("transform", "translate(" + MPlayUsuarioSkillTree.tree_options.margin.left + "," + MPlayUsuarioSkillTree.tree_options.margin.top + ")");
		
		root = MPlaySitio.nodos_mejorar_casa[0];
		  
		MPlayUsuarioSkillTree.update_layout(root, tree, g, diagonal);
		
		MPlayUI.buttonEvents();
	},
	fill_nodes_mejorar_casa: function(data, onSuccess){
		MPlaySitio.nodos_mejorar_casa = [];
		
		var model_root = { id: '99999', name: "Casa de "+MPlayUsuario.usuario_activo.nombre, description: "", properties: "", cost: "", icon: MPlayUsuario.usuario_activo.avatar, parent: null, aprendida: true };
		
		if (data != undefined && data.length > 0){
			var children_root = [];
			$.each(data, function(idx, ele){
				if (ele.padre == '0' || ele.padre == ''){
					var padre = '99999';
				} else {
					var padre = ele.padre;
				}
				var model = MPlayUsuarioSkillTree.get_skill_model(ele.id, data, padre);
				
				if (model.id != undefined && model.id != 0){
					children_root.push(model);
				}
			});
			
			model_root.children = children_root;
			MPlaySitio.nodos_mejorar_casa.push(model_root);
			
			if (MideasFunciones.isFunction(onSuccess)){
				$('body').fadeIn(0, onSuccess);
			}
		}
	},
	reset_mejorar_casa: function (contenedor_jq){
		var jElementInventario = contenedor_jq.find(this.attrMejorarCasa);
		if (jElementInventario.length > 0) {
			jElementInventario.each(function(idx, ele){
				var contenedor_info_item = $(ele).find('.mplay-ui-mejorar-info');
				var contenedor_list_item = $(ele).find('.mplay-ui-mejorar-list');
				
				contenedor_list_item.html('');
				contenedor_info_item.html('');
			});
		}
	},
	update_mejorar_casa: function (contenedor_jq, id_sitio){
		MPlaySitio.reset_mejorar_casa(contenedor_jq);
		
		var jElementInventario = contenedor_jq.find(this.attrMejorarCasa);
		if (jElementInventario.length > 0) {

				$.get(MPlay.config.base_url + 'api/mplay/usuario/rellenarInventarioMejorarCasa.json/', {id_sitio: id_sitio }, function(data){
					if (data.response == 'ok'){
						MPlaySitio.fill_nodes_mejorar_casa(data.data, function(){
							MPlaySitio.update_mejorar_casa_tree();
						});
						
						jElementInventario.each(function(idx, ele){
						$.each(data.data, function(idx, elem){
							var active_cls = '';
							var hide_info_cls = ' style="display: none;"';
							if (idx == 0){
								active_cls = ' active';
								hide_info_cls = '';
							}
							var contenedor_info_item = $(ele).find('.mplay-ui-mejorar-info');
							var tpl_inv_item_info = contenedor_info_item.data('mplay-tpl');
							var tpl_inv_item_prop = contenedor_info_item.data('mplay-tplpropiedad');
							var uid_cont = contenedor_info_item.data('mplay-uid');
							
							var idx_uid = idx + '-' + uid_cont;
																														
							var res_tpl_info = tpl_inv_item_info.replace("##IDX##", idx_uid);
							res_tpl_info = res_tpl_info.replace("##NOMBRE##", elem.nombre);
							res_tpl_info = res_tpl_info.replace("##TIPO##", elem.tipo);
							res_tpl_info = res_tpl_info.replace("##DESCRIPCION##", elem.descripcion);
							res_tpl_info = res_tpl_info.replace("##ACTIVECLASS##", hide_info_cls);
							res_tpl_info = res_tpl_info.replace("##PROPIEDADES##", elem.propiedades_html);
							res_tpl_info = res_tpl_info.replace("##OPCIONES##", elem.opciones);
														
							contenedor_info_item.append(res_tpl_info);
						});
						
						$(ele).find(".mplay-item-inv").off( "click" );
						$(ele).find(".mplay-item-inv").on("click", function(){
							var $href = $(this).attr('href');
							var $todos_contenedores = $(ele).find("[data-mplay-infoitem]");
							var $todos_items = $(ele).find("[data-mplay-toggleitems]");
							
							$todos_items.removeClass('active');
							$todos_contenedores.hide();
							
							$($href).show();
							$(this).addClass('active');
							
							return false;
						});
						
						$(ele).find(".mplay-popup-optbtn-buildmejora").off("click");
						$(ele).find(".mplay-popup-optbtn-buildmejora").on('click', function(){
							var id_skill = $(this).data('skillid');
							var nombre_skill =  $(this).data('skill-nombre');
							var precio =  $(this).data('valor');
							var este = $(this);
							
							var actual_html = este.html();
							
							este.addClass("disabled").html('<i class="fa fa-cog fa-spin"></i>');
							
							$.post(MPlay.config.base_url + 'api/mplay/usuario/comprarMejora.json', { id_skill: id_skill, precio: precio, id_sitio: id_sitio }, function(data){
								if (data.response == 'ok'){
									MPlaySitio.update_mejorar_casa(contenedor_jq,id_sitio);
									MPlayUsuario.update_status_user(null, null, function(){
										MPlayMap.realtime.update();
									  });
									
									MPlayUI.Notificar("Mejora construida", "Has mejorado tu casa con " + nombre_skill + " por " + precio +" MO", "info");
									este.removeClass('disabled').html(actual_html);
								} else {
									MPlayUI.Notificar("Error", data.response_text, 'error');
									este.removeClass('disabled').html(actual_html);
								}
							});							
						});
						
						});
						
					} else {
						MPlayUI.Notificar("Error", data.response_text, 'error');
					}
				
			});
		}
		
		MPlayUI.buttonEvents();
	},
	init_comerciar: function (contenedor_jq, onEnd){
		var jElementInventario = contenedor_jq.find(this.clsLinkComerciar);
		var map = $("[data-mplay-mapa]");
		
		map.off("click", this.clsLinkComerciar);
		map.on("click", this.clsLinkComerciar, function(){
			var este = $(this);
			var id_sitio = este.data("sitioid");
			var modal_id = este.attr("href");
			
			MPlaySitio.update_comerciar(contenedor_jq, id_sitio);
			
			$(modal_id).modal({show: true});
			
			return false;
		});
		
		if (MideasFunciones.isFunction(onEnd)){
			$('body').fadeIn(0, onEnd);
		}
	},
	reset_comerciar: function (contenedor_jq){
		if (MPlay.config.opciones.modulos.modulos.inventario.activo != '1'){
			return false;
		}
		
		var jElementInventario = contenedor_jq.find(this.attrComerciar);
		if (jElementInventario.length > 0) {
			jElementInventario.each(function(idx, ele){
				var contenedor_info_item = $(ele).find('.mplay-ui-inventory-info');
				var contenedor_list_item = $(ele).find('.mplay-ui-inventory-list');
				
				var tpl_inv_item_list = contenedor_list_item.data('mplay-tpl');
				
				contenedor_list_item.html('');
				for (i=0; i < MPlay.config.opciones.modulos.modulos.inventario.opciones.max_items_comercios; i++){
					contenedor_list_item.append(tpl_inv_item_list);
				}
				
				contenedor_info_item.html('');
			});
		}
	},
	update_comerciar: function (contenedor_jq, id_sitio){
		MPlaySitio.reset_comerciar(contenedor_jq);
		MPlaySitio.update_status_comercio(id_sitio);
		
		var jElementInventario = contenedor_jq.find(this.attrComerciar);
		if (jElementInventario.length > 0) {
				
				$.get(MPlay.config.base_url + 'api/mplay/usuario/rellenarInventarioComerciar.json/', {id_sitio: id_sitio }, function(data){
					if (data.response == 'ok'){
						jElementInventario.each(function(idx, ele){
						$.each(data.data, function(idx, elem){
							var active_cls = '';
							var hide_info_cls = ' style="display: none;"';
							if (idx == 0){
								active_cls = ' active';
								hide_info_cls = '';
							}
							var contenedor_info_item = $(ele).find('.mplay-ui-inventory-info');
							var tpl_inv_item_info = contenedor_info_item.data('mplay-tpl');
							var tpl_inv_item_prop = contenedor_info_item.data('mplay-tplpropiedad');
							var uid_cont = contenedor_info_item.data('mplay-uid');
							
							var idx_uid = idx + '-' + uid_cont;
							
							var tpl_inv_item = '<a class="mplay-item-inv thumbnail tip-e'+active_cls+'" data-mplay-toggleitems href="#mplay-iteminfo-'+idx_uid+'" title="'+elem.nombre+' ('+elem.cantidad+' uds. restantes en la tienda)"> <span class="absolute bottom-right label label-success">'+elem.cantidad+'</span> <img src="'+elem.icono+'" class="img-responsive" /> </a>';
							
							var propiedades_item = elem.propiedades_html;
							
							/*$.each(elem.propiedades, function(idxprop, eleprop){
								if (idxprop != undefined && idxprop != ''){
									if (eleprop.visible != false){
										var valor = '';
										var tpl_inv_item_prop_tmp = tpl_inv_item_prop;
										if (eleprop.valor != undefined && eleprop.valor != '' && eleprop.valor != 'undefined'){
											valor = eleprop.valor;
										} else {
											valor = '0';
										}
										
										var tmp_tpl = tpl_inv_item_prop_tmp.replace("##NOMBRE##", eleprop.nombre);
										tmp_tpl = tmp_tpl.replace("##ICONO##", eleprop.icono);
										tmp_tpl = tmp_tpl.replace("##VALOR##", valor);
										
										propiedades_item += tmp_tpl;
									}
								}
							});*/
																							
							var res_tpl_info = tpl_inv_item_info.replace("##IDX##", idx_uid);
							res_tpl_info = res_tpl_info.replace("##NOMBRE##", elem.nombre);
							res_tpl_info = res_tpl_info.replace("##TIPO##", elem.tipo);
							res_tpl_info = res_tpl_info.replace("##DESCRIPCION##", elem.descripcion);
							res_tpl_info = res_tpl_info.replace("##ACTIVECLASS##", hide_info_cls);
							res_tpl_info = res_tpl_info.replace("##PROPIEDADES##", propiedades_item);
							res_tpl_info = res_tpl_info.replace("##OPCIONES##", elem.opciones);
							res_tpl_info = res_tpl_info.replace("##CANTIDAD##", elem.cantidad);
							
							$(ele).find('.mplay-inv-slot').eq(idx).html(tpl_inv_item);
							
							contenedor_info_item.append(res_tpl_info);
						});
						
						$(ele).find(".mplay-item-inv").off( "click" );
						$(ele).find(".mplay-item-inv").on("click", function(){
							var $href = $(this).attr('href');
							var $todos_contenedores = $(ele).find("[data-mplay-infoitem]");
							var $todos_items = $(ele).find("[data-mplay-toggleitems]");
							
							$todos_items.removeClass('active');
							$todos_contenedores.hide();
							
							$($href).show();
							$(this).addClass('active');
							
							return false;
						});
						
						$(ele).find(".mplay-popup-optbtn-buyitem").off("click");
						$(ele).find(".mplay-popup-optbtn-buyitem").on('click', function(){
							var id_item = $(this).data('itemid');
							var nombre_item =  $(this).data('item-nombre');
							var id_sitio =  $(this).data('item-sitio');
							var precio =  $(this).data('item-precio');
							var este = $(this);
							
							var actual_html = este.html();
							
							este.addClass("disabled").html('<i class="fa fa-cog fa-spin"></i>');
							
							$.post(MPlay.config.base_url + 'api/mplay/usuario/comprarItem.json', { id_item: id_item, id_sitio: id_sitio, precio: precio }, function(data){
								if (data.response == 'ok'){
									MPlayUsuario.init_inventario(contenedor_jq, true);
									MPlayUsuario.update_status_user(null, null, function(){
										MPlayMap.realtime.update();
									  });
									
									MPlayUI.Notificar("Item comprado", "Has comprado el item " + nombre_item + " por " + precio +" MO", "info");
									este.removeClass('disabled').html(actual_html);
								} else {
									MPlayUI.Notificar("Error", data.response_text, 'error');
									este.removeClass('disabled').html(actual_html);
								}
							});							
						});
					});
				} else {
					MPlayUI.Notificar("Error", data.response_text, 'error');
				}
			});
		}
		
		MPlayUI.buttonEvents();
	},
	update_sell_items_comerciar: function(contenedor_jq){
		$("#mdl-comerciar-sitio-vender").find(".mplay-popup-optbtn-sellitem").each(function(index, element) {
			var vi = $(element).data('item-valor');
			var dcs = MPlaySitio.comercio_activo.descuento_compras;
			
			var precio_item = parseInt( vi - ( ( dcs / 100 ) * vi ) );
			
			var id_sitio = MPlaySitio.comercio_activo.id;
			
			$(element).attr("data-item-sitio", MPlaySitio.comercio_activo.id);
			$(element).attr("data-item-precio", precio_item);
			$(element).find(".mplay-item-sellprice").html('('+ precio_item +' MO)');

			$(element).off("click");
			$(element).on('click', function(){
				var id_item = $(this).data('itemid');
				var nombre_item =  $(this).data('item-nombre');
				//var id_sitio =  $(this).data('item-sitio');
				var precio =  precio_item;
				var este = $(this);
				
				var actual_html = este.html();
				
				este.addClass("disabled").html('<i class="fa fa-cog fa-spin"></i>');
				
				$.post(MPlay.config.base_url + 'api/mplay/usuario/venderItem.json', { id_item: id_item, id_sitio: id_sitio, precio: precio }, function(data){
					if (data.response == 'ok'){
						MPlayUsuario.init_inventario(contenedor_jq, true);
						
						MPlayUsuario.update_status_user(null, null, function(){
							MPlayMap.realtime.update();
						  });
						
						MPlayUI.Notificar("Item vendido", "Has vendido el item " + nombre_item + " por " + precio +" MO", "info");
						este.removeClass('disabled').html(actual_html);
					} else {
						MPlayUI.Notificar("Error", data.response_text, 'error');
						este.removeClass('disabled').html(actual_html);
					}
				});							
			});
		});
	}
};