var stack_topleft = {"dir1": "down", "dir2": "right", "push": "top"};
var stack_bottomleft = {"dir1": "right", "dir2": "up", "push": "top"};
var stack_custom = {"dir1": "right", "dir2": "down"};
var stack_custom2 = {"dir1": "left", "dir2": "up", "push": "top"};
var stack_modal = {"dir1": "down", "dir2": "right", "push": "top", "modal": true, "overlay_close": true};
var stack_bar_top = {"dir1": "down", "dir2": "right", "push": "top", "spacing1": 0, "spacing2": 0};
var stack_bar_bottom = {"dir1": "up", "dir2": "right", "spacing1": 0, "spacing2": 0};

var MPlayUI = {
	anj: {},
	asistente: false,
	asistenteNuevoJugador: function(){
		MPlayUI.asistente = true;
		var modal_newplayer = $('#mdl-asistente-nuevo-jugador');
		var btn_continuar = $('[data-mplay-anj-btncontinuar]');
		
		var paso1_cont = $('[data-mplay-anj-paso1]');
		var paso2_cont = $('[data-mplay-anj-paso2]');
		var paso3_cont = $('[data-mplay-anj-paso3]');
		
		var input_nombre = $('[data-mplay-anj-inputnombre]');
		
		var select_oficio = $('[data-mplay-anj-selectoficio]');
		var selected_oficio = $('[data-mplay-anj-oficio-selected]');
		
		var latitud_casa_inp = $('[data-mplay-anj-latitudcasa]');
		var longitud_casa_inp = $('[data-mplay-anj-longitudcasa]');
		
		var cont = $("#mplay-main-container");
		cont.hide();
		
		if (MPlay.config.opciones.asistente.musica_asistente != ""){
			MPlayUI.playMusic(MPlay.config.opciones.asistente.musica_asistente);
		}
		
		MPlayUI.anj = { paso: 1 };
		
		modal_newplayer.modal({backdrop: 'static', keyboard: false, show: true});
		
		select_oficio.off("click");
		select_oficio.on("click", function(){
			var este = $(this);
			var oficio_id = este.data("mplay-oficioid");
			var oficio_nombre = este.data("mplay-oficio-nombre");
			
			if (oficio_nombre == undefined || oficio_nombre == '')
				oficio_nombre = "Ninguno";
			
			if (oficio_id == undefined || oficio_id == ''){
				MPlayUI.Notificar("Oficio desconocido","No podemos entender que oficio deseas","error");
				return false;
			}
			
			if (MPlayUI.anj.paso != 2){
				MPlayUI.Notificar("Acción no permitida","No puedes elegir oficio en este paso del asistente","error");
				return false;
			}
			
			MPlayUI.anj.oficio = oficio_id;
			
			selected_oficio.html(oficio_nombre);
			
			$('[data-mplay-anj-selectoficio]').removeClass('active');
			este.addClass('active');
		});
		
		btn_continuar.off("click");
		btn_continuar.on("click", function(){
			if (MPlayUI.anj.paso == 3){
				if (MPlayUI.anj.nombre  == undefined || MPlayUI.anj.nombre  == ''){
					MPlayUI.Notificar("Sin nombre", "Debes escribir tu nombre para continuar", "error");
					paso3_cont.hide(0, function(){
						paso1_cont.show();
					});
					return false;
				}
				
				if (MPlayUI.anj.oficio  == undefined || MPlayUI.anj.oficio  == ''){
					MPlayUI.Notificar("Sin oficio", "Debes elegir un oficio para continuar", "error");
					paso3_cont.hide(0, function(){
						paso2_cont.show();
					});
					return false;
				}
				
				var latitud_casa = latitud_casa_inp.val();
				var longitud_casa = longitud_casa_inp.val();
				
				if (latitud_casa == undefined || latitud_casa == '' || longitud_casa == undefined || longitud_casa == ''){
					MPlayUI.Notificar("Sin casa", "Debes seleccionar la ubicación de tu casa", "error");
					return false;
				}
				
				var este = $(this);
				var old_html = este.html();
				
				este.addClass("disabled").html('<div id="loading_ta" style="position: relative;display: block;top: auto;right: auto;z-index: 0;"><i class="fa fa-spin fa-circle-o-notch"></i></div>');
				
				$.post(MPlay.config.base_url + 'api/mplay/usuario/altaNuevoJugador.json', { id_usuario: MPlayUI.anj.user_id, nombre: MPlayUI.anj.nombre, oficio: MPlayUI.anj.oficio, latitud_casa: latitud_casa, longitud_casa: longitud_casa }, function(data){
					if (data.response == 'ok'){
						modal_newplayer.modal('hide');
						MPlayUI.asistente = false;
						MPlayUsuario.iniciado = true;
						cont.show();
						MPlay.reload('body');
						//MPlayUI.Notificar("¡Bienvenido al juego!","Es hora de que comencemos nuestra aventura, ¿no crees?","success");
						if (data.data.tutorial != undefined && data.data.tutorial.id_juego != undefined && data.data.tutorial.id_juego != ''){
							MPlay.tutorial = data.data.tutorial;
						}
						este.html(old_html).removeClass("disabled");
						return false;
					} else {
						MPlayUI.Notificar("Error", data.response_text, 'error');
						return false;
					}
				});
			} else if (MPlayUI.anj.paso == 2){
				if (MPlayUI.anj.nombre  == undefined || MPlayUI.anj.nombre  == ''){
					MPlayUI.Notificar("Sin nombre", "Debes escribir tu nombre para continuar", "error");
					paso2_cont.hide(0, function(){
						paso1_cont.show();
					});
					return false;
				}
				
				if (MPlayUI.anj.oficio  == undefined || MPlayUI.anj.oficio  == ''){
					MPlayUI.Notificar("Sin oficio", "Debes elegir un oficio para continuar", "error");
					return false;
				}
				
				MPlayUI.anj.paso = 3;
				
				paso2_cont.hide(0, function(){
					paso3_cont.show();
				});
				
			} else if (MPlayUI.anj.paso == 1){
				if (input_nombre.val() == ''){
					MPlayUI.Notificar("Sin nombre", "Debes escribir tu nombre para continuar", "error");
					return false;
				}
				
				MPlayUI.anj.paso = 2;
				MPlayUI.anj.nombre = input_nombre.val();
				MPlayUI.anj.user_id = MPlayUsuario.usuario_activo.id;
				
				paso1_cont.hide(0, function(){
					paso2_cont.show();
				});
			}
		});
		
		$('body').find('#loading_ta').remove();
	},
	Notificar: function(titulo, texto, tipo) {
		if (typeof PNotify != "undefined") {
			if (tipo == '' || tipo == undefined){
				tipo = '';
			} else if (tipo == 'danger'){
				tipo = 'error';
			}
			
			PNotify.prototype.options.styling = "bootstrap3";
						
			var opts = {
				title: titulo,
				text: texto,
				addclass: "stack-bar-bottom",
				cornerclass: "",
        		width: "30%",
				stack: stack_bar_bottom
			};
			
			switch (tipo) {
			case 'error':
			case 'danger':
				opts.type = "error";
				break;
			case 'info':
			case 'warning':
			case 'warn':
				opts.type = "info";
				break;
			case 'success':
				opts.type = "success";
				break;
			}
			new PNotify(opts);
		} else {
			bootbox.alert(titulo+": "+texto);
		}
	},
	loader_max: 0,
	loader_current: 0,
	loader_percent: 0,
	show_loader: function(contenedor_jq, num_inicial, num_max){
		if (num_max == undefined || num_max == ''){
			num_max = 100;
		}
		if (num_inicial == undefined || num_inicial == ''){
			num_inicial = 0;
		}
		
		var cont = $("#mplay-main-container");
		cont.hide();
		
		MPlayUI.loader_max = parseInt(num_max);
		MPlayUI.loader_current = parseInt(num_inicial);

		var perc_inicial = parseInt( ( 100 * MPlayUI.loader_current ) / MPlayUI.loader_max );
		
		MPlayUI.loader_percent = perc_inicial;
		
		MPlayUI.refresh_loader(contenedor_jq, function(){
			var loader = $(contenedor_jq).find("#mplay-loader-ajax");
			loader.fadeIn(200);
		});
	},
	inc_loader: function(contenedor_jq, inc_num){
		if (MPlayUI.loader_max < 1){
			return false;
		}
		
		MPlayUI.loader_current = MPlayUI.loader_current + inc_num;
		if (MPlayUI.loader_current >= MPlayUI.loader_max){
			MPlayUI.hide_loader(contenedor_jq);
		} else {
			var perc_new = parseInt( ( 100 * MPlayUI.loader_current ) / MPlayUI.loader_max );
			MPlayUI.loader_percent = perc_new;
			MPlayUI.refresh_loader(contenedor_jq);
		}
	},
	hide_loader: function(contenedor_jq){
		if (MPlayUI.loader_max < 1){
			return false;
		}
		MPlayUI.loader_current = MPlayUI.loader_max;
		var perc_new = 100;
		MPlayUI.loader_percent = perc_new;
		if (MPlayUsuario.usuario_activo.es_nuevo == false){
			MPlayUI.refresh_loader(contenedor_jq, function(){
				MPlayUI.loader_max = 0;
				MPlayUI.loader_current = 0;
				MPlayUI.loader_percent = 0;
				var cont = $("#mplay-main-container");
				cont.fadeIn(200, function(){
					L.Util.requestAnimFrame(MPlayMap.map.invalidateSize,MPlayMap.map,!1,MPlayMap.map._container);
					var loader = $(contenedor_jq).find("#mplay-loader-ajax");
					loader.fadeOut(200);
				});
			});
		}
	},
	refresh_loader: function(contenedor_jq, onEnd){
		if (MPlayUI.loader_max < 1){
			return false;
		}
		
		var loader = $(contenedor_jq).find("#mplay-loader-ajax");
		loader.find("[data-mplay-loader-percent]").html(MPlayUI.loader_percent+"%");
		
		loader.find("[data-mplay-loader-progressbar]").find(".progress-bar").css("width", MPlayUI.loader_percent+"%");
		
		if (MideasFunciones.isFunction(onEnd)){
			$('body').fadeIn(0, onEnd);
		}
	},
	preload_assets: function(onEnd){
		var cont_audios = $('<div>', { id: "mplay_audios", style: "display:none;" }).appendTo('body');
		if (MPlay.config.opciones.audio.precargar_musica == "1" && MPlay.config.opciones.audio.musica != undefined && MPlay.config.opciones.audio.musica.length > 0){
			$.each(MPlay.config.opciones.audio.musica, function(idx, val){
				if (val.img != undefined && val.img != ""){
					if (MPlayUI.assets.musica == undefined){
						MPlayUI.assets.musica = [];
					}
					MPlayUI.assets.musica.push($("<audio>", {src:val.img,preload:"auto",id:"mplay_music_"+idx}).appendTo(cont_audios));
				}
			});
		}
		
		if (MPlay.config.opciones.audio.precargar_fx == "1" && MPlay.config.opciones.audio.fx != undefined && MPlay.config.opciones.audio.fx.length > 0){
			$.each(MPlay.config.opciones.audio.fx, function(idx, val){
				if (val.img != undefined && val.img != ""){
					if (MPlayUI.assets.fx == undefined){
						MPlayUI.assets.fx = [];
					}
					MPlayUI.assets.fx.push($("<audio>", {src:val.img,preload:"auto",id:"mplay_sfx_"+idx}).appendTo(cont_audios));
				}
			});
		}
		
		MPlayUI.buttonEvents();

		if (MideasFunciones.isFunction(onEnd)){
			$('body').fadeIn(0, onEnd);
		}
	},
	buttonEvents: function(){
		if (MPlay.config.opciones.ui.fx_btn_hover != undefined && MPlay.config.opciones.ui.fx_btn_hover != ""){
			$('a, button, input[type=submit]').on("mouseenter", function(){
				console.debug(MPlay.config.opciones.ui.fx_btn_click);
				MPlayUI.playSFX(MPlay.config.opciones.ui.fx_btn_hover);
			});
		}
		
		if (MPlay.config.opciones.ui.fx_btn_click != undefined && MPlay.config.opciones.ui.fx_btn_click != ""){
			$('a, button, input[type=submit]').on("click", function(){
				MPlayUI.playSFX(MPlay.config.opciones.ui.fx_btn_click);
			});
		}
		
		$("[data-mplay-toggle-music]").off("click").on("click", function(){
			var icon = $(this).find("i.fa");
						
			if (MPlayUI.currentMusic && !MPlayUI.currentMusic[0].paused){
				$(this).removeClass("active");
				icon.removeClass("fa-check").addClass("fa-times");
				MPlayUI.pauseMusic();
			} else if (MPlayUI.currentMusic && MPlayUI.currentMusic[0].paused){
				$(this).addClass("active");
				icon.removeClass("fa-times").addClass("fa-check");
				MPlayUI.currentMusic[0].play();
			}
			
			return false;
		});
	},
	playSFX: function(id_sfx){
		if (MPlayUI.assets.musica[id_sfx] != undefined){
			var sfx_audio = MPlayUI.assets.fx[id_sfx];
			sfx_audio.prop("currentTime",0);
			sfx_audio[0].play();
		}
	},
	playMusic: function(id_pista=-1){
		if (MPlayUI.assets.musica[id_pista] != undefined){
			if (MPlayUI.currentMusic && !MPlayUI.currentMusic[0].paused){
				MPlayUI.currentMusic[0].pause();
				MPlayUI.currentMusic.prop("currentTime",0);
				MPlayUI.currentMusic = {};
			}
			MPlayUI.currentMusic = MPlayUI.assets.musica[id_pista];
			MPlayUI.currentMusic[0].play();
		} else if (MPlayUI.currentMusic && !MPlayUI.currentMusic[0].paused){
			MPlayUI.currentMusic[0].pause();
			MPlayUI.currentMusic.prop("currentTime",0);
			MPlayUI.currentMusic[0].play();
		}
	},
	stopMusic: function(){
		if (MPlayUI.currentMusic && !MPlayUI.currentMusic[0].paused){
			MPlayUI.currentMusic[0].pause();
			MPlayUI.currentMusic.prop("currentTime",0);
		}
	},
	pauseMusic: function(){
		if (MPlayUI.currentMusic && !MPlayUI.currentMusic[0].paused){
			MPlayUI.currentMusic[0].pause();
		} else if (MPlayUI.currentMusic && MPlayUI.currentMusic[0].paused){
			MPlayUI.currentMusic[0].play();
		}
	},
	currentMusic: null,
	assets: {},
	add_game_alert: function(id, mensaje, label_btn, onclick){
		if (id==undefined || id == '')
			return false;
			
		var idx = "#mplay-alert-"+id;
		
		if ($("[data-mplay-alerts]").find(idx).length > 0)
			return false;
			
		$(".mplay-ui-game-messages").removeClass("hide");
		
		var li_content = mensaje + ' <hr class="light" />';
		if (label_btn != undefined && label_btn != ''){
			li_content = li_content + '<a href="javascript:;" id="btn-mplay-alert-btn-'+id+'" class="btn btn-xs btn-success pull-right">'+label_btn+'</a>';
		}
					
		$("[data-mplay-alerts]").append('<li id="mplay-alert-'+id+'">'+li_content+'<div class="clearfix"></div></li>');
		
		if (MideasFunciones.isFunction(onclick)){
			$("[data-mplay-alerts]").find("a#btn-mplay-alert-btn-"+id).off("click");
			$("[data-mplay-alerts]").find("a#btn-mplay-alert-btn-"+id).on("click", function(){
				$('body').fadeIn(0, onclick);
				return false;
			});
		}
	},
	remove_game_alert: function(id){
		if (id==undefined || id == '')
			return false;
			
		var idx = "#mplay-alert-"+id;
			
		$("[data-mplay-alerts]").find(idx).remove();
		
		if ($("[data-mplay-alerts]").find("li").length == 0){
			$(".mplay-ui-game-messages").addClass("hide");
		}
	},
	add_to_missions: function(datos){
		if (datos.id == undefined || datos.id == ''){
			MPlayUI.Notificar("Datos de juego incorrectos","El juego no se puede iniciar porque los datos del juego no son correctos","error");
			return false;
		}
		
		var cont_missions_sidebar = $('[data-mplay-game-missions-sidebar]');
		
		if (cont_missions_sidebar.find("#mplay-ui-mission-sidebar-"+datos.id).length > 0){
			var li_game = cont_missions_sidebar.find("#mplay-ui-mission-sidebar-"+datos.id);
			
			li_game.find(".mplay-toggle-mission.active").removeClass("active");
		} else {
			if (datos.estado == 'finalizado'){
				cont_missions_sidebar.prepend('<li id="mplay-ui-mission-sidebar-'+datos.id+'"></li>');
			} else {
				cont_missions_sidebar.append('<li id="mplay-ui-mission-sidebar-'+datos.id+'"></li>');
			}
			
			var li_game = cont_missions_sidebar.find("#mplay-ui-mission-sidebar-"+datos.id);
			var class_game = "mplay-ui-game-name";
			var extra_data = "";
			if (datos.estado == 'finalizado'){
				class_game = class_game + " disabled mplay-ui-game-completed";
				extra_data = ' data-mplay-game-completed="true"';
			}
			
			li_game.append('<h5 class="'+class_game+'"><a href="javascript:;" data-mplay-show-game-info data-mplay-game-id="'+datos.id+'"'+extra_data+'><img class="img-responsive sub_icon" src="'+datos.icono+'" style="height: 16px; width: auto;"> '+datos.nombre+'</a></h5>');
			
			$("[data-mplay-show-game-info]").off("click").on("click", function(){
				if ($(this).data("mplay-game-completed") == true){					
					var datos = MPlayJuegos.juegos_completados[$(this).data("mplay-game-id")];
				} else {
					var datos = MPlayJuegos.juegos_activos[$(this).data("mplay-game-id")];
				}
				
				MPlayJuegos.open_modal_game(datos);
			});
		}
			
		if (datos.mision_activa != undefined && datos.mision_activa.id_mision != undefined){
			li_game.append('<a id="mplay-ui-mission-sidebar-'+datos.id+'-'+datos.mision_activa.id_mision+'" href="javascript:;" class="mplay-toggle-mission active"><img class="img-responsive sub_icon" src="'+datos.icono+'">'+datos.mision_activa.descripcion_corta_mision+'</a>');
		}
		
		var cont_missions = $('[data-mplay-game-missions]');
		
		if (datos.mision_activa != undefined && datos.mision_activa.id_mision != undefined){
		
			if (cont_missions.find("#mplay-ui-btn-mission-"+datos.id).length > 0){
				var cur_elem = cont_missions.find("#mplay-ui-btn-mission-"+datos.id);
				cur_elem.data("lat", datos.mision_activa.latitud_mision).data("lng", datos.mision_activa.longitud_mision).attr("data-content", datos.mision_activa.descripcion_corta_mision);
				
				var missionIcon = L.AwesomeMarkers.icon({
					icon: 'ra-shoe-prints',
					markerColor: 'yellow',
					prefix: 'ra',
					className: 'awesome-marker mplay-ui-iconmap-missiondest animated flash'
				});
				
				if (MPlayMap.marker_missions[datos.mision_activa.id_mision] != undefined){
					MPlayMap.map.removeLayer(MPlayMap.marker_missions[datos.mision_activa.id_mision]);
					delete MPlayMap.marker_missions[datos.mision_activa.id_mision];
				}
						
				MPlayMap.marker_missions[datos.mision_activa.id_mision] = L.marker([datos.mision_activa.latitud_mision, datos.mision_activa.longitud_mision], {
					icon: missionIcon,
					draggable: false,
					clickable: false
				}).addTo(MPlayMap.map);
				
				cur_elem.find(".mplay-ui-timer-mission").attr("id", "mplay-ui-timer-mission-"+datos.mision_activa.id_mision);
				cur_elem.find(".mplay-ui-info-mission").attr("id", "mplay-ui-info-mission-"+datos.mision_activa.id_mision);
			} else {
				cont_missions.append('<a href="javascript:;" data-mplay-setview data-lat="'+datos.mision_activa.latitud_mision+'" data-lng="'+datos.mision_activa.longitud_mision+'" class="mplay-ui-mini-icon mplay-ui-btn-danger" id="mplay-ui-btn-mission-'+datos.id+'" data-toggle="popover" data-content="'+datos.mision_activa.descripcion_corta_mision+'" data-html="true" data-trigger="hover" data-container="body" data-placement="left" title="'+datos.nombre+'"><img class="img-responsive" src="'+datos.icono+'"><div id="mplay-ui-timer-mission-'+datos.mision_activa.id_mision+'" class="mplay-ui-timer-mission hide"></div><div id="mplay-ui-info-mission-'+datos.mision_activa.id_mision+'" class="mplay-ui-info-mission hide"></div></a>');
				var missionIcon = L.AwesomeMarkers.icon({
					icon: 'ra-shoe-prints',
					markerColor: 'yellow',
					prefix: 'ra',
					className: 'awesome-marker mplay-ui-iconmap-missiondest animated flash'
				});
							
				MPlayMap.marker_missions[datos.mision_activa.id_mision] = L.marker([datos.mision_activa.latitud_mision, datos.mision_activa.longitud_mision], {
					icon: missionIcon,
					draggable: false,
					clickable: false
				}).addTo(MPlayMap.map);
			}
		
		}
		$("#mplay-ui-btn-mission-"+datos.id).popover('show');
	},
	del_from_missions: function(idm){
		if (idm == undefined || idm == ''){
			MPlayUI.Notificar("Datos de juego incorrectos","El juego no se puede cancelar porque los datos del juego no son correctos","error");
			return false;
		}
		
		var cont_missions_sidebar = $('[data-mplay-game-missions-sidebar]');
		
		cont_missions_sidebar.find("#mplay-ui-mission-sidebar-"+idm+" a.mplay-toggle-mission").remove();
		
		cont_missions_sidebar.find("#mplay-ui-mission-sidebar-"+idm+" h5.mplay-ui-game-name").addClass("mplay-ui-game-completed").addClass("disabled");
		
		cont_missions_sidebar.find("#mplay-ui-mission-sidebar-"+idm+" h5.mplay-ui-game-name a[data-mplay-show-game-info]").attr("data-mplay-game-completed", "true")
		
		$("[data-mplay-show-game-info]").off("click").on("click", function(){
			if ($(this).data("mplay-game-completed") == true){					
				var datos = MPlayJuegos.juegos_completados[$(this).data("mplay-game-id")];
			} else {
				var datos = MPlayJuegos.juegos_activos[$(this).data("mplay-game-id")];
			}
			
			MPlayJuegos.open_modal_game(datos);
		});
		
		var cont_missions = $('[data-mplay-game-missions]');
		
		cont_missions.find('#mplay-ui-btn-mission-'+idm).popover('hide').remove();
	}
};