var MPlayUsuario = {
	usuario_activo: null,
	es_nuevo: false,
	iniciado: false,
	geolocation_activa: null,
	lat: null,
	lng: null,
	inventario: [],
	habilidades: [],
	attrInventario: '[data-mplay-inventario]',
	attrCasa: '[data-mplay-inventario-casa]',
	attrSlotUsr: '[data-mplay-usuario-slot]',
	clsLinkCasa: '.mplay-popup-optbtn-almacenar',
	init_usuario: function (onSuccess, onError){
		$.get(MPlay.config.base_url + 'api/mplay/usuario/updateStatus.json/', {}, function(data){
			if (data.response_text == 'not-logged'){
				return false;
			}
			if (data.response == 'ok'){
				MPlayUsuario.usuario_activo = data.data.usuario;
				MPlayUsuario.geolocation_activa = MPlayUsuario.usuario_activo.actividad.geolocation;
				MPlayUsuario.check_jugador(function(){
					if (MPlayUsuario.es_nuevo == false){
						MPlayUsuario.update_slots_user();
						MPlayUsuario.check_casa();
						MPlayUsuario.check_nuevo_nivel();
						MPlayUsuarioSkillTree.init_skilltree();
						setInterval("MPlayUsuario.update_status_user();", MPlay.config.opciones.mapa.tiempo_refresco * 1000);
					}
					if (MideasFunciones.isFunction(onSuccess)) {
						$('body').fadeIn(0, onSuccess);
					}
				});
			} else {
				if (MideasFunciones.isFunction(onError)) {
					$('body').fadeIn(0, onError);
				}
				MPlayUI.Notificar("Error", data.response_text, 'error');
				return false;
			}
		});
	},
	check_jugador: function(onEnd){
		if (MPlayUsuario.usuario_activo == null || MPlayUsuario.usuario_activo.length == 0)
			return false;
			
		if (MPlayUsuario.usuario_activo.vida < 50 && MPlayUsuario.usuario_activo.casa != undefined && MPlayUsuario.usuario_activo.casa.id != undefined){
			MPlayUI.add_game_alert("vida-menos-50", "No puedes luchar hasta que alcances 50 PV", "Ir a mi casa", function(){
				var lat = MPlayUsuario.usuario_activo.casa.lat;
				var lng = MPlayUsuario.usuario_activo.casa.lng;
				
				var m_usr = { latlng: { lat: lat, lng: lng } };
			
				MPlayMap.mover_jugador(m_usr);
			});
		} else if (MPlayUsuario.usuario_activo.vida >= 50){
			MPlayUI.remove_game_alert("vida-menos-50");
		} else {
			MPlayUI.add_game_alert("vida-menos-50", "No puedes luchar hasta que alcances 50 PV");
		}
		
		if (MPlayUsuario.usuario_activo.es_nuevo == true){
			MPlayUsuario.es_nuevo = true;
		} else if (MPlayUsuario.usuario_activo.es_nuevo == false){
			MPlayUsuario.es_nuevo = false;
		}
		
		if (MideasFunciones.isFunction(onEnd)) {
			$('body').fadeIn(0, onEnd);
		}
	},
	check_nuevo_nivel: function(){
		if (MPlayUsuario.usuario_activo.nivel != undefined && MPlayUsuario.usuario_activo.nivel.nuevos_niveles != undefined && MPlayUsuario.usuario_activo.nivel.nuevos_niveles.length > 0){
			$.each(MPlayUsuario.usuario_activo.nivel.nuevos_niveles, function(idx, elem){
				MPlayUI.Notificar("¡Has subido de nivel!", "Has alcanzado el " + elem.nombre, "success");
			});
			MPlayUsuario.usuario_activo.nivel.nuevos_niveles = [];
			MPlayUsuario.update_status_user();
		}
	},
	check_casa: function (){
		$("[data-mplay-shortcut-home]").addClass("disabled");
		if (MPlayUsuario.usuario_activo.casa == undefined || MPlayUsuario.usuario_activo.casa == ''){
			MPlayUI.add_game_alert("crear-casa", "¡Aun no has elegido la dirección de tu casa!", "Crear casa", function(){
				MPlayUsuario.crear_casa_init();
				$("#mdl-search-address").modal({show: true});
			});
			MPlayUI.Notificar("Error al buscar tu casa", "Se ha producido un error al buscar tu casa. Recarga la página, por favor.", "error");
		} else if (MPlayUsuario.usuario_activo.casa == 'no'){
			MPlayUI.add_game_alert("crear-casa", "¡Aun no has elegido la dirección de tu casa!", "Crear casa", function(){
				MPlayUsuario.crear_casa_init();
				$("#mdl-search-address").modal({show: true});
			});
			bootbox.confirm({ message: "Aún no has establecido cuál es tu casa. Es necesario que establezcas la dirección de tu casa para poder jugar. ¿Quieres guardar ahora la dirección de tu casa?", locale: 'es', closeButton: false, size: "small", callback: function(result){
					if (result == true){
						MPlayUsuario.crear_casa_init();
						$("#mdl-search-address").modal({show: true});
					}
				}
			});
		} else {
			MPlayUI.remove_game_alert("crear-casa");
			$("[data-mplay-shortcut-home]").attr("data-lat", MPlayUsuario.usuario_activo.casa.lat);
			$("[data-mplay-shortcut-home]").attr("data-lng", MPlayUsuario.usuario_activo.casa.lng);
			$("[data-mplay-shortcut-home]").removeClass("disabled");
			MPlaySitio.init_mejorar_casa($('body'));
		}
	},
	crear_casa_init: function (){
		var jElement = $("[data-mplay-crear-casa]");
		if (jElement.length > 0) {
			jElement.each(function(idx, ele){
				$(ele).off("click");
				$(ele).on("click", function(){
					var input_lat = $(this).data("input-lat");
					var input_lng = $(this).data("input-lng");
					
					if (input_lng == undefined || input_lat == undefined){
						MPlayUI.Notificar("Error al crear tu casa", "No se han encontrado las coordenadas de tu casa", "error");
						return false;
					}
					
					var lat = $(input_lat).val();
					var lng = $(input_lng).val();
					
					if (lat == undefined || lat == "" || lng == undefined || lng == ""){
						MPlayUI.Notificar("Error al crear tu casa", "No se han encontrado las coordenadas de tu casa", "error");
						return false;
					}
					
					var este = $(this);
					var old_html = este.html();
					
					este.addClass("disabled").html('<div id="loading_ta" style="position: relative;display: block;top: auto;right: auto;z-index: 0;"><i class="fa fa-spin fa-circle-o-notch"></i></div>');
					
					$.post(MPlay.config.base_url + "api/mplay/usuario/crearCasa.json", { lat: lat, lng: lng }, function(data){
						if (data.response == 'ok'){
							$("#mdl-search-address").modal('hide');
							MPlayUsuario.update_status_user(null, null, function(){
								MPlayUsuario.check_casa();
							});
							este.html(old_html).removeClass("disabled");
							MPlayUI.Notificar("¡Enhorabuena, ya tienes casa!", "Ahora podrás guardar todos los items que no necesites en tus viajes en tu casa.", "success");
						} else {
							este.html(old_html).removeClass("disabled");
							MPlayUI.Notificar("Error", data.response_text, "error");
						}
					});
				});
			});
		}
		MPlayUI.buttonEvents();
	},
	update_status_user: function (lat, lng, onEnd){
		var options = { geolocation: MPlayUsuario.geolocation_activa };
		var append_opts = '/';
		if (lat != null && lng != null){
			options.lat = lat;
			options.lng = lng;
		}
		$.get(MPlay.config.base_url + 'api/mplay/usuario/updateStatus.json'+append_opts, options, function(data){
			if (data.response_text == 'not-logged'){
				window.location.reload(false);
				return false;
			}
			if (data.response == 'ok'){
				if (MPlayUsuario.iniciado == true){
					if (data.data.lat != undefined && data.data.lng != undefined){
						MPlayUsuario.lat = data.data.lat;
						MPlayUsuario.lng = data.data.lng;
					} else {
						MPlayUsuario.lat = MPlay.config.opciones.usuario.lat_inicial;
						MPlayUsuario.lng = MPlay.config.opciones.usuario.lng_final;
					}
					MPlayUsuario.geolocation_activa = '0';
					
					data.data.usuario.actividad.latitud = MPlay.config.opciones.usuario.lat_inicial;
					data.data.usuario.actividad.longitud = MPlay.config.opciones.usuario.lng_final;
					
					MPlayUsuario.iniciado == false;
				} else {
					MPlayUsuario.lat = data.data.lat;
					MPlayUsuario.lng = data.data.lng;
					MPlayUsuario.geolocation_activa = data.data.usuario.actividad.geolocation;
				}
				MPlayUsuario.usuario_activo = data.data.usuario;
				
				MPlayUsuario.habilidades = data.data.usuario.habilidades;
				
				var perc_vida = parseInt( ( 100 * parseInt(data.data.usuario.vida) ) / parseInt(data.data.usuario.max_vida) );
				
				$("[data-mplay-user-name]").html(data.data.usuario.nombre);
				$("[data-mplay-user-money]").html(parseInt(data.data.usuario.dinero).formatMoney(0, ',', '.'));
				$("[data-mplay-user-level]").html(parseInt(data.data.usuario.puntos).formatMoney(0, ',', '.'));
				$("[data-mplay-user-vida]").html(parseInt(data.data.usuario.vida).formatMoney(0, ',', '.')+"/"+parseInt(data.data.usuario.max_vida).formatMoney(0, ',', '.')).attr("aria-valuemax", parseInt(data.data.usuario.max_vida)).attr("aria-valuenow", parseInt(data.data.usuario.vida)).css("width", perc_vida+"%");
				$("[data-mplay-user-velocidad]").html(parseInt(data.data.usuario.velocidad).formatMoney(0, ',', '.'));
				$("[data-mplay-user-rvisibilidad]").html(parseFloat(data.data.usuario.rango_vision).formatMoney(2, ',', '.'));
				$("[data-mplay-user-rinteraccion]").html(parseFloat(data.data.usuario.rango_interaccion).formatMoney(2, ',', '.'));
				$("[data-mplay-user-ataque]").html(parseInt(data.data.usuario.ataque).formatMoney(0, ',', '.'));
				$("[data-mplay-user-defensa]").html(parseInt(data.data.usuario.defensa).formatMoney(0, ',', '.'));
				$("[data-mplay-user-carisma]").html(parseInt(data.data.usuario.carisma).formatMoney(0, ',', '.'));
				$("[data-mplay-user-especial]").html(parseInt(data.data.usuario.especial).formatMoney(0, ',', '.'));
				$("[data-mplay-user-level-text]").html(data.data.usuario.nivel.nombre);
				$("[data-mplay-user-level-number]").html(data.data.usuario.nivel.orden);
				$("[data-mplay-user-oficio-text]").html(data.data.usuario.oficio.nombre);
				
				MPlayUsuario.check_jugador();
				MPlayUsuario.update_slots_user();
				//MPlayUsuario.check_casa();
				MPlayUsuario.check_nuevo_nivel();
				MPlayUsuarioSkillTree.init_skilltree();
				
				if (MPlayUI.loader_max > 0){
					MPlayUI.inc_loader($('body'), 1);
				}

				if (MideasFunciones.isFunction(onEnd)){
					$('body').fadeIn(0,onEnd);
				}
				
				return true;
			} else {
				MPlayUI.Notificar("Error", data.response_text, "error");
				return false;
			}
		});
	},
	update_slots_user: function (){
		MPlayUsuario.reset_slots_user();
	},
	reset_slots_user: function (){
		if (MPlay.config.opciones.modulos.modulos.inventario.activo != '1'){
			return false;
		}
		var jElementSlot = $(this.attrSlotUsr);
		if (jElementSlot.length > 0) {
			jElementSlot.each(function(idx, ele){
				var tpl_empty_slot = '<img src="'+MPlay.config.opciones.modulos.modulos.inventario.opciones.img_invslot_empty_sm+'" class="img-responsive thumbnail" />';
				var tpl_full_slot = '<a href="javascript:;" class="thumbnail" title="##NOMBRE##" data-item-nombre="##NOMBRE##" data-itemid="##ID##" data-item-slot="##SLOT##" data-item-tiposlots="##TIPOSLOTS##"><img src="##ICONO##" class="img-responsive" /></a>';
				
				var slot = $(ele).data("mplay-slot");
				var tipo_slot = $(ele).data("mplay-tiposlot");
				
				if (MPlayUsuario.usuario_activo[tipo_slot][slot] != undefined && MPlayUsuario.usuario_activo[tipo_slot][slot] != ""){
					var res_tpl_info = tpl_full_slot.replace("##ID##", MPlayUsuario.usuario_activo[tipo_slot][slot]['id']);
					res_tpl_info = res_tpl_info.replace("##NOMBRE##", MPlayUsuario.usuario_activo[tipo_slot][slot]['nombre']);
					res_tpl_info = res_tpl_info.replace("##NOMBRE##", MPlayUsuario.usuario_activo[tipo_slot][slot]['nombre']);
					res_tpl_info = res_tpl_info.replace("##ICONO##", MPlayUsuario.usuario_activo[tipo_slot][slot]['icono_big']);
					res_tpl_info = res_tpl_info.replace("##SLOT##", slot);
					res_tpl_info = res_tpl_info.replace("##TIPOSLOTS##", tipo_slot);
					
					var cont = $(ele).find('[data-mplay-slot-content]');
					
					cont.html('').html(res_tpl_info);
					
					$(ele).find("a.thumbnail").unbind("click");
					$(ele).find("a.thumbnail").on("click", function(){
							var id_item = $(this).data('itemid');
							var nombre_item =  $(this).data('item-nombre');
							var tipo_slots =  $(this).data('item-tiposlots');
							var slot =  $(this).data('item-slot');
							var este = $(this);
							
							var actual_html = este.html();
							
							este.addClass("disabled").html('<i class="fa fa-cog fa-spin"></i>');
							
							$.post(MPlay.config.base_url + 'api/mplay/usuario/desequiparItem.json', { id_item: id_item, tipo_slots: tipo_slots, slot: slot }, function(data){
								if (data.response == 'ok'){
									MPlayUsuario.init_inventario($('body'));
									MPlayUsuario.update_status_user();
									MPlayUsuario.update_slots_user();
									MPlayUI.Notificar("Item desequipado", "Te has desequipado el item " + nombre_item, "info");
									este.removeClass('disabled').html(actual_html);
								} else {
									MPlayUI.Notificar("Error", data.response_text, 'error');
									este.removeClass('disabled').html(actual_html);
								}
							});							
						});
				} else {
					var cont = $(ele).find('[data-mplay-slot-content]');
					cont.html('').html(tpl_empty_slot);
				}
			});
		}
		
		MPlayUI.buttonEvents();
	},
	reset_inventario: function (contenedor_jq){
		if (MPlay.config.opciones.modulos.modulos.inventario.activo != '1'){
			return false;
		}
		MPlayUsuario.inventario = [];
		var jElementInventario = contenedor_jq.find(this.attrInventario);
		if (jElementInventario.length > 0) {
			jElementInventario.each(function(idx, ele){
				var contenedor_info_item = $(ele).find('.mplay-ui-inventory-info');
				var contenedor_list_item = $(ele).find('.mplay-ui-inventory-list');
				
				var tpl_inv_item_list = contenedor_list_item.data('mplay-tpl');
				
				contenedor_list_item.html('');
				for (i=0; i < MPlay.config.opciones.modulos.modulos.inventario.opciones.max_items_inventario; i++){
					contenedor_list_item.append(tpl_inv_item_list);
				}
				
				contenedor_info_item.html('');
			});
		}
		
		MPlayUI.buttonEvents();
	},
	init_inventario: function (contenedor_jq, desde_comercio, onEnd){
		MPlayUsuario.reset_inventario(contenedor_jq);
		
		var jElementInventario = contenedor_jq.find(this.attrInventario);
		if (jElementInventario.length > 0) {
			
			$.get(MPlay.config.base_url + 'api/mplay/usuario/rellenarInventario.json', {}, function(data){
				if (data.response == 'ok'){
					
					$.each(data.data, function(idx, elem){
						MPlayUsuario.inventario.push(elem);
						
						jElementInventario.each(function(idx2, ele){

							var active_cls = '';
							var extra_cls = ''
							var hide_info_cls = ' style="display: none;"';
							if (idx == 0){
								active_cls = ' active';
								hide_info_cls = '';
							}
							if (elem.esta_equipado == true){
								extra_cls = ' mplay-item-equipped';
							}
							var contenedor_info_item = $(ele).find('.mplay-ui-inventory-info');
							var tpl_inv_item_info = contenedor_info_item.data('mplay-tpl');
							var tpl_inv_item_prop = contenedor_info_item.data('mplay-tplpropiedad');
							var uid_cont = contenedor_info_item.data('mplay-uid');
							
							var idx_uid = idx + '-' + uid_cont;
							
							var tpl_inv_item = '<a class="mplay-item-inv thumbnail tip-e'+active_cls+extra_cls+'" data-mplay-toggleitems href="#mplay-iteminfo-'+idx_uid+'" title="'+elem.nombre+'"> <img src="'+elem.icono+'" class="img-responsive" /> </a>';
							
							var propiedades_item = elem.propiedades_html;
							
							/*$.each(elem.propiedades, function(idxprop, eleprop){
								if (idxprop != undefined && idxprop != ''){
									if (eleprop.visible != false){
										var valor = '';
										var tpl_inv_item_prop_tmp = tpl_inv_item_prop;
										if (eleprop.valor != undefined && eleprop.valor != '' && eleprop.valor != 'undefined'){
											valor = eleprop.valor;
										} else {
											valor = '0';
										}
										
										var tmp_tpl = tpl_inv_item_prop_tmp.replace("##NOMBRE##", eleprop.nombre);
										tmp_tpl = tmp_tpl.replace("##ICONO##", eleprop.icono);
										tmp_tpl = tmp_tpl.replace("##VALOR##", valor);
										
										propiedades_item += tmp_tpl;
									}
								}
							});*/
																							
							var res_tpl_info = tpl_inv_item_info.replace("##IDX##", idx_uid);
							res_tpl_info = res_tpl_info.replace("##NOMBRE##", elem.nombre);
							res_tpl_info = res_tpl_info.replace("##TIPO##", elem.tipo);
							res_tpl_info = res_tpl_info.replace("##DESCRIPCION##", elem.descripcion);
							res_tpl_info = res_tpl_info.replace("##ACTIVECLASS##", hide_info_cls);
							res_tpl_info = res_tpl_info.replace("##PROPIEDADES##", propiedades_item);
							if ($(ele).data('mplay-comerciar') == true){
								res_tpl_info = res_tpl_info.replace("##OPCIONES##", elem.opciones_comerciar);
							} else if ($(ele).data('mplay-almacenar') == true) {
								res_tpl_info = res_tpl_info.replace("##OPCIONES##", elem.opciones_almacenar);
							} else {
								res_tpl_info = res_tpl_info.replace("##OPCIONES##", elem.opciones);
							}
							
							$(ele).find('.mplay-inv-slot').eq(idx).html(tpl_inv_item);
							
							contenedor_info_item.append(res_tpl_info);

							$(ele).find(".mplay-item-inv").unbind( "click" );
							$(ele).find(".mplay-item-inv").on("click", function(){
								var $href = $(this).attr('href');
								var $todos_contenedores = $(ele).find("[data-mplay-infoitem]");
								var $todos_items = $(ele).find("[data-mplay-toggleitems]");
								
								$todos_items.removeClass('active');
								$todos_contenedores.hide();
								
								$($href).show();
								$(this).addClass('active');
								
								return false;
							});
							
							$(ele).find(".mplay-popup-optbtn-dropitem").unbind( "click" );
							$(ele).find(".mplay-popup-optbtn-dropitem").on('click', function(){
								var id_item = $(this).data('itemid');
								var nombre_item =  $(this).data('item-nombre');
								var este = $(this);
								
								var actual_html = este.html();
								
								este.addClass("disabled").html('<i class="fa fa-cog fa-spin"></i>');
								
								$.post(MPlay.config.base_url + 'api/mplay/usuario/soltarItem.json', { id_item: id_item }, function(data){
									if (data.response == 'ok'){
										MPlayUsuario.init_inventario(contenedor_jq);
										MPlayUsuario.update_status_user(null, null, function(){
											MPlayMap.realtime.update();
										  });
										MPlayUI.Notificar("Item perdido", "Has soltado el item " + nombre_item, "info");
										este.removeClass('disabled').html(actual_html);
									} else {
										MPlayUI.Notificar("Error", data.response_text, 'error');
										este.removeClass('disabled').html(actual_html);
									}
								});							
							});
							
							$(ele).find(".mplay-popup-optbtn-useitem").unbind( "click" );
							$(ele).find(".mplay-popup-optbtn-useitem").on('click', function(){
								var id_item = $(this).data('itemid');
								var nombre_item =  $(this).data('item-nombre');
								var este = $(this);
								
								var actual_html = este.html();
								
								este.addClass("disabled").html('<i class="fa fa-cog fa-spin"></i>');
								
								$.post(MPlay.config.base_url + 'api/mplay/usuario/usarItem.json', { id_item: id_item }, function(data){
									if (data.response == 'ok'){
										MPlayUsuario.init_inventario(contenedor_jq);
										MPlayUsuario.update_status_user(null, null, function(){
											MPlayMap.realtime.update();
										  });
										MPlayUI.Notificar("Item usado", "Has usado el item " + nombre_item, "info");
										este.removeClass('disabled').html(actual_html);
									} else {
										MPlayUI.Notificar("Error", data.response_text, 'error');
										este.removeClass('disabled').html(actual_html);
									}
								});							
							});
							
							$(ele).find(".mplay-popup-optbtn-readitem").unbind( "click" );
							$(ele).find(".mplay-popup-optbtn-readitem").on('click', function(){
								var id_item = $(this).data('itemid');
								var nombre_item =  $(this).data('item-nombre');
								var este = $(this);
								
								var actual_html = este.html();
								
								este.addClass("disabled").html('<i class="fa fa-cog fa-spin"></i>');
								
								$.post(MPlay.config.base_url + 'api/mplay/usuario/leerItem.json', { id_item: id_item }, function(data){
									if (data.response == 'ok'){
										MPlayUsuario.update_status_user();
										
										var titulo = data.data.titulo;
										var contenido = data.data.contenido;
										
										$("body").append('<div class="modal" id="mdl-read-book"><div class="modal-dialog modal-lg"><div class="modal-content"><div class="modal-header"><button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button><h4 class="modal-title">'+titulo+'</h4></div><div class="modal-body">'+contenido+'</div></div></div></div>');
										
										$("#mdl-read-book").modal('show');
										
										$("#mdl-read-book").on("hidden.bs.modal", function(){
											$("#mdl-read-book").remove();
											MPlayUsuario.update_status_user(null, null, function(){
												MPlayMap.realtime.update();
											  });
										});
																				
										//MPlayUI.Notificar("Item leido", "Has leido el item " + nombre_item, "info");
										este.removeClass('disabled').html(actual_html);
									} else {
										MPlayUI.Notificar("Error", data.response_text, 'error');
										este.removeClass('disabled').html(actual_html);
									}
								});							
							});
							
							$(ele).find(".mplay-popup-optbtn-equipitem").unbind( "click" );
							$(ele).find(".mplay-popup-optbtn-equipitem").on('click', function(){
								var id_item = $(this).data('itemid');
								var nombre_item =  $(this).data('item-nombre');
								var tipo_slots =  $(this).data('item-tiposlots');
								var slot =  $(this).data('item-slot');
								var este = $(this);
								
								var actual_html = este.html();
								
								este.addClass("disabled").html('<i class="fa fa-cog fa-spin"></i>');
								
								$.post(MPlay.config.base_url + 'api/mplay/usuario/equiparItem.json', { id_item: id_item, tipo_slots: tipo_slots, slot: slot }, function(data){
									if (data.response == 'ok'){
										MPlayUsuario.init_inventario(contenedor_jq);
										MPlayUsuario.update_status_user(null, null, function(){
											MPlayMap.realtime.update();
										  });
										MPlayUI.Notificar("Item equipado", "Te has equipado con el item " + nombre_item, "info");
										este.removeClass('disabled').html(actual_html);
									} else {
										MPlayUI.Notificar("Error", data.response_text, 'error');
										este.removeClass('disabled').html(actual_html);
									}
								});							
							});
							
							$(ele).find(".mplay-popup-optbtn-unequipitem").unbind( "click" );
							$(ele).find(".mplay-popup-optbtn-unequipitem").on('click', function(){
								var id_item = $(this).data('itemid');
								var nombre_item =  $(this).data('item-nombre');
								var tipo_slots =  $(this).data('item-tiposlots');
								var slot =  $(this).data('item-slot');
								var este = $(this);
								
								var actual_html = este.html();
								
								este.addClass("disabled").html('<i class="fa fa-cog fa-spin"></i>');
								
								$.post(MPlay.config.base_url + 'api/mplay/usuario/desequiparItem.json', { id_item: id_item, tipo_slots: tipo_slots, slot: slot }, function(data){
									if (data.response == 'ok'){
										MPlayUsuario.init_inventario(contenedor_jq);
										MPlayUsuario.update_status_user(null, null, function(){
											MPlayMap.realtime.update();
										  });
										MPlayUI.Notificar("Item desequipado", "Te has desequipado el item " + nombre_item, "info");
										este.removeClass('disabled').html(actual_html);
									} else {
										MPlayUI.Notificar("Error", data.response_text, 'error');
										este.removeClass('disabled').html(actual_html);
									}
								});							
							});

						});

					});
				} else {
					MPlayUI.Notificar("Error", data.response_text, 'error');
				}
				if (desde_comercio == true){
					MPlaySitio.update_comerciar(contenedor_jq, MPlaySitio.comercio_activo.id);
					MPlayUsuario.update_status_user();
				}
			});
			if (MideasFunciones.isFunction(onEnd)){
				$('body').fadeIn(0, onEnd);
			}
		} else {
			if (MideasFunciones.isFunction(onEnd)){
				$('body').fadeIn(0, onEnd);
			}
		}
		
		MPlayUI.buttonEvents();
	},
	update_status_casa: function (){
		var options = {};
		var append_opts = '';
		if (MPlayUsuario.usuario_activo.casa.id != null){
			options.id_casa = MPlayUsuario.usuario_activo.casa.id;
			append_opts = '/';
		}
		$.get(MPlay.config.base_url + 'api/mplay/usuario/updateStatusCasa.json'+append_opts, options, function(data){
			if (data.response == 'ok'){
				MPlayUsuario.update_status_user(null, null, function(){
					MPlayMap.realtime.update();
				  });
				$("[data-mplay-casa-name]").html(data.data.casa.nombre);
				$("[data-mplay-casa-money]").html(data.data.casa.dinero);
				return true;
			} else {
				MPlayUI.Notificar("Error", data.response_text, "error");
				return false;
			}
		});
	},
	init_casa: function (contenedor_jq, onEnd){
		var jElementInventario = contenedor_jq.find(this.clsLinkCasa);
		var map = $("[data-mplay-mapa]");
		
		map.off("click", this.clsLinkCasa);
		map.on("click", this.clsLinkCasa, function(){
			var este = $(this);
			var modal_id = este.attr("href");
							
			MPlayUsuario.update_casa(contenedor_jq);
			
			$(modal_id).modal({show: true});
			
			return false;
		});
		if (MideasFunciones.isFunction(onEnd)){
			$('body').fadeIn(0, onEnd);
		}
	},
	reset_casa: function (contenedor_jq){
		var jElementInventario = contenedor_jq.find(this.attrCasa);
		if (jElementInventario.length > 0) {
			jElementInventario.each(function(idx, ele){
				var contenedor_info_item = $(ele).find('.mplay-ui-inventory-info');
				var contenedor_list_item = $(ele).find('.mplay-ui-inventory-list');
				
				var tpl_inv_item_list = contenedor_list_item.data('mplay-tpl');
				
				contenedor_list_item.html('');
				if (MPlayUsuario.usuario_activo.casa != undefined && MPlayUsuario.usuario_activo.casa.casillas != undefined){				
					for (i=0; i < MPlayUsuario.usuario_activo.casa.casillas; i++){
						contenedor_list_item.append(tpl_inv_item_list);
					}
				}
				
				contenedor_info_item.html('');
			});
		}
	},
	update_casa: function (contenedor_jq){
		MPlayUsuario.reset_casa(contenedor_jq);
		//MPlaySitio.update_status_comercio(id_sitio);
		
		MPlayUsuario.update_status_casa();
		
		var jElementInventario = contenedor_jq.find(this.attrCasa);
		if (jElementInventario.length > 0) {
			jElementInventario.each(function(idx, ele){
				
				$.get(MPlay.config.base_url + 'api/mplay/usuario/rellenarInventarioCasa.json/', {}, function(data){
					if (data.response == 'ok'){
						$.each(data.data, function(idx, elem){
							var active_cls = '';
							var hide_info_cls = ' style="display: none;"';
							if (idx == 0){
								active_cls = ' active';
								hide_info_cls = '';
							}
							var contenedor_info_item = $(ele).find('.mplay-ui-inventory-info');
							var tpl_inv_item_info = contenedor_info_item.data('mplay-tpl');
							var tpl_inv_item_prop = contenedor_info_item.data('mplay-tplpropiedad');
							var uid_cont = contenedor_info_item.data('mplay-uid');
							
							var idx_uid = idx + '-' + uid_cont;
							
							var tpl_inv_item = '<a class="mplay-item-inv thumbnail tip-e'+active_cls+'" data-mplay-toggleitems href="#mplay-iteminfo-'+idx_uid+'" title="'+elem.nombre+'"> <img src="'+elem.icono+'" class="img-responsive" /> </a>';
							
							var propiedades_item = elem.propiedades_html;
																							
							var res_tpl_info = tpl_inv_item_info.replace("##IDX##", idx_uid);
							res_tpl_info = res_tpl_info.replace("##NOMBRE##", elem.nombre);
							res_tpl_info = res_tpl_info.replace("##TIPO##", elem.tipo);
							res_tpl_info = res_tpl_info.replace("##DESCRIPCION##", elem.descripcion);
							res_tpl_info = res_tpl_info.replace("##ACTIVECLASS##", hide_info_cls);
							res_tpl_info = res_tpl_info.replace("##PROPIEDADES##", propiedades_item);
							res_tpl_info = res_tpl_info.replace("##OPCIONES##", elem.opciones);
							
							$(ele).find('.mplay-inv-slot').eq(idx).html(tpl_inv_item);
							
							contenedor_info_item.append(res_tpl_info);
						});

						$(ele).find(".mplay-item-inv").unbind( "click" );
						$(ele).find(".mplay-item-inv").on("click", function(){
							var $href = $(this).attr('href');
							var $todos_contenedores = $(ele).find("[data-mplay-infoitem]");
							var $todos_items = $(ele).find("[data-mplay-toggleitems]");
							
							$todos_items.removeClass('active');
							$todos_contenedores.hide();
							
							$($href).show();
							$(this).addClass('active');
							
							return false;
						});
						
						$(ele).find(".mplay-popup-optbtn-getitem").off("click");
						$(ele).find(".mplay-popup-optbtn-getitem").on("click", function(){
							var id_item = $(this).data('itemid');
							
							var este = $(this);
								
							var actual_html = este.html();
							
							este.addClass("disabled").html('<i class="fa fa-cog fa-spin"></i>');
							
							$.post(MPlay.config.base_url + 'api/mplay/usuario/recogerItem.json', { id_item: id_item }, function(data){
								if (data.response == 'ok'){
									MPlayUsuario.update_casa(contenedor_jq);
									MPlayUsuario.init_inventario($('body'));
									MPlayUI.Notificar("Item recogido", "Has recogido el item " + data.data.nombre +" de tu casa", "info");
									este.removeClass('disabled').html(actual_html);
								} else {
									MPlayUI.Notificar("Error", data.response_text, 'error');
									este.removeClass('disabled').html(actual_html);
								}
							});							
						});
						
						
					} else {
						MPlayUI.Notificar("Error", data.response_text, 'error');
					}
					$("[data-mplay-almacenar]").find(".mplay-popup-optbtn-archiveitem").attr("data-item-sitio", MPlayUsuario.usuario_activo.casa.id);
					
					$("[data-mplay-almacenar]").find(".mplay-popup-optbtn-archiveitem").unbind("click");
					$("[data-mplay-almacenar]").find(".mplay-popup-optbtn-archiveitem").on('click', function(){
						var id_item = $(this).data('itemid');
						var nombre_item =  $(this).data('item-nombre');
						var id_sitio =  $(this).data('item-sitio');
						var este = $(this);
						
						var actual_html = este.html();
						
						este.addClass("disabled").html('<i class="fa fa-cog fa-spin"></i>');
						
						$.post(MPlay.config.base_url + 'api/mplay/usuario/almacenarItem.json', { id_item: id_item, id_sitio: id_sitio }, function(data){
							if (data.response == 'ok'){
								MPlayUsuario.init_inventario(contenedor_jq);
								MPlayUsuario.update_casa(contenedor_jq);
								MPlayUsuario.update_status_user(null, null, function(){
									MPlayMap.realtime.update();
								  });
								MPlayUI.Notificar("Item almacenado", "Has almacenado el item " + nombre_item + " en tu casa", "info");
								este.removeClass('disabled').html(actual_html);
							} else {
								MPlayUI.Notificar("Error", data.response_text, 'error');
								este.removeClass('disabled').html(actual_html);
							}
						});							
					});
					
				});
			});
		}
		MPlayUI.buttonEvents();
	}
};