var MPlayUsuarioSkillTree = {
	habilidades: [],
	habilidades_conseguidas: [],
	nodes: [],
	tree_options: {
		margin: {top: 50, right: 0, bottom: 20, left: 210},
		width: 100,
		height: 100
	},
	init_skilltree: function(onSuccess, onError){
		MPlayUsuarioSkillTree.update_nodes();
	},
	update_nodes: function(){
		var arr_habilidades = $.makeArray(MPlayUsuario.usuario_activo.habilidades);
		var arr_todas_habilidades = $.makeArray(MPlayUsuario.usuario_activo.todas_habilidades);
		
		MPlayUsuarioSkillTree.habilidades_conseguidas = [];
		MPlayUsuarioSkillTree.habilidades = [];
		
		if (arr_habilidades != undefined && arr_habilidades.length > 0){
			$.each(arr_habilidades, function(idx, ele){
				MPlayUsuarioSkillTree.habilidades_conseguidas.push(ele.id);
			});
		}
		
		if (arr_todas_habilidades != undefined && arr_todas_habilidades.length > 0){
			MPlayUsuarioSkillTree.habilidades = arr_todas_habilidades;
		}
		
		MPlayUsuarioSkillTree.fill_nodes(MPlayUsuarioSkillTree.habilidades);
		
		MPlayUsuarioSkillTree.init_layout();
	},
	fill_nodes: function(data, skill_root){
		MPlayUsuarioSkillTree.nodes = [];
		if (skill_root == undefined || skill_root == ''){
			skill_root = '99999';
		}
		if (data != undefined && data.length > 0){
			if (skill_root != '0'){
				var model_root = { id: skill_root, name: MPlayUsuario.usuario_activo.nombre, description: "", properties: "", cost: "", icon: MPlayUsuario.usuario_activo.avatar, parent: null, aprendida: true };
			}
			var children_root = [];
			$.each(data, function(idx, ele){
				var model = MPlayUsuarioSkillTree.get_skill_model(ele.id, data, skill_root);
				
				if (model.id != undefined && model.id != 0){
					children_root.push(model);
				}
			});
			if (skill_root != '0'){
				model_root.children = children_root;
				MPlayUsuarioSkillTree.nodes.push(model_root);
			} else {
				MPlayUsuarioSkillTree.nodes = children_root;
			}
		}
	},
	get_skill: function(skill_id, data){
		if (skill_id == undefined || skill_id == '' || data == undefined || data.length == 0)
			return false;
			
		//Buscamos la habilidad entre las habilidades disponibles
		var obj_skill = false;
		$.each(data, function(idx, ele){
			if (ele.id == skill_id){
				obj_skill = ele;
				return false;
			}
		});

		return obj_skill;
	},
	get_skill_model: function(skill_id, data, skill_root){
		var obj_skill = MPlayUsuarioSkillTree.get_skill(skill_id, data);
		
		if (obj_skill != false && obj_skill.id != undefined){
			if (obj_skill.padre == '0'){
				var model = { id: obj_skill.id, name: obj_skill.nombre, description: obj_skill.descripcion, properties: obj_skill.propiedades_html, cost: obj_skill.coste, icon: obj_skill.icono, parent: skill_root, aprendida: obj_skill.aprendida/*MPlayUsuarioSkillTree.check_learned_skill(obj_skill.id)*/, onclick: obj_skill.onclick, href: obj_skill.href };
				if (MPlayUsuarioSkillTree.node_has_children(obj_skill.id, data)){
					model.children = MPlayUsuarioSkillTree.get_node_children(obj_skill.id, data);
				}
				return model;
			} else {
				return false;
			}
		} else {
			return false;
		}
	},
	node_has_children: function(skill_id, data){
		var obj_skill = MPlayUsuarioSkillTree.get_skill(skill_id, data);
		if (obj_skill != false && obj_skill.id != undefined){
			var encontrado = false;
			$.each(data, function(idx, ele){
				if (ele.padre == skill_id){
					encontrado = true;
					return false;
				}
			});
			if (encontrado == true){
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	},
	get_node_children: function(skill_id, data){
		if (!MPlayUsuarioSkillTree.node_has_children(skill_id, data))
			return false;
			
		var obj_skill = MPlayUsuarioSkillTree.get_skill(skill_id, data);
		if (obj_skill != false && obj_skill.id != undefined){
			var hijos = [];
			$.each(data, function(idx, ele){
				if (ele.padre == skill_id){
					var obj_skill_hijo = MPlayUsuarioSkillTree.get_skill(ele.id, data);
					var model = { id: obj_skill_hijo.id, name: obj_skill_hijo.nombre, description: obj_skill_hijo.descripcion, properties: obj_skill_hijo.propiedades_html, cost: obj_skill_hijo.coste, icon: obj_skill_hijo.icono, parent: skill_id, aprendida: obj_skill_hijo.aprendida /*MPlayUsuarioSkillTree.check_learned_skill(obj_skill_hijo.id)*/, onclick: obj_skill_hijo.onclick, href: obj_skill_hijo.href };
					if (MPlayUsuarioSkillTree.node_has_children(obj_skill_hijo.id, data)){
						model.children = MPlayUsuarioSkillTree.get_node_children(obj_skill_hijo.id, data);
					}
					hijos.push(model);
				}
			});
			return hijos;
		} else {
			return false;
		}
	},
	check_learned_skill: function(skill_id){
		if (skill_id == undefined || skill_id == '' || MPlayUsuarioSkillTree.habilidades_conseguidas == undefined || MPlayUsuarioSkillTree.habilidades_conseguidas.length == 0)
			return false;
			
		if ($.inArray(skill_id.toString(), MPlayUsuarioSkillTree.habilidades_conseguidas) != '-1'){
			return true;
		} else {
			return false;
		}
	},
	init_layout: function(){
		if (MPlayUsuarioSkillTree.nodes == undefined || MPlayUsuarioSkillTree.nodes.length == 0)
			return false;
			
		$(".mplay-skill-tree").html("");	
		
		var tree = d3.layout.tree()
			.nodeSize([MPlayUsuarioSkillTree.tree_options.width, MPlayUsuarioSkillTree.tree_options.height]);
			//.size([MPlayUsuarioSkillTree.tree_options.height, MPlayUsuarioSkillTree.tree_options.width]);
		
		var diagonal = d3.svg.diagonal()
			.projection(function(d) { return [d.x, d.y]; });
		
		var svg = d3.select(".mplay-skill-tree").append("svg")
			.attr("width", '100%')
			.attr("height", '100%');
			
		var g =	svg.append("g")
			.attr("class", "node-root")
			.attr("transform", "translate(" + MPlayUsuarioSkillTree.tree_options.margin.left + "," + MPlayUsuarioSkillTree.tree_options.margin.top + ")");
		
		root = MPlayUsuarioSkillTree.nodes[0];
		  
		MPlayUsuarioSkillTree.update_layout(root, tree, g, diagonal);
	},
	update_layout: function(source, tree, svg, diagonal){
		var i = 0;
		
		// Add tooltip div
		var div = d3.select("body").append("div")
		.attr("class", "mplay-tooltip")
		.style("opacity", 0)
		.style("display", "none");
		
		// Compute the new tree layout.
		var nodes = tree.nodes(root).reverse(),
		  links = tree.links(nodes);
		
		// Normalize for fixed-depth.
		nodes.forEach(function(d) { d.y = d.depth * 100; });
		
		// Declare the nodes…
		var node = svg.selectAll("g.node")
		  .data(nodes, function(d) { return d.id || (d.id = ++i); });
		
		// Enter the nodes.
		var nodeEnter = node.enter().append("g")
		  .attr("class", function(d) {
			  if (d.aprendida == true){
				  return "node learned";
			  } else {
				  return "node not-learned";
			  }
		  })
		  .attr("transform", function(d) { 
			  return "translate(" + d.x + "," + d.y + ")"; });
				
		nodeEnter.append("image")
		  .attr("xlink:href", function(d) { return d.icon; })
		  .attr("x", "-30px")
		  .attr("y", "-30px")
		  .attr("width", "60px")
		  .attr("height", "60px");
		  
		var img_frame = nodeEnter.append("image")
		  	.attr("xlink:href", function(d){
				if (d.aprendida == true){
					return "extensions/ext_mplay/assets/css/themes/default/img/frame_avatar.png";
				} else {
					return "extensions/ext_mplay/assets/css/themes/default/img/frame_inactive.png";
				}
			})
			.attr("class", "frame")
			.attr("x", "-35px")
			.attr("y", "-35px")
			.attr("width", "76px")
			.attr("height", "78px");
		   
		var cost_txt = nodeEnter.append("text")
		  .attr("y", 28)
		  .attr("dy", ".35em")
		  .attr("x", 25)
		  .attr('class', function(d){
			  if (d.aprendida == true){
			  	return 'skill-cost hide';
			  } else {
				return 'skill-cost inactive';  
			  }
		  })
		  .attr("text-anchor", "middle")
		  .html(function(d) {
			  if (d.aprendida == false){
		  		return d.cost;
			  } else {
				return 'ok';  
			  }
		  })
		  .style("fill-opacity", 1)
		  .style("fill", 'white');
		  
		img_frame.on("mouseover", function(d){
			if (d.onclick != undefined && d.onclick != ''){
				if (d.aprendida == true){
					d3.select(this).attr("xlink:href", "extensions/ext_mplay/assets/css/themes/default/img/frame_avatar_hover.png");
				} else {
					d3.select(this).attr("xlink:href", "extensions/ext_mplay/assets/css/themes/default/img/frame_hover.png");
				}
			}
		})
		.on("mouseout", function(d){
			if (d.onclick != undefined && d.onclick != ''){
				if (d.aprendida == true){
					d3.select(this).attr("xlink:href", "extensions/ext_mplay/assets/css/themes/default/img/frame_avatar.png");
				} else {
					d3.select(this).attr("xlink:href", "extensions/ext_mplay/assets/css/themes/default/img/frame_inactive.png");
				}
			}
		});
		  
		nodeEnter.on("mouseover", function(d){
			  div.transition().duration(300).style("opacity", 1).style("display", "block");
			  
			  if (d.onclick != undefined && d.onclick != ''){
				  d3.select(this).classed("node-hover", true);
			  }
		  })
			.on("mousemove", function(d){
				var append_text = '';
				var coste_text = '';
				if (d.aprendida == false && d.parent.aprendida == false){
					append_text = '<hr class="light" /><b class="font-red">Aprende '+d.parent.name+' para desbloquear</b>';
				}
				if (d.aprendida == false){
					coste_text = '<small class="label label-warning pull-right">'+d.cost+' MO</small>';
				}
				div
					.html("<h5>" + d.name + coste_text + '</h5>' + d.description + '<hr class="light" />' + d.properties + append_text)
					.style("left", (d3.event.pageX + 15 ) + "px")
					.style("top", (d3.event.pageY + 15) + "px");
			})
			.on("mouseout", function(d){
				div.transition().duration(300).style("opacity", 0).style("display", "none");
				
				if (d.onclick != undefined && d.onclick != ''){
					  d3.select(this).classed("node-hover", false);
				  }
			})
			.on("click", function(d){
				if (d.onclick != undefined && d.onclick != ""){
					if (d.onclick == 'collapse' && d.href != undefined && d.href != ''){
						var $href = d.href;
						var $todos_contenedores = $(d.href).parent().parent().parent().find("[data-mplay-infoitem]");
						var $todos_items = $(d.href).parent().parent().parent().find("g.node");
						
						d3.selectAll(".node").classed('active', false);
						$todos_contenedores.hide();
						
						$($href).show();
						d3.select(this).classed('active', true);
						
						return false;
					} else {
						return false;
					}
				} else {
					return false;
				}
			});
		
		// Declare the links…
		var link = svg.selectAll("path.link")
		  .data(links, function(d) { return d.target.id; });
		
		// Enter the links.
		link.enter().insert("path", "g")
		  .attr("class", function(d){
			  if (d.source.aprendida == true && d.target.aprendida == true){
				return "link active";
			  } else {
			  	return "link inactive";
			  }
		   })
		  .attr("d", diagonal);
	},
	rounded_rect: function(x, y, w, h, r, tl, tr, bl, br) {
		var retval;
		retval  = "M" + (x + r) + "," + y;
		retval += "h" + (w - 2*r);
		if (tr) { retval += "a" + r + "," + r + " 0 0 1 " + r + "," + r; }
		else { retval += "h" + r; retval += "v" + r; }
		retval += "v" + (h - 2*r);
		if (br) { retval += "a" + r + "," + r + " 0 0 1 " + -r + "," + r; }
		else { retval += "v" + r; retval += "h" + -r; }
		retval += "h" + (2*r - w);
		if (bl) { retval += "a" + r + "," + r + " 0 0 1 " + -r + "," + -r; }
		else { retval += "h" + -r; retval += "v" + -r; }
		retval += "v" + (2*r - h);
		if (tl) { retval += "a" + r + "," + r + " 0 0 1 " + r + "," + -r; }
		else { retval += "v" + -r; retval += "h" + r; }
		retval += "z";
		return retval;
	},
	safe_tags: function(str) {
		return str.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
	}
};