<?php
c_include('api/apiAdaptador');
e_include('ext_mplay/class/helpers/mplayUsuarioHelper','ext_mplay/class/helpers/mplaySitioHelper','ext_mplay/class/mplayUsuariosActivos','ext_mplay/class/misionJuegoMplay','ext_mplay/class/mplayMisionTipo','ext_mplay/class/juego','ext_mplay/class/mplayJuegoTipo');

/**
 * Musica Api Adapter class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Api
 * @since		1.0
 */
class MplayApiAdaptador extends ApiAdaptador
{
	protected $extension = 'mplay';
	protected $carpeta = 'ext_mplay';
	
	protected $elementos_permitidos = array("juego","misionJuegoMplay","general","usuario","admin");
	
	protected $campos_ignorados_nuevo = array("id","fecha","numero_valoraciones","media_valoracion","visitas");
	protected $campos_multilang = array("titulo","contenido","texto_corto","lugar");
	
	public function __construct($elemento, $accion){
		parent::__construct($elemento, $accion);
		$this->mensajes = array("nuevo_ok"=>__("Se ha creado el juego. Haz click <a href='%s'>aquí</a> para ver el nuevo juego."), "nuevo_ko"=>__("Se ha producido un error al intentar crear el juego"), "editar_ok"=>__("Se ha modificado el juego. Haz click <a href='%s'>aquí</a> para visitar la página del juego."));
	}
	
	function getConfig(){
		if ($this->get('elemento') != 'general'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		if (!empty($GLOBALS['opciones']['ext_mplay']['general']['img_invslot_empty'])){
			$GLOBALS['opciones']['ext_mplay']['general']['img_invslot_empty_sm'] = Helpers::generateImageLink($GLOBALS['opciones']['ext_mplay']['general']['img_invslot_empty'], 96, 96);
			$GLOBALS['opciones']['ext_mplay']['general']['img_invslot_empty_md'] = Helpers::generateImageLink($GLOBALS['opciones']['ext_mplay']['general']['img_invslot_empty'], 150, 150);
			$GLOBALS['opciones']['ext_mplay']['general']['img_invslot_empty_lg'] = Helpers::generateImageLink($GLOBALS['opciones']['ext_mplay']['general']['img_invslot_empty'], 256, 256);
		}
		
		if (!empty($GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['opciones']['img_invslot_empty'])){
			$GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['opciones']['img_invslot_empty_sm'] = Helpers::generateImageLink($GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['opciones']['img_invslot_empty'], 96, 96);
			$GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['opciones']['img_invslot_empty_md'] = Helpers::generateImageLink($GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['opciones']['img_invslot_empty'], 150, 150);
			$GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['opciones']['img_invslot_empty_lg'] = Helpers::generateImageLink($GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['opciones']['img_invslot_empty'], 256, 256);
		}
		
		$data = array("base_url"=>CONF_URL_APP, "base_url_admin"=>CONF_URL_APP_ADMIN, 'opciones'=>$GLOBALS['opciones']['ext_mplay']);
		
		return $this->arrResp(__('Configuración recuperada'), $data);
	}
	
	function getRutaOSRM(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
				
		if (!class_exists('MplayUsuarioHelper')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if (empty($_POST['lat1']) || empty($_POST['lng1']) || empty($_POST['lat2']) || empty($_POST['lng2'])){
			return $this->error(__('No se han definido las coordenadas de la ruta'));
		}
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		$request=file_get_contents("http://127.0.0.1:5000/viaroute?loc=".$_POST['lat1'].",".$_POST['lng1']."&loc=".$_POST['lat2'].",".$_POST['lng2']."&instructions=true&alt=false");
		
		return $this->arrResp(__('Ruta calculada con éxito'), $request);
		
	}
	
	function getAltaNuevoJugador(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		
		if (!Usuario::isLoged())
			return $this->error(__('No estás conectado'));
			
		$usr_obj = Usuario::getLoged();
		
		$usr_ip = $_SERVER['REMOTE_ADDR'];
		
		$usr_fecha = time();
		
		e_include('ext_mplay/class/mplayItem','ext_mplay/class/mplayOficioUsuario');
		
		if (!class_exists('MplayItem')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
				
		if ($_POST['id_usuario'] != $usr_id)
			return $this->error(__('No coincide el id de usuario'));
			
		if (empty($_POST['nombre']))
			return $this->error(__('¡No sabemos tu nombre!'));
			
		if (empty($_POST['oficio']))
			return $this->error(__('¡No sabemos cual es tu oficio!'));
			
		if (empty($_POST['latitud_casa']) || empty($_POST['longitud_casa']))
			return $this->error(__('¡No sabemos cual es la dirección de tu casa!'));
			
		$usr_obj->setnombre($_POST['nombre']);
		$usr_obj->setapellidos('');
		$usr_obj->setcontrasena('');
		
		if ($usr_obj->Modificar()){
			$usr_obj = Usuario::getLoged();
		}
		
		MplayUsuarioHelper::setPropUsr($usr_obj, 'oficio', $_POST['oficio']);
		
		$oficio_obj = new MplayOficioUsuario();
		$oficio_obj->setid($_POST['oficio']);
		if ($oficio_obj = $oficio_obj->BuscarId()){
			$props_oficio = Helpers::toArray(json_decode($oficio_obj->propiedades));
		} else {
			return $this->error(__('No se encuentra el oficio'));
		}
			
		$monedas = (int) $GLOBALS['opciones']['ext_mplay']['usuario']['monedas'];
		$monedas += (int) $props_oficio['monedas'];
		MplayUsuarioHelper::setMonedas($usr_obj, $monedas);
		
		if ($GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['activo'] == '1'){
			
			$items_defecto = $GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['opciones']['items_defecto_jugador'];
			if (is_array($props_oficio['items']) && sizeof($props_oficio) > 0){
				$items_defecto = array_merge($items_defecto, $props_oficio['items']);
			}
			if (is_array($items_defecto) && sizeof($items_defecto) > 0){
				foreach ($items_defecto as $id_model_item){
					$model_item = new MplayItem();
					$model_item->setid($id_model_item);
					if ($model_item = $model_item->BuscarId()){
						$update_vars_item = $model_item->get('update_vars');
						$item_new = new MplayItem();
						foreach ($update_vars_item as $var){
							$item_new->$var = $model_item->$var;
						}
						$item_new->sitio = 0;
						$item_new->propietario = '-'.$usr_id;
						$item_new->bot = 0;
						$item_new->estado = 1;
						$item_new->visibilidad = 1;
						$item_new->fecha_recogido = strftime("%Y-%m-%d %H:%M:%S", time());
						$item_new->model_id = $model_item->id;
						$item_new->Guardar();
					}
				}
			}
		
		}
		
		$data = array();
		
		$model_tuto = array();
		$tutorial = $GLOBALS['opciones']['ext_mplay']['usuario']['tutorial'];
		if (!empty($props_oficio['tutorial'])){
			$tutorial = $props_oficio['tutorial'];
		}
		if (!empty($tutorial)){
			$tuto_obj = new Juego();
			$tuto_obj->setid($tutorial);
			if ($tuto_obj = $tuto_obj->BuscarId()){
				$hora_inicio = time();
				$params_tuto = Helpers::toArray(json_decode($tuto_obj->params));
				
				$misiones_arr = $tuto_obj->getMisiones();
				$misiones_juego = array();
				$mision_activa = false;
				$mision_finalizada = false;
				$count_mis = 0;
				foreach ($misiones_arr as $m){
					if ($count_mis == 0){
						$estado_mision = 'activa';
						$hora_inicio_mision = time();
					} else {
						$estado_mision = 'pendiente';
						$hora_inicio_mision = false;
					}
					
					$mision_model = array("id_mision"=>$m->id, "nombre_mision"=>SistemaIdioma::Imprimir($m->titulo), "descripcion_mision"=>SistemaIdioma::Imprimir($m->descripcion), "descripcion_corta_mision"=>SistemaIdioma::Imprimir($m->descripcion_corta), "tipo_mision"=>$m->tipo, "icono_mision"=>$m->geticono(48,48), "propiedades_mision"=>(array) json_decode($m->propiedades), "latitud_mision"=>$m->latitud, "longitud_mision"=>$m->longitud, "orden_mision"=>$m->orden, "juego_mision"=>$tuto_obj->id, "timestamp_inicio_mision"=>$hora_inicio_mision, "estado_mision"=>$estado_mision);
					$misiones_juego[] = $mision_model;
					if ($count_mis == 0){
						$mision_model['timestamp_inicio_mision'] = time();
						$mision_activa_model = $mision_model;
					}
					$count_mis ++;
				}
				
				$data = array("tutorial"=>array("id_juego"=>$tuto_obj->id, "nombre_juego"=>$tuto_obj->titulo_formateado, "descripcion_juego"=>$tuto_obj->contenido_formateado, "instrucciones_juego"=>SistemaIdioma::Imprimir($tuto_obj->texto_corto), "icono_juego"=>$tuto_obj->getimagen_destacada(48,48), "tipo_juego"=>$tuto_obj->tipo, "propiedades_juego"=>$params_tuto['propiedades'], "misiones_juego"=>$misiones_juego, "mision_activa"=>$mision_activa_model, "timestamp_inicio_juego"=>$hora_inicio));
			}
		}
		
		$check_casa_usr = MplayUsuarioHelper::getCasaUsr($usr_obj);
		if ($check_casa_usr != 'no')
			return $this->error(__('¡Ya tienes al menos una casa!'));
			
		$nombre_player = $usr_obj->getnombre_completo();
		$nombre_casa = sprintf(__('Casa de %s'), $nombre_player);
		$descripcion_casa = __("Este es tu cuartel general donde podrás guardar los items que no vayas a usar en tus viajes.");
		$img_casa = $GLOBALS['opciones']['ext_mplay']['general']['img_casa'];
		$cat_casa = $GLOBALS['opciones']['ext_mplay']['general']['categoria_casa'];
		$monedas_casa_defecto = $GLOBALS['opciones']['ext_mplay']['general']['monedas_casa'];
		
		$valor_casa_defecto = $GLOBALS['opciones']['ext_mplay']['general']['valor_casa'];
		
		$params_casa = array(	"tipo"			=>		"casa",
								"propiedades"	=>		array(	"valor"		=>		$valor_casa_defecto,
																"monedas"	=>		$monedas_casa_defecto,
																"items"		=>		""
															)
							);
		
		$casa = new Sitio();
		
		$casa->settitulo(json_encode(array(SistemaIdioma::getIdiomaSesion()=>$nombre_casa)));
		$casa->setalias(json_encode(array(SistemaIdioma::getIdiomaSesion()=>Helpers::parseaTexto($nombre_casa).'-'.time())));
		$casa->settexto_corto(json_encode(array(SistemaIdioma::getIdiomaSesion()=>"")));
		$casa->setcontenido(json_encode(array(SistemaIdioma::getIdiomaSesion()=>$descripcion_casa)));
		$casa->setfecha_publicacion(strftime("%Y-%m-%d %H:%M:%S", time()));
		$casa->setestado("1");
		$casa->setimagen_destacada($img_casa);
		$casa->setcategorias(json_encode(array($cat_casa)));
		$casa->setcreador('-'.$usr_id);
		$casa->setpropietario('-'.$usr_id);
		$casa->setparams(json_encode($params_casa));
		$casa->setlatitud($_POST['latitud_casa']);
		$casa->setlongitud($_POST['longitud_casa']);
		$casa->setacceso('1');
		$casa->setvisibilidad('0');
		
		if ($id_casa = $casa->Guardar()){
			$items_defecto_casa =  $GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['opciones']['items_defecto_casa'];
			
			if ($GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['activo'] == '1' && is_array($items_defecto_casa) && sizeof($items_defecto_casa) > 0){
				foreach ($items_defecto_casa as $id_model_item){
					$model_item = new MplayItem();
					$model_item->setid($id_model_item);
					if ($model_item = $model_item->BuscarId()){
						$update_vars_item = $model_item->get('update_vars');
						$item_new = new MplayItem();
						foreach ($update_vars_item as $var){
							$item_new->$var = $model_item->$var;
						}
						$item_new->sitio = $id_casa;
						$item_new->propietario = 0;
						$item_new->bot = 0;
						$item_new->estado = 1;
						$item_new->visibilidad = 1;
						$item_new->fecha_recogido = strftime("%Y-%m-%d %H:%M:%S", time());
						$item_new->latitud = $casa->latitud;
						$item_new->longitud = $casa->longitud;
						$item_new->model_id = $model_item->id;
						$item_new->Guardar();
					}
				}
			}
			
			$data['id_casa'] = $id_casa;
			$data['nombre_casa'] = $nombre_casa;
			$data['latitud_casa'] = $casa->latitud;
			$data['longitud_casa'] = $casa->longitud;
		}

		MplayUsuarioHelper::setPropUsr($usr_obj, 'nuevo', '1');
		
		$usr_obj->nuevaActividad(sprintf(__('¡Bienvenido al juego! Te hemos regalado %s PE solo por empezar a jugar.'), $GLOBALS['opciones']['ext_mplay']['experiencia']['puntos_nuevo_jugador']), 'new', (int) $GLOBALS['opciones']['ext_mplay']['experiencia']['puntos_nuevo_jugador'], array('id_usuario'=>$usr_id));
		
		return $this->arrResp(__('Jugador dado de alta con éxito'), $data);
	}
	
	function getUpdateStatus(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		
		if (!Usuario::isLoged())
			return $this->error('not-logged');
			
		$usr_obj = Usuario::getLoged();
		
		if (!empty($_GET['lat']) && !empty($_GET['lng'])){
			$lat = $_GET['lat'];
			$lng = $_GET['lng'];
			$geolocation = 0;
			
			Helpers::getSesion()->set('mplay.usuario.geolocalizacion.latitud', $lat);
			Helpers::getSesion()->set('mplay.usuario.geolocalizacion.longitud', $lng);
			Helpers::getSesion()->set('mplay.usuario.geolocalizacion.activo', 0);
		} else {
			$lat_tmp = Helpers::getSesion()->get('mplay.usuario.geolocalizacion.latitud');
			$lng_tmp = Helpers::getSesion()->get('mplay.usuario.geolocalizacion.longitud');
			
			if (!empty($lat_tmp) && !empty($lng_tmp)){
				 $lng = $lng_tmp;
				 $lat = $lat_tmp;
			} else {
				 $lat = $GLOBALS['opciones']['ext_mplay']['usuario']['lat_inicial'];
				 $lng = $GLOBALS['opciones']['ext_mplay']['usuario']['lng_final'];
			 }
			$geolocation = Helpers::getSesion()->get('usuario.geolocalizacion.activo');
			if (empty($lat)){
				$lat = $GLOBALS['opciones']['ext_mplay']['usuario']['lat_inicial'];
			}
			if (empty($lng)){
				$lng = $GLOBALS['opciones']['ext_mplay']['usuario']['lng_final'];
			}
		}
		
		if (isset($_GET['geolocation'])){
			$geolocation = $_GET['geolocation'];
		}
		
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
			$usr_ip = $_SERVER['REMOTE_ADDR'];
			$usr_fecha = time();
			
			$mua = new MplayUsuariosActivos();
			$mua_chk = $mua->ListarCount("id_usuario='".$usr_id."'");
			
			if ($mua_chk == 1){
				$mua = $mua->Listar("id_usuario='".$usr_id."'");
				$mua = $mua[0];
				$mua->setfecha_ultimo_acceso($usr_fecha);
				$mua->Modificar();
			} else {
				$mua->setid_usuario($usr_id);
				$mua->setip_usuario($usr_ip);
				$mua->setfecha_ultimo_acceso($usr_fecha);
				$mua->setlatitud($lat);
				$mua->setlongitud($lng);
				$mua->setgeolocation($geolocation);
				
				if ($lid = $mua->Guardar()){
					$mua->setid($lid);
					$mua = $mua->BuscarId();
					$mua_chk = 1;
				} else {
					return $this->error(__('Error desconocido'));
				}
			}
		} else {
			$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
			$mua_chk = 1;
			
			if (empty($_GET['lat']) || empty($_GET['lng'])){
				$lat = $mua->latitud;
				$lng = $mua->longitud;
			}
		}
		
		$mensajes = array();
		$msg_muerto = Helpers::getSesion()->get('mplay.mensajes.muerto');
		if (!empty($msg_muerto)){
			$mensajes[] = $msg_muerto;
			Helpers::getSesion()->clear('mplay.mensajes.muerto');
		}
		
		e_include('ext_mplay/class/mplaySitioTipo');
		
		if (Usuario::isLoged()){
			$usr_obj = Usuario::getLoged();
			
			$es_nuevo_usr = MplayUsuarioHelper::esNuevo($usr_obj);
			
			$casillas_casa_user = 0;
			
			$casa_user = MplayUsuarioHelper::getCasaUsr($usr_obj);
			if ($casa_user instanceof Sitio){
				$casillas_casa_user = MplaySitioHelper::getCasillasSitio($casa_user);
				$params_casa = Helpers::toArray(json_decode($casa_user->params));
				$tipo_sitio_obj = MplaySitioTipo::getInstance($params_casa['tipo'], $params_casa['propiedades']);
				$tmp_array = array('id'=>$casa_user->id, 'nombre'=>$casa_user->titulo_formateado, 'imagen'=>$casa_user->getimagen_destacada(250, 250), 'distancia'=>$casa_user->get_distancia(true), 'lat'=>$casa_user->latitud, 'lng'=>$casa_user->longitud, 'tipo'=>'sitio', 'propiedades_html'=>$tipo_sitio_obj->printPropiedadesHtml(' class="col-xs-12"'), 'propiedades'=>$tipo_sitio_obj->propiedades, 'casillas'=>$casillas_casa_user);
				$casa_user = $tmp_array;
			}
			
			$nivel_usr = MplayUsuarioHelper::getNivelUsr($usr_obj);
			
			$oficio_usr = MplayUsuarioHelper::getOficioUsr($usr_obj);
			
			$habilidades_usr = MplayUsuarioHelper::getHabilidadesUsrArray($usr_obj);
			
			$todas_habilidades_usr = MPlayUsuarioHelper::getHabilidadesUsrArray($usr_obj, false);
			
			$slots_armas = MplayUsuarioHelper::getSlotsUsr($usr_obj, 'armas', true);
			$slots_ropa = MplayUsuarioHelper::getSlotsUsr($usr_obj, 'ropa', true);
			
			foreach ($slots_armas as $ksa=>$sa){
				if ($sa instanceof MplayItem){
					$model_sa = array("id"=>$sa->id, "nombre"=>SistemaIdioma::Imprimir($sa->nombre), "icono"=>$sa->geticono(48,48), "icono_big"=>$sa->geticono(256,256), "descripcion"=>SistemaIdioma::Imprimir($sa->descripcion));
					$slots_armas[$ksa] = $model_sa;
				}
			}
			
			foreach ($slots_ropa as $ksa=>$sa){
				if ($sa instanceof MplayItem){
					$model_sa = array("id"=>$sa->id, "nombre"=>SistemaIdioma::Imprimir($sa->nombre), "icono"=>$sa->geticono(48,48), "icono_big"=>$sa->geticono(256,256), "descripcion"=>SistemaIdioma::Imprimir($sa->descripcion));
					$slots_ropa[$ksa] = $model_sa;
				}
			}
			
			if ($es_nuevo_usr || empty($mua->latitud) || empty($mua->longitud)){
				if (!empty($_GET['lat']) && !empty($_GET['lng'])){
					$mua->latitud = $_GET['lat'];
					$mua->longitud = $_GET['lng'];
				} else {
					$mua->latitud = $GLOBALS['opciones']['ext_mplay']['usuario']['lat_inicial'];
					$mua->longitud = $GLOBALS['opciones']['ext_mplay']['usuario']['lng_final'];
				}
				$mua->geolocation = 0;
				
				$mua->Modificar();
			}
			
			$user_config = array(
				"es_admin"	=>	$usr_obj->es_admin,
				"es_nuevo"	=>	$es_nuevo_usr,
				"id"		=>	$usr_obj->id,
				"nombre"	=>	$usr_obj->getnombre_completo(),
				"avatar"	=>	MplayUsuarioHelper::getAvatar($usr_obj, 400),
				"icono"		=>	MplayUsuarioHelper::getAvatarMap($usr_obj),
				"icono_big"	=>	MplayUsuarioHelper::getAvatarMap($usr_obj),
				"link"		=>	'javascript:;',
				"link_attr"	=>	'',
				"dinero"	=>	MplayUsuarioHelper::getMonedas($usr_obj),
				"puntos"	=>	(int) $usr_obj->puntos,
				"velocidad"	=>	MplayUsuarioHelper::getVelocidad($usr_obj),
				"vida"		=>	MplayUsuarioHelper::getVida($usr_obj),
				"max_vida"		=>	MplayUsuarioHelper::getMaxVida($usr_obj),
				"rango_vision"	=>	MplayUsuarioHelper::getRangoVision($usr_obj),
				"rango_interaccion"	=>	MplayUsuarioHelper::getRangoInteraccion($usr_obj),
				"ataque"	=>	MplayUsuarioHelper::getAtaque($usr_obj),
				"defensa"	=>	MplayUsuarioHelper::getDefensa($usr_obj),
				"carisma"	=>	MplayUsuarioHelper::getCarisma($usr_obj),
				"especial"	=>	MplayUsuarioHelper::getEspecial($usr_obj),
				"armas"		=>	$slots_armas,
				"ropa"		=>	$slots_ropa,
				"nivel"		=>	$nivel_usr,
				"oficio"	=>	$oficio_usr,
				"habilidades"	=>	$habilidades_usr,
				"todas_habilidades"	=>	$todas_habilidades_usr,
				"casa"		=>	$casa_user,
				"mensajes"	=>	$mensajes,
				"actividad"	=>	array(	"ip"			=>	$mua->ip_usuario, 
										"ultimo_acceso"	=>	$mua->fecha_ultimo_acceso, 
										"latitud"		=>	$lat,
										"longitud"		=>	$lng,
										"geolocation"	=>	$mua->geolocation
									)
			);
		 } else {
			 $user_config = array(
			 	"es_admin"	=>	0,
			 	"es_nuevo"	=>	true,
			 	"id"		=>	'0',
				"nombre"	=>	__('Jugador anónimo'),
				"avatar"	=>	Helpers::getImagenDesaparecida(250,250),
				"icono"		=>	Helpers::getImagenDesaparecida(32,32),
				"icono_big"	=>	Helpers::getImagenDesaparecida(250,250),
				"link"		=>	'#',
				"link_attr"	=>	' data-toggle="modal" data-target="#frm_modal_Formulario-de-identificacion"',
				"dinero"	=>	0,
				"puntos"	=>	0,
				"velocidad"	=> 	$GLOBALS['opciones']['ext_mplay']['usuario']['velocidad'],
				"vida"		=>	$GLOBALS['opciones']['ext_mplay']['usuario']['vida'],
				"max_vida"		=>	$GLOBALS['opciones']['ext_mplay']['usuario']['vida'],
				"rango_vision"		=>	$GLOBALS['opciones']['ext_mplay']['usuario']['rango_vision'],
				"rango_interaccion"	=>	$GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'],
				"ataque"	=>	$GLOBALS['opciones']['ext_mplay']['usuario']['ataque'],
				"defensa"	=>	$GLOBALS['opciones']['ext_mplay']['usuario']['defensa'],
				"carisma"	=>	$GLOBALS['opciones']['ext_mplay']['usuario']['carisma'],
				"especial"	=>	$GLOBALS['opciones']['ext_mplay']['usuario']['especial'],
				"armas"		=>	array(),
				"ropa"		=>	array(),
				"nivel"		=>	array(),
				"oficio"	=>	array(),
				"habilidades"	=>	array(),
				"todas_habilidades"	=>	array(),
				"casa"		=>	"no",
				"mensajes"	=>	$mensajes,
				"actividad"	=>	array(	"ip"			=>	$mua->ip_usuario, 
										"ultimo_acceso"	=>	$mua->fecha_ultimo_acceso, 
										"latitud"		=>	$lat,
										"longitud"		=>	$lng,
										"geolocation"	=>	$mua->geolocation
									)
			);
		 }
		
		if ($mua_chk == 1){
			$usr_fecha = time();
			$mua->setfecha_ultimo_acceso($usr_fecha);
			$mua->setlatitud($lat);
			$mua->setlongitud($lng);
			$mua->setgeolocation($geolocation);
			
			if ($mua->Modificar()){
				$data = array("usr_id"=>$usr_id, "usr_ip"=>$usr_ip, "ultima_fecha_acceso"=>$usr_fecha, "lat"=>$lat, "lng"=>$lng, "geolocation"=>$geolocation, "usuario"=>$user_config);
				return $this->arrResp(__('Estado de usuario actualizado'), $data);
			} else {
				return $this->error(__('Error desconocido'));
			}
		}
	}
	
	function getCrearCasa(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		if (!Helpers::checkExtension('ext_sitios')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		e_include('ext_mplay/class/mplayItem', 'ext_sitios/class/sitio');
		
		if (!class_exists('MplayUsuarioHelper') || !class_exists('Sitio')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if (empty($_POST['lat']) || empty($_POST['lng'])){
			return $this->error(__('No se han definido las coordenadas de la casa'));
		}
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		$check_casa_usr = MplayUsuarioHelper::getCasaUsr($usr_obj);
		if ($check_casa_usr != 'no')
			return $this->error(__('¡Ya tienes al menos una casa!'));
			
		$nombre_player = $usr_obj->getnombre_completo();
		$nombre_casa = sprintf(__('Casa de %s'), $nombre_player);
		$descripcion_casa = __("Este es tu cuartel general donde podrás guardar los items que no vayas a usar en tus viajes.");
		$img_casa = $GLOBALS['opciones']['ext_mplay']['general']['img_casa'];
		$cat_casa = $GLOBALS['opciones']['ext_mplay']['general']['categoria_casa'];
		$monedas_casa_defecto = $GLOBALS['opciones']['ext_mplay']['general']['monedas_casa'];
		
		$valor_casa_defecto = $GLOBALS['opciones']['ext_mplay']['general']['valor_casa'];
		
		$params_casa = array(	"tipo"			=>		"casa",
								"propiedades"	=>		array(	"valor"		=>		$valor_casa_defecto,
																"monedas"	=>		$monedas_casa_defecto,
																"items"		=>		""
															)
							);
		
		
		$casa = new Sitio();
		
		$casa->settitulo(json_encode(array(SistemaIdioma::getIdiomaSesion()=>$nombre_casa)));
		$casa->setalias(json_encode(array(SistemaIdioma::getIdiomaSesion()=>Helpers::parseaTexto($nombre_casa).'-'.time())));
		$casa->settexto_corto(json_encode(array(SistemaIdioma::getIdiomaSesion()=>"")));
		$casa->setcontenido(json_encode(array(SistemaIdioma::getIdiomaSesion()=>$descripcion_casa)));
		$casa->setfecha_publicacion(strftime("%Y-%m-%d %H:%M:%S", time()));
		$casa->setestado("1");
		$casa->setimagen_destacada($img_casa);
		$casa->setcategorias(json_encode(array($cat_casa)));
		$casa->setcreador('-'.$usr_id);
		$casa->setpropietario('-'.$usr_id);
		$casa->setparams(json_encode($params_casa));
		$casa->setlatitud($_POST['lat']);
		$casa->setlongitud($_POST['lng']);
		$casa->setacceso('1');
		$casa->setvisibilidad('0');
		
		if ($id_casa = $casa->Guardar()){
			$items_defecto_casa =  $GLOBALS['opciones']['ext_mplay']['general']['items_defecto_casa'];
			
			if (is_array($items_defecto_casa) && sizeof($items_defecto_casa) > 0){
				foreach ($items_defecto_casa as $id_model_item){
					$model_item = new MplayItem();
					$model_item->setid($id_model_item);
					if ($model_item = $model_item->BuscarId()){
						$update_vars_item = $model_item->get('update_vars');
						$item_new = new MplayItem();
						foreach ($update_vars_item as $var){
							$item_new->$var = $model_item->$var;
						}
						$item_new->sitio = $id_casa;
						$item_new->propietario = 0;
						$item_new->bot = 0;
						$item_new->estado = 1;
						$item_new->visibilidad = 1;
						$item_new->fecha_recogido = strftime("%Y-%m-%d %H:%M:%S", time());
						$item_new->latitud = $casa->latitud;
						$item_new->longitud = $casa->longitud;
						$item_new->model_id = $model_item->id;
						$item_new->Guardar();
					}
				}
			}
			
			$data = array("id"=>$id_casa, "nombre"=>$nombre_casa, "lat"=>$_POST['lat'], "lng"=>$_POST['lng']);
			
			return $this->arrResp(__('¡Casa creada con éxito!'), $data);
		} else {
			return $this->error(__('No se ha podido guardar tu casa'));
		}
	}
	
	function getUpdateStatusComercio(){
		if ($this->get('elemento') != 'usuario' || empty($_GET['id_sitio']) || !Helpers::checkExtension('ext_sitios') || !Usuario::isLoged()){
			return $this->error(__('Acceso incorrecto'));
		}
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		
		e_include('ext_sitios/class/sitio');
		
		if (!class_exists('Sitio')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		$sitio = new Sitio();
		$sitio->setid($_GET['id_sitio']);
		
		if ($sitio = $sitio->BuscarId()){
		} else {
			return $this->error(__('No existe el sitio'));
		}
		
		$params_sitio = Helpers::toArray(json_decode($sitio->params));
				
		$sitio_config = array(
			"id"		=>	$sitio->id,
			"nombre"	=>	$sitio->titulo_formateado,
			"icono"		=>	$sitio->getimagen_destacada(32,32),
			"icono_big"	=>	$sitio->getimagen_destacada(48,48),
			"link"		=>	$sitio->enlace_formateado,
			"link_attr"	=>	'',
			"dinero"	=>	number_format($params_sitio['propiedades']['monedas'], 0, ',', '.'),
			"valor"		=>	number_format($params_sitio['propiedades']['valor'], 0, ',', '.'),
			"margen_ventas"	=>	$params_sitio['propiedades']['margen_ventas'],
			"descuento_compras"		=>	$params_sitio['propiedades']['descuento_compras']
		);
		
		$data = array("sitio_id"=>$sitio->id, "lat"=>(float)$sitio->latitud, "lng"=>(float)$sitio->longitud, "sitio"=>$sitio_config);
		
		return $this->arrResp(__('Info de sitio recuperada'), $data);
	}
	
	function getUpdateStatusCasa(){
		if ($this->get('elemento') != 'usuario' || empty($_GET['id_casa']) || !Helpers::checkExtension('ext_sitios') || !Usuario::isLoged()){
			return $this->error(__('Acceso incorrecto'));
		}
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		
		e_include('ext_sitios/class/sitio');
		
		if (!class_exists('Sitio')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		$casa = new Sitio();
		$casa->setid($_GET['id_casa']);
		
		if ($casa = $casa->BuscarId()){
		} else {
			return $this->error(__('No existe la casa'));
		}
		
		$params_casa = Helpers::toArray(json_decode($casa->params));
				
		$casa_config = array(
			"id"		=>	$casa->id,
			"nombre"	=>	$casa->titulo_formateado,
			"icono"		=>	$casa->getimagen_destacada(32,32),
			"icono_big"	=>	$casa->getimagen_destacada(48,48),
			"link"		=>	$casa->enlace_formateado,
			"link_attr"	=>	'',
			"dinero"	=>	number_format($params_casa['propiedades']['monedas'], 0, ',', '.'),
			"valor"		=>	number_format($params_casa['propiedades']['valor'], 0, ',', '.'),
			"margen_ventas"	=>	$params_casa['propiedades']['margen_ventas'],
			"descuento_compras"		=>	$params_casa['propiedades']['descuento_compras']
		);
		
		$data = array("casa_id"=>$casa->id, "lat"=>(float)$casa->latitud, "lng"=>(float)$casa->longitud, "casa"=>$casa_config);
		
		return $this->arrResp(__('Info de casa recuperada'), $data);
	}
	
	private function calcularEntorno($lat, $lng){
		if (empty($lat) || empty($lng)){
			return false;
		}
		
		$timeActual = time() - (2 * 60 * 60);
		
		$url_time = "https://maps.googleapis.com/maps/api/timezone/json?location=".$lat.",".$lng."&timestamp=".$timeActual;
		$timeJson = file_get_contents($url_time);
		$timeArray = Helpers::toArray(json_decode($timeJson));
		
		$timeTotal = $timeActual + $timeArray["dstOffset"] + $timeArray["rawOffset"];
		
		$horaLocal = strftime("%H", $timeTotal);
		$minutosLocal = strftime("%M", $timeTotal);
		
		$diaLocal = strftime("%d", $timeTotal);
		$mesLocal = strftime("%m", $timeTotal);
		$anyoLocal = strftime("%Y", $timeTotal);
		
		$dateLocal = array("dia"=>$diaLocal, "mes"=>$mesLocal, "anyo"=>$anyoLocal, "hora"=>$horaLocal, "minutos"=>$minutosLocal);
		
		$url_loc = "https://maps.googleapis.com/maps/api/geocode/json?latlng=".$lat.",".$lng;
		
		$locJson = file_get_contents($url_loc);
		$locArray = Helpers::toArray(json_decode($locJson));
		$localizacion = array();
		
		if (!empty($locArray["results"][0])){
			foreach ($locArray["results"][0]->address_components as $ac){
				if (in_array("locality",$ac->types) && empty($localizacion["poblacion"])){
					$localizacion["poblacion"] = $ac->long_name;
				} elseif (in_array("country",$ac->types) && empty($localizacion["pais"])){
					$localizacion["pais"] = $ac->long_name;
				}
			}
		}
		
		$url_temp = "http://earth.apis.netsyms.net/weather.php?lat=".$lat."&long=".$lng."&format=json";
		
		$tempJson = file_get_contents($url_temp);
		$temperaturaArray = (array)json_decode($tempJson);
		
		$temperatura = false;
		$meteorologia = false;
		
		if ($temperaturaArray["status"] == "OK"){
			$meteorologia = (string) $temperaturaArray["icon"];
			$temperatura = (int) (($temperaturaArray["temp"] - 32) / 1.8);
		}
		
		$distance = 0.3;
		
		$radius = $distance/ 6371.01; //6371.01 is the earth radius in KM
		$minLatR = deg2rad($lat) - $radius;
		$maxLatR = deg2rad($lat) + $radius;
		$deltaLon = asin(sin($radius) / cos(deg2rad($lat)));
		$minLonR = deg2rad($lng) - $deltaLon;
		$maxLonR = deg2rad($lng) + $deltaLon;
		   
		$minLat = str_replace(",",".",rad2deg($minLatR));
		$maxLat = str_replace(",",".",rad2deg($maxLatR));
		$minLon = str_replace(",",".",rad2deg($minLonR));
		$maxLon = str_replace(",",".",rad2deg($maxLonR));
		
		$query = '[out:json][timeout:25];(node["natural"]('.$minLat.','.$minLon.','.$maxLat.','.$maxLon.');way["natural"]('.$minLat.','.$minLon.','.$maxLat.','.$maxLon.');relation["natural"]('.$minLat.','.$minLon.','.$maxLat.','.$maxLon.');node["leisure"]('.$minLat.','.$minLon.','.$maxLat.','.$maxLon.');way["leisure"]('.$minLat.','.$minLon.','.$maxLat.','.$maxLon.');relation["leisure"]('.$minLat.','.$minLon.','.$maxLat.','.$maxLon.');node["landuse"]('.$minLat.','.$minLon.','.$maxLat.','.$maxLon.');way["landuse"]('.$minLat.','.$minLon.','.$maxLat.','.$maxLon.');relation["landuse"]('.$minLat.','.$minLon.','.$maxLat.','.$maxLon.');node["tourism"]('.$minLat.','.$minLon.','.$maxLat.','.$maxLon.');way["tourism"]('.$minLat.','.$minLon.','.$maxLat.','.$maxLon.');relation["tourism"]('.$minLat.','.$minLon.','.$maxLat.','.$maxLon.'););out body;';
		
		$node_xml = file_get_contents("http://api.openstreetmap.fr/oapi/interpreter/?data=" . urlencode($query));
		$node_array = Helpers::toArray(json_decode($node_xml));
		
		$result_terrain = array();
		$total_nodes = 0;
		
		if (is_array($node_array['elements']) && sizeof($node_array['elements']) > 0){
			foreach ($node_array['elements'] as $node){
				$node = (array)$node->tags;
				
				if (array_key_exists("leisure", $node) && !in_array("leisure.".$node["leisure"], $result_terrain)){
					$result_terrain[] = "leisure.".$node["leisure"];
				}
				if (array_key_exists("tourism", $node) && !in_array("tourism.".$node["tourism"], $result_terrain)){
					$result_terrain[] = "tourism.".$node["tourism"];
				}
				if (array_key_exists("natural", $node) && !in_array("natural.".$node["natural"], $result_terrain)){
					$result_terrain[] = "natural.".$node["natural"];
				}
				if (array_key_exists("landuse", $node) && !in_array("landuse.".$node["landuse"], $result_terrain)){
					$result_terrain[] = "landuse.".$node["landuse"];
				}
			}
		}
		
		return array("fecha"=>$dateLocal, "localizacion"=>$localizacion, "temp"=>$temperatura, "meteo"=>$meteorologia, "terreno"=>$result_terrain);
	}
	 
	 function getInfoEntorno(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		$array_json = array();
		
		$lat = "";
		$lng = "";
		
		if (empty($lat) && empty($lng)){
			$lat = $_GET['lat'];
			$lng = $_GET['lng'];
		}
		
		if (!empty($lat) && !empty($lng)){
		
			$lat = str_replace(",",".",$lat);
			$lng = str_replace(",",".",$lng);
			
			$entorno = $this->calcularEntorno($lat, $lng);
		}
		
		$json_string = json_encode($entorno);
				
		header('Content-type: application/json');
		header("Access-Control-Allow-Origin: *");
		header("Access-Control-Allow-Methods: GET, POST, OPTIONS");
		header('Access-Control-Allow-Credentials: true');
		if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {
	
			if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
				header("Access-Control-Allow-Methods: GET, POST, OPTIONS");         
	
			if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
				header("Access-Control-Allow-Headers: {$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");
	
		}
		echo $json_string;
		exit;
		
	 }
	
	function getUsuariosCercanos(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/mplayItem');
		
		if (!class_exists('MplayItem')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		$usr_id = $usr_obj->id;
		
		$usr_fecha = time();
		
		if (empty($usr_id))
			return $this->error(__('No estás identificado'));
		
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		$mua_linea = $mua;
		
		if (empty($mua_linea->latitud) || empty($mua_linea->longitud)){
return $this->error(__('No existen datos de geolocalización'));
}
		
		if ($usr_obj){
			$radio_resultados = (float) MplayUsuarioHelper::getRangoVision($usr_obj); // en kilometros
		} else {
			$radio_resultados = $GLOBALS['opciones']['ext_mplay']['usuario']['rango_vision'];
		}
		if ($usr_id > 0){
			$where_loc = '(id_usuario <> "'.$usr_id.'" AND id_usuario <> "0" AND fecha_ultimo_acceso > '.($usr_fecha - 60).')';
		} else {
			$where_loc = '(id_usuario <> "0" AND fecha_ultimo_acceso > '.($usr_fecha - 60).')';
		}
		
		$mua_chk_location = $mua->ListarCountPorLocalizacion($mua_linea->latitud, $mua_linea->longitud, $radio_resultados, 0, 0, array($where_loc));
		
		$juegos_cercanos = $this->getJuegosCercanos($mua_linea->latitud, $mua_linea->longitud, $radio_resultados);
		
		$items_cercanos = $this->getItemsCercanos($mua_linea->latitud, $mua_linea->longitud, $radio_resultados);
		
		$bots_cercanos = $this->getBotsCercanos($mua_linea->latitud, $mua_linea->longitud, $radio_resultados);
		
		$sitios_cercanos = $this->getSitiosCercanos($mua_linea->latitud, $mua_linea->longitud, $radio_resultados);
		
		$casa_mapa = $this->getCasaMapa($mua_linea->latitud, $mua_linea->longitud);
		
		if ($mua_chk_location > 0){
			
			$mua_location = $mua->ListarPorLocalizacion($mua_linea->latitud, $mua_linea->longitud, $radio_resultados, 0, 0, array($where_loc));
			
			if ($usr_obj){
				$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
			} else {
				$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
			}
						
			$array_json = array();
			
			foreach ($mua_location as $ml){
				$distancia_ml = (float) $ml->get_distancia(false);
				$nivel_jugador = MplayUsuarioHelper::getNivelUsr($ml->usuario_obj);
				
				$propiedades_html = '<div class="mplay-item-propiedades row"><div class="col-xs-6" id="mplay-userprop-vida"><h5 class="mplay-prop-valor" data-toggle="tooltip" title="'.__('Puntos de Vida').': '.__('Puntos de Vida del jugador').'"><span class="label label-primary mplay-prop-icon">PV</span><span class="label label-warning">'.MplayUsuarioHelper::getVida($ml->usuario_obj).'/'.MplayUsuarioHelper::getMaxVida($ml->usuario_obj).'</span></h5></div><div class="col-xs-6" id="mplay-userprop-experiencia"><h5 class="mplay-prop-valor" data-toggle="tooltip" title="'.__('Puntos de Experiencia').': '.__('Puntos de Experiencia del jugador').'"><span class="label label-primary mplay-prop-icon">PE</span><span class="label label-warning">'.$ml->usuario_obj->puntos.'</span></h5></div></div>';
				
				if ($distancia_ml < $radio_interaccion){
					$popup_content = "<div class='mplay-popup-content'><h4 class='mplay-popup-title'>".$ml->usuario_obj->getnombre_completo()."<br><small class='pull-right label label-warning' style='padding: .2em .6em;'>".$nivel_jugador['nombre']."</small><small>".$ml->get_distancia(true)."</small></h4>".$propiedades_html."<hr class='light'><div class='mplay-popup-options'><div class='row'><div class='col-xs-6 mplay-opt'><a href='javascript:;' class='mplay-popup-optbtn btn btn-primary btn-block mplay-popup-optbtn-retar tip-e' data-userid='".$ml->id."' title='".__('Retar')."'><i class='fa fa-flash'></i></a></div><div class='col-xs-6 mplay-opt'><a href='javascript:;' class='mplay-popup-optbtn btn btn-primary btn-block mplay-popup-optbtn-go tip-e' data-lat='".(float) $ml->latitud."' data-lng='".(float) $ml->longitud."' title='".__('Ir')."'><i class='fa fa-crosshairs'></i> ".__('Ir')."</a></div></div></div></div>";
				} else {
					$popup_content = "<div class='mplay-popup-content'><h4 class='mplay-popup-title'>".$ml->usuario_obj->getnombre_completo()."<br><small class='pull-right label label-warning' style='padding: .2em .6em;'>".$nivel_jugador['nombre']."</small><small>".$ml->get_distancia(true)."</small></h4>".$propiedades_html."<hr class='light' /><div class='mplay-popup-alert alert alert-info'>".__("Estás demasiado lejos para interactuar con el jugador.")."</div><p><small>".sprintf(__('Estás a %s del jugador y necesitas estar a %s como mínimo para poder interactuar con él.'), $ml->get_distancia(true), number_format($radio_interaccion * 1000, 0).' '.__('metros'))."</small></p><hr class='light'><div class='mplay-popup-options'><div class='row'><div class='col-xs-12 mplay-opt'><a href='javascript:;' class='mplay-popup-optbtn btn btn-primary btn-block mplay-popup-optbtn-go tip-e' data-lat='".(float) $ml->latitud."' data-lng='".(float) $ml->longitud."' title='".__('Ir')."'><i class='fa fa-crosshairs'></i> ".__('Ir')."</a></div></div></div></div>";
				}
				
				$tmp_array = array('type'=>'Feature', 'geometry'=>array('type'=>'Point', 'coordinates'=>array((float) $ml->latitud, (float) $ml->longitud)), 'properties'=>array('nombre'=>$ml->usuario_obj->getnombre_completo(), 'imagen'=>MplayUsuarioHelper::getAvatarMap($ml->usuario_obj), 'distancia'=>$ml->get_distancia(true), 'content'=>$popup_content, 'tipo'=>'jugador'), 'id'=>$ml->id_usuario.'_'.Helpers::parseaTexto($ml->ip_usuario, false, '_'));
				
				$array_json[] = $tmp_array;
			}
			
			if (is_array($items_cercanos)){
				$array_json = array_merge($array_json, $items_cercanos);
			}
			
			if (is_array($juegos_cercanos)){
				$array_json = array_merge($array_json, $juegos_cercanos);
			}
			
			if (is_array($bots_cercanos)){
				$array_json = array_merge($array_json, $bots_cercanos);
			}
			
			if (is_array($sitios_cercanos)){
				$array_json = array_merge($array_json, $sitios_cercanos);
			}
			
			if (is_array($casa_mapa)){
				$array_json = array_merge($array_json, $casa_mapa);
			}
			
			$array_final = array('type'=>'FeatureCollection', 'features'=>$array_json);
			
			$json_string = json_encode($array_final);
				
			header('Content-type: application/json');
			header("Access-Control-Allow-Origin: *");
			header("Access-Control-Allow-Methods: GET, POST, OPTIONS");
			header('Access-Control-Allow-Credentials: true');
			if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {
		
				if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
					header("Access-Control-Allow-Methods: GET, POST, OPTIONS");         
		
				if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
					header("Access-Control-Allow-Headers: {$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");
		
			}
			echo $json_string;
			exit;
		} else {
			$array_final = array();
			$array_merge = array();
			if (is_array($items_cercanos)){				
				$array_merge = $items_cercanos;
			}
			if (is_array($juegos_cercanos)){				
				$array_merge = array_merge($array_merge, $juegos_cercanos);
			}
			if (is_array($bots_cercanos)){				
				$array_merge = array_merge($array_merge, $bots_cercanos);
			}
			if (is_array($sitios_cercanos)){				
				$array_merge = array_merge($array_merge, $sitios_cercanos);
			}
			if (is_array($casa_mapa)){				
				$array_merge = array_merge($array_merge, $casa_mapa);
			}
			if (is_array($array_merge) && sizeof($array_merge) > 0){				
				$array_final = array('type'=>'FeatureCollection', 'features'=>$array_merge);
			}
			$json_string = json_encode($array_final);
				
			header('Content-type: application/json');
			header("Access-Control-Allow-Origin: *");
			header("Access-Control-Allow-Methods: GET, POST, OPTIONS");
			header('Access-Control-Allow-Credentials: true');

			if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {
		
				if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
					header("Access-Control-Allow-Methods: GET, POST, OPTIONS");         
		
				if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
					header("Access-Control-Allow-Headers: {$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");
		
			}
			echo $json_string;
			exit;
		}
	}
	
	function getJuegosCercanos($lat, $lng, $radio){
		if (empty($lat) || empty($lng))
			return false;
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if (empty($usr_id))
			return $this->error(__('No estás identificado'));
		
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$ua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$extra_sql = '';
		
		$oficio_usr = MplayUsuarioHelper::getOficioUsr($usr_obj);
		if (!empty($oficio_usr["id"])){
			$extra_sql .= " AND (oficio = '0' OR oficio = '".$oficio_usr["id"]."')";
		} else {
			$extra_sql .= " AND oficio = '0'";
		}
		
		$juegos_finalizados = Helpers::toArray(json_decode($ua->juegos_finalizados));
		if (is_array($juegos_finalizados) && sizeof($juegos_finalizados) > 0){
			$extra_sql .= " AND id NOT IN (".implode(",", $juegos_finalizados).")";
		}

		if (empty($radio)){
			if ($usr_obj){
				$radio = (float) MplayUsuarioHelper::getRangoVision($usr_obj); // en kilometros
			} else {
				$radio = $GLOBALS['opciones']['ext_mplay']['usuario']['rango_vision'];
			}
		}
			
		if ($usr_id > 0){
			$usr_loged = Usuario::getLoged();
			$usr_loged_seguidores = new ItemsSeguidores();
			$usr_loged_seguidores_c = $usr_loged_seguidores->ListarCount("item_id='ext_usuarios.".$usr_id."'");
			
			$usrs_where = '';
			if ($usr_loged_seguidores_c > 0){
				$usr_loged_seguidores = $usr_loged_seguidores->Listar("item_id='ext_usuarios.".$usr_id."'");
				
				$usrs_where = " OR (visibilidad = '2' AND creador IN (";
				
				$ii = 0;
				foreach ($usr_loged_seguidores as $uls){
					$ii ++;
					$usrs_where .= "'-".$uls->usuario_id."'";
					
					if ($ii < $usr_loged_seguidores_c){
						$usrs_where .= ', ';
					}
				}
				
				$usrs_where .= "))";
			}
			
			$where_loc = 'estado = "1" AND ((visibilidad = "1") OR (visibilidad = "0" AND creador = "-'.$usr_id.'")'.$usrs_where.')'.$extra_sql;
		} else {
			$where_loc = 'estado = "1" AND (visibilidad = "1")'.$extra_sql;
		}
		
		$mua = new Juego();
		
		$mua_chk_location = $mua->ListarCountPorLocalizacion($lat, $lng, $radio, '', 0, 0, array($where_loc));
		
		if ($mua_chk_location > 0){
			
			$mua_location = $mua->ListarPorLocalizacion($lat, $lng, $radio, '', 0, 0, array($where_loc));
			
			if ($usr_obj){
				$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
			} else {
				$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
			}
			
			$array_json = array();
			
			foreach ($mua_location as $ml){
				$distancia_ml = (float) $ml->get_distancia(false);
				
				$params_juego = Helpers::toArray(json_decode($ml->params));
				
				$tipo_item_obj = MplayJuegoTipo::getInstance($ml->tipo, Helpers::toArray(json_decode($params_juego['propiedades'])));
				
				$txt_juego_iniciado = '';
				if ($ml->iniciado()){
					$txt_juego_iniciado = '<small class="pull-right label label-success">'.__('En curso').'</small>';
				}
								
				if ($tipo_item_obj->onShow()){
					if ($distancia_ml < $radio_interaccion){
						$popup_content = "<div class='mplay-popup-content'><h4 class='mplay-popup-title'>".SistemaIdioma::Imprimir($ml->titulo)."<br>".$txt_juego_iniciado."<small>".$ml->get_distancia(true)."</small></h4><div class='mplay-popup-description'>".SistemaIdioma::Imprimir($ml->contenido)."</div><p>".$tipo_item_obj->printPropiedadesHtml(' class="col-xs-12"')."</p><hr class='light'><div class='mplay-popup-options'><div class='row'>".$tipo_item_obj->printOpcionesBtns('mapa', $ml)."</div></div></div>";
					} else {
						$popup_content = "<div class='mplay-popup-content'><h4 class='mplay-popup-title'>".SistemaIdioma::Imprimir($ml->titulo)."<br>".$txt_juego_iniciado."<small>".$ml->get_distancia(true)."</small></h4><p>".$tipo_item_obj->printPropiedadesHtml(' class="col-xs-12"')."</p><div class='mplay-popup-description'>".SistemaIdioma::Imprimir($ml->contenido)."</div><div class='mplay-popup-alert alert alert-info'>".__("Estás demasiado lejos para interactuar con el juego.")."</div><p><small>".sprintf(__('Estás a %s del juego y necesitas estar a %s como mínimo para poder interactuar con él.'), $ml->get_distancia(true), number_format($radio_interaccion * 1000, 0).' '.__('metros'))."</small></p><div class='clearfix'></div><hr class='light'><div class='mplay-popup-options'>
  <div class='row'>
    <div class='mplay-opt col-md-12'><a href='javascript:;' class='mplay-popup-optbtn btn btn-primary btn-block mplay-popup-optbtn-go tip-e' data-lat='".(float) $ml->latitud."' data-lng='".(float) $ml->longitud."' title='".__('Ir')."'><i class='fa fa-crosshairs'></i> ".__('Ir')."</a></div>
  </div>
</div></div>";
					}
					
					$tmp_array = array('type'=>'Feature', 'geometry'=>array('type'=>'Point', 'coordinates'=>array((float) $ml->latitud, (float) $ml->longitud)), 'properties'=>array('nombre'=>SistemaIdioma::Imprimir($ml->titulo), 'imagen'=>$ml->getimagen_destacada(32, 32), 'distancia'=>$ml->get_distancia(true), 'content'=>$popup_content, 'tipo'=>'juego', 'propiedades_html'=>$tipo_item_obj->printPropiedadesHtml(' class="col-xs-12"'), 'propiedades'=>$tipo_item_obj->propiedades), 'id'=>$ml->id);
					
					$array_json[] = $tmp_array;
				}
			}
			
			return $array_json;
		} else {
			return false;
		}
	}
	
	function getBotsCercanos($lat, $lng, $radio){
		if (empty($lat) || empty($lng))
			return false;
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;

		if (empty($radio)){
			if ($usr_obj){
				$radio = (float) MplayUsuarioHelper::getRangoVision($usr_obj); // en kilometros
			} else {
				$radio = $GLOBALS['opciones']['ext_mplay']['usuario']['rango_vision'];
			}
		}
			
		if ($usr_id > 0){
			$usr_loged = Usuario::getLoged();
			$usr_loged_seguidores = new ItemsSeguidores();
			$usr_loged_seguidores_c = $usr_loged_seguidores->ListarCount("item_id='ext_usuarios.".$usr_id."'");
			
			$usrs_where = '';
			if ($usr_loged_seguidores_c > 0){
				$usr_loged_seguidores = $usr_loged_seguidores->Listar("item_id='ext_usuarios.".$usr_id."'");
				
				$usrs_where = " OR (visibilidad = '2' AND propietario IN (";
				
				$ii = 0;
				foreach ($usr_loged_seguidores as $uls){
					$ii ++;
					$usrs_where .= "'-".$uls->usuario_id."'";
					
					if ($ii < $usr_loged_seguidores_c){
						$usrs_where .= ', ';
					}
				}
				
				$usrs_where .= "))";
			}
			
			$where_loc = 'estado = "1" AND ((visibilidad = "1") OR (visibilidad = "0" AND propietario = "-'.$usr_id.'")'.$usrs_where.')';
		} else {
			$where_loc = 'estado = "1" AND (visibilidad = "1")';
		}
		
		$mua = new MplayBot();
		
		$mua_chk_location = $mua->ListarCountPorLocalizacion($lat, $lng, $radio, 0, 0, array($where_loc));
		
		if ($mua_chk_location > 0){
			
			$mua_location = $mua->ListarPorLocalizacion($lat, $lng, $radio, 0, 0, array($where_loc));
			
			if ($usr_obj){
				$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
			} else {
				$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
			}
			
			$array_json = array();
			
			foreach ($mua_location as $ml){
				$distancia_ml = (float) $ml->get_distancia(false);
				$tipo_item_obj = MplayBotTipo::getInstance($ml->tipo, Helpers::toArray(json_decode($ml->propiedades)));
				
				if ($tipo_item_obj->onShow()){
					if ($distancia_ml < $radio_interaccion){
						$popup_content = "<div class='mplay-popup-content'><h4 class='mplay-popup-title'>".SistemaIdioma::Imprimir($ml->nombre)."<br><small>".$ml->get_distancia(true)."</small></h4><div class='mplay-popup-description'>".SistemaIdioma::Imprimir($ml->descripcion)."</div><p>".$tipo_item_obj->printPropiedadesHtml(' class="col-xs-12"')."</p><hr class='light'><div class='mplay-popup-options'><div class='row'>".$tipo_item_obj->printOpcionesBtns('mapa', $ml)."</div></div></div>";
					} else {
						$popup_content = "<div class='mplay-popup-content'><h4 class='mplay-popup-title'>".SistemaIdioma::Imprimir($ml->nombre)."<br><small>".$ml->get_distancia(true)."</small></h4><p>".$tipo_item_obj->printPropiedadesHtml(' class="col-xs-12"')."</p><div class='mplay-popup-description'>".SistemaIdioma::Imprimir($ml->descripcion)."</div><div class='mplay-popup-alert alert alert-info'>".__("Estás demasiado lejos para interactuar con el personaje.")."</div><p><small>".sprintf(__('Estás a %s del personaje y necesitas estar a %s como mínimo para poder interactuar con él.'), $ml->get_distancia(true), number_format($radio_interaccion * 1000, 0).' '.__('metros'))."</small></p><div class='clearfix'></div><hr class='light'><div class='mplay-popup-options'>
  <div class='row'>
    <div class='mplay-opt col-md-12'><a href='javascript:;' class='mplay-popup-optbtn btn btn-primary btn-block mplay-popup-optbtn-go tip-e' data-lat='".(float) $ml->latitud."' data-lng='".(float) $ml->longitud."' title='".__('Ir')."'><i class='fa fa-crosshairs'></i> ".__('Ir')."</a></div>
  </div>
</div></div>";
					}
					
					$tmp_array = array('type'=>'Feature', 'geometry'=>array('type'=>'Point', 'coordinates'=>array((float) $ml->latitud, (float) $ml->longitud)), 'properties'=>array('nombre'=>SistemaIdioma::Imprimir($ml->nombre), 'imagen'=>$ml->icono, 'distancia'=>$ml->get_distancia(true), 'content'=>$popup_content, 'tipo'=>'bot', 'propiedades_html'=>$tipo_item_obj->printPropiedadesHtml(' class="col-xs-12"'), 'propiedades'=>$tipo_item_obj->propiedades), 'id'=>'bot_'.$ml->id);
					
					$array_json[] = $tmp_array;
				}
			}
			
			return $array_json;
		} else {
			return false;
		}
	}
	
	function getCasaMapa($lat, $lng){
		if (empty($lat) || empty($lng) || !Helpers::checkExtension('ext_sitios'))
			return false;
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return false;
			
		e_include('ext_sitios/class/sitio','ext_mplay/class/mplaySitioTipo');
		
		$casa = MplayUsuarioHelper::getCasaUsr($usr_obj, $lat, $lng);
		if (!$casa instanceof Sitio)
			return false;
			
		if ($usr_obj){
			$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
		} else {
			$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
		}
			
		$params_casa = Helpers::toArray(json_decode($casa->params));
			
		$tipo_casa_obj = MplaySitioTipo::getInstance($params_casa['tipo'], $params_casa['propiedades']);
		
		$distancia_casa = (float) $casa->get_distancia(false);
		
		if ($tipo_casa_obj->onShow()){
			if ($distancia_casa < $radio_interaccion){
				$popup_content = "<div class='mplay-popup-content'><h4 class='mplay-popup-title'>".$casa->titulo_formateado."<br><small>".$casa->get_distancia(true)."</small></h4><div class='mplay-popup-description'>".$casa->contenido_formateado."</div><p>".$tipo_casa_obj->printPropiedadesHtml(' class="col-xs-12"')."</p><hr class='light'><div class='mplay-popup-options'><div class='row'>".$tipo_casa_obj->printOpcionesBtns('mapa', $casa)."</div></div></div>";
			} else {
				$popup_content = "<div class='mplay-popup-content'><h4 class='mplay-popup-title'>".$casa->titulo_formateado."<br><small>".$casa->get_distancia(true)."</small></h4><p>".$tipo_casa_obj->printPropiedadesHtml(' class="col-xs-12"')."</p><div class='mplay-popup-description'>".$casa->contenido_formateado."</div><div class='mplay-popup-alert alert alert-info'>".__("Estás demasiado lejos para interactuar con tu casa.")."</div><p><small>".sprintf(__('Estás a %s de tu casa y necesitas estar a %s como mínimo para poder interactuar con ella.'), $casa->get_distancia(true), number_format($radio_interaccion * 1000, 0).' '.__('metros'))."</small></p><div class='clearfix'></div><hr class='light'><div class='mplay-popup-options'>
  <div class='row'>
    <div class='mplay-opt col-md-12'><a href='javascript:;' class='mplay-popup-optbtn btn btn-primary btn-block mplay-popup-optbtn-go tip-e' data-lat='".(float) $casa->latitud."' data-lng='".(float) $casa->longitud."' title='".__('Ir')."'><i class='fa fa-crosshairs'></i> ".__('Ir')."</a></div>
  </div>
</div></div>";
			}
		}
		
		$ancho_icono = $GLOBALS['opciones']['ext_mplay']['ui']['ancho_icono_casas'];
		$alto_icono = $GLOBALS['opciones']['ext_mplay']['ui']['alto_icono_casas'];
		if (!empty($params_casa['ancho_icono']) && !empty($params_casa['alto_icono'])){
			$ancho_icono = $params_casa['ancho_icono'];
			$alto_icono = $params_casa['alto_icono'];
		}
		if (empty($ancho_icono)){
			$ancho_icono = 64;
		}
		if (empty($alto_icono)){
			$alto_icono = 64;
		}
		$icono = $casa->getimagen_destacada($ancho_icono, $alto_icono);
		if (empty($icono) && !empty($GLOBALS['opciones']['ext_mplay']['ui']['icono_casas'])){
			$icono = Helpers::generateImageLink($GLOBALS['opciones']['ext_mplay']['ui']['icono_casas'], $ancho_icono, $alto_icono);
		}
		
		$tmp_array =array( array('type'=>'Feature', 'geometry'=>array('type'=>'Point', 'coordinates'=>array((float) $casa->latitud, (float) $casa->longitud)), 'properties'=>array('nombre'=>$casa->titulo_formateado, 'imagen'=>$icono, 'ancho_icono'=>$ancho_icono, 'alto_icono'=>$alto_icono, 'distancia'=>$casa->get_distancia(true), 'content'=>$popup_content, 'tipo'=>'casa', 'propiedades_html'=>$tipo_casa_obj->printPropiedadesHtml(' class="col-xs-12"'), 'propiedades'=>$tipo_casa_obj->propiedades), 'id'=>'casa_'.$casa->id) );
		
		return $tmp_array;
	}
	
	function getRecogerItem(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/mplayItem');
		
		if (!class_exists('MplayItem')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if (empty($_POST['id_item'])){
			return $this->error(__('No hay ningún item'));
		}
		
		$id_item = $_POST['id_item'];
		if (substr($id_item, 0, 5) != 'item_'){
			return $this->error(__('ID de item incorrecto'));
		}
		
		if ($GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['activo'] != '1'){
			return $this->error(__('El módulo Inventario no se encuentra activo'));
		}
		
		$id_item = substr($id_item, 5);
		
		if (empty($id_item)){
			return $this->error(__('ID de item incorrecto'));
		}
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$mua_linea = $mua;
		
		if (empty($mua_linea->latitud) || empty($mua_linea->longitud)){
return $this->error(__('No existen datos de geolocalización'));
}
		
		if ($usr_obj){
			$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
		} else {
			$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
		}
		
		$items_usr = new MplayItem();
		
		$where_items_usr = 'estado="1" AND propietario="-'.$usr_id.'"';
		
		$items_usr_c = $items_usr->ListarCount($where_items_usr);
		
		if ($items_usr_c >= $GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['opciones']['max_items_inventario']){
			return $this->error(__('No puedes recoger este item porque no tienes espacio en tu inventario'));
		}
		
		$item_obj = new MplayItem();
		$item_obj->setid($id_item);
		
		if ($item_obj = $item_obj->BuscarId(SistemaIdioma::getIdiomaSesion(), '', '', true, $mua_linea->latitud, $mua_linea->longitud)){
			
			if (!empty($item_obj->propietario)){
				return $this->error(__('Este item ya lo ha recogido alguien'));
			}
			
			if ($radio_interaccion < (float) $item_obj->distancia){
				return $this->error(__('No puedes recoger el item porque estás muy lejos: '.$item_obj->distancia));
			}
			
			$tipo_item_obj = MplayItemTipo::getInstance($item_obj->tipo, Helpers::toArray(json_decode($item_obj->propiedades)));
			
			if (!$tipo_item_obj->onPickup()){
				return $this->error(__('No puedes recoger el item'));
			}
			
			//Hay que incluir valoraciones específicas de cada item
			
			$item_obj->setpropietario('-'.$usr_id);
			$item_obj->setsitio(0);
			$item_obj->setbot(0);
			$item_obj->setfecha_recogido(strftime('%Y-%m-%d %H:%M:%S', time()));
			
			if ($item_obj->Modificar()){
				Usuario::getLoged()->nuevaActividad(sprintf(__('Item recogido: <b>%s</b>'), SistemaIdioma::Imprimir($item_obj->nombre)), 'new', (int) $GLOBALS['opciones']['ext_mplay']['experiencia']['puntos_recoger_item'], array('id_item'=>$item_obj->id));
				
				$data = array('id_item'=>'item_'.$item_obj->id, 'nombre'=>SistemaIdioma::Imprimir($item_obj->nombre));
				return $this->arrResp(__('Item recogido'), $data);
			} else {
				return $this->error(__('No se ha podido recoger el item por un error desconocido'));
			}
		} else {
			return $this->error(__('No se ha encontrado el item'));
		}
	}
	
	function getSoltarItem(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/mplayItem');
		
		if (!class_exists('MplayUsuariosActivos') || !class_exists('MplayItem')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if (empty($_POST['id_item'])){
			return $this->error(__('No hay ningún item'));
		}
		
		$id_item = $_POST['id_item'];
		if (substr($id_item, 0, 5) != 'item_'){
			return $this->error(__('ID de item incorrecto'));
		}
		
		if ($GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['activo'] != '1'){
			return $this->error(__('El módulo Inventario no se encuentra activo'));
		}
		
		$id_item = substr($id_item, 5);
		
		if (empty($id_item)){
			return $this->error(__('ID de item incorrecto'));
		}
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$mua_linea = $mua;
		
		if (empty($mua_linea->latitud) || empty($mua_linea->longitud)){
return $this->error(__('No existen datos de geolocalización'));
}
		
		if ($usr_obj){
			$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
		} else {
			$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
		}
		
		$item_obj = new MplayItem();
		$item_obj->setid($id_item);
		
		if ($item_obj = $item_obj->BuscarId(SistemaIdioma::getIdiomaSesion(), '', '', true, $mua_linea->latitud, $mua_linea->longitud)){
			
			if ($item_obj->propietario != '-'.$usr_id){
				return $this->error(__('Este item no es tuyo'));
			}
			
			$tipo_item_obj = MplayItemTipo::getInstance($item_obj->tipo, Helpers::toArray(json_decode($item_obj->propiedades)));
			
			if (!$tipo_item_obj->onDrop()){
				return $this->error(__('No puedes soltar el item'));
			}
			
			//Hay que incluir valoraciones específicas de cada item
			
			$item_obj->setpropietario(0);
			$item_obj->setlatitud($mua_linea->latitud);
			$item_obj->setlongitud($mua_linea->longitud);
			$item_obj->setfecha_recogido('0000-00-00 00:00:00');
			
			if ($item_obj->Modificar()){
				$item_obj->desequipar();
				
				Usuario::getLoged()->nuevaActividad(sprintf(__('Item soltado: <b>%s</b>'), SistemaIdioma::Imprimir($item_obj->nombre)), 'delete', (int) $GLOBALS['opciones']['ext_mplay']['experiencia']['puntos_soltar_item'], array('id_item'=>$item_obj->id));
				
				$data = array('id_item'=>'item_'.$item_obj->id);
				return $this->arrResp(__('Item soltado'), $data);
			} else {
				return $this->error(__('No se ha podido soltar el item por un error desconocido'));
			}
		} else {
			return $this->error(__('No se ha encontrado el item'));
		}
	}
	
	function getUsarItem(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/mplayItem');
		
		if (!class_exists('MplayItem')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if (empty($_POST['id_item'])){
			return $this->error(__('No hay ningún item'));
		}
		
		if ($GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['activo'] != '1'){
			return $this->error(__('El módulo Inventario no se encuentra activo'));
		}
		
		$id_item = $_POST['id_item'];
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$mua_linea = $mua;
		
		if (empty($mua_linea->latitud) || empty($mua_linea->longitud)){
return $this->error(__('No existen datos de geolocalización'));
}
		
		if ($usr_obj){
			$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
		} else {
			$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
		}
		
		$item_obj = new MplayItem();
		$item_obj->setid($id_item);
		
		if ($item_obj = $item_obj->BuscarId(SistemaIdioma::getIdiomaSesion(), '', '', true, $mua_linea->latitud, $mua_linea->longitud)){
			
			if ($item_obj->propietario != '-'.$usr_id){
				return $this->error(__('Este item no es tuyo'));
			}
			
			$tipo_item_obj = MplayItemTipo::getInstance($item_obj->tipo, Helpers::toArray(json_decode($item_obj->propiedades)));
			
			$on_use_item = $tipo_item_obj->onUse();
			
			if ($on_use_item !== true){
				return $this->error($on_use_item);
			}
			
			$item_obj->desequipar();
						
			if ($tipo_item_obj->reutilizable === false){
				$item_obj->setestado('0');
				$item_obj->setpropietario('0');
				if ($item_obj->Modificar()){
					Usuario::getLoged()->nuevaActividad(sprintf(__('Item usado: <b>%s</b>'), SistemaIdioma::Imprimir($item_obj->nombre)), 'new', (int) $GLOBALS['opciones']['ext_mplay']['experiencia']['puntos_usar_item'], array('id_item'=>$item_obj->id));
				
					$data = array('id_item'=>''.$item_obj->id);
					return $this->arrResp(__('Item usado'), $data);
				} else {
					return $this->error(__('No se ha podido eliminar el item tras su uso'));
				}
			} else {
				Usuario::getLoged()->nuevaActividad(sprintf(__('Item usado: <b>%s</b>'), SistemaIdioma::Imprimir($item_obj->nombre)), 'new', (int) $GLOBALS['opciones']['ext_mplay']['experiencia']['puntos_usar_item'], array('id_item'=>$item_obj->id));
				
				$data = array('id_item'=>''.$item_obj->id);
				return $this->arrResp(__('Item usado'), $data);
			}
		} else {
			return $this->error(__('No se ha encontrado el item'));
		}
	}
	
	function getLeerItem(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/mplayItem');
		
		if (!class_exists('MplayUsuariosActivos') || !class_exists('MplayItem')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if (empty($_POST['id_item'])){
			return $this->error(__('No hay ningún item'));
		}
		
		if ($GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['activo'] != '1'){
			return $this->error(__('El módulo Inventario no se encuentra activo'));
		}
		
		$id_item = $_POST['id_item'];
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$mua_linea = $mua;
		
		if (empty($mua_linea->latitud) || empty($mua_linea->longitud)){
return $this->error(__('No existen datos de geolocalización'));
}
		
		if ($usr_obj){
			$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
		} else {
			$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
		}
		
		$item_obj = new MplayItem();
		$item_obj->setid($id_item);
		
		if ($item_obj = $item_obj->BuscarId(SistemaIdioma::getIdiomaSesion(), '', '', true, $mua_linea->latitud, $mua_linea->longitud)){
			
			if ($item_obj->propietario != '-'.$usr_id){
				return $this->error(__('Este item no es tuyo'));
			}
			
			$props_item = Helpers::toArray(json_decode($item_obj->propiedades));
			
			$tipo_item_obj = MplayItemTipo::getInstance($item_obj->tipo, $props_item);
			
			$on_use_item = $tipo_item_obj->onRead();
			
			if ($on_use_item !== true){
				return $this->error($on_use_item);
			}
			
			$contenido_item = MplayUsuarioHelper::parsearTexto($usr_obj, $props_item['contenido'][SistemaIdioma::getIdiomaSesion()]);
			$contenido_raw = html_entity_decode(strip_tags($contenido_item));
			
			Usuario::getLoged()->nuevaActividad(sprintf(__('Libro leido: <b>%s</b>'), SistemaIdioma::Imprimir($item_obj->nombre)), 'new', (int) $GLOBALS['opciones']['ext_mplay']['experiencia']['puntos_leer_item'], array('id_item'=>$item_obj->id));
			
			$data = array("id_item"=>$item_obj->id, "titulo"=>SistemaIdioma::Imprimir($item_obj->nombre), "contenido"=>$contenido_item, "contenido_raw"=>$contenido_raw);
			return $this->arrResp(__('Leyendo libro'), $data);
		} else {
			return $this->error(__('No se ha encontrado el item'));
		}
	}
	
	function getEquiparItem(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/mplayItem');
		
		if (!class_exists('MplayUsuariosActivos') || !class_exists('MplayItem')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if (empty($_POST['id_item'])){
			return $this->error(__('No hay ningún item'));
		}
		
		if (empty($_POST['tipo_slots'])){
			return $this->error(__('No se ha seleccionado ningún tipo de slots'));
		}
		
		if (empty($_POST['slot'])){
			return $this->error(__('No se ha seleccionado ningún slot'));
		}
		
		if ($GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['activo'] != '1'){
			return $this->error(__('El módulo Inventario no se encuentra activo'));
		}
		
		$id_item = $_POST['id_item'];
		$tipo_slots = $_POST['tipo_slots'];
		$slot = $_POST['slot'];
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$mua_linea = $mua;
		
		if (empty($mua_linea->latitud) || empty($mua_linea->longitud)){
return $this->error(__('No existen datos de geolocalización'));
}
		
		if ($usr_obj){
			$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
		} else {
			$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
		}
		
		$item_obj = new MplayItem();
		$item_obj->setid($id_item);
		
		if ($item_obj = $item_obj->BuscarId(SistemaIdioma::getIdiomaSesion(), '', '', true, $mua_linea->latitud, $mua_linea->longitud)){
			
			if ($item_obj->propietario != '-'.$usr_id){
				return $this->error(__('Este item no es tuyo'));
			}
			
			$props_item = Helpers::toArray(json_decode($item_obj->propiedades));
			
			$tipo_item_obj = MplayItemTipo::getInstance($item_obj->tipo, $props_item);
			
			$slots_usr = MplayUsuarioHelper::getSlotsUsr($usr_obj, $tipo_slots);
			
			if (in_array($item_obj->id, $slots_usr))
				return $this->error(__('El item ya está equipado'));
				
			if (!isset($slots_usr[$slot]))
				return $this->error(__('La posición no existe'));
				
			if ($tipo_slots == 'armas' && $slot == 'dos_manos'){
				$slots_usr['mano_izquierda'] = $slots_usr['mano_derecha'] = '';
			} elseif ($tipo_slots == 'armas' && ($slot == 'mano_derecha' || $slot == 'mano_izquierda')){
				$slots_usr['dos_manos'] = '';
			}
				
			$slots_usr[$slot] = $item_obj->id;
			
			if ($slots_saved = MplayUsuarioHelper::setPropUsr($usr_obj, 'slots_'.$tipo_slots, $slots_usr)){
				Usuario::getLoged()->nuevaActividad(sprintf(__('Item equipado: <b>%s</b>'), SistemaIdioma::Imprimir($item_obj->nombre)), 'new', (int) $GLOBALS['opciones']['ext_mplay']['experiencia']['puntos_equipar_item'], array('id_item'=>$item_obj->id));
				
				$data = array('id_item'=>''.$item_obj->id, 'tipo_slots'=>$tipo_slots, 'slot'=>$slot);
				return $this->arrResp(__('Item equipado'), $data);
			} else {
				return $this->error(__('No se ha podido equipar el item'));
			}
		} else {
			return $this->error(__('No se ha encontrado el item'));
		}
	}
	
	function getDesequiparItem(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/mplayItem');
		
		if (!class_exists('MplayUsuariosActivos') || !class_exists('MplayItem')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if (empty($_POST['id_item'])){
			return $this->error(__('No hay ningún item'));
		}
		
		if (empty($_POST['tipo_slots'])){
			return $this->error(__('No se ha seleccionado ningún tipo de slots'));
		}
		
		if (empty($_POST['slot'])){
			return $this->error(__('No se ha seleccionado ningún slot'));
		}
		
		if ($GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['activo'] != '1'){
			return $this->error(__('El módulo Inventario no se encuentra activo'));
		}
		
		$id_item = $_POST['id_item'];
		$tipo_slots = $_POST['tipo_slots'];
		$slot = $_POST['slot'];
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$mua_linea = $mua;
		
		if (empty($mua_linea->latitud) || empty($mua_linea->longitud)){
return $this->error(__('No existen datos de geolocalización'));
}
		
		if ($usr_obj){
			$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
		} else {
			$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
		}
		
		$item_obj = new MplayItem();
		$item_obj->setid($id_item);
		
		if ($item_obj = $item_obj->BuscarId(SistemaIdioma::getIdiomaSesion(), '', '', true, $mua_linea->latitud, $mua_linea->longitud)){
			
			if ($item_obj->propietario != '-'.$usr_id){
				return $this->error(__('Este item no es tuyo'));
			}
			
			$props_item = Helpers::toArray(json_decode($item_obj->propiedades));
			
			$tipo_item_obj = MplayItemTipo::getInstance($item_obj->tipo, $props_item);
			
			$slots_usr = MplayUsuarioHelper::getSlotsUsr($usr_obj, $tipo_slots);
			
			if (!in_array($item_obj->id, $slots_usr))
				return $this->error(__('El item no está equipado'));
				
			if (!isset($slots_usr[$slot]))
				return $this->error(__('La posición no existe'));
				
			$slots_usr[$slot] = "";
			
			if ($slots_saved = MplayUsuarioHelper::setPropUsr($usr_obj, 'slots_'.$tipo_slots, $slots_usr)){
				Usuario::getLoged()->nuevaActividad(sprintf(__('Item desequipado: <b>%s</b>'), SistemaIdioma::Imprimir($item_obj->nombre)), 'delete', (int) $GLOBALS['opciones']['ext_mplay']['experiencia']['puntos_desequipar_item'], array('id_item'=>$item_obj->id));
				
				$data = array('id_item'=>''.$item_obj->id, 'tipo_slots'=>$tipo_slots, 'slot'=>$slot);
				return $this->arrResp(__('Item desequipado'), $data);
			} else {
				return $this->error(__('No se ha podido desequipar el item'));
			}
		} else {
			return $this->error(__('No se ha encontrado el item'));
		}
	}
	
	function getTransferirDinero(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		if (!Usuario::isLoged())
			return $this->error(__('No estás conectado'));
			
		$usr_obj = Usuario::getLoged();
		
		e_include('ext_sitios/class/sitio');
		
		if (!class_exists('Sitio')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		$casa_usr = MplayUsuarioHelper::getCasaUsr($usr_obj);
		
		if (!$casa_usr instanceof Sitio)
			return $this->error(__('¡No tienes casa!'));
		
		$params_casa = Helpers::toArray(json_decode($casa_usr->params));
		
		if (empty($_POST['dinero'])){
			return $this->error(__('No se ha elegido un valor para la transferencia'));
		}
		
		if (empty($_POST['sentido'])){
			return $this->error(__('No sé que hacer con el dinero'));
		}
		
		switch ($_POST['sentido']){
			case 'bolsa-almacen':
				$origen = MplayUsuarioHelper::getMonedas($usr_obj);
				$destino = $params_casa['propiedades']['monedas'];
								
				$origen -= $_POST['dinero'];
				$destino += $_POST['dinero'];
				
				MplayUsuarioHelper::setMonedas($usr_obj,$origen);
				$params_casa['propiedades']['monedas'] = $destino;
				$casa_usr->setparams(json_encode($params_casa));
				$casa_usr->Modificar();
				
				return $this->arrResp(__('Transferencia desde tu bolsa a tu almacén realizada con éxito'), array('sentido'=>'bolsa-almacen', 'dinero'=>$_POST['dinero']));
				break;
				
			case 'almacen-bolsa':
				$origen = $params_casa['propiedades']['monedas'];
				$destino = MplayUsuarioHelper::getMonedas($usr_obj);
				
				$origen -= $_POST['dinero'];
				$destino += $_POST['dinero'];
				
				$params_casa['propiedades']['monedas'] = $origen;
				$casa_usr->setparams(json_encode($params_casa));
				$casa_usr->Modificar();
				MplayUsuarioHelper::setMonedas($usr_obj,$destino);
				
				return $this->arrResp(__('Transferencia desde tu bolsa a tu almacén realizada con éxito'), array('sentido'=>'almacen-bolsa', 'dinero'=>$_POST['dinero']));
				break;
		}
		
		return $this->error(__('No se ha realizado la transferencia'));
		
	}
	
	function getAlmacenarItem(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_sitios/class/sitio','ext_mplay/class/mplayItem');
		
		if (!class_exists('Sitio') || !class_exists('MplayItem')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if (empty($_POST['id_item'])){
			return $this->error(__('No hay ningún item'));
		}
		
		if (empty($_POST['id_sitio'])){
			return $this->error(__('No hay ningún sitio en el que almacenar el item'));
		}
		
		if ($GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['activo'] != '1'){
			return $this->error(__('El módulo Inventario no se encuentra activo'));
		}
		
		$id_item = $_POST['id_item'];
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$mua_linea = $mua;
		
		if (empty($mua_linea->latitud) || empty($mua_linea->longitud)){
return $this->error(__('No existen datos de geolocalización'));
}
		
		if ($usr_obj){
			$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
		} else {
			$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
		}
		
		$where_items_sitio = ' AND sitio = "'.$_POST['id_sitio'].'"';
					
		$items_usr = new MplayItem();
		
		$where_items_usr = 'estado="1"'.$where_items_sitio;
		
		$items_usr_c = $items_usr->ListarCount($where_items_usr);
		
		$sitio_obj = new Sitio();
		$sitio_obj->setid($_POST['id_sitio']);
		if ($sitio_obj = $sitio_obj->BuscarId()){
		} else {
			return $this->error(__('No existe el sitio en el que almacenar el item'));
		}
		
		$casillas_sitio = MplaySitioHelper::getCasillasSitio($sitio_obj);
		
		if ($items_usr_c >= $casillas_sitio){
			return $this->error(__('No puedes almacenar este item porque el sitio no tiene espacio de almacenamiento'));
		}
		
		$params_sitio = Helpers::toArray(json_decode($sitio_obj->params));
		$monedas_sitio = (int) $params_sitio['propiedades']['monedas'];
		
		if ($params_sitio['tipo'] != 'casa' || !$sitio_obj->es_propietario()){
			return $this->error(__('No puedes almacenar items en sitios que no sean una casa de tu propiedad'));
		}
		
		$item_obj = new MplayItem();
		$item_obj->setid($id_item);
		
		if ($item_obj = $item_obj->BuscarId(SistemaIdioma::getIdiomaSesion(), '', '', true, $sitio_obj->latitud, $sitio_obj->longitud)){
			
			if ($item_obj->propietario != '-'.$usr_id){
				return $this->error(__('Este item no es tuyo'));
			}
			
			$tipo_item_obj = MplayItemTipo::getInstance($item_obj->tipo, Helpers::toArray(json_decode($item_obj->propiedades)));
			
			if (!$tipo_item_obj->onStore()){
				return $this->error(__('No puedes almacenar el item'));
			}
			
			//Hay que incluir valoraciones específicas de cada item
			
			$item_obj->setsitio($sitio_obj->id);
			$item_obj->setpropietario('0');
			$item_obj->setlatitud($sitio_obj->latitud);
			$item_obj->setlongitud($sitio_obj->longitud);
			$item_obj->setfecha_recogido(strftime("%Y-%m-%d %H:%M:%S"));
			
			if ($item_obj->Modificar()){
				$item_obj->desequipar();
				
				$sitio_obj->setparams(json_encode($params_sitio));
				$sitio_obj->Modificar();
				
				$usr_obj->nuevaActividad(sprintf(__('Item <b>%s</b> almacenado en el sitio <b>%s</b>.'), SistemaIdioma::Imprimir($item_obj->nombre), $sitio_obj->titulo_formateado), 'new', (int) $GLOBALS['opciones']['ext_mplay']['experiencia']['puntos_almacenar_item'], array('id_item'=>$item_obj->id, 'id_sitio'=>$sitio_obj->id));
				
				$data = array('id_item'=>$item_obj->id, 'id_sitio'=>$sitio_obj->id);
				return $this->arrResp(__('Item almacenado'), $data);
			} else {
				return $this->error(__('No se ha podido almacenar el item por un error desconocido'));
			}
		} else {
			return $this->error(__('No se ha encontrado el item'));
		}
	}
	
	function getVenderItem(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_sitios/class/sitio','ext_mplay/class/mplayItem');
		
		if (!class_exists('Sitio') || !class_exists('MplayItem')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if (empty($_POST['id_item'])){
			return $this->error(__('No hay ningún item'));
		}
		
		if (empty($_POST['id_sitio'])){
			return $this->error(__('No hay ningún sitio al que vender el item'));
		}
		
		if (empty($_POST['precio'])){
			return $this->error(__('No se ha establecido el precio de venta del item'));
		}
		
		if ($GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['activo'] != '1'){
			return $this->error(__('El módulo Inventario no se encuentra activo'));
		}
		
		$precio = (int) $_POST['precio'];
		$id_item = $_POST['id_item'];
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$mua_linea = $mua;
		
		if (empty($mua_linea->latitud) || empty($mua_linea->longitud)){
return $this->error(__('No existen datos de geolocalización'));
}
		
		if ($usr_obj){
			$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
		} else {
			$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
		}
		
		$where_items_sitio = ' AND sitio = "'.$_POST['id_sitio'].'"';
					
		$items_usr = new MplayItem();
		
		$where_items_usr = 'estado="1"'.$where_items_sitio;
		
		$items_usr_c = $items_usr->ListarCount($where_items_usr);
		
		$sitio_obj = new Sitio();
		$sitio_obj->setid($_POST['id_sitio']);
		if ($sitio_obj = $sitio_obj->BuscarId()){
		} else {
			return $this->error(__('No existe el sitio al que vender el item'));
		}
		
		$params_sitio = Helpers::toArray(json_decode($sitio_obj->params));
		$propiedades_sitio = $params_sitio['propiedades'];
		$monedas_sitio = (int) $params_sitio['propiedades']['monedas'];
		
		if ($monedas_sitio < $precio)
			return $this->error(__('El sitio no tiene suficientes Monedas de Oro (MO) para comprar el item'));
			
		$monedas_sitio -= $precio;
		$params_sitio['propiedades']['monedas'] = $monedas_sitio;
		
		$item_obj = new MplayItem();
		$item_obj->setid($id_item);
		
		if ($item_obj = $item_obj->BuscarId(SistemaIdioma::getIdiomaSesion(), '', '', true, $sitio_obj->latitud, $sitio_obj->longitud)){
			
			if ($item_obj->propietario != '-'.$usr_id){
				return $this->error(__('Este item no es tuyo'));
			}
			
			if (is_array($propiedades_sitio['tipo_items']) && sizeof($propiedades_sitio['tipo_items']) > 0){
				if (!in_array($item_obj->tipo, $propiedades_sitio['tipo_items'])){
					return $this->error(__('Este sitio no acepta este tipo de objetos'));
				}
			}
			
			$tipo_item_obj = MplayItemTipo::getInstance($item_obj->tipo, Helpers::toArray(json_decode($item_obj->propiedades)));
			
			if (!$tipo_item_obj->onSell()){
				return $this->error(__('No puedes vender el item'));
			}
			
			$model_item = $item_obj->getmodel();
			
			$item_en_sitio = false;
			$items_sitio = MplaySitioTipo::getitems($sitio_obj, false, true);
			if (is_array($items_sitio) && sizeof($items_sitio) > 0){
				foreach ($items_sitio as $is){
					if ($is['model_id'] == $model_item && !empty($model_item)){
						$item_en_sitio = $is['id'];
						continue;
					}
				}
			}
			
			if ($item_en_sitio != false){
				foreach ($propiedades_sitio['items'] as $kit=>$it){
					if ($it->id == $item_en_sitio){
						$propiedades_sitio['items'][$kit]->cantidad += 1;
						continue;
					}
				}
				$params_sitio['propiedades'] = $propiedades_sitio;
				
				$item_obj->setestado(0);
				$item_obj->setpropietario('0');
				$item_obj->setfecha_recogido(strftime("%Y-%m-%d %H:%M:%S"));
			} else {
				if ($items_usr_c >= $GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['opciones']['max_items_comercios']){
					return $this->error(__('No puedes vender este item porque el sitio no tiene espacio de almacenamiento'));
				}
				$item_obj->setsitio($sitio_obj->id);
				$item_obj->setpropietario('0');
				$item_obj->setlatitud($sitio_obj->latitud);
				$item_obj->setlongitud($sitio_obj->longitud);
				$item_obj->setfecha_recogido(strftime("%Y-%m-%d %H:%M:%S"));
				
				$propiedades_sitio['items'][] = array("id"=>$item_obj->id, "cantidad"=>1);
				$params_sitio['propiedades'] = $propiedades_sitio;
			}
			
			//Hay que incluir valoraciones específicas de cada item

			if ($item_obj->Modificar()){
				$item_obj->desequipar();
				
				$sitio_obj->setparams(json_encode($params_sitio));
				$sitio_obj->Modificar();
				
				$usr_obj->cambiaCredito($precio);
				
				$usr_obj->nuevaActividad(sprintf(__('Item <b>%s</b> vendido al sitio <b>%s</b> al precio de <b>%s MO</b>.'), SistemaIdioma::Imprimir($item_obj->nombre), $sitio_obj->titulo_formateado, $_POST['precio']), 'new', (int) $GLOBALS['opciones']['ext_mplay']['experiencia']['puntos_vender_item'], array('id_item'=>$item_obj->id, 'id_sitio'=>$sitio_obj->id, 'precio'=>$_POST['precio']));
				
				$data = array('id_item'=>$item_obj->id, 'id_sitio'=>$sitio_obj->id, 'precio'=>$_POST['precio']);
				return $this->arrResp(__('Item vendido'), $data);
			} else {
				return $this->error(__('No se ha podido vender el item por un error desconocido'));
			}
		} else {
			return $this->error(__('No se ha encontrado el item'));
		}
	}
	
	function getComprarItem(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_sitios/class/sitio','ext_mplay/class/mplayItem','ext_mplay/class/mplaySitioTipo');
		
		if (!class_exists('Sitio') || !class_exists('MplayItem')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if (empty($_POST['id_item'])){
			return $this->error(__('No hay ningún item'));
		}
		
		if (empty($_POST['id_sitio'])){
			return $this->error(__('No hay ningún sitio al que comprar el item'));
		}
		
		if (empty($_POST['precio'])){
			return $this->error(__('No se ha establecido el precio de compra del item'));
		}
		
		if ($GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['activo'] != '1'){
			return $this->error(__('El módulo Inventario no se encuentra activo'));
		}
		
		$precio = (int) $_POST['precio'];
		$id_item = $_POST['id_item'];
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$mua_linea = $mua;
		
		if (empty($mua_linea->latitud) || empty($mua_linea->longitud)){
return $this->error(__('No existen datos de geolocalización'));
}
		
		if ($usr_obj){
			$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
		} else {
			$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
		}
		
		$items_usr = new MplayItem();
		
		$where_items_usr = 'estado="1" AND propietario="-'.$usr_id.'"';
		
		$items_usr_c = $items_usr->ListarCount($where_items_usr);
		
		if ($items_usr_c >= $GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['opciones']['max_items_inventario']){
			return $this->error(__('No puedes comprar este item porque no tienes espacio en tu inventario'));
		}
		
		$sitio_obj = new Sitio();
		$sitio_obj->setid($_POST['id_sitio']);
		if ($sitio_obj = $sitio_obj->BuscarId()){
		} else {
			return $this->error(__('No existe el sitio al que comprar el item'));
		}
		
		$monedas_usr = MplayUsuarioHelper::getMonedas($usr_obj);
		
		$params_sitio = Helpers::toArray(json_decode($sitio_obj->params));
		$monedas_sitio = (int) $params_sitio['propiedades']['monedas'];
		
		if ($monedas_usr < $precio)
			return $this->error(__('No tienes suficientes Monedas de Oro (MO) para comprar el item'));
			
		$monedas_sitio += $precio;
		$params_sitio['propiedades']['monedas'] = $monedas_sitio;
		
		$items_sitio = MplaySitioTipo::getitems($sitio_obj, false, true);
		
		$cantidad_items_sitio = 0;
		foreach ($items_sitio as $isit){
			if ($isit['id'] == $id_item){
				$cantidad_items_sitio = $isit['cantidad'];
				continue;
			}
		}
		
		if ($cantidad_items_sitio < 1){
			return $this->error(__('La tienda no tiene existencias del objeto'));
		}
		$cantidad_items_sitio -= 1;
		
		$item_obj = new MplayItem();
		$item_obj->setid($id_item);
		
		if ($item_obj = $item_obj->BuscarId(SistemaIdioma::getIdiomaSesion(), '', '', true, $sitio_obj->latitud, $sitio_obj->longitud)){
			
			if ($item_obj->propietario == '-'.$usr_id){
				return $this->error(__('Este item ya es tuyo'));
			}
			
			$update_vars_item = $item_obj->get('update_vars');
			$item_new = new MplayItem();
			foreach ($update_vars_item as $var){
				$item_new->$var = $item_obj->$var;
			}
			$item_new->sitio = 0;
			$item_new->propietario = '-'.$usr_id;
			$item_new->bot = 0;
			$item_new->estado = 1;
			$item_new->visibilidad = 1;
			$item_new->setlatitud($mua_linea->latitud);
			$item_new->setlongitud($mua_linea->longitud);
			$item_new->fecha_recogido = strftime("%Y-%m-%d %H:%M:%S", time());
			if (!empty($item_obj->model_id))
				$item_new->model_id = $item_obj->model_id;
			else
				$item_new->model_id = $item_obj->id;
				
			if ($id_new_item = $item_new->Guardar()){
				$item_new->id = $id_new_item;
				
				$tipo_item_obj = MplayItemTipo::getInstance($item_new->tipo, Helpers::toArray(json_decode($item_new->propiedades)));
			
				if (!$tipo_item_obj->onBuy()){
					return $this->error(__('No puedes comprar el item'));
				}
				
				//Hay que incluir valoraciones específicas de cada item
				
				foreach ($params_sitio['propiedades']['items'] as $kpar=>$par){
					$params_sitio['propiedades']['items'][$kpar] = (array) $par;
					if ($par->id == $item_obj->id){
						$params_sitio['propiedades']['items'][$kpar]['cantidad'] -= 1;
						if ($params_sitio['propiedades']['items'][$kpar]['cantidad'] == 0){
							$item_obj->setestado(0);
							$item_obj->Modificar();
						}
						continue;
					}
				}
				
				$sitio_obj->setparams(json_encode($params_sitio));
				$sitio_obj->Modificar();
				
				$usr_obj->cambiaCredito("-".$precio);
				
				$usr_obj->nuevaActividad(sprintf(__('Item <b>%s</b> comprado al sitio <b>%s</b> al precio de <b>%s MO</b>.'), SistemaIdioma::Imprimir($item_obj->nombre), $sitio_obj->titulo_formateado, $_POST['precio']), 'new', (int) $GLOBALS['opciones']['ext_mplay']['experiencia']['puntos_comprar_item'], array('id_item'=>$item_obj->id, 'id_sitio'=>$sitio_obj->id, 'precio'=>$_POST['precio']));
				
				$data = array('id_item'=>$item_obj->id, 'id_sitio'=>$sitio_obj->id, 'precio'=>$_POST['precio']);
				return $this->arrResp(__('Item comprado'), $data);
			} else {
				return $this->error(__('No se pudo comprar el item'));
			}
		} else {
			return $this->error(__('No se ha encontrado el item'));
		}
	}
	
	function getComprarHabilidad(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/mplayHabilidadesUsuarios','ext_mplay/class/mplayHabilidadUsuario','ext_mplay/class/mplayHabilidadTipo');
		
		if (!class_exists('MplayHabilidadUsuario')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if (empty($_POST['id_skill'])){
			return $this->error(__('No hay ninguna habilidad'));
		}
		
		if (empty($_POST['precio'])){
			return $this->error(__('No se ha establecido el precio de compra de la habilidad'));
		}
		
		$precio = (int) $_POST['precio'];
		$id_item = $_POST['id_skill'];
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$mua_linea = $mua;
		
		if (empty($mua_linea->latitud) || empty($mua_linea->longitud)){
return $this->error(__('No existen datos de geolocalización'));
}
		
		if ($usr_obj){
			$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
		} else {
			$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
		}
		
		$check_comprado = new MplayHabilidadesUsuarios();
		$check_comprado_c = $check_comprado->ListarCount("id_habilidad='".$id_item."' AND id_usuario='".$usr_id."'");
		if ($check_comprado_c > 0)
			return $this->error(__('Ya has aprendido esta habilidad'));
			
		$monedas_usr = MplayUsuarioHelper::getMonedas($usr_obj);
		
		if ($monedas_usr < $precio)
			return $this->error(__('No tienes suficientes Monedas de Oro (MO) para aprender la habilidad'));
			
		$check_comprado->setid_usuario($usr_id);
		$check_comprado->setid_habilidad($id_item);
		$check_comprado->setfecha(strftime("%Y-%m-%d %H:%M:%S"));
		
		if ($check_comprado->Guardar()){
			$usr_obj->cambiaCredito("-".$precio);
			
			$habilidad = new MplayHabilidadUsuario();
			$habilidad->setid($id_item);
			$habilidad = $habilidad->BuscarId();
			
			$usr_obj->nuevaActividad(sprintf(__('Habilidad <b>%s</b> aprendida por un precio de <b>%s MO</b>.'), SistemaIdioma::Imprimir($habilidad->nombre), $_POST['precio']), 'new', (int) $GLOBALS['opciones']['ext_mplay']['experiencia']['puntos_aprender_habilidad'], array('id_habilidad'=>$habilidad->id, 'precio'=>$_POST['precio']));
			
			$data = array("id_usuario"=>$usr_id,"id_habilidad"=>$id_item);
			return $this->arrResp(__("Habilidad aprendida"), $data);
		} else {
			return $this->error(__("Error desconocido"));
		}
	}
	
	function getComprarMejora(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/mplayHabilidadesSitios','ext_mplay/class/mplayHabilidadUsuario','ext_mplay/class/mplayHabilidadTipo');
		
		if (!class_exists('MplayHabilidadUsuario')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if (empty($_POST['id_skill'])){
			return $this->error(__('No hay ninguna mejora'));
		}
		
		if (empty($_POST['id_sitio'])){
			return $this->error(__('No hay ningún sitio'));
		}
		
		if (empty($_POST['precio'])){
			return $this->error(__('No se ha establecido el precio de compra de la mejora'));
		}
		
		$precio = (int) $_POST['precio'];
		$id_item = $_POST['id_skill'];
		$id_sitio = $_POST['id_sitio'];
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$mua_linea = $mua;
		
		if (empty($mua_linea->latitud) || empty($mua_linea->longitud)){
return $this->error(__('No existen datos de geolocalización'));
}
		
		if ($usr_obj){
			$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
		} else {
			$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
		}
		
		$check_comprado = new MplayHabilidadesSitios();
		$check_comprado_c = $check_comprado->ListarCount("id_habilidad='".$id_item."' AND id_sitio='".$id_sitio."'");
		if ($check_comprado_c > 0)
			return $this->error(__('Ya has comprado esta mejora'));
			
		$monedas_usr = MplayUsuarioHelper::getMonedas($usr_obj);
		
		if ($monedas_usr < $precio)
			return $this->error(__('No tienes suficientes Monedas de Oro (MO) para comprar la mejora'));
			
		$check_comprado->setid_sitio($id_sitio);
		$check_comprado->setid_habilidad($id_item);
		$check_comprado->setfecha(strftime("%Y-%m-%d %H:%M:%S"));
		
		if ($check_comprado->Guardar()){
			$usr_obj->cambiaCredito("-".$precio);
			
			$habilidad = new MplayHabilidadUsuario();
			$habilidad->setid($id_item);
			$habilidad = $habilidad->BuscarId();
			
			$sitio = new Sitio();
			$sitio->setid($id_sitio);
			$sitio = $sitio->BuscarId();
			
			$usr_obj->nuevaActividad(sprintf(__('Mejora <b>%s</b> comprada por un precio de <b>%s MO</b> para el sitio <b>%s</b>.'), SistemaIdioma::Imprimir($habilidad->nombre), $_POST['precio'], SistemaIdioma::Imprimir($sitio->titulo)), 'new', (int) $GLOBALS['opciones']['ext_mplay']['experiencia']['puntos_comprar_mejora'], array('id_habilidad'=>$habilidad->id, 'precio'=>$_POST['precio'], 'id_sitio'=>$id_sitio));
			
			$data = array("id_usuario"=>$usr_id,"id_habilidad"=>$id_item, "id_sitio"=>$id_sitio);
			return $this->arrResp(__("Mejora construida"), $data);
		} else {
			return $this->error(__("Error desconocido"));
		}
	}
	
	function getRellenarInventario(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/mplayItem');
		
		if (!class_exists('MplayItem')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if ($GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['activo'] != '1'){
			return $this->error(__('El módulo Inventario no se encuentra activo'));
		}
			
		$items_usr = new MplayItem();
		
		$where_items_usr = 'estado="1" AND propietario="-'.$usr_id.'"';
		
		$items_usr_c = $items_usr->ListarCount($where_items_usr);
		
		if ($items_usr_c > 0){
			$items_usr = $items_usr->Listar($where_items_usr, 'fecha_recogido', 'DESC');
			
			$data = array();
			
			foreach ($items_usr as $iu){
				$props_iu = Helpers::toArray(json_decode($iu->propiedades));
				$tipo_item_obj = MplayItemTipo::getInstance($iu->tipo, $props_iu);
				
				$esta_equipado = $iu->esta_equipado($tipo_item_obj->tipo_slots, $props_iu['slot']);
				
				$tmp_item = array('nombre'=>SistemaIdioma::Imprimir($iu->nombre), 'descripcion'=>SistemaIdioma::Imprimir($iu->descripcion), 'id'=>$iu->id, 'model'=>$iu->getmodel(), 'tipo'=>$iu->tipo, 'icono'=>$iu->geticono(256,256), 'propiedades_html'=>$tipo_item_obj->printPropiedadesHtml(' class="col-xs-12"'), 'propiedades'=>$tipo_item_obj->get_propiedades_parsed(), 'opciones'=>$tipo_item_obj->printOpcionesBtns('inventario', $iu), 'opciones_comerciar'=>$tipo_item_obj->printOpcionesBtns('inventario_comercio', $iu), 'opciones_almacenar'=>$tipo_item_obj->printOpcionesBtns('loot_jugador', $iu), "esta_equipado"=>$esta_equipado);
				
				$data[] = $tmp_item;
			}
						
			return $this->arrResp(sprintf(__('Hay %s items en el inventario del usuario'), $items_usr_c), $data);
			
		} else {
			return $this->arrResp(__('No hay items en el inventario del usuario'), array());
		}
	}
	
	function getRellenarInventarioAprender(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_sitios/class/sitio','ext_mplay/class/mplayHabilidadUsuario','ext_mplay/class/mplaySitioTipo','ext_mplay/class/helpers/mplayUsuarioHelper');
		
		if (!class_exists('MplayHabilidadUsuario') || !Helpers::checkExtension('ext_sitios')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (empty($_GET['id_sitio']))
			return $this->error(__('No hay ningún sitio donde estudiar'));
			
		$usr_obj = Usuario::getLoged();
		
		$oficio_usr = MplayUsuarioHelper::getOficioUsr($usr_obj);
			
		$sitio_obj = new Sitio();
		$sitio_obj->setid($_GET['id_sitio']);
		if ($sitio_obj = $sitio_obj->BuscarId()){
		} else {
			return $this->error(__('No se encuentra el sitio donde aprender'));
		}
		
		$habilidades_sitio = MplaySitioTipo::gethabilidades($sitio_obj, false, true, 'mapa');
		
		if (!$habilidades_sitio)
			$habilidades_sitio = array();
		
		$habilidades_sitio_c = count($habilidades_sitio);
		
		if ($habilidades_sitio_c > 0){
			$data = array();
			
			$count = 0;
			
			foreach ($habilidades_sitio as $iu){
				if (!empty($iu['oficio']) && $oficio_usr['id'] != $iu['oficio'])
					continue;
				
				$tipo_item_obj = MplayHabilidadTipo::getInstance($iu['tipo'], $iu['propiedades_full']);
				$tmp_item = array('nombre'=>$iu['nombre'], 'descripcion'=>$iu['descripcion'], 'id'=>$iu['id'], 'model'=>$iu['model_id'], 'padre'=>$iu['padre'], 'tipo'=>$iu['tipo'], 'icono'=>$iu['icono'], 'propiedades_html'=>$tipo_item_obj->printPropiedadesHtml(' class="col-xs-12"'), 'propiedades'=>$tipo_item_obj->get_propiedades_parsed(), 'propiedades_html'=>$tipo_item_obj->printPropiedadesHtml('class="col-xs-12"'), 'opciones'=>$iu['opciones'], 'coste'=>$iu['coste'], 'onclick'=>'collapse', 'href'=>'#mplay-iteminfo-'.$count.'-aprender-sitio', 'aprendida'=>$iu['aprendida']);
				
				$count ++;
				
				$data[] = $tmp_item;
			}
						
			return $this->arrResp(sprintf(__('Hay %s habilidades en el inventario del sitio'), $count), $data);
			
		} else {
			return $this->error(__('No hay habilidades en el inventario del sitio'));
		}
	}
	
	function getRellenarInventarioMejorarCasa(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_sitios/class/sitio','ext_mplay/class/mplayHabilidadUsuario','ext_mplay/class/mplaySitioTipo','ext_mplay/class/helpers/mplayUsuarioHelper','ext_mplay/class/helpers/mplaySitioHelper');
		
		if (!class_exists('MplayHabilidadUsuario') || !Helpers::checkExtension('ext_sitios')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (empty($_GET['id_sitio']))
			return $this->error(__('No hay ningún sitio que mejorar'));
			
		$usr_obj = Usuario::getLoged();
		
		$oficio_usr = MplayUsuarioHelper::getOficioUsr($usr_obj);
			
		$sitio_obj = new Sitio();
		$sitio_obj->setid($_GET['id_sitio']);
		if ($sitio_obj = $sitio_obj->BuscarId()){
		} else {
			return $this->error(__('No se encuentra el sitio que mejorar'));
		}
		
		if (!$sitio_obj->es_propietario()){
			return $this->error(__('No eres el propietario del sitio que intentas mejorar'));
		}
		
		$habilidades_sitio = MplaySitioTipo::gethabilidades($sitio_obj, false, true, 'mapa');
		
		if (!$habilidades_sitio)
			$habilidades_sitio = array();
		
		$habilidades_sitio_c = count($habilidades_sitio);
		
		if ($habilidades_sitio_c > 0){
			$data = array();
			
			$count = 0;
			
			foreach ($habilidades_sitio as $iu){
				if (!empty($iu['oficio']) && $oficio_usr['id'] != $iu['oficio'])
					continue;
				
				$tipo_item_obj = MplayHabilidadTipo::getInstance($iu['tipo'], $iu['propiedades_full']);
				$tmp_item = array('nombre'=>$iu['nombre'], 'descripcion'=>$iu['descripcion'], 'id'=>$iu['id'], 'model'=>$iu['model_id'], 'padre'=>$iu['padre'], 'tipo'=>$iu['tipo'], 'icono'=>$iu['icono'], 'propiedades_html'=>$tipo_item_obj->printPropiedadesHtml(' class="col-xs-12"'), 'propiedades'=>$tipo_item_obj->get_propiedades_parsed(), 'propiedades_html'=>$tipo_item_obj->printPropiedadesHtml('class="col-xs-12"'), 'opciones'=>$iu['opciones'], 'coste'=>$iu['coste'], 'onclick'=>'collapse', 'href'=>'#mplay-iteminfo-'.$count.'-mejorar-casa', 'aprendida'=>$iu['aprendida']);
				
				$count ++;
				
				$data[] = $tmp_item;
			}
						
			return $this->arrResp(sprintf(__('Hay %s habilidades en el inventario del sitio'), $count), $data);
			
		} else {
			return $this->error(__('No hay mejoras del sitio'));
		}
	}
	
	function getRellenarInventarioComerciar(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_sitios/class/sitio','ext_mplay/class/mplayItem','ext_mplay/class/mplaySitioTipo');
		
		if (!class_exists('MplayItem') || !Helpers::checkExtension('ext_sitios')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if ($GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['activo'] != '1'){
			return $this->error(__('El módulo Inventario no se encuentra activo'));
		}
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (empty($_GET['id_sitio']))
			return $this->error(__('No hay ningún sitio con el que comerciar'));
			
		$sitio_obj = new Sitio();
		$sitio_obj->setid($_GET['id_sitio']);
		if ($sitio_obj = $sitio_obj->BuscarId()){
		} else {
			return $this->error(__('No se encuentra el sitio con el que comerciar'));
		}
		
		$items_sitio = MplaySitioTipo::getitems($sitio_obj, false, true, 'comercio');
		
		$items_usr_c = count($items_sitio);
		
		if ($items_usr_c > 0){
			$data = array();
			
			foreach ($items_sitio as $iu){
				$tipo_item_obj = MplayItemTipo::getInstance($iu['tipo'], $iu['propiedades_full']);
				$tmp_item = array('nombre'=>$iu['nombre'], 'descripcion'=>$iu['descripcion'], 'id'=>$iu['id'], 'model'=>$iu['model_id'], 'tipo'=>$iu['tipo'], 'icono'=>$iu['icono'], 'propiedades_html'=>$tipo_item_obj->printPropiedadesHtml(' class="col-xs-12"'), 'propiedades'=>$tipo_item_obj->get_propiedades_parsed(), 'opciones'=>$iu['opciones'], 'cantidad'=>$iu['cantidad']);
				
				$data[] = $tmp_item;
			}
						
			return $this->arrResp(sprintf(__('Hay %s items en el inventario del sitio'), $items_usr_c), $data);
			
		} else {
			return $this->error(__('No hay items en el inventario del sitio'));
		}
	}
	
	function getRellenarInventarioCasa(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/mplayItem');
		
		if (!class_exists('MplayItem') || !Helpers::checkExtension('ext_sitios')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if ($GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['activo'] != '1'){
			return $this->error(__('El módulo Inventario no se encuentra activo'));
		}
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		$usr_obj = Usuario::getLoged();
		$casa_usr = MplayUsuarioHelper::getCasaUsr($usr_obj);
		
		if (!$casa_usr instanceof Sitio)
			return $this->error(__('¡No tienes casa!'));			
			
		$where_items_sitio = ' AND sitio = "'.$casa_usr->id.'"';
					
		$items_usr = new MplayItem();
		
		$where_items_usr = 'estado="1"'.$where_items_sitio;
		
		$items_usr_c = $items_usr->ListarCount($where_items_usr);
		
		if ($items_usr_c > 0){
			$items_usr = $items_usr->Listar($where_items_usr, 'fecha_recogido', 'DESC');
			
			$data = array();
			
			foreach ($items_usr as $iu){
				$tipo_item_obj = MplayItemTipo::getInstance($iu->tipo, Helpers::toArray(json_decode($iu->propiedades)));
				$tmp_item = array('nombre'=>SistemaIdioma::Imprimir($iu->nombre), 'descripcion'=>SistemaIdioma::Imprimir($iu->descripcion), 'id'=>$iu->id, 'model'=>$iu->getmodel(), 'tipo'=>$iu->tipo, 'icono'=>$iu->geticono(256,256), 'propiedades_html'=>$tipo_item_obj->printPropiedadesHtml(' class="col-xs-12"'), 'propiedades'=>$tipo_item_obj->get_propiedades_parsed(), 'opciones'=>$tipo_item_obj->printOpcionesBtns('loot', $iu));
				
				$data[] = $tmp_item;
			}
						
			return $this->arrResp(sprintf(__('Hay %s items en el almacén de tu casa'), $items_usr_c), $data);
			
		} else {
			return $this->error(__('No hay items en el almacén de tu casa'));
		}
	}
	
	function getRellenarRetarBot(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/mplayBot');
		
		if (!class_exists('MplayBot')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (empty($_GET['id_bot']))
			return $this->error(__('No hay ningún personaje al que retar'));
			
		$bot = new MplayBot();
		$bot->setid($_GET['id_bot']);
		
		if ($bot = $bot->BuscarId()){
			$tipo_item_obj = MplayBotTipo::getInstance($bot->tipo, Helpers::toArray(json_decode($bot->propiedades)));
			$data = array('nombre'=>SistemaIdioma::Imprimir($bot->nombre), 'descripcion'=>SistemaIdioma::Imprimir($bot->descripcion), 'id'=>$bot->id, 'tipo'=>$bot->tipo, 'icono'=>$bot->getavatar(32,32), 'icono_big'=>$bot->getavatar(400,400), 'propiedades_html'=>$tipo_item_obj->printPropiedadesHtml(' class="col-xs-12 col-sm-4"'), 'propiedades'=>$tipo_item_obj->get_propiedades_parsed(), 'opciones'=>$tipo_item_obj->printOpcionesBtns('mapa', $bot));
			
			return $this->arrResp(__('Datos de personaje recuperados'), $data);
		} else {
			return $this->error(__('No se ha encontrado el personaje al que retar'));
		}
	}
	
	function getRellenarDialogoBot(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/mplayBot','ext_mplay/class/mplayItem');
		
		if (!class_exists('MplayBot')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (empty($_GET['id_bot']))
			return $this->error(__('No hay ningún personaje con el que hablar'));
			
		$bot = new MplayBot();
		$bot->setid($_GET['id_bot']);
		
		if ($bot = $bot->BuscarId()){
			$tipo_item_obj = MplayBotTipo::getInstance($bot->tipo, Helpers::toArray(json_decode($bot->propiedades)));
			
			foreach ($tipo_item_obj->propiedades["dialogos"]["valor"] as $kv=>$v){
				if ($v->tipo == 'evento'){
					$val_evento = explode(":",$v->txt);
					if (sizeof($val_evento) == 2){
						switch ($val_evento[0]){
							case 'recoger_item':
								if (!empty($val_evento[1])){
									$item_obj = new MplayItem();
									$item_obj->setid($val_evento[1]);
									if ($item_obj = $item_obj->BuscarId()){
										$props_item = Helpers::toArray(json_decode($item_obj->propiedades));
										$v->accion_evento = 'RecogerItem';
										$v->mensaje_evento = sprintf(__('Has recogido el item <b>%s</b>'), SistemaIdioma::Imprimir($item_obj->nombre));
										$v->valor_evento = array("id"=>$item_obj->id,"nombre"=>SistemaIdioma::Imprimir($item_obj->nombre), "tipo"=>$item_obj->tipo, "descripcion"=>SistemaIdioma::Imprimir($item_obj->descripcion), "propiedades"=>$props_item);
									}
								}
								break;
						}
						
						$tipo_item_obj->propiedades["dialogos"]["valor"][$kv] = $v;
					}
				}
			}
			
			$data = array('nombre'=>SistemaIdioma::Imprimir($bot->nombre), 'descripcion'=>SistemaIdioma::Imprimir($bot->descripcion), 'id'=>$bot->id, 'tipo'=>$bot->tipo, 'icono'=>$bot->getavatar(32,32), 'icono_big'=>$bot->getavatar(400,400), 'propiedades_html'=>$tipo_item_obj->printPropiedadesHtml(' class="col-xs-12 col-sm-4"'), 'propiedades'=>$tipo_item_obj->propiedades, 'opciones'=>$tipo_item_obj->printOpcionesBtns('mapa', $bot));
			
			return $this->arrResp(__('Datos de personaje recuperados'), $data);
		} else {
			return $this->error(__('No se ha encontrado el personaje con el que hablar'));
		}
	}
	
	function getBatallaBot(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/mplayBot');
		
		if (!class_exists('MplayBot')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		$usr_obj = Usuario::getLoged();
			
		if (empty($_GET['id_bot']))
			return $this->error(__('No hay ningún personaje con el que pelear'));
			
		$bot = new MplayBot();
		$bot->setid($_GET['id_bot']);
		
		if ($bot = $bot->BuscarId()){
			$tipo_item_obj = MplayBotTipo::getInstance($bot->tipo, Helpers::toArray(json_decode($bot->propiedades)));
			
			$slots_armas = MplayUsuarioHelper::getSlotsUsr($usr_obj, 'armas', true);
			$slots_ropa = MplayUsuarioHelper::getSlotsUsr($usr_obj, 'ropa', true);
			
			foreach ($slots_armas as $ksa=>$sa){
				if ($sa instanceof MplayItem){
					$model_sa = array("id"=>$sa->id, "nombre"=>SistemaIdioma::Imprimir($sa->nombre), "icono"=>$sa->geticono(48,48), "icono_big"=>$sa->geticono(256,256), "descripcion"=>SistemaIdioma::Imprimir($sa->descripcion));
					$slots_armas[$ksa] = $model_sa;
				}
			}
			
			foreach ($slots_ropa as $ksa=>$sa){
				if ($sa instanceof MplayItem){
					$model_sa = array("id"=>$sa->id, "nombre"=>SistemaIdioma::Imprimir($sa->nombre), "icono"=>$sa->geticono(48,48), "icono_big"=>$sa->geticono(256,256), "descripcion"=>SistemaIdioma::Imprimir($sa->descripcion));
					$slots_ropa[$ksa] = $model_sa;
				}
			}
			
			$user_config = array(
				"tipo"		=>	"player",
				"id"		=>	$usr_obj->id,
				"nombre"	=>	$usr_obj->getnombre_completo(),
				"icono"		=>	MplayUsuarioHelper::getAvatarMap($usr_obj),
				"icono_big"	=>	MplayUsuarioHelper::getAvatarMap($usr_obj),
				"link"		=>	'javascript:;',
				"link_attr"	=>	'',
				"dinero"	=>	MplayUsuarioHelper::getMonedas($usr_obj),
				"puntos"		=>	$usr_obj->puntos,
				"velocidad"	=> 	MplayUsuarioHelper::getVelocidad($usr_obj),
				"vida"		=>	MplayUsuarioHelper::getVida($usr_obj),
				"max_vida"		=>	MplayUsuarioHelper::getMaxVida($usr_obj),
				"rango_vision"	=>	MplayUsuarioHelper::getRangoVision($usr_obj),
				"rango_interaccion"	=>	MplayUsuarioHelper::getRangoInteraccion($usr_obj),
				"ataque"	=>	MplayUsuarioHelper::getAtaque($usr_obj),
				"defensa"	=>	MplayUsuarioHelper::getDefensa($usr_obj),
				"carisma"	=>	MplayUsuarioHelper::getCarisma($usr_obj),
				"especial"	=>	MplayUsuarioHelper::getEspecial($usr_obj),
				"armas"		=>	$slots_armas,
				"ropa"		=>	$slots_ropa,
				"inventario"	=>	array(),
				"objeto"	=>	$usr_obj
				);
				
			$props_bot = Helpers::toArray(json_decode($bot->propiedades));
				
			$bot_config = array(
				"tipo"		=>	"bot",
				"id"		=>	$bot->id,
				"nombre"	=>	SistemaIdioma::Imprimir($bot->nombre),
				"icono"		=>	$bot->getavatar(32, 32),
				"icono_big"	=>	$bot->getavatar(250, 250),
				"link"		=>	'javascript:;',
				"link_attr"	=>	'',
				"dinero"	=>	$props_bot['monedas_vencido'],
				"dinero_huir"	=>	$props_bot['monedas_huye'],
				"velocidad"	=> 	$props_bot['velocidad'],
				"vida"		=>	$props_bot['vida'],
				"max_vida"		=>	$props_bot['vida'],
				"rango_vision"	=>	$props_bot['rango_vision'],
				"rango_interaccion"	=>	$props_bot['rango_interaccion'],
				"ataque"	=>	$props_bot['ataque'],
				"defensa"	=>	$props_bot['defensa'],
				"carisma"	=>	$props_bot['carisma'],
				"especial"	=>	$props_bot['especial'],
				"armas"		=>	$slots_armas_bot,
				"ropa"		=>	$slots_ropa_bot,
				"inventario"	=>	$bot->getitems(false, true),
				"objeto"	=>	$bot
				);
				
				$data = self::generarBatalla($user_config, $bot_config);
			
			return $this->arrResp(__('Batalla finalizada'), $data);
		} else {
			return $this->error(__('No se ha encontrado el personaje con el que pelear'));
		}
	}
	
	private static function generarBatalla($player1, $player2){
		if (!is_array($player1) || !is_array($player2))
			return false;
			
		$turnos = 5;
		$player1_dead = false;
		$player2_dead = false;
		$player1_ataque_total = 0;
		$player2_ataque_total = 0;
		
		$player1_experiencia = 0;
		$player2_experiencia = 0;
		
		$log_batalla = array();
		
		$opts = $GLOBALS['opciones']['ext_mplay']['experiencia'];
		
		for ($i = 1; $i <= $turnos; $i++){
			if (!$player1_dead && !$player2_dead){
				$log_batalla[] = array("tiempo"=>time(), "mensaje"=>"<h5 align='left'>".sprintf(__("Turno #%s"), $i)."</h5>");
				$ataque_player1 = $player1['ataque'] - $player2['defensa'];
				
				if ($ataque_player1 < 0)
					$ataque_player1 = 0;
				
				if ($ataque_player1 > 0){
					$player1_experiencia += $opts['puntos_ataque_acierto'];
					$player2_experiencia += $opts['puntos_defensa_fallo'];
					$log_batalla[] = array("tiempo"=>time(), "mensaje"=>sprintf(__("<b>%s</b> realiza un ataque sobre <b>%s</b> infligiendo <b>%s</b> de daño a PV"), $player1['nombre'], $player2['nombre'], $ataque_player1));
				} else {
					$player1_experiencia += $opts['puntos_ataque_fallo'];
					$player2_experiencia += $opts['puntos_defensa_acierto'];
					$log_batalla[] = array("tiempo"=>time(), "mensaje"=>sprintf(__("<b>%s</b> ha resistido el ataque de <b>%s</b>"), $player2['nombre'], $player1['nombre']));
				}
				$player1_ataque_total += $ataque_player1;
				if ($ataque_player1 >= $player2['vida']){
					$player1_experiencia += $opts['puntos_batalla_victoria'];
					$player2_experiencia += $opts['puntos_batalla_derrota'];
					$log_batalla[] = array("tiempo"=>time(), "mensaje"=>sprintf(__("<b>%s</b> ha matado a <b>%s</b>"), $player1['nombre'], $player2['nombre']));
					$player2['vida'] = 0;
					$player2_dead = true;
					continue;
				}
				$player2['vida'] -= $ataque_player1;
				
				$ataque_player2 = $player2['ataque'] - $player1['defensa'];
				if ($ataque_player2 < 0)
					$ataque_player2 = 0;
				
				if ($ataque_player2 > 0){
					$player1_experiencia += $opts['puntos_defensa_fallo'];
					$player2_experiencia += $opts['puntos_ataque_acierto'];
					$log_batalla[] = array("tiempo"=>time(), "mensaje"=>sprintf(__("<b>%s</b> realiza un ataque sobre <b>%s</b> infligiendo <b>%s</b> de daño a PV"), $player2['nombre'], $player1['nombre'], $ataque_player2));
				} else {
					$player1_experiencia += $opts['puntos_defensa_acierto'];
					$player2_experiencia += $opts['puntos_ataque_fallo'];
					$log_batalla[] = array("tiempo"=>time(), "mensaje"=>sprintf(__("<b>%s</b> ha resistido el ataque de <b>%s</b>"), $player1['nombre'], $player2['nombre']));
				}
				$player2_ataque_total += $ataque_player2;
				if ($ataque_player2 >= $player1['vida']){
					$player1_experiencia += $opts['puntos_batalla_derrota'];
					$player2_experiencia += $opts['puntos_batalla_victoria'];
					$log_batalla[] = array("tiempo"=>time(), "mensaje"=>sprintf(__("<b>%s</b> ha matado a <b>%s</b>"), $player2['nombre'], $player1['nombre']));
					$player1['vida'] = 0;
					$player1_dead = true;
					continue;
				}
				$player1['vida'] -= $ataque_player2;
			}
		}
		
		$player1['ataque_total'] = $player1_ataque_total;
		$player2['ataque_total'] = $player2_ataque_total;
		
		$player1['experiencia_ganada'] = $player1_experiencia;
		$player2['experiencia_ganada'] = $player2_experiencia;
		
		if ($player2_dead == true){
			if ($player1["tipo"] == 'player'){
				MplayUsuarioHelper::setVida($player1['objeto'], $player1["vida"]);
				$player1['objeto']->cambiaCredito($player2['dinero']);
				$player1['objeto']->nuevaActividad(sprintf(__('<b>%s</b> ha derrotado a <b>%s</b> en una batalla.'), $player1['objeto']->getnombre_completo(), $player2['nombre']), 'new', $player1_experiencia, array('player1'=>$player1["id"], 'player2'=>$player2["id"], 'tipo'=>'botbattle', 'resultado'=>'victoria'));
			} elseif ($player1["tipo"] == 'bot'){
				$player1["objeto"]->setVida($player1["vida"]);
			}
			
			if ($player2["tipo"] == 'player'){
				MplayUsuarioHelper::setVida($player2['objeto'], 0);
				if (MplayUsuarioHelper::getMonedas($player2['objeto']) - $player1['dinero'] < 0){
					$dinero = MplayUsuarioHelper::getMonedas($player2['objeto']);
				} else {
					$dinero = $player1['dinero'];
				}
				
				$player2['objeto']->cambiaCredito('-'.$dinero);
				$player2['objeto']->nuevaActividad(sprintf(__('<b>%s</b> ha sido derrotado por <b>%s</b> en una batalla.'), $player2['objeto']->getnombre_completo(), $player1['nombre']), 'new', $player2_experiencia, array('player1'=>$player2["id"], 'player2'=>$player1["id"], 'tipo'=>'botbattle', 'resultado'=>'derrota'));
			} elseif ($player2["tipo"] == 'bot'){
				$player2["objeto"]->setVida(0);
				$player2["objeto"]->setestado('0');
				$player2["objeto"]->Modificar();
			}
			
			$resultado_batalla = array("ganador"=>"player1", "mensaje"=>sprintf(__('%s ha ganado la batalla contra %s.'), $player1['nombre'], $player2['nombre']), "monedas"=>$player2['dinero']);
			
			$data = array("resultado_batalla"=>$resultado_batalla, "player1"=>$player1, "player2"=>$player2, "log"=>$log_batalla);
		} elseif ($player1_dead == true){
			
			if ($player1["tipo"] == 'player'){
				MplayUsuarioHelper::setVida($player1['objeto'], 0);
				if (MplayUsuarioHelper::getMonedas($player1['objeto']) - $player2['dinero'] < 0){
					$dinero = MplayUsuarioHelper::getMonedas($player1['objeto']);
				} else {
					$dinero = $player2['dinero'];
				}
				
				$player1['objeto']->cambiaCredito('-'.$dinero);
				$player1['objeto']->nuevaActividad(sprintf(__('<b>%s</b> ha sido derrotado por <b>%s</b> en una batalla.'), $player1['objeto']->getnombre_completo(), $player2['nombre']), 'new', $player1_experiencia, array('player1'=>$player1["id"], 'player2'=>$player2["id"], 'tipo'=>'botbattle', 'resultado'=>'derrota'));
			} elseif ($player1["tipo"] == 'bot'){
				$player1["objeto"]->setVida(0);
				$player1["objeto"]->setestado('0');
				$player1["objeto"]->Modificar();
			}
			
			if ($player2["tipo"] == 'player'){
				MplayUsuarioHelper::setVida($player2['objeto'], $player2["vida"]);
				$player2['objeto']->cambiaCredito($player1['dinero']);
				$player2['objeto']->nuevaActividad(sprintf(__('<b>%s</b> ha derrotado a <b>%s</b> en una batalla.'), $player2['objeto']->getnombre_completo(), $player1['nombre']), 'new', $player2_experiencia, array('player1'=>$player2["id"], 'player2'=>$player1["id"], 'tipo'=>'botbattle', 'resultado'=>'victoria'));
			} elseif ($player2["tipo"] == 'bot'){
				$player2["objeto"]->setVida($player2["vida"]);
			}
			
			$resultado_batalla = array("ganador"=>"player2", "mensaje"=>sprintf(__('%s ha ganado la batalla contra %s.'), $player2['nombre'], $player1['nombre']), "monedas"=>$player1['dinero']);
			
			$data = array("resultado_batalla"=>$resultado_batalla, "player1"=>$player1, "player2"=>$player2, "log"=>$log_batalla);
		} else {
			if ($player1["tipo"] == 'player'){
				MplayUsuarioHelper::setVida($player1['objeto'], $player1["vida"]);
			} elseif ($player1["tipo"] == 'bot'){
				$player1["objeto"]->setVida($player1["vida"]);
			}
			
			if ($player2["tipo"] == 'player'){
				MplayUsuarioHelper::setVida($player2['objeto'], $player2["vida"]);
			} elseif ($player2["tipo"] == 'bot'){
				$player2["objeto"]->setVida($player2["vida"]);
			}
			
			$resultado_batalla = array("ganador"=>"", "mensaje"=>sprintf(__('%s y %s han empatado en la batalla.'), $player1['nombre'], $player2['nombre']));
			
			$data = array("resultado_batalla"=>$resultado_batalla, "player1"=>$player1, "player2"=>$player2, "log"=>$log_batalla);
		}
		
		return $data;
	}
	
	function getBorrarBot(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/mplayBot');
		
		if (!class_exists('MplayBot')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if (empty($_POST['id_bot'])){
			return $this->error(__('No hay ningún bot que borrar'));
		}
		
		$id_item = $_POST['id_bot'];
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$bot_obj = new MplayBot();
		$bot_obj->setid($id_item);
		if ($bot_obj = $bot_obj->BuscarId()){
			$id_bot = $bot_obj->id;
			
			$items_bot = $bot_obj->getitems();
			if (is_array($items_bot)){
				foreach ($items_bot as $ib){
					$ib->Borrar();
				}
			}
			
			if ($bot_obj->Borrar()){
				$data = array("id_bot"=>$id_bot);
				return $this->arrResp(__('Bot borrado'), $data);
			} else {
				return $this->error(__('No se puede borrar el bot'));
			}
		} else {
			return $this->error(__('No se encuentra el bot'));
		}
	}
	
	function getComenzarJuego(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/juego','ext_mplay/class/helpers/mplayUsuarioHelper');
		
		if (!class_exists('Juego')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if (empty($_POST['id_juego'])){
			return $this->error(__('No hay ningún juego al que jugar'));
		}
		
		$id_item = $_POST['id_juego'];
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$juegos_activos = MPlayUsuarioHelper::getJuegosActivos($usr_obj);
		$juegos_finalizados = MPlayUsuarioHelper::getJuegosFinalizados($usr_obj);
		
		$misiones_activas = MPlayUsuarioHelper::getMisionesActivas($usr_obj);
		$misiones_finalizadas = MPlayUsuarioHelper::getMisionesFinalizadas($usr_obj);
		
		if (in_array($_POST['id_juego'], $juegos_activos))
			return $this->error(__('Ya estás jugando a este juego'));
			
		if (in_array($_POST['id_juego'], $juegos_finalizados))
			return $this->error(__('Ya has jugado a este juego'));
		
		$mua_linea = $mua;
		
		if (empty($mua_linea->latitud) || empty($mua_linea->longitud)){
return $this->error(__('No existen datos de geolocalización'));
}
		
		if ($usr_obj){
			$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
		} else {
			$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
		}
		
		$juego = new Juego();
		$juego->setid($_POST['id_juego']);
		if ($juego = $juego->BuscarId()){
			$hora_inicio = time();
			$juegos_activos[$hora_inicio] = $_POST['id_juego'];
			
			$params_juego = Helpers::toArray(json_decode($juego->params));
			
			$misiones_arr = $juego->getMisiones();
			$misiones_juego = array();
			$mision_activa = false;
			$mision_finalizada = false;
			$count_mis = 0;
			foreach ($misiones_arr as $m){
				$estado_mision = 'pendiente';
				if (in_array($m->id, $misiones_activas)){
					$estado_mision = 'activa';
					foreach ($misiones_activas as $kmact=>$mact){
						if ($mact == $m->id){
							$hora_inicio_mision = $kmact;
							$mision_activa = true;
						}
					}
				} elseif (in_array($m->id, $misiones_finalizadas)){
					$estado_mision = 'finalizada';
					foreach ($misiones_finalizadas as $kmact=>$mact){
						if ($mact == $m->id){
							$hora_inicio_mision = $kmact;
							$mision_activa = false;
							$mision_finalizada = true;
						}
					}
				} elseif ($mision_finalizada){
					$estado_mision = 'activa';
					$mision_activa = true;
					$mision_finalizada = false;
					$hora_inicio_mision = time();
				} else {
					$hora_inicio_mision = false;
				}
				
				$mision_model = array("id_mision"=>$m->id, "nombre_mision"=>SistemaIdioma::Imprimir($m->titulo), "descripcion_mision"=>SistemaIdioma::Imprimir($m->descripcion), "descripcion_corta_mision"=>SistemaIdioma::Imprimir($m->descripcion_corta), "tipo_mision"=>$m->tipo, "icono_mision"=>$m->geticono(48,48), "propiedades_mision"=>(array) json_decode($m->propiedades), "latitud_mision"=>$m->latitud, "longitud_mision"=>$m->longitud, "orden_mision"=>$m->orden, "juego_mision"=>$juego->id, "timestamp_inicio_mision"=>$hora_inicio_mision, "estado_mision"=>$estado_mision);
				$misiones_juego[] = $mision_model;
				if ($count_mis == 0){
					$mision_model['timestamp_inicio_mision'] = time();
					$primera_mision = $mision_model;
					$mision_activa_obj_primera = $m;
				}
				if ($mision_activa === true){
					$mision_model['timestamp_inicio_mision'] = $hora_inicio;
					$mision_activa_model = $mision_model;
					$mision_activa_obj = $m;
					$mision_activa = false;
				}
				$count_mis ++;
			}
						
			if (is_array($mision_activa_model) && sizeof($mision_activa_model) > 0 && !in_array($mision_activa_model['id_mision'], $misiones_activas)){
				$misiones_activas[$mision_activa_model['timestamp_inicio_mision']] = $mision_activa_model['id_mision'];
			} else {
				$mision_activa_obj = $mision_activa_obj_primera;
				$misiones_activas[$primera_mision['timestamp_inicio_mision']] = $primera_mision['id_mision'];
				$mision_activa_model = $primera_mision;
			}
			
			if (!MPlayUsuarioHelper::addJuegoActivo($usr_obj, $juego, $mision_activa_obj)){
				return $this->error(__('No se puede activar el juego'));
			}
			
			$data = array("id_juego"=>$juego->id, "nombre_juego"=>$juego->titulo_formateado, "descripcion_juego"=>$juego->contenido_formateado, "instrucciones_juego"=>SistemaIdioma::Imprimir($juego->texto_corto), "icono_juego"=>$juego->getimagen_destacada(48,48), "tipo_juego"=>$juego->tipo, "propiedades_juego"=>$params_juego['propiedades'], "misiones_juego"=>$misiones_juego, "mision_activa"=>$mision_activa_model, "timestamp_inicio_juego"=>$hora_inicio);
			
			return $this->arrResp(__('Juego iniciado.'), $data);
		} else {
			return $this->error(__('No existe el juego'));
		}
	}
	
	function getTodosLosJuegos(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/juego','ext_mplay/class/helpers/mplayUsuarioHelper');
		
		if (!class_exists('Juego')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$juegos_activos = MPlayUsuarioHelper::getJuegosActivos($usr_obj);
		$juegos_finalizados = MPlayUsuarioHelper::getJuegosFinalizados($usr_obj);
		
		$misiones_activas = MPlayUsuarioHelper::getMisionesActivas($usr_obj);
		$misiones_finalizadas = MPlayUsuarioHelper::getMisionesFinalizadas($usr_obj);
		
		$data = array();
		
		foreach ($juegos_activos as $juego_id){
			$juego = new Juego();
			$juego->setid($juego_id);
			
			if ($juego = $juego->BuscarId()){
			} else {
				return $this->error(__('Se ha producido un error irrecuperable al intentar cargar un juego'));
			}
						
			$params_juego = Helpers::toArray(json_decode($juego->params));
			
			$misiones_arr = $juego->getMisiones();
			$misiones_juego = array();
			$mision_activa = false;
			$mision_finalizada = false;
			$count_mis = 0;
			foreach ($misiones_arr as $m){
				$estado_mision = 'pendiente';
				if (in_array($m->id, $misiones_activas)){
					$estado_mision = 'activa';
					foreach ($misiones_activas as $kmact=>$mact){
						if ($mact == $m->id){
							$hora_inicio_mision = $kmact;
							$mision_activa = true;
						}
					}
				} elseif (in_array($m->id, $misiones_finalizadas)){
					$estado_mision = 'finalizada';
					foreach ($misiones_finalizadas as $kmact=>$mact){
						if ($mact == $m->id){
							$hora_inicio_mision = $kmact;
							$mision_activa = false;
							$mision_finalizada = true;
						}
					}
				} elseif ($mision_finalizada){
					$estado_mision = 'activa';
					$mision_activa = true;
					$mision_finalizada = false;
					$hora_inicio_mision = time();
				} else {
					$hora_inicio_mision = false;
				}
				
				$mision_model = array("id_mision"=>$m->id, "nombre_mision"=>SistemaIdioma::Imprimir($m->titulo), "descripcion_mision"=>SistemaIdioma::Imprimir($m->descripcion), "descripcion_corta_mision"=>SistemaIdioma::Imprimir($m->descripcion_corta), "tipo_mision"=>$m->tipo, "icono_mision"=>$m->geticono(48,48), "propiedades_mision"=>(array) json_decode($m->propiedades), "latitud_mision"=>$m->latitud, "longitud_mision"=>$m->longitud, "orden_mision"=>$m->orden, "juego_mision"=>$juego->id, "timestamp_inicio_mision"=>$hora_inicio_mision, "estado_mision"=>$estado_mision);
				$misiones_juego[] = $mision_model;
				if ($count_mis == 0){
					$mision_model['timestamp_inicio_mision'] = time();
					$primera_mision = $mision_model;
					$mision_activa_obj_primera = $m;
				}
				if ($mision_activa === true){
					$mision_model['timestamp_inicio_mision'] = $hora_inicio;
					$mision_activa_model = $mision_model;
					$mision_activa_obj = $m;
					$mision_activa = false;
				}
				$count_mis ++;
			}
						
			if (is_array($mision_activa_model) && sizeof($mision_activa_model) > 0 && !in_array($mision_activa_model['id_mision'], $misiones_activas)){
				$misiones_activas[$mision_activa_model['timestamp_inicio_mision']] = $mision_activa_model['id_mision'];
			} else {
				$mision_activa_obj = $mision_activa_obj_primera;
				$misiones_activas[$primera_mision['timestamp_inicio_mision']] = $primera_mision['id_mision'];
				$mision_activa_model = $primera_mision;
			}
			
			$data[] = array("id_juego"=>$juego->id, "nombre_juego"=>$juego->titulo_formateado, "descripcion_juego"=>$juego->contenido_formateado, "instrucciones_juego"=>SistemaIdioma::Imprimir($juego->texto_corto), "icono_juego"=>$juego->getimagen_destacada(48,48), "tipo_juego"=>$juego->tipo, "estado_juego"=>"activo", "propiedades_juego"=>$params_juego['propiedades'], "misiones_juego"=>$misiones_juego, "mision_activa"=>$mision_activa_model, "timestamp_inicio_juego"=>$hora_inicio);
		}
		
		foreach ($juegos_finalizados as $juego_id){
			$juego = new Juego();
			$juego->setid($juego_id);
			
			if ($juego = $juego->BuscarId()){
			} else {
				return $this->error(__('Se ha producido un error irrecuperable al intentar cargar un juego'));
			}
						
			$params_juego = Helpers::toArray(json_decode($juego->params));
			
			$misiones_arr = $juego->getMisiones();

			$misiones_juego = array();
			$mision_activa = false;
			$mision_finalizada = false;
			$count_mis = 0;
			foreach ($misiones_arr as $m){
				$estado_mision = 'pendiente';
				if (in_array($m->id, $misiones_activas)){
					$estado_mision = 'activa';
					foreach ($misiones_activas as $kmact=>$mact){
						if ($mact == $m->id){
							$hora_inicio_mision = $kmact;
							$mision_activa = true;
						}
					}
				} elseif (in_array($m->id, $misiones_finalizadas)){
					$estado_mision = 'finalizada';
					foreach ($misiones_finalizadas as $kmact=>$mact){
						if ($mact == $m->id){
							$hora_inicio_mision = $kmact;
							$mision_activa = false;
							$mision_finalizada = true;
						}
					}
				} elseif ($mision_finalizada){
					$estado_mision = 'activa';
					$mision_activa = true;
					$mision_finalizada = false;
					$hora_inicio_mision = time();
				} else {
					$hora_inicio_mision = false;
				}
				
				$mision_model = array("id_mision"=>$m->id, "nombre_mision"=>SistemaIdioma::Imprimir($m->titulo), "descripcion_mision"=>SistemaIdioma::Imprimir($m->descripcion), "descripcion_corta_mision"=>SistemaIdioma::Imprimir($m->descripcion_corta), "tipo_mision"=>$m->tipo, "icono_mision"=>$m->geticono(48,48), "propiedades_mision"=>(array) json_decode($m->propiedades), "latitud_mision"=>$m->latitud, "longitud_mision"=>$m->longitud, "orden_mision"=>$m->orden, "juego_mision"=>$juego->id, "timestamp_inicio_mision"=>$hora_inicio_mision, "estado_mision"=>$estado_mision);
				$misiones_juego[] = $mision_model;
				if ($count_mis == 0){
					$mision_model['timestamp_inicio_mision'] = time();
					$primera_mision = $mision_model;
					$mision_activa_obj_primera = $m;
				}
				if ($mision_activa === true){
					$mision_model['timestamp_inicio_mision'] = $hora_inicio;
					$mision_activa_model = $mision_model;
					$mision_activa_obj = $m;
					$mision_activa = false;
				}
				$count_mis ++;
			}
			
			$data[] = array("id_juego"=>$juego->id, "nombre_juego"=>$juego->titulo_formateado, "descripcion_juego"=>$juego->contenido_formateado, "instrucciones_juego"=>SistemaIdioma::Imprimir($juego->texto_corto), "icono_juego"=>$juego->getimagen_destacada(48,48), "tipo_juego"=>$juego->tipo, "estado_juego"=>"finalizado", "propiedades_juego"=>$params_juego['propiedades'], "misiones_juego"=>$misiones_juego, "timestamp_inicio_juego"=>$hora_inicio);
		}
		
		return $this->arrResp(__('Juegos recuperados con éxito'), array('juegos'=>$data));
		
	}
	
	function getCancelarJuego(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/juego');
		
		if (!class_exists('Juego')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if (empty($_POST['id_juego'])){
			return $this->error(__('No hay ningún juego que cancelar'));
		}
		
		$id_item = $_POST['id_juego'];
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$juegos_activos = MPlayUsuarioHelper::getJuegosActivos($usr_obj);
		$juegos_finalizados = MPlayUsuarioHelper::getJuegosFinalizados($usr_obj);
		
		if (!in_array($_POST['id_juego'], $juegos_activos))
			return $this->error(__('No estás jugando a este juego'));
			
		if (in_array($_POST['id_juego'], $juegos_finalizados))
			return $this->error(__('Los juegos finalizados no se pueden cancelar'));
		
		$mua_linea = $mua;
		
		if (empty($mua_linea->latitud) || empty($mua_linea->longitud)){
return $this->error(__('No existen datos de geolocalización'));
}
		
		if ($usr_obj){
			$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
		} else {
			$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
		}
		
		$juego = new Juego();
		$juego->setid($_POST['id_juego']);
		if ($juego = $juego->BuscarId()){
			if (!MplayUsuarioHelper::removeJuegoActivo($usr_obj, $juego)){
				return $this->error(__('No se puede cancelar el juego'));
			}
			
			$params_juego = Helpers::toArray(json_decode($juego->params));
			
			$data = array("id_juego"=>$juego->id, "nombre_juego"=>$juego->titulo_formateado, "descripcion_juego"=>$juego->contenido_formateado, "instrucciones_juego"=>SistemaIdioma::Imprimir($juego->texto_corto), "icono_juego"=>$juego->getimagen_destacada(48,48), "tipo_juego"=>$juego->tipo, "propiedades_juego"=>$params_juego['propiedades'], "juego_mision"=>$juego->id, "timestamp_inicio_juego"=>$hora_inicio);
			
			return $this->arrResp(__('Juego cancelado.'), $data);
		} else {
			return $this->error(__('No existe el juego'));
		}
	}
	
	function getComenzarMision(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/juego','ext_mplay/class/misionJuegoMplay','ext_mplay/class/mplayMisionTipo');
		
		if (!class_exists('Juego') || !class_exists('MisionJuegoMplay')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if (empty($_POST['datos']['id_mision'])){
			return $this->error(__('No hay ninguna misión que comenzar'));
		}
		
		$id_item = $_POST['datos']['id_mision'];
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$misiones_activas = (array) json_decode($mua->misiones_activas);
		$misiones_finalizadas = (array) json_decode($mua->misiones_finalizadas);
			
		if (in_array($_POST['datos']['id_mision'], $misiones_finalizadas))
			return $this->error(__('Ya has jugado esta misión'));
		
		$mua_linea = $mua;
		
		if (empty($mua_linea->latitud) || empty($mua_linea->longitud)){
return $this->error(__('No existen datos de geolocalización'));
}
		
		if ($usr_obj){
			$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
		} else {
			$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
		}
		
		$mision = new MisionJuegoMplay();
		$mision->setid($_POST['datos']['id_mision']);
		if ($mision = $mision->BuscarId()){
			$propiedades_mision = Helpers::toArray(json_decode($mision->propiedades));
			$tipo_mision = MplayMisionTipo::getInstance($mision->tipo, $propiedades_mision);
			
			$datos_procesados = $tipo_mision->process_start_mission($_POST['datos']);
			
			return $this->arrResp(__('Misión iniciada.'), $datos_procesados);
		} else {
			return $this->error(__('No existe la misión'));
		}
	}
	
	function getMisionCompletada(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/juego','ext_mplay/class/misionJuegoMplay');
		
		if (!class_exists('MisionJuegoMplay')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if (empty($_POST['id_mision'])){
			return $this->error(__('No hay ninguna misión que completar'));
		}
		
		$id_item = $_POST['id_mision'];
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$juegos_activos = MPlayUsuarioHelper::getJuegosActivos($usr_obj);
		$juegos_finalizados = MPlayUsuarioHelper::getJuegosFinalizados($usr_obj);
		
		$misiones_activas = MPlayUsuarioHelper::getMisionesActivas($usr_obj);
		$misiones_finalizadas = MPlayUsuarioHelper::getMisionesFinalizadas($usr_obj);
		
		if (!in_array($_POST['id_mision'], $misiones_activas))
			return $this->error(__('No estás jugando esta misión').' '.$_POST['id_mision']);
			
		if (in_array($_POST['id_mision'], $misiones_finalizadas))
			return $this->error(__('Las misiones finalizados no se pueden volver a completar'));
		
		$mua_linea = $mua;
		
		if (empty($mua_linea->latitud) || empty($mua_linea->longitud)){
return $this->error(__('No existen datos de geolocalización'));
}
		
		if ($usr_obj){
			$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
		} else {
			$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
		}
		
		$mision = new MisionJuegoMplay();
		$mision->setid($_POST['id_mision']);
		if ($mision = $mision->BuscarId()){
			if ($mision->completar()){
				MplayUsuarioHelper::completarMisionActiva($usr_obj, $mision);
				
				$data = array("id_mision"=>$mision->id, "id_juego"=>$mision->juego);
				
				return $this->arrResp(__('Misión completada'), $data);
			} else {
				return $this->error(__('No se ha podido completar la misión'));
			}
		} else {
			return $this->error(__('No existe la misión'));
		}
	}
	
	function getJuegoCompletado(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/juego','ext_mplay/class/misionJuegoMplay');
		
		if (!class_exists('Juego')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		if (empty($_POST['id_juego'])){
			return $this->error(__('No hay ningún juego que completar'));
		}
		
		$id_item = $_POST['id_juego'];
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$juegos_activos = MPlayUsuarioHelper::getJuegosActivos($usr_obj);
		$juegos_finalizados = MPlayUsuarioHelper::getJuegosFinalizados($usr_obj);
		
		$misiones_activas = MPlayUsuarioHelper::getMisionesActivas($usr_obj);
		$misiones_finalizadas = MPlayUsuarioHelper::getMisionesFinalizadas($usr_obj);
		
		if (!in_array($_POST['id_juego'], $juegos_activos))
			return $this->error(__('No estás jugando a este juego'));
			
		if (in_array($_POST['id_juego'], $juegos_finalizados))
			return $this->error(__('Los juegos finalizados no se pueden volver a completar'));
		
		$mua_linea = $mua;
		
		if (empty($mua_linea->latitud) || empty($mua_linea->longitud)){
return $this->error(__('No existen datos de geolocalización'));
}
		
		if ($usr_obj){
			$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
		} else {
			$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
		}
		
		$juego = new Juego();
		$juego->setid($_POST['id_juego']);
		if ($juego = $juego->BuscarId()){
			if ($juego->completar()){
				MplayUsuarioHelper::completarJuegoActivo($usr_obj, $juego);
				
				$hora_inicio = time();
				
				$params_juego = Helpers::toArray(json_decode($juego->params));
				
				
				$misiones_arr = $juego->getMisiones();
				$misiones_juego = array();
				$mision_activa = false;
				$mision_finalizada = false;
				$count_mis = 0;
				foreach ($misiones_arr as $m){
					$estado_mision = 'finalizada';
					$mision_activa = false;
					$mision_finalizada = true;
					
					$mision_model = array("id_mision"=>$m->id, "nombre_mision"=>SistemaIdioma::Imprimir($m->titulo), "descripcion_mision"=>SistemaIdioma::Imprimir($m->descripcion), "descripcion_corta_mision"=>SistemaIdioma::Imprimir($m->descripcion_corta), "tipo_mision"=>$m->tipo, "icono_mision"=>$m->geticono(48,48), "propiedades_mision"=>(array) json_decode($m->propiedades), "latitud_mision"=>$m->latitud, "longitud_mision"=>$m->longitud, "orden_mision"=>$m->orden, "juego_mision"=>$juego->id, "timestamp_inicio_mision"=>$hora_inicio_mision, "estado_mision"=>$estado_mision);
					$misiones_juego[] = $mision_model;
					$count_mis ++;
				}
				
				
				$data = array("id"=>$juego->id, "nombre"=>$juego->titulo_formateado, "descripcion"=>$juego->contenido_formateado, "instrucciones"=>SistemaIdioma::Imprimir($juego->texto_corto), "icono"=>$juego->getimagen_destacada(48,48), "tipo"=>$juego->tipo, "propiedades"=>$params_juego['propiedades'], "timestamp_fin"=>$hora_inicio, "misiones"=>$misiones_juego, "mision_activa"=>false, "recompensas"=>$juego->printRecompensas('col-xs-4'));
								
				return $this->arrResp(sprintf(__('Has completado el juego %s'), SistemaIdioma::Imprimir($juego->titulo)), $data);
			} else {
				return $this->error(__('No se ha podido completar el juego'));
			}
		} else {
			return $this->error(__('No existe el juego'));
		}
	}
	
	function getActualizarJuegosActivos(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/juego','ext_mplay/class/mplayJuegosUsuarios');
		
		if (!class_exists('Juego')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		$ids = $_POST['ids'];
		if (empty($ids)){
			$ids = array();
		}
		$ids_misiones = $_POST['ids_misiones'];
		if (empty($ids_misiones)){
			$ids_misiones = array();
		}
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$mua_linea = $mua;
		
		if (empty($mua_linea->latitud) || empty($mua_linea->longitud)){
return $this->error(__('No existen datos de geolocalización'));
}
		
		if ($usr_obj){
			$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
		} else {
			$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
		}
		
		$juegos_activos_objs = array();
		foreach ($ids as $id_juego_activo){
			$mju = new MplayJuegosUsuarios();
			$mju_c = $mju->ListarCount("id_juego='".$id_juego_activo."' AND id_usuario='".$usr_id."'");
			if ($mju_c == 0){
				$mju->setid_juego($id_juego_activo);
				$mju->setid_usuario($usr_id);
				$mju->setfecha(strftime("%Y-%m-%d %H:%M:%S"));
				$mju->setestado(1);
				
				if ($id_new_mju = $mju->Guardar()){
					$mju->id = $id_new_mju;
					$juegos_activos_objs[$mju->id_juego] = $mju;
				}
			} else {
				$mju = $mju->Listar("id_juego='".$id_juego_activo."' AND id_usuario='".$usr_id."'");
				$mju = $mju[0];
				
				//$mju->setestado(1);
				if ($mju->Modificar()){
					$juegos_activos_objs[$mju->id_juego] = $mju;
				}
			}
		}
		
		foreach ($ids_misiones as $id_mision_activa){
			$mision_obj = new MisionJuegoMplay();
			$mision_obj->setid($id_mision_activa);
			if ($mision_obj = $mision_obj->BuscarId()){
				if (array_key_exists($mision_obj->juego, $juegos_activos_objs)){
					$mju_activo = $juegos_activos_objs[$mision_obj->juego];
					if ($mju_activo->mision_activa != $id_mision_activa){
						$misiones_finalizadas = (array) json_decode($mju_activo->misiones_finalizadas);
						if (!empty($mju_activo->mision_activa)){
							$misiones_finalizadas[time()] = $mju_activo->mision_activa;
							$mju_activo->setmisiones_finalizadas(json_encode($misiones_finalizadas));
						}
						$mju_activo->setmision_activa($id_mision_activa);
						$mju_activo->setfecha(strftime("%Y-%m-%d %H:%M:%S"));
						$mju_activo->Modificar();

						$juegos_activos_objs[$mision_obj->juego] = $mju_activo;
					}
				}
			}
		}
		
		
		
		return $this->arrResp(__('Juegos activos actualizados'), array());
	}
	
	function getActualizarJuegosCompletados(){
		if ($this->get('elemento') != 'usuario'){
			return $this->error(__('Acceso incorrecto'));
		}
		
		e_include('ext_mplay/class/juego','ext_mplay/class/mplayJuegosUsuarios');
		
		if (!class_exists('Juego')){
			return $this->error(__('No existe la clase de la extensión'));
		}
		
		$ids = $_POST['ids'];
		if (empty($ids)){
			$ids = array();
		}
		
		$usr_id = Usuario::isLoged() ? Usuario::getLogedId() : 0;
		$usr_obj = Usuario::isLoged() ? Usuario::getLoged() : false;
		
		if ($usr_id == 0)
			return $this->error(__('No estás identificado'));
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return $this->error(__('¡No estás conectado al juego!'));
		}
		
		$mua = MplayUsuariosActivos::getUsrConectado($usr_obj);
		
		$mua_linea = $mua;
		
		if (empty($mua_linea->latitud) || empty($mua_linea->longitud)){
return $this->error(__('No existen datos de geolocalización'));
}
		
		if ($usr_obj){
			$radio_interaccion = (float) MplayUsuarioHelper::getRangoInteraccion($usr_obj); // en kilometros
		} else {
			$radio_interaccion = (float) $GLOBALS['opciones']['ext_mplay']['usuario']['rango_interaccion'];
		}
		
		$juegos_completados_objs = array();
		foreach ($ids as $id_juego_activo){
			$mju = new MplayJuegosUsuarios();
			$mju_c = $mju->ListarCount("id_juego='".$id_juego_activo."' AND id_usuario='".$usr_id."'");
			if ($mju_c == 0){
				$mju->setid_juego($id_juego_activo);
				$mju->setid_usuario($usr_id);
				$mju->setfecha(strftime("%Y-%m-%d %H:%M:%S"));
				$mju->setestado(1);
				
				if ($id_new_mju = $mju->Guardar()){
					$mju->id = $id_new_mju;
					$juegos_completados_objs[$mju->id_juego] = $mju;
				}
			} else {
				$mju = $mju->Listar("id_juego='".$id_juego_activo."' AND id_usuario='".$usr_id."'");
				$mju = $mju[0];
				
				//$mju->setestado(1);
				if ($mju->Modificar()){
					$juegos_completados_objs[$mju->id_juego] = $mju;
				}
			}
		}
		
		return $this->arrResp(__('Juegos activos actualizados'), array());
	}
	
	function getMain(){
		if (!Usuario::isLoged(true)){
			return $this->error(__('Acceso no permitido'));
		}
		
		$usr_logged = Usuario::getLoged(true);
		
		if ($usr_logged->es_admin != '1'){
			return $this->error(__('Acceso no permitido. Administrador requerido.'));
		}
		
		if (!is_array($_POST['bounds']['ne']) || !is_array($_POST['bounds']['sw'])){
			return $this->error(__('Coordenadas no facilitadas.'));
		}
		
		if (!is_array($_POST['center'])){
			return $this->error(__('Punto central no facilitado.'));
		}
		
		$usuarios_features = $this->AdminMapaUsuarios($_POST['bounds'], $_POST['center']);
		$items_features = $this->AdminMapaItems($_POST['bounds'], $_POST['center']);
		
		$features = array();
		
		if (is_array($usuarios_features)){
			$features = array_merge($features, $usuarios_features);
		}
		
		if (is_array($items_features)){
			$features = array_merge($features, $items_features);
		}
		
		$array_final = array('type'=>'FeatureCollection', 'features'=>$features);
		
		$json_string = json_encode($array_final);
		
		header('Content-type: application/json');
		header("Access-Control-Allow-Origin: *");
		header("Access-Control-Allow-Methods: GET, POST, OPTIONS");
		header('Access-Control-Allow-Credentials: true');
		if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {
	
			if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
				header("Access-Control-Allow-Methods: GET, POST, OPTIONS");         
	
			if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
				header("Access-Control-Allow-Headers: {$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");
	
		}
		echo $json_string;
		exit;
	}
	
	private function AdminMapaUsuarios($bounds = array(), $center = array()){
		if (!is_array($bounds['ne']) || !is_array($bounds['sw']) || !is_array($center)){
			return false;
		}
		
		e_include('ext_mplay/class/mplayUsuariosActivos');
		
		if (!class_exists('MplayUsuariosActivos')){
			return false;
		}
		
		$mua = new MplayUsuariosActivos();
		
		$arr_where[] = 'id_usuario <> 0 AND MBRContains(
        GeomFromText( "LINESTRING('.Helpers::mres($bounds['ne'][0]).' '.Helpers::mres($bounds['ne'][1]).','.Helpers::mres($bounds['sw'][0]).' '.Helpers::mres($bounds['sw'][1]).')" ),
        location) GROUP BY id_usuario';
		
		$items_c = $mua->ListarCountPorLocalizacion($center[0], $center[1], 20000, 0, 0, $arr_where);
		
		if ($items_c > 0){
			$mua = $mua->ListarPorLocalizacion($center[0], $center[1], 20000, 0, 0, $arr_where);
			
			$array_json = array();
			
			foreach ($mua as $ml){
				$popup_content = "<div class='mplay-popup-content'><h4 class='mplay-popup-title'>".$ml->usuario_obj->getnombre_completo()."<br><small>".$ml->get_distancia(true)."</small></h4><div class='mplay-popup-options'><div class='row'><div class='col-xs-6'><a href='javascript:;' class='mplay-popup-optbtn btn btn-primary btn-block'>".__('Hablar')."</a></div></div></div></div>";
			
				$tmp_array = array('type'=>'Feature', 'geometry'=>array('type'=>'Point', 'coordinates'=>array((float) $ml->latitud, (float) $ml->longitud)), 'properties'=>array('nombre'=>$ml->usuario_obj->getnombre_completo(), 'imagen'=>$ml->usuario_obj->getimagen_destacada(32, 32), 'distancia'=>$ml->get_distancia(true), 'content'=>$popup_content), 'id'=>$ml->id_usuario.'_'.Helpers::parseaTexto($ml->ip_usuario, false, '_'));
				
				$array_json[] = $tmp_array;
			}
			
			return $array_json;
		} else {
			return false;
		}
	}
	
	private function AdminMapaItems($bounds = array(), $center = array()){
		if (!is_array($bounds['ne']) || !is_array($bounds['sw']) || !is_array($center)){
			return false;
		}
		
		e_include('ext_mplay/class/mplayItem', 'ext_mplay/class/mplayItemTipo');
		
		if (!class_exists('MplayItem')){
			return false;
		}
		
		$mua = new MplayItem();
		
		$arr_where[] = 'propietario = "0" AND MBRContains(
        GeomFromText( "LINESTRING('.Helpers::mres($bounds['ne'][0]).' '.Helpers::mres($bounds['ne'][1]).','.Helpers::mres($bounds['sw'][0]).' '.Helpers::mres($bounds['sw'][1]).')" ),
        location)';
		
		$items_c = $mua->ListarCountPorLocalizacion($center[0], $center[1], 20000, 0, 0, $arr_where);
		
		if ($items_c > 0){
			$mua = $mua->ListarPorLocalizacion($center[0], $center[1], 20000, 0, 0, $arr_where);
			
			$array_json = array();
			
			foreach ($mua as $ml){
				$tipo_item_obj = MplayItemTipo::getInstance($ml->tipo, Helpers::toArray(json_decode($ml->propiedades)));
				
				$popup_content = "<div class='mplay-popup-content'><h4 class='mplay-popup-title'>".SistemaIdioma::Imprimir($ml->nombre)."<br><small>".$ml->get_distancia(true)."</small></h4><div class='mplay-popup-description'>".SistemaIdioma::Imprimir($ml->descripcion)."</div><p>".$tipo_item_obj->printPropiedadesHtml(' class="col-xs-12"')."</p><div class='mplay-popup-options'><div class='row'>".$tipo_item_obj->printOpcionesBtns('mapa', $ml)."</div></div></div>";
			
				$tmp_array = array('type'=>'Feature', 'geometry'=>array('type'=>'Point', 'coordinates'=>array((float) $ml->latitud, (float) $ml->longitud)), 'properties'=>array('nombre'=>SistemaIdioma::Imprimir($ml->nombre), 'imagen'=>$ml->geticono(32, 32), 'distancia'=>$ml->get_distancia(true), 'content'=>$popup_content, 'tipo'=>'item', 'propiedades_html'=>$tipo_item_obj->printPropiedadesHtml(' class="col-xs-12"'), 'propiedades'=>$tipo_item_obj->propiedades), 'id'=>'item_'.$ml->id);
					
				$array_json[] = $tmp_array;
			}
			
			return $array_json;
		} else {
			return false;
		}
	}
}