<?php
/**
 * @package     Mideas.mPlay
 * @subpackage  Item
 *
 * @copyright   Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE
 */

defined('CONF_URL_APP') or die;

class MplayHabilidadTipoSitio extends MplayHabilidadTipo
{
	protected $name = 'Sitio';
	protected $description = 'Mejora de sitios';
	
	protected $acciones = array('construir','construida');
	
	public function __construct($options = array())
	{
		$this->propiedades = array(
									"items"		=>	array(
															"nombre"	=>	__("Items"), 
															"tipo"		=>	"string", 
															"input"		=>	"mplayitemslist", 
															"icono"		=>	"IT", 
															"descripcion" =>	__("Items que consigue el jugador cuando construye la mejora"), 
															"params"	=>	array("multiple"=>"true", "models_only"=>"true"),
															"visible"	=>	false
													),
									"monedas"		=>	array(
															"nombre"	=>	__("Monedas"), 
															"tipo"		=>	"int", 
															"input"		=>	"number", 
															"icono"		=>	"MO", 
															"descripcion" =>	__("Monedas de Oro (MO) que consigue el jugador cuando construye la mejora"), 
															"params"	=>	array("class"=>"form-control"),
													),
									"juego"		=>	array(
															"nombre"	=>	__("Juego"), 
															"tipo"		=>	"string", 
															"input"		=>	"itemslist", 
															"icono"		=>	"TU", 
															"descripcion" =>	__("Juego que se activa cuando se construye esta mejora"), 
															"params"	=>	array("forzar_extension"=>"ext_mplay.1"),
															"visible"	=>	false
													),
									"casillas"	=>	array(
															"nombre"	=>	__("Casillas"), 
															"tipo"		=>	"int",
															"input"		=>	"number",
															"icono"		=>	"CA",
															"descripcion"	=>	__("Casillas extra de tu almacén que otorga la mejora"),
															"params"	=>	array("class"=>"form-control")
													)
		);
		
		parent::__construct($options);
	}
}