<?php
c_include('usuario');
e_include('ext_mplay/class/mplayHabilidadUsuario','ext_mplay/class/mplayHabilidadesSitios','ext_mplay/class/mplayHabilidadTipo','ext_mplay/class/helpers/mplayUsuarioHelper','ext_sitios/class/sitio','ext_mplay/class/mplaySitioTipo');

class MplaySitioHelper
{
	public static function getTypes(){		
		$dir = dirname(__FILE__) . '/../sitios';
		$handlers = Helpers::dir_list($dir,'','.php',false);
		$handlers = $handlers[dirname(__FILE__) . '/../sitios'];
		
		$names = array();
		foreach ($handlers as $handler)
		{
			$name = substr($handler, 0, strrpos($handler, '.'));
			$class = 'MplaySitioTipo' . $name;

			if (!class_exists($class))
			{
				include_once dirname(__FILE__) . '/../sitios/' . $name . '.php';
			}

			if (call_user_func_array(array(trim($class), 'test'), array()))
			{
				$names[] = $name;
			}
		}

		return $names;
	}
	
	public static function getCasillasSitio($sitio){
		if (!$sitio instanceof Sitio || $GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['activo'] != '1')
			return false;
			
		$casillas = $GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['opciones']['max_items_casa'];
		
		$inc = self::getMejorasInc($sitio, 'casillas');
		
		$casillas += $inc;
		
		return $casillas;
	}
	
	public static function getMejorasInc($sitio, $prop){
		if (!$sitio instanceof Sitio || empty($prop))
			return false;
		
		$habilidades_sitio = self::getHabilidadesSitioArray($sitio);
		
		$inc = 0;
		if (is_array($habilidades_sitio) && sizeof($habilidades_sitio) > 0){
			foreach ($habilidades_sitio as $hu){
				$props_hu = $hu["propiedades"];
				if (!empty($props_hu[$prop])){
					$inc += $props_hu[$prop];
				}
			}
		}
		
		return $inc;
	}
	
	public static function addHabilidadSitio($sitio, $habilidad){
		if (!$sitio instanceof Sitio || !$habilidad instanceof MplayHabilidadUsuario)
			return false;
			
		$habilidades_sitio = self::getHabilidadesSitio($sitio);
		
		if (in_array($habilidad->id, $habilidades_sitio))
			return false;
		
		$mju = new MplayHabilidadesSitios();
		$mju->setid_sitio($sitio->id);
		$mju->setid_habilidad($habilidad->id);
		$mju->setfecha(strftime("%Y-%m-%d %H:%M:%S"));
		if ($id_new_mju = $mju->Guardar()){
			return true;
		} else {
			return false;
		}
	}
	public static function removeHabilidadSitio($sitio, $habilidad){
		if (!$sitio instanceof Sitio || !$habilidad instanceof MplayHabilidadUsuario)
			return false;
			
		$habilidades_sitio = self::getHabilidadesSitio($sitio);
		
		if (!in_array($habilidad->id, $habilidades_sitio))
			return false;
					
		$mju = new MplayHabilidadesSitios();
		$mju_c = $mju->ListarCount("id_sitio='".$sitio->id."' AND id_habilidad='".$habilidad->id."'");
		
		if ($mju_c == 0)
			return false;
			
		$mju = $mju->Listar("id_sitio='".$sitio->id."' AND id_habilidad='".$habilidad->id."'");
		$mju = $mju[0];
		
		if ($mju->Borrar()){
			return true;
		} else {
			return false;
		}
	}
	public static function getHabilidadesSitio($sitio, $solo_conseguidas=true){
		if (!$sitio instanceof Sitio)
			return false;
			
		if ($solo_conseguidas == true){
			$habilidades_sitio = new MplayHabilidadesSitios();
			$habilidades_sitio_c = $habilidades_sitio->ListarCount("id_sitio='".$sitio->id."'");
			
			if ($habilidades_sitio_c > 0){
				
				$habilidades_sitio = $habilidades_sitio->Listar("id_sitio='".$sitio->id."'", "fecha", "DESC");
				$habilidades_ids = array();
				foreach ($habilidades_sitio as $ja){
					$habilidades_ids[] = $ja->id_habilidad;
				}
							
				return $habilidades_ids;
			} else {
				return array();
			}
		} else {			
			$where_habs = 'tipo="sitio" AND estado="1"';
			
			$habilidades_usr = new MplayHabilidadUsuario();
			$habilidades_usr_c = $habilidades_usr->ListarCount($where_habs);
			
			if ($habilidades_usr_c > 0){
				$habilidades_usr = $habilidades_usr->Listar($where_habs);
				$habilidades_ids = array();
				foreach ($habilidades_usr as $ja){
					$habilidades_ids[] = $ja->id;
				}
				return $habilidades_ids;
			} else {
				return array();
			}
		}
	}
	public static function getHabilidadesSitioArray($sitio, $solo_conseguidas=true){
		if (!$sitio instanceof Sitio)
			return false;
			
		$usr_sitio = $sitio->getpropietario(true, true);
		if (!$usr_sitio instanceof Usuario)
			return false;
			
		$habilidades_ids = self::getHabilidadesSitio($sitio, $solo_conseguidas);
		
		if (is_array($habilidades_ids) && sizeof($habilidades_ids) > 0){
			$tmp_arr = array();
			foreach ($habilidades_ids as $hid){
				$hobj = new MplayHabilidadUsuario();
				$hobj->setid($hid);
				if ($hobj = $hobj->BuscarId()){
					if ($hobj->tipo == 'sitio'){
						$aprendida = $hobj->construida($usr_sitio);
					} else {
						$aprendida = $hobj->aprendida($usr_sitio);
					}
					$tipo_hab = MplayHabilidadTipo::getInstance($hobj->tipo, Helpers::toArray(json_decode($hobj->propiedades)));
					
					$output = array("id"=>$hobj->id, "nombre"=>SistemaIdioma::Imprimir($hobj->nombre), "descripcion"=>SistemaIdioma::Imprimir($hobj->descripcion), "tipo"=>$hobj->tipo, "oficio"=>$hobj->oficio, "padre"=>$hobj->padre, "coste"=>$hobj->coste, "icono"=>$hobj->geticono(256,256), "propiedades"=>Helpers::toArray(json_decode($hobj->propiedades)), "propiedades_html"=>$tipo_hab->printPropiedadesHtml('class="col-xs-12"'), "aprendida"=>$aprendida);
					$tmp_arr[] = $output;
				}
			}
			return $tmp_arr;
		} else {
			return array();
		}
	}
}