<?php
c_include('usuario');
e_include('ext_mplay/class/mplayItem','ext_mplay/class/mplayBot','ext_mplay/class/mplayNivelExperiencia','ext_mplay/class/mplayOficioUsuario','ext_mplay/class/mplayJuegosUsuarios','ext_mplay/class/mplayHabilidadUsuario','ext_mplay/class/mplayHabilidadesUsuarios','ext_mplay/class/mplayHabilidadTipo');

class MplayUsuarioHelper
{
	public static function esNuevo($usr){
		if (!$usr instanceof Usuario)
			return false;
			
		$flag_nuevo = self::getPropUsr($usr, 'nuevo');
		
		if (empty($flag_nuevo)){
			self::setPropUsr($usr, 'nuevo', '0');
			//self::setPropUsr($usr, 'nuevo', '1');
			return true;
		} elseif ($flag_nuevo == '1'){
			return false;
		} else {
			self::setPropUsr($usr, 'nuevo', '0');
			return true;
		}
	}
	public static function parsearTexto($usr, $txt){
		if (!$usr instanceof Usuario || empty($txt))
			return false;
			
		$nombre_usr = $usr->getnombre_completo();
		$oficio_usr = self::getOficioUsr($usr);
		$casa_usr = self::getCasaUsr($usr);
		
		$txt_p = str_replace('##NOMBRE##', $nombre_usr, $txt);
		if (is_object($casa_usr)){
			$txt_p = str_replace('##DOMICILIO##', $casa_usr->localizacion_formateada, $txt_p);
		}
		if (is_array($oficio_usr) && sizeof($oficio_usr) > 0){
			$txt_p = str_replace('##OFICIO##', $oficio_usr['nombre'], $txt_p);
		}
		
		return $txt_p;
			
	}
	public static function getCasaUsr($usr, $lat, $lng){
		if (!$usr instanceof Usuario || !Helpers::checkExtension('ext_sitios'))
			return false;
			
		e_include('ext_sitios/class/sitio');
			
		$where_check = "estado='1' AND propietario='-".$usr->id."' AND params LIKE '%\"tipo\":\"casa\"%'";
		$casa_check = new Sitio();
		
		if (!empty($lat) && !empty($lng)){
			$casa_check_c = $casa_check->ListarCountPorLocalizacion($lat, $lng, 2000000, '', 0, 0, array($where_check));
		} else {
			$casa_check_c = $casa_check->ListarCount($where_check);
		}
		if ($casa_check_c == 1){
			if (!empty($lat) && !empty($lng)){
				$casa_check = $casa_check->ListarPorLocalizacion($lat, $lng, 2000000, '', 0, 0, array($where_check));
			} else {
				$casa_check = $casa_check->Listar($where_check);
			}
			$casa_check = $casa_check[0];
			return $casa_check;
		} elseif ($casa_check_c > 1){
			return 'multiples_casas';
		} else {
			return 'no';
		}
	}
	public static function addHabilidadUsr($usr, $habilidad){
		if (!$usr instanceof Usuario || !$habilidad instanceof MplayHabilidadUsuario)
			return false;
			
		$habilidades_usr = self::getHabilidadesUsr($usr);
		
		if (in_array($habilidad->id, $habilidades_usr))
			return false;
		
		$mju = new MplayHabilidadesUsuarios();
		$mju->setid_usuario($usr->id);
		$mju->setid_habilidad($habilidad->id);
		$mju->setfecha(strftime("%Y-%m-%d %H:%M:%S"));
		if ($id_new_mju = $mju->Guardar()){
			return true;
		} else {
			return false;
		}
	}
	public static function removeHabilidadUsr($usr, $habilidad){
		if (!$usr instanceof Usuario || !$habilidad instanceof MplayHabilidadUsuario)
			return false;
			
		$habilidades_usr = self::getHabilidadesUsr($usr);
		
		if (!in_array($habilidad->id, $habilidades_usr))
			return false;
					
		$mju = new MplayHabilidadesUsuarios();
		$mju_c = $mju->ListarCount("id_usuario='".$usr->id."' AND id_habilidad='".$habilidad->id."'");
		
		if ($mju_c == 0)
			return false;
			
		$mju = $mju->Listar("id_usuario='".$usr->id."' AND id_habilidad='".$habilidad->id."'");
		$mju = $mju[0];
		
		if ($mju->Borrar()){
			return true;
		} else {
			return false;
		}
	}
	public static function getHabilidadesUsr($usr, $solo_conseguidas=true){
		if (!$usr instanceof Usuario)
			return false;
			
		if ($solo_conseguidas == true){
			$habilidades_usr = new MplayHabilidadesUsuarios();
			$habilidades_usr_c = $habilidades_usr->ListarCount("id_usuario='".$usr->id."'");
			
			if ($habilidades_usr_c > 0){
				
				$habilidades_usr = $habilidades_usr->Listar("id_usuario='".$usr->id."'", "fecha", "DESC");
				$habilidades_ids = array();
				foreach ($habilidades_usr as $ja){
					$habilidades_ids[] = $ja->id_habilidad;
				}
							
				return $habilidades_ids;
			} else {
				return array();
			}
		} else {
			$oficio_usr = MplayUsuarioHelper::getOficioUsr($usr);
			
			$where_habs = 'tipo="default" AND estado="1" AND (oficio="0" OR oficio="'.$oficio_usr['id'].'")';
			
			$habilidades_usr = new MplayHabilidadUsuario();
			$habilidades_usr_c = $habilidades_usr->ListarCount($where_habs);
			
			if ($habilidades_usr_c > 0){
				$habilidades_usr = $habilidades_usr->Listar($where_habs);
				$habilidades_ids = array();
				foreach ($habilidades_usr as $ja){
					$habilidades_ids[] = $ja->id;
				}
				return $habilidades_ids;
			} else {
				return array();
			}
		}
	}
	public static function getHabilidadesUsrArray($usr, $solo_conseguidas=true){
		if (!$usr instanceof Usuario)
			return false;
			
		$habilidades_ids = self::getHabilidadesUsr($usr, $solo_conseguidas);
		
		if (is_array($habilidades_ids) && sizeof($habilidades_ids) > 0){
			$tmp_arr = array();
			foreach ($habilidades_ids as $hid){
				$hobj = new MplayHabilidadUsuario();
				$hobj->setid($hid);
				if ($hobj = $hobj->BuscarId()){
					if ($hobj->tipo == 'sitio'){
						$aprendida = $hobj->construida($usr);
					} else {
						$aprendida = $hobj->aprendida($usr);
					}
					$tipo_hab = MplayHabilidadTipo::getInstance($hobj->tipo, Helpers::toArray(json_decode($hobj->propiedades)));
					
					$output = array("id"=>$hobj->id, "nombre"=>SistemaIdioma::Imprimir($hobj->nombre), "descripcion"=>SistemaIdioma::Imprimir($hobj->descripcion), "tipo"=>$hobj->tipo, "oficio"=>$hobj->oficio, "padre"=>$hobj->padre, "coste"=>$hobj->coste, "icono"=>$hobj->geticono(256,256), "propiedades"=>Helpers::toArray(json_decode($hobj->propiedades)), "propiedades_html"=>$tipo_hab->printPropiedadesHtml('class="col-xs-12"'), 'aprendida'=>$aprendida);
					$tmp_arr[] = $output;
				}
			}
			return $tmp_arr;
		} else {
			return array();
		}
	}
	public static function addJuegoActivo($usr, $juego, $mision_activa){
		if (!$usr instanceof Usuario || !$juego instanceof Juego)
			return false;
			
		$juegos_activos = self::getJuegosActivos($usr);
		$juegos_finalizados = self::getJuegosFinalizados($usr);
		
		if (in_array($juego->id, $juegos_activos) || in_array($juego, $juegos_finalizados))
			return false;
			
		$id_mision_activa = 0;
		if ($mision_activa instanceof MisionJuegoMplay){
			$id_mision_activa = $mision_activa->id;
		}
		
		$mju = new MplayJuegosUsuarios();
		$mju->setid_usuario($usr->id);
		$mju->setid_juego($juego->id);
		$mju->setfecha(strftime("%Y-%m-%d %H:%M:%S"));
		$mju->setestado("1");
		$mju->setmision_activa($id_mision_activa);
		if ($id_new_mju = $mju->Guardar()){
			return true;
		} else {
			return false;
		}
	}
	public static function removeJuegoActivo($usr, $juego){
		if (!$usr instanceof Usuario || !$juego instanceof Juego)
			return false;
			
		$juegos_activos = self::getJuegosActivos($usr);
		
		if (!in_array($juego->id, $juegos_activos))
			return false;
					
		$mju = new MplayJuegosUsuarios();
		$mju_c = $mju->ListarCount("id_usuario='".$usr->id."' AND id_juego='".$juego->id."' AND estado='1'");
		
		if ($mju_c == 0)
			return false;
			
		$mju = $mju->Listar("id_usuario='".$usr->id."' AND id_juego='".$juego->id."' AND estado='1'");
		$mju = $mju[0];
		
		if ($mju->Borrar()){
			return true;
		} else {
			return false;
		}
	}
	public static function completarJuegoActivo($usr, $juego){
		if (!$usr instanceof Usuario || !$juego instanceof Juego)
			return false;
			
		$juegos_activos = self::getJuegosActivos($usr);
		
		if (!in_array($juego->id, $juegos_activos))
			return false;
					
		$mju = new MplayJuegosUsuarios();
		$mju_c = $mju->ListarCount("id_usuario='".$usr->id."' AND id_juego='".$juego->id."' AND estado='1'");
		
		if ($mju_c == 0)
			return false;
			
		$mju = $mju->Listar("id_usuario='".$usr->id."' AND id_juego='".$juego->id."' AND estado='1'");
		$mju = $mju[0];
		
		$mju->setestado(2);
		$misiones_completadas = (array) json_decode($mju->misiones_finalizadas);
		$misiones_completadas[time()] = $mju->mision_activa;
		$mju->setmision_activa(0);
		$mju->setmisiones_finalizadas(json_encode($misiones_completadas));
		if ($mju->Modificar()){
			return true;
		} else {
			return false;
		}
	}
	public static function completarMisionActiva($usr, $mision){
		if (!$usr instanceof Usuario || !$juego instanceof MisionJuegoMplay)
			return false;
			
		$misiones_activas = self::getMisionesActivas($usr);
		
		if (!in_array($mision->id, $misiones_activas))
			return false;
					
		$mju = new MplayJuegosUsuarios();
		$mju_c = $mju->ListarCount("id_usuario='".$usr->id."' AND id_juego='".$mision->juego."' AND estado='1'");
		
		if ($mju_c == 0)
			return false;
			
		$mju = $mju->Listar("id_usuario='".$usr->id."' AND id_juego='".$mision->juego."' AND estado='1'");
		$mju = $mju[0];
		
		$misiones_completadas = (array) json_decode($mju->misiones_finalizadas);
		$misiones_completadas[time()] = $mju->mision_activa;
		$mju->setmision_activa($mision->id);
		$mju->setmisiones_finalizadas(json_encode($misiones_completadas));
		if ($mju->Modificar()){
			return true;
		} else {
			return false;
		}
	}
	public static function getJuegosActivos($usr){
		return self::getJuegos($usr, 1);
	}
	public static function getJuegosFinalizados($usr){
		return self::getJuegos($usr, 2);
	}
	public static function getJuegos($usr, $estado){
		if (!$usr instanceof Usuario)
			return false;
			
		if (empty($estado))
			$estado = 0;
			
		$juegos_activos = new MplayJuegosUsuarios();
		$juegos_activos_c = $juegos_activos->ListarCount("id_usuario='".$usr->id."' AND estado ='".$estado."'");

		if ($juegos_activos_c > 0){
			
			$juegos_activos = $juegos_activos->Listar("id_usuario='".$usr->id."' AND estado ='".$estado."'", "fecha", "DESC");
			$juegos_ids = array();
			foreach ($juegos_activos as $ja){
				$juegos_ids[] = $ja->id_juego;
			}
						
			return $juegos_ids;
		} else {
			return false;
		}
	}
	public static function getMisionesActivas($usr){
		return self::getMisiones($usr, 1);
	}
	public static function getMisionesFinalizadas($usr){
		return self::getMisiones($usr, 2);
	}
	public static function getMisiones($usr, $estado){
		// estado: 1-activa, 2-finalizada
		if (!$usr instanceof Usuario)
			return false;
			
		if (empty($estado))
			$estado = 1;
			
		if ($estado == 1){
			$where = "id_usuario='".$usr->id."' AND estado ='1' AND mision_activa <> '0'";
		} elseif ($estado == 2){
			$where = "id_usuario='".$usr->id."' AND (estado = '1' OR estado = '2') AND misiones_finalizadas <> ''";
		}
			
		$juegos_activos = new MplayJuegosUsuarios();
		$juegos_activos_c = $juegos_activos->ListarCount($where);

		if ($juegos_activos_c > 0){
			
			$juegos_activos = $juegos_activos->Listar($where, "fecha", "DESC");
			$misiones_ids = array();
			foreach ($juegos_activos as $ja){
				if ($estado == 1){
					$misiones_ids[] = $ja->mision_activa;
				} elseif ($estado == 2){
					$misiones_finalizadas = (array) json_decode($ja->misiones_finalizadas);
					$misiones_ids = array_merge($misiones_ids, $misiones_finalizadas);
				}
			}
						
			return $misiones_ids;
		} else {
			return false;
		}
	}
	public static function getNivelUsr($usr){
		if (!$usr instanceof Usuario)
			return false;
			
		$nuevos_niveles = self::checkNuevoNivelUsr($usr);
		
		$nivel_actual_id = self::getPropUsr($usr, 'nivel_experiencia');
		if (empty($nivel_actual_id))
			return 0;
			
		$nivel_actual = new MplayNivelExperiencia();
		$nivel_actual->setid($nivel_actual_id);
		if ($nivel_actual = $nivel_actual->BuscarId()){
			$output = array("id"=>$nivel_actual->id, "nombre"=>SistemaIdioma::Imprimir($nivel_actual->titulo), "puntos"=>$nivel_actual->puntos, "orden"=>$nivel_actual->orden, "nuevos_niveles"=>$nuevos_niveles);
			
			return $output;
		} else {
			return false;
		}
	}
	public static function checkNuevoNivelUsr($usr){
		if (!$usr instanceof Usuario)
			return false;
			
		return MplayNivelExperiencia::checkAll($usr->id);
	}
	public static function getOficioUsr($usr){
		if (!$usr instanceof Usuario)
			return false;
			
		$oficio_id = self::getPropUsr($usr, 'oficio');
		if (empty($oficio_id))
			return 0;
			
		$oficio = new MplayOficioUsuario();
		$oficio->setid($oficio_id);
		if ($oficio = $oficio->BuscarId()){
			$output = array("id"=>$oficio->id, "nombre"=>SistemaIdioma::Imprimir($oficio->nombre), "descripcion"=>SistemaIdioma::Imprimir($oficio->descripcion), "tipo"=>$oficio->tipo, "icono"=>$oficio->geticono(256,256), "propiedades"=>Helpers::toArray(json_decode($oficio->propiedades)));
			
			return $output;
		} else {
			return false;
		}
	}
	public static function getSlotsRopa(){
		return array("cabeza","torso","manos","piernas","pies");
	}
	public static function getSlotsArmas(){
		return array("mano_derecha","mano_izquierda","dos_manos");
	}
	public static function getSlotsUsr($usr, $tipo, $formatted=false){
		if (!$usr instanceof Usuario)
			return false;
			
		if (empty($tipo))
			$tipo = 'ropa';
			
		e_include('ext_mplay/class/mplayItem');
			
		$params_usr = Helpers::toArray(json_decode($usr->params));
			
		switch ($tipo){
			case 'ropa':
				$model_slots = self::getSlotsRopa();
				$slots_usr = $params_usr['ext_mplay.slots_ropa'];
				break;
			case 'armas':
				$model_slots = self::getSlotsArmas();
				$slots_usr = $params_usr['ext_mplay.slots_armas'];
				break;
		}
		
		$slots = array();
		foreach ($model_slots as $sl){
			if (isset($slots_usr[$sl])){
				if ($formatted == false){
					$slots[$sl] = $slots_usr[$sl];
				} else {
					$it = new MplayItem();
					$it->setid($slots_usr[$sl]);
					
					if ($it = $it->BuscarId()){
						$slots[$sl] = $it;
					}
				}
			} else {
				$slots[$sl] = "";
			}
		}
		
		return $slots;
	}
	public static function getPropUsr($usr, $prop){
		if (!$usr instanceof Usuario || empty($prop))
			return false;
			
		$key_prop = 'ext_mplay.'.$prop;
			
		$params_usr = Helpers::toArray(json_decode($usr->params));
		
		if (!isset($params_usr[$key_prop])){
			if ($prop == 'monedas'){
				$monedas = (int) $usr->credito;
				
				return $monedas;
			} elseif ($prop == 'nivel_experiencia'){
				MplayNivelExperiencia::checkAll($usr->id);
			} else {
				$params_usr[$key_prop] = $GLOBALS['opciones']['ext_mplay']['usuario'][$prop];
				
				$usr->setparams(json_encode($params_usr));
				$usr->setcontrasena('');
				
				$usr->Modificar();
			}
		}
		
		return $params_usr[$key_prop];
	}
	
	public static function setPropUsr($usr, $prop, $val){
		if (!$usr instanceof Usuario || empty($prop))
			return false;
			
		if ($prop == 'monedas'){
			$monedas = (int) $val;
			$usr->setcredito($monedas);
			$usr->setcontrasena('');
			$usr->Modificar();
			
			return $monedas;
		} else {
			$key_prop = 'ext_mplay.'.$prop;
				
			$params_usr = Helpers::toArray(json_decode($usr->params));
	
			$params_usr[$key_prop] = $val;
			$usr->setparams(json_encode($params_usr));
			$usr->setcontrasena('');
			$usr->Modificar();
			
			return $params_usr[$key_prop];
		}
	}
	
	public static function getEquipedInc($usr, $prop){
		if (!$usr instanceof Usuario || empty($prop))
			return false;
			
		$slots_ropa_usr = self::getSlotsUsr($usr, 'ropa');
		$slots_armas_usr = self::getSlotsUsr($usr, 'armas');
		
		e_include('ext_mplay/class/mplayItem','ext_mplay/class/mplayItemTipo');
		
		$inc = 0;
		
		foreach ($slots_ropa_usr as $it_id){
			if (empty($it_id))
				continue;
				
			$item_obj = new MplayItem();
			$item_obj->setid($it_id);
			
			if ($item_obj = $item_obj->BuscarId()){
				$props_item = Helpers::toArray(json_decode($item_obj->propiedades));
				$inc += $props_item[$prop];
			}
		}
		
		foreach ($slots_armas_usr as $it_id){
			if (empty($it_id))
				continue;
				
			$item_obj = new MplayItem();
			$item_obj->setid($it_id);
			
			if ($item_obj = $item_obj->BuscarId()){
				$props_item = Helpers::toArray(json_decode($item_obj->propiedades));
				$inc += $props_item[$prop];
			}
		}
		
		$inc += self::getOficioInc($usr, $prop);
		$inc += self::getHabilidadesInc($usr, $prop);
		
		return $inc;
	}
	
	public static function getOficioInc($usr, $prop){
		if (!$usr instanceof Usuario || empty($prop))
			return false;
		
		e_include('ext_mplay/class/mplayOficioUsuario','ext_mplay/class/mplayOficioTipo');
		
		$oficio_id = self::getPropUsr($usr, 'oficio');
		
		if (empty($oficio_id))
			return 0;
			
		$oficio_obj = new MplayOficioUsuario();
		$oficio_obj->setid($oficio_id);
		if ($oficio_obj = $oficio_obj->BuscarId()){
			$props_oficio = Helpers::toArray(json_decode($oficio_obj->propiedades));
		} else {
			return 0;
		}
		
		$inc = 0;
		
		if (!empty($props_oficio[$prop])){
			$inc += $props_oficio[$prop];
		}
		
		return $inc;
	}
	
	public static function getHabilidadesInc($usr, $prop){
		if (!$usr instanceof Usuario || empty($prop))
			return false;
		
		$habilidades_usr = self::getHabilidadesUsrArray($usr);
		
		$inc = 0;
		if (is_array($habilidades_usr) && sizeof($habilidades_usr) > 0){
			foreach ($habilidades_usr as $hu){
				$props_hu = $hu["propiedades"];
				if (!empty($props_hu[$prop])){
					$inc += $props_hu[$prop];
				}
			}
		}
		
		return $inc;
	}
	
	public static function getVida($usr){
		$vida = self::getPropUsr($usr, 'vida');
		$vida_max = self::getMaxVida($usr);
		
		if ($vida_max < $vida){
			$vida = $vida_max;
			self::setVida($usr, $vida);
		}
		
		if ($vida == '0'){
			$vida = '15';
			self::setVida($usr, $vida);
		}
		
		return $vida;
	}
	
	public static function setVida($usr, $val){
		return self::setPropUsr($usr, 'vida', $val);
	}
	
	public static function getMaxVida($usr){
		$vida_max = $GLOBALS['opciones']['ext_mplay']['usuario']['vida'];
		$vida_max += self::getEquipedInc($usr, 'vida');
		
		return $vida_max;
	}
	
	public static function setMonedas($usr, $val){
		return self::setPropUsr($usr, 'monedas', $val);
	}
	
	public static function getMonedas($usr){
		$monedas = self::getPropUsr($usr, 'monedas');
		return $monedas;
	}
	
	public static function setVelocidad($usr, $val){
		return self::setPropUsr($usr, 'velocidad', $val);
	}
	
	public static function getVelocidad($usr){
		$velocidad = self::getPropUsr($usr, 'velocidad');
		$velocidad += self::getEquipedInc($usr, 'velocidad');
		return $velocidad;
	}
		
	public static function getRangoVision($usr){
		$rango_vision = self::getPropUsr($usr, 'rango_vision');
		$rango_vision += self::getEquipedInc($usr, 'rango_vision');
		return $rango_vision;
	}
	
	public static function setRangoVision($usr, $val){
		return self::setPropUsr($usr, 'rango_vision', $val);
	}
	
	public static function getRangoInteraccion($usr){
		$rango_interaccion = self::getPropUsr($usr, 'rango_interaccion');
		$rango_interaccion += self::getEquipedInc($usr, 'rango_interaccion');
		return $rango_interaccion;
	}
	
	public static function setRangoInteraccion($usr, $val){
		return self::setPropUsr($usr, 'rango_interaccion', $val);
	}
	
	public static function getAtaque($usr){
		$ataque = self::getPropUsr($usr, 'ataque');
		$ataque += self::getEquipedInc($usr, 'ataque');
		return $ataque;
	}
	
	public static function setAtaque($usr, $val){
		return self::setPropUsr($usr, 'ataque', $val);
	}
	
	public static function getDefensa($usr){
		$defensa = self::getPropUsr($usr, 'defensa');
		$defensa += self::getEquipedInc($usr, 'defensa');
		return $defensa;
	}
	
	public static function setDefensa($usr, $val){
		return self::setPropUsr($usr, 'defensa', $val);
	}
	
	public static function getCarisma($usr){
		$carisma = self::getPropUsr($usr, 'carisma');
		$carisma += self::getEquipedInc($usr, 'carisma');
		return $carisma;
	}
	
	public static function setCarisma($usr, $val){
		return self::setPropUsr($usr, 'carisma', $val);
	}
	
	public static function getEspecial($usr){
		$especial = self::getPropUsr($usr, 'especial');
		$especial += self::getEquipedInc($usr, 'especial');
		return $especial;
	}
	
	public static function setEspecial($usr, $val){
		return self::setPropUsr($usr, 'especial', $val);
	}
	
	public static function getAvatar($usr, $size){
		if (!$usr instanceof Usuario)
			return false;
			
		if (empty($size))
			$size = 80;
			
		$seed = $usr->email;
		
		include_once(CONF_REALPATH_APP . 'includes/library/monsterid/monsterid.php');
		
		if (!is_dir(CONF_REALPATH_APP . 'uploads/imagenes/avatars'))
			Helpers::ftpCrearCarpeta(CONF_REALPATH_APP . 'uploads/imagenes/avatars');
		
		$filename = CONF_REALPATH_APP . 'uploads/imagenes/avatars/avtr_'.$usr->id.'_'.$size.'.png';
		
		$img_realpath = build_monster($seed,$size,$filename);
		$img = str_replace(CONF_REALPATH_APP, CONF_URL_APP, $img_realpath);
		
		return $img;
	}
	public static function getAvatarMap($usr, $ancho, $alto){
		if (!$usr instanceof Usuario)
			return false;
			
		if (empty($ancho) || empty($alto)){
			$ancho = 90;
			$alto = 237;
		}
		
		$default_img = $GLOBALS['opciones']['ext_mplay']['usuario']['img_player'];
		
		if (!empty($default_img)){
			return Helpers::generateImageLink($default_img, $ancho, $alto);
		} else {
			return Helpers::getImagenDesaparecida($ancho, $alto);
		}
	}
}