<?php
/**
 * @package     Mideas.mPlay
 * @subpackage  Item
 *
 * @copyright   Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE
 */

defined('CONF_URL_APP') or die;

class MplayItemTipoArma extends MplayItemTipo
{
	protected $name = 'Arma';
	protected $description = 'Inflige daño a los Puntos de Vida (PV) de los enemigos';
	
	protected $acciones_mapa = array('recoger','ir');
	protected $acciones_inventario = array('equipar','desequipar','soltar');
	protected $acciones_inventario_comercio = array('vender');
	protected $acciones_comercio = array('comprar');
	protected $acciones_loot = array('recoger');
	protected $acciones_loot_jugador = array('almacenar');
	
	var $tipo_slots = 'armas';
	
	var $reutilizable = false;
	
	public function __construct($options = array())
	{
		$this->propiedades = array(
									"valor"	=>	array(
										"nombre"	=>	__("Valor"), 
										"tipo"		=>	"int",
										"input"		=>	"number",
										"icono"		=>	"MO",
										"descripcion"	=>	__("Valor del item en Monedas de Oro (MO)"),
										"params"	=>	array("class"=>"form-control")
										),
									"ataque"	=>	array(
										"nombre"	=>	__("Ataque"), 
										"tipo"		=>	"int",
										"input"		=>	"number",
										"icono"		=>	"PA",
										"descripcion"	=>	__("Puntos de Ataque (PA) que otorga el item"),
										"params"	=>	array("class"=>"form-control")
										),
									"defensa"	=>	array(
										"nombre"	=>	__("Defensa"), 
										"tipo"		=>	"int",
										"input"		=>	"number",
										"icono"		=>	"PD",
										"descripcion"	=>	__("Puntos de Defensa (PD) que otorga el item"),
										"params"	=>	array("class"=>"form-control")
										),
									"vida"	=>	array(
										"nombre"	=>	__("Vida"), 
										"tipo"		=>	"int",
										"input"		=>	"number",
										"icono"		=>	"PV",
										"descripcion"	=>	__("Puntos de Vida (PV) que otorga el item"),
										"params"	=>	array("class"=>"form-control")
										),
									"velocidad"	=>	array(
										"nombre"	=>	__("Velocidad"), 
										"tipo"		=>	"int",
										"input"		=>	"number",
										"icono"		=>	"VM",
										"descripcion"	=>	__("Incremento de Velocidad de Movimiento (VM) que otorga el item"),
										"params"	=>	array("class"=>"form-control")
										),
									"rango_vision"	=>	array(
										"nombre"	=>	__("Rango de Visión"), 
										"tipo"		=>	"int",
										"input"		=>	"number",
										"icono"		=>	"RV",
										"descripcion"	=>	__("Incremento de Rango de Visión (RV) que otorga el item"),
										"params"	=>	array("class"=>"form-control")
										),
									"rango_interaccion"	=>	array(
										"nombre"	=>	__("Rango de Interacción"), 
										"tipo"		=>	"int",
										"input"		=>	"number",
										"icono"		=>	"RI",
										"descripcion"	=>	__("Incremento de Rango de Interacción (RV) que otorga el item"),
										"params"	=>	array("class"=>"form-control")
										),
									"carisma"	=>	array(
										"nombre"	=>	__("Carisma"), 
										"tipo"		=>	"int",
										"input"		=>	"number",
										"icono"		=>	"NC",
										"descripcion"	=>	__("Incremento del Nivel de Carisma (NC) que otorga el item"),
										"params"	=>	array("class"=>"form-control")
										),
									"especial"	=>	array(
										"nombre"	=>	__("Especial"), 
										"tipo"		=>	"int",
										"input"		=>	"number",
										"icono"		=>	"PE",
										"descripcion"	=>	__("Puntos Especial (PE) que otorga el item"),
										"params"	=>	array("class"=>"form-control")
										),
									"slot"	=>	array(
										"nombre"	=>	__("Tipo"), 
										"tipo"		=>	"string",
										"input"		=>	"list",
										"icono"		=>	"TP",
										"descripcion"	=>	__("Tipo de arma"),
										"visible"	=>	false,
										"params"	=>	array("opciones" => array("mano_izquierda"=>__('Mano izquierda'), "mano_derecha"=>__('Mano derecha'), "dos_manos"=>__('Dos manos')))
										)
		);
		
		parent::__construct($options);
	}
}