<?php
/**
 * @package     Mideas.mPlay
 * @subpackage  Item
 *
 * @copyright   Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE
 */

defined('CONF_URL_APP') or die;

class MplayItemTipoLibro extends MplayItemTipo
{
	protected $name = 'Libro';
	protected $description = 'Puedes leer este objeto para descubrir nuevos objetivos y pistas';
	
	protected $acciones_mapa = array('recoger','ir');
	protected $acciones_inventario = array('leer','soltar');
	protected $acciones_inventario_comercio = array('vender');
	protected $acciones_comercio = array('comprar');
	protected $acciones_loot = array('recoger');
	protected $acciones_loot_jugador = array('almacenar');
	
	var $reutilizable = false;
	
	public function __construct($options = array())
	{
		$this->propiedades = array(
									"valor"	=>	array(
										"nombre"	=>	__("Valor"), 
										"tipo"		=>	"int",
										"icono"		=>	"MO",
										"descripcion"	=>	__("Valor del item en Monedas de Oro (MO)"),
										"input"		=>	"number",
										"params"	=>	array("class"=>"form-control")
										),
									"contenido"	=>	array(
										"nombre"	=>	__("Contenido del libro"), 
										"tipo"		=>	"string",
										"icono"		=>	"CN",
										"descripcion"	=>	__("Contenido del libro"),
										"visible"	=>	false,
										"input"		=>	"textarea",
										"params"	=>	array("class"=>"wysiwyg", "multilanguage"=>"true")
										),
									"rango_vision"	=>	array(
										"nombre"	=>	__("Rango de Visión"), 
										"tipo"		=>	"int",
										"icono"		=>	"RV",
										"descripcion"	=>	__("Incremento de Rango de Visión (RV) que otorga el item"),
										"input"		=>	"number",
										"params"	=>	array("class"=>"form-control")
										),
									"rango_interaccion"	=>	array(
										"nombre"	=>	__("Rango de Interacción"), 
										"tipo"		=>	"int",
										"icono"		=>	"RI",
										"descripcion"	=>	__("Incremento de Rango de Interacción (RV) que otorga el item"),
										"input"		=>	"number",
										"params"	=>	array("class"=>"form-control")
										),
									"carisma"	=>	array(
										"nombre"	=>	__("Carisma"), 
										"tipo"		=>	"int",
										"icono"		=>	"NC",
										"descripcion"	=>	__("Incremento del Nivel de Carisma (NC) que otorga el item"),
										"input"		=>	"number",
										"params"	=>	array("class"=>"form-control")
										),
									"especial"	=>	array(
										"nombre"	=>	__("Especial"), 
										"tipo"		=>	"int",
										"icono"		=>	"PE",
										"descripcion"	=>	__("Puntos Especial (PE) que otorga el item"),
										"input"		=>	"number",
										"params"	=>	array("class"=>"form-control")
										)
		);
		
		parent::__construct($options);
	}	
	
	function onUse(){
		if (!Usuario::isLoged())
			return __('Debes estar identificado para leer el libro');
			
		$usr_obj = Usuario::getLoged();
			
		e_include('ext_mplay/class/mplayUsuariosActivos','ext_mplay/class/helpers/mplayUsuarioHelper');
			
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return __('No estás conectado al juego');
		}
		
		$contenido = $this->propiedades['contenido']['valor'][SistemaIdioma::getIdiomaSesion()];
		if (empty($contenido))
			return __('El libro no tiene nada escrito');
		
		return true;
	}
}