<?php
/**
 * @package     Mideas.mPlay
 * @subpackage  Item
 *
 * @copyright   Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE
 */

defined('CONF_URL_APP') or die;

class MplayItemTipoVida extends MplayItemTipo
{
	protected $name = 'Vida';
	protected $description = 'Recuperación de vida';
	
	protected $acciones_mapa = array('recoger','ir');
	protected $acciones_inventario = array('usar','soltar');
	protected $acciones_inventario_comercio = array('vender');
	protected $acciones_comercio = array('comprar');
	protected $acciones_loot = array('recoger');
	protected $acciones_loot_jugador = array('almacenar');
	
	var $reutilizable = false;
	
	public function __construct($options = array())
	{
		$this->propiedades = array(
									"valor"	=>	array(
										"nombre"	=>	__("Valor"), 
										"tipo"		=>	"int",
										"icono"		=>	"MO",
										"descripcion"	=>	__("Valor del item en Monedas de Oro (MO)"),
										"input"		=>	"number",
										"params"	=>	array("class"=>"form-control")
										),
									"restaurar_vida"	=>	array(
										"nombre"	=>	__("Restaurar Vida"), 
										"tipo"		=>	"int",
										"icono"		=>	"RPV",
										"descripcion"	=>	__("Puntos de Vida (PV) que restaura el item"),
										"input"		=>	"number",
										"params"	=>	array("class"=>"form-control")
										)
		);
		
		parent::__construct($options);
	}	
	
	function onUse(){
		if (!Usuario::isLoged())
			return __('Debes estar identificado para usar el item');
			
		$usr_obj = Usuario::getLoged();
			
		e_include('ext_mplay/class/mplayUsuariosActivos','ext_mplay/class/helpers/mplayUsuarioHelper');
		
		if (!MplayUsuariosActivos::esta_conectado($usr_obj)){
			return __('No estás conectado al juego');
		}
		
		$restaurar_vida = $this->propiedades['restaurar_vida']['valor'];
		if (empty($restaurar_vida))
			return __('El item no restaura ningún punto de vida');;
			
		$max_vida_usr = MplayUsuarioHelper::getMaxVida($usr_obj);
		$vida_usr = MplayUsuarioHelper::getVida($usr_obj);
		
		if ($max_vida_usr == $vida_usr)
			return __('No puedes usar este item porque tienes los Puntos de Vida (PV) al máximo');
			
		$vida_usr += $restaurar_vida;
		if ($vida_usr > $max_vida_usr)
			$vida_usr = $max_vida_usr;
			
		MplayUsuarioHelper::setVida($usr_obj, $vida_usr);
		
		return true;
	}
}