<?php
defined('CONF_URL_APP') or die;

class MisionJuegoMplay extends EntidadModel
{
	protected $dbt_const = "DBT_JUEGOS_MISIONES";
	protected $dbt = "mplay_juegos_misiones";
	
	protected $ext_folder = "ext_misiones";

	protected $all_vars = array("id", "titulo", "descripcion", "descripcion_corta", "tipo", "icono", "estado", "creador", "propietario", "fecha", "propiedades", "params", "idioma", "visibilidad", "radio", "latitud", "longitud", "location", "juego", "orden");
	
	protected $idx_vars = array("id");
	protected $update_vars = array("titulo", "descripcion", "descripcion_corta", "tipo", "icono", "estado", "creador", "propietario", "propiedades", "params", "idioma", "visibilidad", "radio", "latitud", "longitud", "location", "juego", "orden");
	
	protected $campos_multilang = array("titulo", "descripcion", "descripcion_corta");
	protected $campos_array = array("propiedades", "params");
		
	function __construct(){
		parent::__construct();
	}
	
	function includes(){
		e_include('ext_mplay/class/juego','ext_mplay/class/mplayMisionTipo','ext_mplay/class/helpers/mplayUsuarioHelper');
	}
	
	private function filtroEntrada($contenido) {
        return (Helpers::mres(Helpers::from_utf8($contenido)));
    }

    private function filtroSalida($contenido) {
        return (Helpers::to_utf8($contenido));
    }
	
	function geticono($ancho = '', $alto = '') {
        if (empty($ancho) || empty($alto)) {
            $ancho = '200';
            $alto = '100';
        }

        if (!empty($this->icono)) {
            return Helpers::generateImageLink($this->icono, $ancho, $alto);
        } else {
            $params_item = Helpers::toArray(json_decode($this->params));

            $contenido = SistemaIdioma::Imprimir($this->descripcion);
            $imagen_destacada = Helpers::extraer_imagenes($contenido);

            if (!empty($imagen_destacada)) {
                return Helpers::generateImageLink($imagen_destacada, $ancho, $alto);
            } else {
                return '';
            }
        }
    }
	
	function getcreador($print = false, $objeto = false) {
        if ($print == false) {
            return $this->creador;
        } else {
            if (!empty($this->creador_alias) && $objeto == false) {
                return $this->creador_alias;
            } else {
                if (substr($this->creador, 0, 1) == '-') {
                    $c = substr($this->creador, 1);
                } else {
                    $c = $this->creador;
                }
                c_include('usuario');

                if (is_object($GLOBALS["site"]["usuarios"][$c])) {
                    if ($objeto == true)
                        return $GLOBALS["site"]["usuarios"][$c];
                    else
                        return $GLOBALS["site"]["usuarios"][$c]->getnombre_completo();
                }

                $c_obj = new Usuario();
                $c_obj->setid($c);

                if ($c_obj = $c_obj->BuscarId()) {
                    $GLOBALS["site"]["usuarios"][$c] = $c_obj;
                    if ($objeto == true)
                        return $c_obj;
                    else
                        return $c_obj->getnombre_completo();
                } else {
                    return $this->creador;
                }
            }
        }
    }

    function getpropietario($print = false, $objeto = false) {
        if (!in_array('propietario', $this->all_vars))
            return false;

        if ($print == false) {
            return $this->propietario;
        } else {
            if (substr($this->propietario, 0, 1) == '-') {
                $c = substr($this->propietario, 1);
            } else {
                $c = $this->propietario;
            }
            c_include('usuario');

            if (is_object($GLOBALS["site"]["usuarios"][$c])) {
                if ($objeto == true)
                    return $GLOBALS["site"]["usuarios"][$c];
                else
                    return $GLOBALS["site"]["usuarios"][$c]->getnombre_completo();
            }

            $c_obj = new Usuario();
            $c_obj->setid($c);
            if ($c_obj = $c_obj->BuscarId()) {
                $GLOBALS["site"]["usuarios"][$c] = $c_obj;
                if ($objeto == true)
                    return $c_obj;
                else
                    return $c_obj->getnombre_completo();
            } else {
                return $this->propietario;
            }
        }
    }
	
	function getjuego($print=false,$object=false)
    {
		if($print==false){
			if ($object == true){
				$c=$this->juego;
				$juego = new Juego();
				$juego->setid($c);
				if ($juego = $juego->BuscarId()){
					return $juego;
				} else {
					return false;
				}
			} else {
       			return $this->juego;
			}
		} else {
			$c=$this->juego;
			$juego = new Juego();
			$juego->setid($c);
			if ($juego = $juego->BuscarId()){
				return SistemaIdioma::Imprimir($juego->titulo);
			} else {
				return '';
			}
		}
    }
	
	function checkAcceso(){
		$parent_acceso = parent::checkAcceso();
		
		if ($parent_acceso === true){
			if (Usuario::es_superadmin()){
				return true;
			}
			$juego = $this->getjuego(false,true);
			
			switch ($juego->visibilidad){
				case "1":
					return true;
					break;
				case "0":
					if (!Usuario::isLoged() || $this->propietario != '-'.Usuario::getLogedId()){
						return false;
					} else {
						return true;
					}
					break;
				case "2":
					if (!Usuario::isLoged()){
						return false;
					}
					$propietario_juego = $this->getpropietario(true,true);
					
					if (!is_object($propietario_juego)){
						return true;
					}
					
					if (Usuario::getLogedId() == $propietario_juego->id)
						return true; 
					
					$seguidores_propietario = $propietario_juego->get_seguidores();
					
					if (!is_array($seguidores_propietario) || sizeof($seguidores_propietario) == 0)
						return false;
						
					foreach ($seguidores_propietario as $sp){
						if ($sp->id == Usuario::getLogedId()){
							return true;
						}
					}
					
					return false;
					break;
			}
			return true;
		} else {
			return $parent_acceso;
		}
	}
	
	function get_distancia($formateada = false) {
        if (!empty($this->distancia)) {
            $dist = $this->distancia;

            if ($formateada == true) {
                if ($this->distancia < 1) {
                    $dist = number_format($this->distancia * 1000, 0);
                    $dist .= ' ' . __('metros');
                } else {
                    $dist = number_format($this->distancia, 2, ',', '.');
                    $dist .= ' ' . __('kms.');
                }
            }

            return $dist;
        } else {
            return false;
        }
    }
	
	function ListarCountPorLocalizacion($latitud = 40.416812493264125, $longitud = -3.703293800354004, $radio = 1, $limit1 = 0, $limit2 = 0, $extra_where = array()) {
		$append = '';
		
        $where = '';

        if (is_array($extra_where) && sizeof($extra_where) > 0) {
            $where = ' WHERE ';
            $where .= implode(' AND ', $extra_where);
            if (!empty($keyword_where)) {
                $where .= ' AND ' . $keyword_where;
            }
        }

        $link = new DB();
        $sql = "SELECT COUNT(*) AS num, ( 6371 * acos( cos( radians(" . $latitud . ") ) * cos( radians( i.latitud ) ) * cos( radians( i.longitud ) - radians(" . $longitud . ") ) + sin( radians(" . $latitud . ") ) * sin( radians( i.latitud ) ) ) ) AS distancia FROM " . constant($this->dbt_const) . " i " . $where . " HAVING distancia < " . $radio . " ORDER BY distancia";
		
        $res = $link->Query($sql);
        $num = $link->FetchArray($res);
        $num = $num['num'];
        $link->Desconectar();
        return $num;
    }

    function ListarPorLocalizacion($latitud = 40.416812493264125, $longitud = -3.703293800354004, $radio = 1, $limit1 = 0, $limit2 = 0, $extra_where = array(), $extra_append) {
		$append = '';
		
        $where = '';

        if (is_array($extra_where) && sizeof($extra_where) > 0) {
            $where = ' WHERE ';
            $where .= implode(' AND ', $extra_where);
            if (!empty($keyword_where)) {
                $where .= ' AND ' . $keyword_where;
            }
        }

        $append .= $extra_append;
		
        $link = new DB();
        $i = 0;
        $sql = "SELECT *, ( 6371 * acos( cos( radians(" . $latitud . ") ) * cos( radians( i.latitud ) ) * cos( radians( i.longitud ) - radians(" . $longitud . ") ) + sin( radians(" . $latitud . ") ) * sin( radians( i.latitud ) ) ) ) AS distancia" . $append . " FROM " . constant($this->dbt_const) . " i " . $where . " HAVING distancia < " . $radio . " ORDER BY distancia";
        if (!empty($limit1) || !empty($limit2)) {
            $sql .= " LIMIT " . $limit1 . " , " . $limit2 . ";";
        }
		
        $res = $link->Query($sql);
        while ($x = $link->FetchArray($res)) {
            $aux = new self();
            //$a   = get_class_vars(get_class($this));
            $a = $aux->get_classvars();
            foreach ($a as $clave) {
                if (!in_array($clave, $this->ignore_vars)) {
                    $aux->$clave = $this->filtroSalida($x[$clave]);
                }
            }
			
			$array[$i] = new self();
            $array[$i] = $aux;
			$array[$i]->distancia = $x["distancia"];
			
			if (!empty($array[$i]->id_usuario)){
				$usr_obj = new Usuario();
				$usr_obj->setid($array[$i]->id_usuario);
				
				if ($usr_obj = $usr_obj->BuscarId()){
					$array[$i]->usuario_obj = $usr_obj;
				}
			} else {
				$array[$i]->usuario_obj = null;
			}
			
			$i++;
        }
        $link->Desconectar();

        if ($i == 0) {
            return false;
        } else {
            return $array;
        }
    }
	
	public static function getTypes()
	{
		e_include('ext_mplay/class/mplayMisionTipo');
		
		$dir = dirname(__FILE__) . '/misiones';
		$handlers = Helpers::dir_list($dir,'','.php',false);
		$handlers = $handlers[dirname(__FILE__) . '/misiones'];
		
		$names = array();
		foreach ($handlers as $handler)
		{
			$name = substr($handler, 0, strrpos($handler, '.'));
			$class = 'MplayMisionTipo' . ucfirst($name);

			if (!class_exists($class))
			{
				include_once dirname(__FILE__) . '/misiones/' . $name . '.php';
			}

			if (call_user_func_array(array(trim($class), 'test'), array()))
			{
				$names[] = $name;
			}
		}

		return $names;
	}
	
	function printDeleteButton($filename = null, $plantilla = '') {
        if (empty($this->id) || $filename == null)
            return false;

        $output = '';

        if (empty($plantilla)) {
            $output .= '<a id="deleteButton_' . $this->id . '" href="javascript:;"><img src="' . CONF_URL_APP_ADMIN . CONF_DIR_THEMES_ADMIN . '/' . TEMPLATE_ADMIN . '/' . 'gfx/icon-delete.gif" alt="' . __('Borrar misión') . '" title="' . __('Borrar misión') . '" /></a>';
        } else {
            $aid = "deleteButton_" . $this->id;
            $txt = __('Borrar misión');

            $tmp = str_replace('##ID##', $aid, $plantilla);
            $tmp = str_replace('##TXT##', $txt, $tmp);

            $output .= $tmp;
        }


        $output .= '<script>
		$(document).ready(function(){ 
	$("#deleteButton_' . $this->id . '").click(function(){
		jConfirm("' . __('¿Seguro que quiere borrar la misión?') . '", "' . __('Borrar misión') . '", function(r){
			if(r == true){
				$.post("' . $filename . '", { borrar: "true", id: ' . $this->id . ' }, function(data) {
					if ($.trim(data) == "ok") {
						MideasFunciones.Notificar("' . __('Misión borrada con éxito') . '");
						setTimeout("location.reload(true)", 1000);
						return false;
					} else { 
						MideasFunciones.Notificar(data);
						return false;
					} 
				});
			}
		});
	});
});
</script>';

        return $output;
    }
	
	function BuscarId($lang, $where = '', $extra_append, $info = true, $lat, $lng) {
        if ($this->id) {
			$idioma_ii = $lang;
			if (empty($idioma_ii)){
				$idioma_ii = SistemaIdioma::getIdiomaSesion();
			}
						
			if (!empty($lat) && !empty($lng)){
				$append = ", ( 6371 * acos( cos( radians(" . $lat . ") ) * cos( radians( latitud ) ) * cos( radians( longitud ) - radians(" . $lng . ") ) + sin( radians(" . $lat . ") ) * sin( radians( latitud ) ) ) ) AS distancia";
			}

            $append .= $extra_append;

            $link = new DB();
            $i = 0;
            $sql = "
					SELECT 
						*" . $append . "
						
					FROM
						" . constant($this->dbt_const) . "
						
					WHERE
						id = " . $this->id . $where;
						
            $res = $link->Query($sql);
            $x = $link->FetchArray($res);
            $aux = new self();
            //$a    = get_class_vars(get_class($this));
            $a = $aux->get_classvars();
            foreach ($a as $clave) {
                if (!in_array($clave, $this->ignore_vars)) {
                    $aux->$clave = $this->filtroSalida($x[$clave]);
                }
            }
            $link->Desconectar();
			$aux->distancia = $x["distancia"];
			
            if (!isset($aux->id)) {
                return false;
            } else {
                return $aux;
            }
        } else {
            return false;
        }
    }
	
	function iniciada(){
		if (!Usuario::isLoged())
			return false;
			
		$usr_obj = Usuario::getLoged();
		$usr_id = $usr_obj->id;
		
		e_include('ext_mplay/class/helpers/mplayUsuarioHelper');
		
		if (!class_exists('MplayUsuarioHelper')){
			return false;
		}
		
		$misiones_activas_usr = MplayUsuarioHelper::getMisionesActivas($usr_obj);
		
		if (in_array($this->id, $misiones_activas_usr)){
			return true;
		} else {
			return false;
		}
	}
	
	function completada(){
		if (!Usuario::isLoged())
			return false;
			
		$usr_obj = Usuario::getLoged();
		$usr_id = $usr_obj->id;
		
		e_include('ext_mplay/class/helpers/mplayUsuarioHelper');
		
		if (!class_exists('MplayUsuarioHelper')){
			return false;
		}
		
		$misiones_finalizadas_usr = MplayUsuarioHelper::getMisionesFinalizadas($usr_obj);
		
		if (in_array($this->id, $misiones_finalizadas_usr)){
			return true;
		} else {
			return false;
		}
	}
	
	function completar(){
		if ($this->completada())
			return false;
			
		if (!Usuario::isLoged())
			return false;
			
		$usr_obj = Usuario::getLoged();
		$usr_id = $usr_obj->id;
			
		$params_mision = Helpers::toArray(json_decode($this->params));
		$propiedades_mision = Helpers::toArray(json_decode($this->propiedades));
		
		e_include('ext_mplay/class/mplayRecompensaTipo');
		
		if (!empty($params_mision['recompensa1']['tipo'])){
			$recompensa_tipo = MplayRecompensaTipo::getInstance($params_mision['recompensa1']['tipo']);
			
			if ($recompensa_tipo instanceof MplayRecompensaTipo){
				$recompensa_aplicada = $recompensa_tipo->aplicar($params_mision['recompensa1']['valor']);
			}
		}
		
		if (!empty($params_mision['recompensa2']['tipo'])){
			$recompensa_tipo = MplayRecompensaTipo::getInstance($params_mision['recompensa2']['tipo']);
			
			if ($recompensa_tipo instanceof MplayRecompensaTipo){
				$recompensa_aplicada = $recompensa_tipo->aplicar($params_mision['recompensa2']['valor']);
			}
		}
		
		if (!empty($params_mision['recompensa3']['tipo'])){
			$recompensa_tipo = MplayRecompensaTipo::getInstance($params_mision['recompensa3']['tipo']);
			
			if ($recompensa_tipo instanceof MplayRecompensaTipo){
				$recompensa_aplicada = $recompensa_tipo->aplicar($params_mision['recompensa3']['valor']);
			}
		}
		
		if ($params_mision['generar_actividad_recompensa'] == '1' && !empty($params_mision['texto_actividad_recompensa'][SistemaIdioma::getIdiomaSesion()])){
			$img_recompensa = '';
			if (!empty($params_mision['icono_recompensa'])){
				$img_recompensa = Helpers::generateImageLink($params_mision['icono_recompensa'], 48, 48);
				$img_recompensa = '<img src="'.$img_recompensa.'" width="48" height="48" /> ';
			}
			$txt_actividad = $img_recompensa . $params_mision['texto_actividad_recompensa'][SistemaIdioma::getIdiomaSesion()];
			$usr_obj->nuevaActividad($txt_actividad, 'new', 0, array("tipo" => 'ext_mplay.recompensa_mision', "id_tipo" => $this->id, "id_recompensa"=>$params_mision['recompensas']['tipo']));
		}
		
		return true;
	}
}
?>