<?php
/**
 * @package     Mideas.mPlay
 * @subpackage  Item
 *
 * @copyright   Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE
 */

defined('CONF_URL_APP') or die;

class MplayMisionTipoBots extends MplayMisionTipo
{
	protected $name = 'Bots';
	protected $description = 'Misión que consiste en derrotar uno o varios bots';
	
	protected $acciones_mapa = array('comenzar','ir');
	
	public function __construct($options=array()){
		$this->propiedades = array(
				"bot1"	=>	array(
								"nombre"	=>	__("Bot 1"), 
								"tipo"		=>	"string", 
								"input"		=>	"mplaybotslist", 
								"icono"		=>	"BT", 
								"descripcion"	=>	__("Bot 1 de la misión"),
								"params"	=>	array("solo_invisibles"=>"true"),
								"visible"	=>	false
							),
				"latlng1"	=>	array(
								"nombre"	=>	__("Coordenadas del bot 1"), 
								"tipo"		=>	"string", 
								"input"		=>	"geocomplete", 
								"icono"		=>	"CB1", 
								"descripcion"	=>	__("Coordenadas del bot 1"),
								"params"	=>	array("class"=>"form-control", "data-input-lat"=>"#ext_misiones_detalles__propiedades__lat1_", "data-input-lng"=>"#ext_misiones_detalles__propiedades__lng1_", "data-atributo-detalles"=>"data-loc1-custom"),
								"visible"	=>	false
							), 
				"lat1"	=>	array(
								"nombre"	=>	__("Latitud de la zona de activación"), 
								"tipo"		=>	"string", 
								"input"		=>	"hidden", 
								"icono"		=>	"LTA1", 
								"descripcion"	=>	__("Latitud del bot 1"),
								"params"	=>	array("data-loc1-custom"=>"lat"),
								"visible"	=>	false
							),
				"lng1"	=>	array(
								"nombre"	=>	__("Longitud de la zona de activación"), 
								"tipo"		=>	"string", 
								"input"		=>	"hidden", 
								"icono"		=>	"LNA1", 
								"descripcion"	=>	__("Longitud del bot 1"),
								"params"	=>	array("data-loc1-custom"=>"lng"),
								"visible"	=>	false
							),
				"bot2"	=>	array(
								"nombre"	=>	__("Bot 2"), 
								"tipo"		=>	"string", 
								"input"		=>	"mplaybotslist", 
								"icono"		=>	"BT", 
								"descripcion"	=>	__("Bot 2 de la misión"),
								"params"	=>	array("solo_invisibles"=>"true"),
								"visible"	=>	false
							),
				"latlng2"	=>	array(
								"nombre"	=>	__("Coordenadas del bot 2"), 
								"tipo"		=>	"string", 
								"input"		=>	"geocomplete", 
								"icono"		=>	"CB2", 
								"descripcion"	=>	__("Coordenadas del bot 2"),
								"params"	=>	array("class"=>"form-control", "data-input-lat"=>"#ext_misiones_detalles__propiedades__lat2_", "data-input-lng"=>"#ext_misiones_detalles__propiedades__lng2_", "data-atributo-detalles"=>"data-loc2-custom"),
								"visible"	=>	false
							), 
				"lat2"	=>	array(
								"nombre"	=>	__("Latitud de la zona de activación"), 
								"tipo"		=>	"string", 
								"input"		=>	"hidden", 
								"icono"		=>	"LTA2", 
								"descripcion"	=>	__("Latitud del bot 2"),
								"params"	=>	array("data-loc2-custom"=>"lat"),
								"visible"	=>	false
							),
				"lng2"	=>	array(
								"nombre"	=>	__("Longitud de la zona de activación"), 
								"tipo"		=>	"string", 
								"input"		=>	"hidden", 
								"icono"		=>	"LNA2", 
								"descripcion"	=>	__("Longitud del bot 2"),
								"params"	=>	array("data-loc2-custom"=>"lng"),
								"visible"	=>	false
							),
				"bot3"	=>	array(
								"nombre"	=>	__("Bot 3"), 
								"tipo"		=>	"string", 
								"input"		=>	"mplaybotslist", 
								"icono"		=>	"BT", 
								"descripcion"	=>	__("Bot 3 de la misión"),
								"params"	=>	array("solo_invisibles"=>"true"),
								"visible"	=>	false
							),
				"latlng3"	=>	array(
								"nombre"	=>	__("Coordenadas del bot 3"), 
								"tipo"		=>	"string", 
								"input"		=>	"geocomplete", 
								"icono"		=>	"CB3", 
								"descripcion"	=>	__("Coordenadas del bot 3"),
								"params"	=>	array("class"=>"form-control", "data-input-lat"=>"#ext_misiones_detalles__propiedades__lat3_", "data-input-lng"=>"#ext_misiones_detalles__propiedades__lng3_", "data-atributo-detalles"=>"data-loc3-custom"),
								"visible"	=>	false
							), 
				"lat3"	=>	array(
								"nombre"	=>	__("Latitud de la zona de activación"), 
								"tipo"		=>	"string", 
								"input"		=>	"hidden", 
								"icono"		=>	"LTA3", 
								"descripcion"	=>	__("Latitud del bot 3"),
								"params"	=>	array("data-loc3-custom"=>"lat"),
								"visible"	=>	false
							),
				"lng3"	=>	array(
								"nombre"	=>	__("Longitud de la zona de activación"), 
								"tipo"		=>	"string", 
								"input"		=>	"hidden", 
								"icono"		=>	"LNA3", 
								"descripcion"	=>	__("Longitud del bot 3"),
								"params"	=>	array("data-loc3-custom"=>"lng"),
								"visible"	=>	false
							),
				"tiempo"	=>	array(
								"nombre"	=>	__("Tiempo límite (en minutos)"), 
								"tipo"		=>	"string", 
								"input"		=>	"number", 
								"icono"		=>	"TM", 
								"descripcion"	=>	__("Tiempo límite en minutos para completar la misión"), 
								"params"	=>	array("class"=>"form-control")
							),
				"jsfunc"	=>	array(
								"nombre"	=>	__("Función JS de la misión"), 
								"tipo"		=>	"string", 
								"input"		=>	"hidden", 
								"icono"		=>	"JS", 
								"descripcion"	=>	__("Función JS de la misión"),
								"valor"		=>	"MPlayBotsMission",
								"value"		=>	"MPlayBotsMission",
								"params"	=>	array("valor"=>"MPlayBotsMission", "value"=>"MPlayBotsMission"),
								"visible"	=>	false
							)
						);
						
		parent::__construct($options);
	}
	
	public function process_start_mission($datos){
		if (!Usuario::isLoged())
			return false;
			
		$usr_obj = Usuario::getLoged();
		$usr_id = $usr_obj->id;
		
		$propiedades_mision = $datos['propiedades_mision'];
		$tipo_mision = $datos['tipo_mision'];
		
		if (empty($propiedades_mision) || empty($tipo_mision))
			return false;
			
		if ($tipo_mision != 'bots')
			return false;
			
		e_include('ext_mplay/class/mplayBot');
		$bots_mision = array();
		
		if (!empty($propiedades_mision['bot1']))
			$bots_mision[] = array('id'=>$propiedades_mision['bot1'], 'lat'=>$propiedades_mision['lat1'], 'lng'=>$propiedades_mision['lng1']);
			
		if (!empty($propiedades_mision['bot2']))
			$bots_mision[] = array('id'=>$propiedades_mision['bot2'], 'lat'=>$propiedades_mision['lat2'], 'lng'=>$propiedades_mision['lng2']);
			
		if (!empty($propiedades_mision['bot3']))
			$bots_mision[] = array('id'=>$propiedades_mision['bot3'], 'lat'=>$propiedades_mision['lat3'], 'lng'=>$propiedades_mision['lng3']);
			
		$bots_procesados = array();
			
		if (is_array($bots_mision) && sizeof($bots_mision) > 0){
			foreach ($bots_mision as $bot_orig){
				$model_bot = new MplayBot();
				$model_bot->setid($bot_orig['id']);
				if ($model_bot = $model_bot->BuscarId()){
					$update_vars_bot = $model_bot->get('update_vars');
					$bot_new = new MplayBot();
					foreach ($update_vars_bot as $var){
						$bot_new->$var = $model_bot->$var;
					}
					$bot_new->propietario = '-'.$usr_id;
					$bot_new->estado = 1;
					$bot_new->visibilidad = 0;
					if (!empty($bot_orig['lat'])){
						$bot_new->latitud = $bot_orig['lat'];
					}
					if (!empty($bot_orig['lng'])){
						$bot_new->longitud = $bot_orig['lng'];
					}
					$items_model = $model_bot->getitems();
					if ($id_new_bot = $bot_new->Guardar()){
						$bot_new_mdl = array('id'=>$id_new_bot, 'nombre'=>SistemaIdioma::Imprimir($bot_new->nombre), 'descripcion'=>SistemaIdioma::Imprimir($bot_new->descripcion), 'propiedades'=>Helpers::toArray(json_decode($bot_new->propiedades)));
						if (is_array($items_model) && sizeof($items_model) > 0){
							foreach ($items_model as $im){
								$update_vars_item = $im->get('update_vars');
								$item_new = new MplayItem();
								foreach ($update_vars_item as $var){
									$item_new->$var = $im->$var;
								}
								$item_new->sitio = 0;
								$item_new->propietario = 0;
								$item_new->bot = $id_new_bot;
								$item_new->estado = 1;
								$item_new->visibilidad = 1;
								$item_new->fecha_recogido = strftime("%Y-%m-%d %H:%M:%S", time());
								$item_new->model_id = $im->id;
								$item_new->latitud = $bot_new->latitud;
								$item_new->longitud = $bot_new->longitud;
								if ($id_new_item = $item_new->Guardar()){
									$bot_new_mdl['items'][] = array('id'=>$id_new_item, 'nombre'=>SistemaIdioma::Imprimir($item_new->nombre), 'descripcion'=>SistemaIdioma::Imprimir($item_new->descripcion), 'icono'=>$item_new->geticono(256,256), 'tipo'=>$item_new->tipo, 'propiedades'=>Helpers::toArray(json_decode($item_new->propiedades)));
								}
							}
						}
						$bots_procesados[] = $bot_new_mdl;
					}
				}
			}
		}
		
		$datos['bots_mision'] = $bots_procesados;
		
		return $datos;
	}
	
	function addScriptMission(){
		return $GLOBALS['AppDoc']->addScriptDeclaration('
		var trMPlayBotsMission = [];
		
		function MPlayBotsMission(datos){
			if (MPlayJuegos.bots_mision == undefined){
				MPlayJuegos.bots_mision = [];
			}
			MPlayJuegos.bots_mision[datos.id_mision] = datos.bots_mision;
			var num_bots = MPlayJuegos.bots_mision.length;
			
			if (MPlayJuegos.timeoutMPlayBotsMission == undefined){
				MPlayJuegos.timeoutMPlayBotsMission = [];
			}
						
			if (num_bots > 0){
				var jq_info = "#mplay-ui-info-mission-"+datos.id_mision;
				$(jq_info).removeClass("hide").html("<i class=\'fa fa-user\'></i> 0/"+num_bots.toString());
			}
			
			if (datos.propiedades_mision.tiempo != undefined && datos.propiedades_mision.tiempo != ""){
				trMPlayBotsMission[datos.id_mision] = parseInt(datos.propiedades_mision.tiempo * 60);
				var jq_timer = "#mplay-ui-timer-mission-"+datos.id_mision;
				$(jq_timer).removeClass("hide").html("<i class=\'fa fa-clock-o\'></i> "+MideasFunciones.formatoHora(trMPlayBotsMission[datos.id_mision]));
			}
						
			MPlayJuegos.timeoutMPlayBotsMission[datos.id_mision] = setInterval(timerMPlayBotsMission, 1000, datos);
		}
		function timerMPlayBotsMission(datos){
			var num_bots = MPlayJuegos.bots_mision[datos.id_mision].length;
			
			if (trMPlayBotsMission[datos.id_mision] != null){
				var jq_timer = "#mplay-ui-timer-mission-"+datos.id_mision;
				if (!$(jq_timer).is(":visible")){
					$(jq_timer).show();
				}
				$(jq_timer).html("<i class=\'fa fa-clock-o\'></i> "+MideasFunciones.formatoHora(trMPlayBotsMission[datos.id_mision]));
				if (trMPlayBotsMission[datos.id_mision] <= 0){
					MPlayJuegos.mission_expired(datos);
					clearInterval(MPlayJuegos.timeoutMPlayBotsMission[datos.id_mision]);
					$(jq_timer).hide();
				} else {
					trMPlayBotsMission[datos.id_mision] = trMPlayBotsMission[datos.id_mision] - 1;
				}
			}
			
			var num_derrotados = 0;
			if (MPlayBotBatalla.bots_derrotados != undefined && MPlayBotBatalla.bots_derrotados.length > 0){
				$.each(MPlayJuegos.bots_mision[datos.id_mision], function(idxb, eleb){
					if ($.inArray(eleb.id.toString(), MPlayBotBatalla.bots_derrotados) != -1){
						num_derrotados = num_derrotados + 1;
					}
				});
			}
			
			var jq_info = "#mplay-ui-info-mission-"+datos.id_mision;
			$(jq_info).removeClass("hide").html("<i class=\'fa fa-user\'></i> "+num_derrotados.toString()+"/"+num_bots.toString());
			
			if (num_derrotados == num_bots){
				var jq_info = "#mplay-ui-info-mission-"+datos.id_mision;
				$(jq_info).addClass("hide").html("");
				if (MPlayJuegos.bots_mision[datos.id_mision] != undefined){
					$.each(MPlayJuegos.bots_mision[datos.id_mision], function(idx, ele){
						MPlayBot.del_bot(ele.id);
					});
				}
				MPlayJuegos.mission_completed(datos);
				clearInterval(MPlayJuegos.timeoutMPlayBotsMission[datos.id_mision]);
			}
		}
		function MPlayBotsMissionDel(idm){
			if (MPlayJuegos.bots_mision[idm] != undefined){
				$.each(MPlayJuegos.bots_mision[idm], function(idx, ele){
					MPlayBot.del_bot(ele.id);
				});
			}
			var jq_info = "#mplay-ui-info-mission-"+idm;
			$(jq_info).addClass("hide").html("");
			clearInterval(MPlayJuegos.timeoutMPlayBotsMission[idm]);
		}
		');
	}
}