<?php
/**
 * @package     Mideas.mPlay
 * @subpackage  Item
 *
 * @copyright   Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE
 */

defined('CONF_URL_APP') or die;

class MplayMisionTipoConseguir_items extends MplayMisionTipo
{
	protected $name = 'Conseguir items';
	protected $description = 'Misión que consiste en conseguir los items propuestos';
	
	protected $acciones_mapa = array('comenzar','ir');
	
	public function __construct($options=array()){
		$this->propiedades = array(
				"items"	=>	array(
								"nombre"	=>	__("Items"), 
								"tipo"		=>	"string", 
								"input"		=>	"mplayitemslist", 
								"icono"		=>	"IT", 
								"descripcion"	=>	__("Items de la misión"),
								"params"	=>	array("multiple"=>"true","models_only"=>"true"),
								"visible"	=>	false
							),
				"condicion"	=>	array(
								"nombre"	=>	__("Condición"), 
								"tipo"		=>	"string",
								"input"		=>	"list",
								"icono"		=>	"CD",
								"descripcion"	=>	__("Condición de la misión"),
								"visible"	=>	false,
								"params"	=>	array("opciones" => array("todos"=>__('Conseguir todos los items'), "alguno"=>__('Conseguir al menos un item')))
							),
				"tiempo"	=>	array(
								"nombre"	=>	__("Tiempo límite (en minutos)"), 
								"tipo"		=>	"string", 
								"input"		=>	"number", 
								"icono"		=>	"TM", 
								"descripcion"	=>	__("Tiempo límite en minutos para completar la misión"), 
								"params"	=>	array("class"=>"form-control")
							),
				"jsfunc"	=>	array(
								"nombre"	=>	__("Función JS de la misión"), 
								"tipo"		=>	"string", 
								"input"		=>	"hidden", 
								"icono"		=>	"JS", 
								"descripcion"	=>	__("Función JS de la misión"),
								"valor"		=>	"MPlayConseguir_itemsMission",
								"value"		=>	"MPlayConseguir_itemsMission",
								"params"	=>	array("valor"=>"MPlayConseguir_itemsMission", "value"=>"MPlayConseguir_itemsMission"),
								"visible"	=>	false
							)
						);
						
		parent::__construct($options);
	}
	
	/*public function process_start_mission($datos){
		if (!Usuario::isLoged())
			return false;
			
		$usr_obj = Usuario::getLoged();
		$usr_id = $usr_obj->id;
		
		$propiedades_mision = $datos['propiedades_mision'];
		$tipo_mision = $datos['tipo_mision'];
		
		if (empty($propiedades_mision) || empty($tipo_mision))
			return false;
			
		if ($tipo_mision != 'bots')
			return false;
			
		e_include('ext_mplay/class/mplayBot');
		$bots_mision = array();
		
		if (!empty($propiedades_mision['bot1']))
			$bots_mision[] = array('id'=>$propiedades_mision['bot1'], 'lat'=>$propiedades_mision['lat1'], 'lng'=>$propiedades_mision['lng1']);
			
		if (!empty($propiedades_mision['bot2']))
			$bots_mision[] = array('id'=>$propiedades_mision['bot2'], 'lat'=>$propiedades_mision['lat2'], 'lng'=>$propiedades_mision['lng2']);
			
		if (!empty($propiedades_mision['bot3']))
			$bots_mision[] = array('id'=>$propiedades_mision['bot3'], 'lat'=>$propiedades_mision['lat3'], 'lng'=>$propiedades_mision['lng3']);
			
		$bots_procesados = array();
			
		if (is_array($bots_mision) && sizeof($bots_mision) > 0){
			foreach ($bots_mision as $bot_orig){
				$model_bot = new MplayBot();
				$model_bot->setid($bot_orig['id']);
				if ($model_bot = $model_bot->BuscarId()){
					$update_vars_bot = $model_bot->get('update_vars');
					$bot_new = new MplayBot();
					foreach ($update_vars_bot as $var){
						$bot_new->$var = $model_bot->$var;
					}
					$bot_new->propietario = '-'.$usr_id;
					$bot_new->estado = 1;
					$bot_new->visibilidad = 0;
					if (!empty($bot_orig['lat'])){
						$bot_new->latitud = $bot_orig['lat'];
					}
					if (!empty($bot_orig['lng'])){
						$bot_new->longitud = $bot_orig['lng'];
					}
					$items_model = $model_bot->getitems();
					if ($id_new_bot = $bot_new->Guardar()){
						$bot_new_mdl = array('id'=>$id_new_bot, 'nombre'=>SistemaIdioma::Imprimir($bot_new->nombre), 'descripcion'=>SistemaIdioma::Imprimir($bot_new->descripcion), 'propiedades'=>Helpers::toArray(json_decode($bot_new->propiedades)));
						if (is_array($items_model) && sizeof($items_model) > 0){
							foreach ($items_model as $im){
								$update_vars_item = $im->get('update_vars');
								$item_new = new MplayItem();
								foreach ($update_vars_item as $var){
									$item_new->$var = $im->$var;
								}
								$item_new->sitio = 0;
								$item_new->propietario = 0;
								$item_new->bot = $id_new_bot;
								$item_new->estado = 1;
								$item_new->visibilidad = 1;
								$item_new->fecha_recogido = strftime("%Y-%m-%d %H:%M:%S", time());
								$item_new->model_id = $im->id;
								$item_new->latitud = $bot_new->latitud;
								$item_new->longitud = $bot_new->longitud;
								if ($id_new_item = $item_new->Guardar()){
									$bot_new_mdl['items'][] = array('id'=>$id_new_item, 'nombre'=>SistemaIdioma::Imprimir($item_new->nombre), 'descripcion'=>SistemaIdioma::Imprimir($item_new->descripcion), 'icono'=>$item_new->geticono(256,256), 'tipo'=>$item_new->tipo, 'propiedades'=>Helpers::toArray(json_decode($item_new->propiedades)));
								}
							}
						}
						$bots_procesados[] = $bot_new_mdl;
					}
				}
			}
		}
		
		$datos['bots_mision'] = $bots_procesados;
		
		return $datos;
	}*/
	
	function addScriptMission(){
		return $GLOBALS['AppDoc']->addScriptDeclaration('
		var trMPlayConseguir_itemsMission = [];
		
		function MPlayConseguir_itemsMission(datos){
			if (MPlayJuegos.items_mision == undefined){
				MPlayJuegos.items_mision = [];
			}
			MPlayJuegos.items_mision[datos.id_mision] = datos.propiedades_mision.items;
			var num_items = MPlayJuegos.items_mision[datos.id_mision].length;
			
			if (MPlayJuegos.timeoutMPlayConseguir_itemsMission == undefined){
				MPlayJuegos.timeoutMPlayConseguir_itemsMission = [];
			}
						
			if (num_items > 0){
				var jq_info = "#mplay-ui-info-mission-"+datos.id_mision;
				$(jq_info).removeClass("hide").html("<i class=\'fa fa-suitcase\'></i> 0/"+num_items.toString());
			}
			
			if (datos.propiedades_mision.tiempo != undefined && datos.propiedades_mision.tiempo != ""){
				trMPlayConseguir_itemsMission[datos.id_mision] = parseInt(datos.propiedades_mision.tiempo * 60);
				var jq_timer = "#mplay-ui-timer-mission-"+datos.id_mision;
				$(jq_timer).removeClass("hide").html("<i class=\'fa fa-clock-o\'></i> "+MideasFunciones.formatoHora(trMPlayConseguir_itemsMission[datos.id_mision]));
			}
						
			MPlayJuegos.timeoutMPlayConseguir_itemsMission[datos.id_mision] = setInterval(timerMPlayConseguir_itemsMission, 1000, datos);
		}
		function timerMPlayConseguir_itemsMission(datos){
			var num_items = MPlayJuegos.items_mision[datos.id_mision].length;
			
			if (trMPlayConseguir_itemsMission[datos.id_mision] != null){
				var jq_timer = "#mplay-ui-timer-mission-"+datos.id_mision;
				if (!$(jq_timer).is(":visible")){
					$(jq_timer).show();
				}
				$(jq_timer).html("<i class=\'fa fa-clock-o\'></i> "+MideasFunciones.formatoHora(trMPlayConseguir_itemsMission[datos.id_mision]));
				if (trMPlayConseguir_itemsMission[datos.id_mision] <= 0){
					MPlayJuegos.mission_expired(datos);
					clearInterval(MPlayJuegos.timeoutMPlayConseguir_itemsMission[datos.id_mision]);
					$(jq_timer).hide();
				} else {
					trMPlayConseguir_itemsMission[datos.id_mision] = trMPlayConseguir_itemsMission[datos.id_mision] - 1;
				}
			}
			
			var num_conseguidos = 0;
			var inv_array = $.makeArray(MPlayUsuario.inventario);
			
			if (inv_array != undefined && inv_array.length > 0){
				$.each(inv_array, function(idxi, elei){
					if ($.inArray(elei.model.toString(), datos.propiedades_mision.items) != -1){
						num_conseguidos = num_conseguidos + 1;
					}
				});
			}
			
			var jq_info = "#mplay-ui-info-mission-"+datos.id_mision;
			$(jq_info).removeClass("hide").html("<i class=\'fa fa-suitcase\'></i> "+num_conseguidos.toString()+"/"+num_items.toString());
						
			if ((datos.propiedades_mision.condicion == "alguno" && num_conseguidos > 0) || num_conseguidos == num_items){
				var jq_info = "#mplay-ui-info-mission-"+datos.id_mision;
				$(jq_info).addClass("hide").html("");
				if (MPlayJuegos.items_mision[datos.id_mision] != undefined){
					delete MPlayJuegos.items_mision[datos.id_mision];
				}
				MPlayJuegos.mission_completed(datos);
				clearInterval(MPlayJuegos.timeoutMPlayConseguir_itemsMission[datos.id_mision]);
			}
		}
		function MPlayConseguir_itemsMissionDel(idm){
			var jq_info = "#mplay-ui-info-mission-"+idm;
			$(jq_info).addClass("hide").html("");
			clearInterval(MPlayJuegos.timeoutMPlayConseguir_itemsMission[idm]);
		}
		');
	}
}