<?php
defined('CONF_URL_APP') or die;

class MplayBot extends EntidadModel {
	
	protected $dbt_const = "DBT_MPLAY_BOTS";
    protected $dbt = "mplay_bots";
    protected $ext_folder = "ext_mplay";
    protected $all_vars = array("id", "nombre", "descripcion", "tipo", "icono", "avatar", "estado", "creador", "propietario", "fecha", "propiedades", "params", "idioma", "visibilidad", "radio", "latitud", "longitud", "location", "model_id");
    protected $idx_vars = array("id");
    protected $update_vars = array("nombre", "descripcion", "tipo", "icono", "avatar", "estado", "creador", "propietario", "propiedades", "params", "idioma", "visibilidad", "radio", "latitud", "longitud", "location", "model_id");
    protected $ignore_vars = array("dbt_const", "dbt", "ext_folder", "ext_vista_categoria", "ext_vista_item", "ext_item_class", "ext_categoria_class", "ext_item_campoextra_class", "all_vars", "idx_vars", "update_vars", "ignore_vars", "campos_multilang", "campos_array");
    protected $campos_multilang = array("nombre", "descripcion");
    protected $campos_array = array("propiedades", "params");
	
	function includes(){
		e_include('ext_mplay/class/mplayBotTipo','ext_mplay/class/mplayItem','ext_mplay/class/helpers/mplayUsuarioHelper');
	}
	
	private function filtroEntrada($contenido) {
        return (Helpers::mres(Helpers::from_utf8($contenido)));
    }

    private function filtroSalida($contenido) {
        return (Helpers::to_utf8($contenido));
    }
	
	function getmodel(){
		if (empty($this->model_id))
			return false;
			
		return MplayBot::retrieve_model($this->model_id);
	}
	
	private static function retrieve_model($model_id){
		if (empty($model_id))
			return false;
			
		$mod_id = $model_id;
		$mod = new MplayBot();
		$mod->setid($model_id);
		if ($mod = $mod->BuscarId()){
			if (empty($mod->model_id)){
				return $mod->id;
			} else {
				$mod_id = MplayBot::retrieve_model($mod->model_id);
			}
		} else {
			return false;
		}
		
		return $mod_id;
	}
	
	function geticono($ancho = '', $alto = '') {
        if (empty($ancho) || empty($alto)) {
            $ancho = '200';
            $alto = '100';
        }

        if (!empty($this->icono)) {
            return Helpers::generateImageLink($this->icono, $ancho, $alto);
        } else {
            $params_item = Helpers::toArray(json_decode($this->params));

            $contenido = SistemaIdioma::Imprimir($this->descripcion);
            $imagen_destacada = Helpers::extraer_imagenes($contenido);

            if (!empty($imagen_destacada)) {
                return Helpers::generateImageLink($imagen_destacada, $ancho, $alto);
            } else {
                return '';
            }
        }
    }
	
	function getavatar($ancho = '', $alto = '') {
        if (empty($ancho) || empty($alto)) {
            $ancho = '200';
            $alto = '100';
        }

        if (!empty($this->avatar)) {
            return Helpers::generateImageLink($this->avatar, $ancho, $alto);
        } else {
            $params_item = Helpers::toArray(json_decode($this->params));

            $contenido = SistemaIdioma::Imprimir($this->descripcion);
            $imagen_destacada = Helpers::extraer_imagenes($contenido);

            if (!empty($imagen_destacada)) {
                return Helpers::generateImageLink($imagen_destacada, $ancho, $alto);
            } else {
                return '';
            }
        }
    }
	
	function getcreador($print = false, $objeto = false) {
        if ($print == false) {
            return $this->creador;
        } else {
            if (!empty($this->creador_alias) && $objeto == false) {
                return $this->creador_alias;
            } else {
                if (substr($this->creador, 0, 1) == '-') {
                    $c = substr($this->creador, 1);
                } else {
                    $c = $this->creador;
                }
                c_include('usuario');

                if (is_object($GLOBALS["site"]["usuarios"][$c])) {
                    if ($objeto == true)
                        return $GLOBALS["site"]["usuarios"][$c];
                    else
                        return $GLOBALS["site"]["usuarios"][$c]->getnombre_completo();
                }

                $c_obj = new Usuario();
                $c_obj->setid($c);

                if ($c_obj = $c_obj->BuscarId()) {
                    $GLOBALS["site"]["usuarios"][$c] = $c_obj;
                    if ($objeto == true)
                        return $c_obj;
                    else
                        return $c_obj->getnombre_completo();
                } else {
                    return $this->creador;
                }
            }
        }
    }
	
	function getpropietario($print = false, $objeto = false) {
        if (!in_array('propietario', $this->all_vars))
            return false;

        if ($print == false) {
            return $this->propietario;
        } else {
            if (substr($this->propietario, 0, 1) == '-') {
                $c = substr($this->propietario, 1);
            } else {
                $c = $this->propietario;
            }
            c_include('usuario');

            if (is_object($GLOBALS["site"]["usuarios"][$c])) {
                if ($objeto == true)
                    return $GLOBALS["site"]["usuarios"][$c];
                else
                    return $GLOBALS["site"]["usuarios"][$c]->getnombre_completo();
            }

            $c_obj = new Usuario();
            $c_obj->setid($c);
            if ($c_obj = $c_obj->BuscarId()) {
                $GLOBALS["site"]["usuarios"][$c] = $c_obj;
                if ($objeto == true)
                    return $c_obj;
                else
                    return $c_obj->getnombre_completo();
            } else {
                return $this->propietario;
            }
        }
    }
	
	function get_distancia($formateada = false) {
        if (!empty($this->distancia)) {
            $dist = $this->distancia;

            if ($formateada == true) {
                if ($this->distancia < 1) {
                    $dist = number_format($this->distancia * 1000, 0);
                    $dist .= ' ' . __('metros');
                } else {
                    $dist = number_format($this->distancia, 2, ',', '.');
                    $dist .= ' ' . __('kms.');
                }
            }

            return $dist;
        } else {
            return false;
        }
    }
	
	function ListarCountPorLocalizacion($latitud = 40.416812493264125, $longitud = -3.703293800354004, $radio = 1, $limit1 = 0, $limit2 = 0, $extra_where = array()) {
		$append = '';
		
        $where = '';

        if (is_array($extra_where) && sizeof($extra_where) > 0) {
            $where = ' WHERE ';
            $where .= implode(' AND ', $extra_where);
            if (!empty($keyword_where)) {
                $where .= ' AND ' . $keyword_where;
            }
        }

        $link = new DB();
        $sql = "SELECT COUNT(*) AS num FROM " . constant($this->dbt_const) . " i " . $where . " AND ( 6371 * acos( cos( radians(" . $latitud . ") ) * cos( radians( i.latitud ) ) * cos( radians( i.longitud ) - radians(" . $longitud . ") ) + sin( radians(" . $latitud . ") ) * sin( radians( i.latitud ) ) ) ) < " . $radio ;
		
        $res = $link->Query($sql);
        $num = $link->FetchArray($res);
        $num = $num['num'];
        $link->Desconectar();
        return $num;
    }

    function ListarPorLocalizacion($latitud = 40.416812493264125, $longitud = -3.703293800354004, $radio = 1, $limit1 = 0, $limit2 = 0, $extra_where = array(), $extra_append) {
		$append = '';
		
        $where = '';

        if (is_array($extra_where) && sizeof($extra_where) > 0) {
            $where = ' WHERE ';
            $where .= implode(' AND ', $extra_where);
            if (!empty($keyword_where)) {
                $where .= ' AND ' . $keyword_where;
            }
        }

        $append .= $extra_append;
		
        $link = new DB();
        $i = 0;
        $sql = "SELECT *, ( 6371 * acos( cos( radians(" . $latitud . ") ) * cos( radians( i.latitud ) ) * cos( radians( i.longitud ) - radians(" . $longitud . ") ) + sin( radians(" . $latitud . ") ) * sin( radians( i.latitud ) ) ) ) AS distancia" . $append . " FROM " . constant($this->dbt_const) . " i " . $where . " HAVING distancia < " . $radio . " ORDER BY distancia";
        if (!empty($limit1) || !empty($limit2)) {
            $sql .= " LIMIT " . $limit1 . " , " . $limit2 . ";";
        }
		
        $res = $link->Query($sql);
        while ($x = $link->FetchArray($res)) {
            $aux = new self();
            //$a   = get_class_vars(get_class($this));
            $a = $aux->get_classvars();
            foreach ($a as $clave) {
                if (!in_array($clave, $this->ignore_vars)) {
                    $aux->$clave = $this->filtroSalida($x[$clave]);
                }
            }
			
			$array[$i] = new self();
            $array[$i] = $aux;
			$array[$i]->distancia = $x["distancia"];
			
			if (!empty($array[$i]->id_usuario)){
				$usr_obj = new Usuario();
				$usr_obj->setid($array[$i]->id_usuario);
				
				if ($usr_obj = $usr_obj->BuscarId()){
					$array[$i]->usuario_obj = $usr_obj;
				}
			} else {
				$array[$i]->usuario_obj = null;
			}
			
			$i++;
        }
        $link->Desconectar();

        if ($i == 0) {
            return false;
        } else {
            return $array;
        }
    }
	
	public static function getTypes()
	{
		e_include('ext_mplay/class/mplayBotTipo');
		
		$dir = dirname(__FILE__) . '/bots';
		$handlers = Helpers::dir_list($dir,'','.php',false);
		$handlers = $handlers[dirname(__FILE__) . '/bots'];
		
		$names = array();
		foreach ($handlers as $handler)
		{
			$name = substr($handler, 0, strrpos($handler, '.'));
			$class = 'MplayBotTipo' . $name;

			if (!class_exists($class))
			{
				include_once dirname(__FILE__) . '/bots/' . $name . '.php';
			}

			if (call_user_func_array(array(trim($class), 'test'), array()))
			{
				$names[] = $name;
			}
		}

		return $names;
	}
	
	function printDeleteButton($filename = null, $plantilla = '') {
        if (empty($this->id) || $filename == null)
            return false;

        $output = '';

        if (empty($plantilla)) {
            $output .= '<a id="deleteButton_' . $this->id . '" href="javascript:;"><img src="' . CONF_URL_APP_ADMIN . CONF_DIR_THEMES_ADMIN . '/' . TEMPLATE_ADMIN . '/' . 'gfx/icon-delete.gif" alt="' . __('Borrar bot') . '" title="' . __('Borrar bot') . '" /></a>';
        } else {
            $aid = "deleteButton_" . $this->id;
            $txt = __('Borrar bot');

            $tmp = str_replace('##ID##', $aid, $plantilla);
            $tmp = str_replace('##TXT##', $txt, $tmp);

            $output .= $tmp;
        }


        $output .= '<script>
		$(document).ready(function(){ 
	$("#deleteButton_' . $this->id . '").click(function(){
		jConfirm("' . __('¿Seguro que quiere borrar el bot de mPlay?') . '", "' . __('Borrar bot') . '", function(r){
			if(r == true){
				$.post("' . $filename . '", { borrar: "true", id: ' . $this->id . ' }, function(data) {
					if ($.trim(data) == "ok") {
						$.jGrowl("' . __('Bot borrado con éxito') . '");
						setTimeout("location.reload(true)", 1000);
						return false;
					} else { 
						$.jGrowl(data);
						return false;
					} 
				});
			}
		});
	});
});
</script>';

        return $output;
    }
	
	function BuscarId($lang, $where = '', $extra_append, $info = true, $lat, $lng) {
        if ($this->id) {
			$idioma_ii = $lang;
			if (empty($idioma_ii)){
				$idioma_ii = SistemaIdioma::getIdiomaSesion();
			}
						
			if (!empty($lat) && !empty($lng)){
				$append = ", ( 6371 * acos( cos( radians(" . $lat . ") ) * cos( radians( latitud ) ) * cos( radians( longitud ) - radians(" . $lng . ") ) + sin( radians(" . $lat . ") ) * sin( radians( latitud ) ) ) ) AS distancia";
			}

            $append .= $extra_append;

            $link = new DB();
            $i = 0;
            $sql = "
					SELECT 
						*" . $append . "
						
					FROM
						" . constant($this->dbt_const) . "
						
					WHERE
						id = " . $this->id . $where;
						
            $res = $link->Query($sql);
            $x = $link->FetchArray($res);
            $aux = new self();
            //$a    = get_class_vars(get_class($this));
            $a = $aux->get_classvars();
            foreach ($a as $clave) {
                if (!in_array($clave, $this->ignore_vars)) {
                    $aux->$clave = $this->filtroSalida($x[$clave]);
                }
            }
            $link->Desconectar();
			$aux->distancia = $x["distancia"];
			
            if (!isset($aux->id)) {
                return false;
            } else {
                return $aux;
            }
        } else {
            return false;
        }
    }
	
	function getitems($only_ids=false, $return_array=false){
		if (is_array($this->items) && sizeof($this->items) > 0){
			if ($only_ids == true){
				$ids = array();
				foreach ($this->items as $it){
					$ids[] = $it->id;
				}
				return $ids;
			} else {
				if ($return_array == true){
					$return = array();
					foreach ($this->items as $it){
						$tipo_item_obj = MplayItemTipo::getInstance($it->tipo, Helpers::toArray(json_decode($it->propiedades)));
						$tmp_item = array('nombre'=>SistemaIdioma::Imprimir($it->nombre), 'descripcion'=>SistemaIdioma::Imprimir($it->descripcion), 'id'=>$it->id, 'tipo'=>$it->tipo, 'icono'=>$it->geticono(256,256), 'propiedades_html'=>$tipo_item_obj->printPropiedadesHtml(' class="col-xs-6"'), 'propiedades'=>$tipo_item_obj->get_propiedades_parsed(), 'opciones'=>$tipo_item_obj->printOpcionesBtns('loot', $it));
						$return[] = $tmp_item;
					}
					return $return;
				} else {
					return $this->items;
				}
			}
		}
		$where = 'estado="1" AND bot="'.$this->id.'"';
		
		$items = new MplayItem();
		$items_c = $items->ListarCount($where, 'fecha_recogido', 'DESC');
		
		if ($items_c > 0){
			$items = $items->Listar($where, 'fecha_recogido', 'DESC');
			
			$this->items = $items;
			
			if ($only_ids == true){
				$ids = array();
				foreach ($items as $it){
					$ids[] = $it->id;
				}
				return $ids;
			} else {
				if ($return_array == true){
					$return = array();
					foreach ($this->items as $it){
						$tipo_item_obj = MplayItemTipo::getInstance($it->tipo, Helpers::toArray(json_decode($it->propiedades)));
						$tmp_item = array('nombre'=>SistemaIdioma::Imprimir($it->nombre), 'descripcion'=>SistemaIdioma::Imprimir($it->descripcion), 'id'=>$it->id, 'tipo'=>$it->tipo, 'icono'=>$it->geticono(256,256), 'propiedades_html'=>$tipo_item_obj->printPropiedadesHtml(' class="col-xs-6"'), 'propiedades'=>$tipo_item_obj->get_propiedades_parsed(), 'opciones'=>$tipo_item_obj->printOpcionesBtns('loot', $it));
						$return[] = $tmp_item;
					}
					return $return;
				} else {
					return $this->items;
				}
			}
		} else {
			$this->items = array();
			return array();
		}
		
	}
	
	function fillItems($fill_empty=true){
		if ($GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['activo'] != '1')
			return false;
			
		$inv_items = (array) $this->getitems(true);
		$max_items = $GLOBALS['opciones']['ext_mplay']['modulos']['modulos']['inventario']['opciones']['max_items_inventario'];
		
		if (empty($max_items))
			$max_items = "6";
			
		$parsed_items = array();
		foreach ($inv_items as $it){
			$parsed_items[] = $it;
		}
		
		if (sizeof($parsed_items) < $max_items && $fill_empty == true){
			$resto_items = $max_items - count($parsed_items);
			
			for ($i = 0; $i < $resto_items; $i ++){
				$parsed_items[] = "";
			}
		} elseif (sizeof($parsed_items) > $max_items){
			array_slice($parsed_items, 0, $max_items);
		}
		
		return $parsed_items;
	}
	
	function printInventarioForm($nombre_campo, $attr){
		$inventario_items = $this->fillItems();

		if (empty($nombre_campo) || !is_array($inventario_items))
			return '';
		
		$tmp_html = '<script>
			var tpl_inv_item = \'<img src="'.CONF_URL_APP.'image.php/uploads/imagenes/templates/bootstrap/noimage.png?width=128&amp;height=128&amp;cropratio=128:128&amp;image='.CONF_URL_APP.'uploads/imagenes/templates/bootstrap/noimage.png" class="img-responsive thumbnail" style="width: 100%;">\';
			</script>
		';

		foreach ($inventario_items as $kopt=>$opt){
			$tmp_html .= '<div '.$attr.'>';
			$tmp_html .= $this->printInvItemInput($nombre_campo.'['.$kopt.']', $opt);
			$tmp_html .= '</div>';
		}

		return $tmp_html;
	}
	
	private function printInvItemInput($nombre_campo=null, $valor){
		if (empty($nombre_campo))
			return '';
			
		$item = new MplayItem();
		if (!empty($valor)){
			$item->setid($valor);
			$item = $item->BuscarId();
			
			$img_inv = $item->geticono(128,128);
			
			$tmp_html = '<div class="relative tip-e" title="'.SistemaIdioma::Imprimir($item->nombre).': '.strip_tags(SistemaIdioma::Imprimir($item->descripcion)).'"><img src="'.$img_inv.'" class="img-responsive thumbnail" style="width: 100%;" />
			<div class="btn-autohide" align="center" style="position: absolute;bottom: 5px;width: 100%;"><a class="btn btn-success btn-xs iframe-config" type="button" href="'.CONF_URL_APP_ADMIN.'?extension=ext_mplay&vista=editar_item&id='.$valor.'&popup=1" title="'.__('Editar item').'"><i class="fa fa-white fa-edit"> </i></a> <a class="handle btn btn-xs btn-default" href="javascript:;"><i class="fa fa-arrows"></i></a> </div></div>
			<input type="hidden" id="'.Helpers::parseaTexto($nombre_campo).'" name="'.$nombre_campo.'" value="'.$valor.'" />';
		} else {
			$img_inv = Helpers::getImagenDesaparecida(128,128);
			
			$tmp_html = '<img src="'.$img_inv.'" class="img-responsive thumbnail" style="width: 100%;" />';
		}
		
		
		
		return $tmp_html;
	}
	
	function setPropBot($prop, $val){
		if (empty($prop))
			return false;
			
		$copy = $this;
			
		$key_prop = $prop;
			
		$params_bot = Helpers::toArray(json_decode($copy->propiedades));

		$params_bot[$key_prop] = $val;
		$copy->setpropiedades(json_encode($params_bot));
		$this->setpropiedades(json_encode($params_bot));
		$copy->Modificar();
		
		return $params_bot[$key_prop];
	}
	
	function setVida($valor){
		return $this->setPropBot('vida', $valor);
	}
	
}