<?php
defined('CONF_URL_APP') or die;

class MplayItem extends EntidadModel {
	
	protected $dbt_const = "DBT_MPLAY_ITEMS";
    protected $dbt = "mplay_items";
    protected $ext_folder = "ext_mplay";
    protected $all_vars = array("id", "nombre", "descripcion", "tipo", "icono", "estado", "creador", "propietario", "sitio", "bot", "fecha", "fecha_recogido", "propiedades", "params", "idioma", "visibilidad", "radio", "latitud", "longitud", "location", "model_id");
    protected $idx_vars = array("id");
    protected $update_vars = array("nombre", "descripcion", "tipo", "icono", "estado", "creador", "propietario", "bot", "fecha_recogido", "propiedades", "params", "sitio", "idioma", "visibilidad", "radio", "latitud", "longitud", "location", "model_id");
    protected $ignore_vars = array("dbt_const", "dbt", "ext_folder", "ext_vista_categoria", "ext_vista_item", "ext_item_class", "ext_categoria_class", "ext_item_campoextra_class", "all_vars", "idx_vars", "update_vars", "ignore_vars", "campos_multilang", "campos_array");
    protected $campos_multilang = array("nombre", "descripcion");
    protected $campos_array = array("propiedades", "params");
	
	function includes(){
		e_include('ext_mplay/class/mplayItemTipo','ext_mplay/class/helpers/mplayUsuarioHelper');
	}
	
	private function filtroEntrada($contenido) {
        return (Helpers::mres(Helpers::from_utf8($contenido)));
    }

    private function filtroSalida($contenido) {
        return (Helpers::to_utf8($contenido));
    }
	
	function getmodel(){
		if (empty($this->model_id))
			return false;
			
		return MplayItem::retrieve_model($this->model_id);
	}
	
	private static function retrieve_model($model_id){
		if (empty($model_id))
			return false;
			
		$mod_id = $model_id;
		$mod = new MplayItem();
		$mod->setid($model_id);
		if ($mod = $mod->BuscarId()){
			if (empty($mod->model_id)){
				return $mod->id;
			} else {
				$mod_id = MplayItem::retrieve_model($mod->model_id);
			}
		} else {
			return false;
		}
		
		return $mod_id;
	}
	
	function geticono($ancho = '', $alto = '') {
        if (empty($ancho) || empty($alto)) {
            $ancho = '200';
            $alto = '100';
        }

        if (!empty($this->icono)) {
            return Helpers::generateImageLink($this->icono, $ancho, $alto);
        } else {
            $params_item = Helpers::toArray(json_decode($this->params));

            $contenido = SistemaIdioma::Imprimir($this->descripcion);
            $imagen_destacada = Helpers::extraer_imagenes($contenido);

            if (!empty($imagen_destacada)) {
                return Helpers::generateImageLink($imagen_destacada, $ancho, $alto);
            } else {
                return '';
            }
        }
    }
	
	function getcreador($print = false, $objeto = false) {
        if ($print == false) {
            return $this->creador;
        } else {
            if (!empty($this->creador_alias) && $objeto == false) {
                return $this->creador_alias;
            } else {
                if (substr($this->creador, 0, 1) == '-') {
                    $c = substr($this->creador, 1);
                } else {
                    $c = $this->creador;
                }
                c_include('usuario');

                if (is_object($GLOBALS["site"]["usuarios"][$c])) {
                    if ($objeto == true)
                        return $GLOBALS["site"]["usuarios"][$c];
                    else
                        return $GLOBALS["site"]["usuarios"][$c]->getnombre_completo();
                }

                $c_obj = new Usuario();
                $c_obj->setid($c);

                if ($c_obj = $c_obj->BuscarId()) {
                    $GLOBALS["site"]["usuarios"][$c] = $c_obj;
                    if ($objeto == true)
                        return $c_obj;
                    else
                        return $c_obj->getnombre_completo();
                } else {
                    return $this->creador;
                }
            }
        }
    }

    function getpropietario($print = false, $objeto = false) {
        if (!in_array('propietario', $this->all_vars))
            return false;

        if ($print == false) {
            return $this->propietario;
        } else {
            if (substr($this->propietario, 0, 1) == '-') {
                $c = substr($this->propietario, 1);
            } else {
                $c = $this->propietario;
            }
            c_include('usuario');

            if (is_object($GLOBALS["site"]["usuarios"][$c])) {
                if ($objeto == true)
                    return $GLOBALS["site"]["usuarios"][$c];
                else
                    return $GLOBALS["site"]["usuarios"][$c]->getnombre_completo();
            }

            $c_obj = new Usuario();
            $c_obj->setid($c);
            if ($c_obj = $c_obj->BuscarId()) {
                $GLOBALS["site"]["usuarios"][$c] = $c_obj;
                if ($objeto == true)
                    return $c_obj;
                else
                    return $c_obj->getnombre_completo();
            } else {
                return $this->propietario;
            }
        }
    }
	
	function getsitio($print = false, $objeto = false) {
        if (!in_array('sitio', $this->all_vars))
            return false;

        if ($print == false) {
            return $this->sitio;
        } else {
            if (substr($this->sitio, 0, 1) == '-') {
                $c = substr($this->sitio, 1);
            } else {
                $c = $this->sitio;
            }
            e_include('ext_sitios/class/sitio');

            if (is_object($GLOBALS["site"]["sitios"][$c])) {
                if ($objeto == true)
                    return $GLOBALS["site"]["sitios"][$c];
                else
                    return $GLOBALS["site"]["sitios"][$c]->titulo_formateado;
            }

            $c_obj = new Sitio();
            $c_obj->setid($c);
            if ($c_obj = $c_obj->BuscarId()) {
                $GLOBALS["site"]["sitios"][$c] = $c_obj;
                if ($objeto == true)
                    return $c_obj;
                else
                    return $c_obj->titulo_formateado;
            } else {
                return $this->sitio;
            }
        }
    }
	
	function get_distancia($formateada = false) {
        if (!empty($this->distancia)) {
            $dist = $this->distancia;

            if ($formateada == true) {
                if ($this->distancia < 1) {
                    $dist = number_format($this->distancia * 1000, 0);
                    $dist .= ' ' . __('metros');
                } else {
                    $dist = number_format($this->distancia, 2, ',', '.');
                    $dist .= ' ' . __('kms.');
                }
            }

            return $dist;
        } else {
            return false;
        }
    }
	
	function ListarCountPorLocalizacion($latitud = 40.416812493264125, $longitud = -3.703293800354004, $radio = 1, $limit1 = 0, $limit2 = 0, $extra_where = array()) {
		$append = '';
		
        $where = '';

        if (is_array($extra_where) && sizeof($extra_where) > 0) {
            $where = ' WHERE ';
            $where .= implode(' AND ', $extra_where);
            if (!empty($keyword_where)) {
                $where .= ' AND ' . $keyword_where;
            }
        }

        $link = new DB();
        $sql = "SELECT COUNT(*) AS num FROM " . constant($this->dbt_const) . " i " . $where . " AND ( 6371 * acos( cos( radians(" . $latitud . ") ) * cos( radians( i.latitud ) ) * cos( radians( i.longitud ) - radians(" . $longitud . ") ) + sin( radians(" . $latitud . ") ) * sin( radians( i.latitud ) ) ) ) < " . $radio ;
		
        $res = $link->Query($sql);
        $num = $link->FetchArray($res);
        $num = $num['num'];
        $link->Desconectar();
        return $num;
    }

    function ListarPorLocalizacion($latitud = 40.416812493264125, $longitud = -3.703293800354004, $radio = 1, $limit1 = 0, $limit2 = 0, $extra_where = array(), $extra_append) {
		$append = '';
		
        $where = '';

        if (is_array($extra_where) && sizeof($extra_where) > 0) {
            $where = ' WHERE ';
            $where .= implode(' AND ', $extra_where);
            if (!empty($keyword_where)) {
                $where .= ' AND ' . $keyword_where;
            }
        }

        $append .= $extra_append;
		
        $link = new DB();
        $i = 0;
        $sql = "SELECT *, ( 6371 * acos( cos( radians(" . $latitud . ") ) * cos( radians( i.latitud ) ) * cos( radians( i.longitud ) - radians(" . $longitud . ") ) + sin( radians(" . $latitud . ") ) * sin( radians( i.latitud ) ) ) ) AS distancia" . $append . " FROM " . constant($this->dbt_const) . " i " . $where . " HAVING distancia < " . $radio . " ORDER BY distancia";
        if (!empty($limit1) || !empty($limit2)) {
            $sql .= " LIMIT " . $limit1 . " , " . $limit2 . ";";
        }
		
        $res = $link->Query($sql);
        while ($x = $link->FetchArray($res)) {
            $aux = new self();
            //$a   = get_class_vars(get_class($this));
            $a = $aux->get_classvars();
            foreach ($a as $clave) {
                if (!in_array($clave, $this->ignore_vars)) {
                    $aux->$clave = $this->filtroSalida($x[$clave]);
                }
            }
			
			$array[$i] = new self();
            $array[$i] = $aux;
			$array[$i]->distancia = $x["distancia"];
			
			if (!empty($array[$i]->id_usuario)){
				$usr_obj = new Usuario();
				$usr_obj->setid($array[$i]->id_usuario);
				
				if ($usr_obj = $usr_obj->BuscarId()){
					$array[$i]->usuario_obj = $usr_obj;
				}
			} else {
				$array[$i]->usuario_obj = null;
			}
			
			$i++;
        }
        $link->Desconectar();

        if ($i == 0) {
            return false;
        } else {
            return $array;
        }
    }
	
	public static function getTypes()
	{
		e_include('ext_mplay/class/mplayItemTipo');
		
		$dir = dirname(__FILE__) . '/items';
		$handlers = Helpers::dir_list($dir,'','.php',false);
		$handlers = $handlers[dirname(__FILE__) . '/items'];
		
		$names = array();
		foreach ($handlers as $handler)
		{
			$name = substr($handler, 0, strrpos($handler, '.'));
			$class = 'MplayItemTipo' . $name;

			if (!class_exists($class))
			{
				include_once dirname(__FILE__) . '/items/' . $name . '.php';
			}

			if (call_user_func_array(array(trim($class), 'test'), array()))
			{
				$names[] = $name;
			}
		}

		return $names;
	}
	
	function printDeleteButton($filename = null, $plantilla = '') {
        if (empty($this->id) || $filename == null)
            return false;

        $output = '';

        if (empty($plantilla)) {
            $output .= '<a id="deleteButton_' . $this->id . '" href="javascript:;"><img src="' . CONF_URL_APP_ADMIN . CONF_DIR_THEMES_ADMIN . '/' . TEMPLATE_ADMIN . '/' . 'gfx/icon-delete.gif" alt="' . __('Borrar item') . '" title="' . __('Borrar item') . '" /></a>';
        } else {
            $aid = "deleteButton_" . $this->id;
            $txt = __('Borrar item');

            $tmp = str_replace('##ID##', $aid, $plantilla);
            $tmp = str_replace('##TXT##', $txt, $tmp);

            $output .= $tmp;
        }


        $output .= '<script>
		$(document).ready(function(){ 
	$("#deleteButton_' . $this->id . '").click(function(){
		jConfirm("' . __('¿Seguro que quiere borrar el item de mPlay?') . '", "' . __('Borrar item') . '", function(r){
			if(r == true){
				$.post("' . $filename . '", { borrar: "true", id: ' . $this->id . ' }, function(data) {
					if ($.trim(data) == "ok") {
						MideasFunciones.Notificar("' . __('Item borrado con éxito') . '");
						setTimeout("location.reload(true)", 1000);
						return false;
					} else { 
						MideasFunciones.Notificar(data);
						return false;
					} 
				});
			}
		});
	});
});
</script>';

        return $output;
    }
	
	function BuscarId($lang, $where = '', $extra_append, $info = true, $lat, $lng) {
        if ($this->id) {
			$idioma_ii = $lang;
			if (empty($idioma_ii)){
				$idioma_ii = SistemaIdioma::getIdiomaSesion();
			}
						
			if (!empty($lat) && !empty($lng)){
				$append = ", ( 6371 * acos( cos( radians(" . $lat . ") ) * cos( radians( latitud ) ) * cos( radians( longitud ) - radians(" . $lng . ") ) + sin( radians(" . $lat . ") ) * sin( radians( latitud ) ) ) ) AS distancia";
			}

            $append .= $extra_append;

            $link = new DB();
            $i = 0;
            $sql = "
					SELECT 
						*" . $append . "
						
					FROM
						" . constant($this->dbt_const) . "
						
					WHERE
						id = " . $this->id . $where;
						
            $res = $link->Query($sql);
            $x = $link->FetchArray($res);
            $aux = new self();
            //$a    = get_class_vars(get_class($this));
            $a = $aux->get_classvars();
            foreach ($a as $clave) {
                if (!in_array($clave, $this->ignore_vars)) {
                    $aux->$clave = $this->filtroSalida($x[$clave]);
                }
            }
            $link->Desconectar();
			$aux->distancia = $x["distancia"];
			
            if (!isset($aux->id)) {
                return false;
            } else {
                return $aux;
            }
        } else {
            return false;
        }
    }
	
	function esta_equipado($tipo_slots, $slot){
		if (!Usuario::isLoged())
			return __('No estás identificado');
			
		//return MplayModulosManager::executeHook('itemIsEquipped', 'bool');
			
		$usr_obj = Usuario::getLoged();
		
		$slots_usr = MplayUsuarioHelper::getSlotsUsr($usr_obj, $tipo_slots);
		
		if ($slots_usr[$slot] == $this->id){
			return true;
		} else {
			return false;
		}
	}
	
	function desequipar(){
		if (!Usuario::isLoged())
			return __('No estás identificado');
			
		return true;
			
		return MplayModulosManager::executeHook('itemUnequip', 'bool');
			
		/*$usr_obj = Usuario::getLoged();
		
		$slots_ropa_usr = MplayUsuarioHelper::getSlotsUsr($usr_obj, 'ropa');
		$slots_armas_usr = MplayUsuarioHelper::getSlotsUsr($usr_obj, 'armas');
		
		$return = false;
		
		if (in_array($this->id, $slots_ropa_usr)){
			foreach ($slots_ropa_usr as $ks=>$s){
				if ($s == $this->id){
					$slots_ropa_usr[$ks] = '';
				}
			}
			
			MplayUsuarioHelper::setPropUsr($usr_obj, 'slots_ropa', $slots_ropa_usr);
			
			$return = true;
		}
		
		if (in_array($this->id, $slots_armas_usr)){
			foreach ($slots_armas_usr as $ks=>$s){
				if ($s == $this->id){
					$slots_armas_usr[$ks] = '';
				}
			}
			
			MplayUsuarioHelper::setPropUsr($usr_obj, 'slots_armas', $slots_armas_usr);
			
			$return = true;
		}
		
		return $return;*/
	}
	
}