<?php
defined('CONF_URL_APP') or die;

class MplayNivelExperiencia extends EntidadModel
{
	
	protected $dbt_const = "DBT_MPLAY_NIVELES_EXPERIENCIA";
	protected $dbt = "mplay_niveles_experiencia";
	
	protected $ext_folder = "ext_mplay";
	
	protected $all_vars = array("id","titulo","contenido","puntos","icono","estado","fecha","params","orden");
	
	protected $idx_vars = array("id");
	protected $update_vars = array("titulo","contenido","puntos","icono","estado","fecha","params","orden");
	
	protected $campos_multilang = array("titulo","contenido");
	protected $campos_array = array("params");
	
	protected $plantilla_info_html = '
                            <div class="panel panel-info" style="margin-top: 10px;"><div class="panel-body">
                            <div class="col-xs-4 col-sm-1 col-md-1 col-lg-1" style="padding-left:0;"> <img class="img-rounded" src="##IMAGEN##" width="100%"> </div>
                            <div class="col-xs-8 col-sm-11 col-md-11 col-lg-11">
            <h4><b>##TITULO##</b></h4>
            <p style="margin-bottom:0;">##CONTENIDO_CORTO##</p>
                            </div>
                            </div></div>';
	
	function __construct(){
		parent::__construct();
	}
	
	function includes(){
		e_include('ext_mplay/class/helpers/mplayUsuarioHelper','ext_mplay/class/mplayItem','ext_mplay/class/mplayRecompensa','ext_mplay/class/mplayRecompensaTipo');
	}
	
    function getLink($url_amigable=false,$lang=null)
    {
        return false;
    }

	public static function checkAll($user_id){
		if (empty($user_id))
			return false;
			
		$usr = new Usuario();
		$usr->setid($user_id);
		
		if ($usr = $usr->BuscarId()){
		} else {
			return false;
		}
			
		$niveles = new MplayNivelExperiencia();
		
		$niveles_c = $niveles->ListarCount('estado=1','orden','ASC');
		
		if ($niveles_c > 0){
			$niveles = $niveles->Listar('estado=1','orden','ASC');
			
			$niveles_conseguidos = array();
			$niveles_conseguidos_ids = array();
			
			$c_news = 0;
			$news = array();
			$suma_puntos = 0;
			foreach ($niveles as $nivel){
				$suma_puntos += $nivel->puntos;
				$cu = $nivel->checkUsuario($user_id, $suma_puntos);

				if ($cu == 'new' && is_string($cu)){
					$c_news++;
					$news[] = array("id"=>$nivel->id, "nombre"=>SistemaIdioma::Imprimir($nivel->titulo), "puntos"=>$nivel->puntos, "orden"=>$nivel->orden);
				}
			}
			
			return $news;
		}
		
		return array();
	}
	
	function checkUsuario($user_id, $puntos_suma){
		if (empty($user_id) || empty($this->id))
			return false;
			
		$nivel_id = $this->id;
			
		c_include('usuario');
		$usr = new Usuario();
		$usr->setid($user_id);
		if ($usr = $usr->BuscarId()){
		} else {
			return false;
		}
		
		$params_nivel = Helpers::toArray(json_decode($this->params));
		$params_usr = Helpers::toArray(json_decode($usr->params));
		
		$puntos_nivel = $this->puntos;
		$orden_nivel = $this->orden;
		
		$orden_activo = 0;
		if ($params_usr['ext_mplay.nivel_experiencia'] > 0){
			$nivel_activo = new MplayNivelExperiencia();
			$nivel_activo->setid($params_usr['ext_mplay.nivel_experiencia']);
			
			if ($nivel_activo = $nivel_activo->BuscarId()){
				$orden_activo = $nivel_activo->orden;
			}
		}
		
		if ($usr->puntos > $puntos_suma || $usr->puntos > ($puntos_suma - $puntos_nivel)){
			if ($params_usr['ext_mplay.nivel_experiencia'] == $nivel_id){
				return true;
			} elseif ($orden_activo < $orden_nivel) {
				MplayUsuarioHelper::setPropUsr($usr, 'nivel_experiencia', $nivel_id);
				
				if (!empty($params_nivel['recompensas']['tipo'])){
					e_include('ext_mplay/class/mplayRecompensaTipo');
					$recompensa_tipo = MplayRecompensaTipo::getInstance($params_nivel['recompensas']['tipo']);
					
					if ($recompensa_tipo instanceof MplayRecompensaTipo){
						$recompensa_aplicada = $recompensa_tipo->aplicar($params_nivel['recompensas']['valor']);
						if ($recompensa_aplicada == true && $params_nivel['generar_actividad_recompensa'] == '1' && !empty($params_nivel['texto_actividad_recompensa'][SistemaIdioma::getIdiomaSesion()])){
							$img_recompensa = '';
							if (!empty($params_nivel['icono_recompensa'])){
								$img_recompensa = Helpers::generateImageLink($params_nivel['icono_recompensa'], 48, 48);
								$img_recompensa = '<img src="'.$img_recompensa.'" width="48" height="48" /> ';
							}
							$txt_actividad = $img_recompensa . $params_nivel['texto_actividad_recompensa'][SistemaIdioma::getIdiomaSesion()];
							$usr->nuevaActividad($txt_actividad, 'new', 0, array("tipo" => 'ext_mplay.recompensa_nivel', "id_tipo" => $nivel_id, "id_recompensa"=>$params_nivel['recompensas']['tipo']));
						}
					}
				}
				
				return 'new';
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
	
	function printDeleteButton($filename = null, $plantilla = '') {
        if (empty($this->id) || $filename == null)
            return false;

        $output = '';

        if (empty($plantilla)) {
            $output .= '<a id="deleteButton_' . $this->id . '" href="javascript:;"><img src="' . CONF_URL_APP_ADMIN . CONF_DIR_THEMES_ADMIN . '/' . TEMPLATE_ADMIN . '/' . 'gfx/icon-delete.gif" alt="' . __('Borrar nivel de experiencia') . '" title="' . __('Borrar nivel de experiencia') . '" /></a>';
        } else {
            $aid = "deleteButton_" . $this->id;
            $txt = __('Borrar item');

            $tmp = str_replace('##ID##', $aid, $plantilla);
            $tmp = str_replace('##TXT##', $txt, $tmp);

            $output .= $tmp;
        }


        $GLOBALS['AppDoc']->AddScriptDeclaration('
		$(document).ready(function(){ 
	$("#deleteButton_' . $this->id . '").click(function(){
		jConfirm("' . __('¿Seguro que quiere borrar el nivel de experiencia de mPlay?') . '", "' . __('Borrar nivel de experiencia') . '", function(r){
			if(r == true){
				$.post("' . $filename . '", { borrar: "true", id: ' . $this->id . ' }, function(data) {
					if ($.trim(data) == "ok") {
						$.jGrowl("' . __('Nivel de experiencia borrado con éxito') . '");
						setTimeout("location.reload(true)", 1000);
						return false;
					} else { 
						$.jGrowl(data);
						return false;
					} 
				});
			}
		});
	});
});');

        return $output;
    }
	
	function prepararParaGuardar($posted_vars = array(), $is_admin = false) {

        if (empty($this->titulo)) {
            return __('¡Error crítico! El logro no tiene título');
        }

        $tmp_titulo_array = (array) json_decode($this->titulo);

        if (!is_array($tmp_titulo_array) || sizeof($tmp_titulo_array) == 0) {
            return __('¡Error crítico! Título con formato desconocido');
        }

        $idioma_item = SistemaIdioma::getIdiomaSesion();
        $idioma_defecto = SistemaIdioma::getIdiomaDefecto();

        foreach ($tmp_titulo_array as $ktlang => $lang_titulo) {
            if (empty($lang_titulo)) {
                if ($idioma_defecto == $ktlang) {
                    return __("¡El logro debe tener un título en el idioma por defecto!");
                } else {
                    $tmp_titulo_array[$lang_titulo] = $tmp_titulo_array[$idioma_defecto];
                }
            }
        }

        $this->settitulo(json_encode($tmp_titulo_array));

        return true;
    }
	
	function imprimir_info_html($plantilla = '') {
		if (empty($plantilla))
			$plantilla = $this->plantilla_info_html;

        if (!empty($this->id)) {
            if (empty($plantilla)) {
                $plantilla = '
                            <div class="panel panel-info" style="margin-top: 10px;"><div class="panel-body">
                            <div class="col-xs-4 col-sm-1 col-md-1 col-lg-1" style="padding-left:0;"> <img class="img-circle" src="##IMAGEN##" width="100%"> </div>
                            <div class="col-xs-8 col-sm-11 col-md-11 col-lg-11">
            <h4><b>##TITULO##</b></h4>
            <p style="margin-bottom:0;">##CONTENIDO_CORTO##</p>
                            </div>
                            </div></div>';
            }

            $output = $this->parsearVariablesItem($plantilla);

            return $output;
        } else {
            return false;
        }
    }
	
	function parsearVariablesItem($txt) {
        if (empty($txt))
            return '';
			
		global $AppTpl;

        $contenido = strip_tags($this->contenido_formateado);
        $contenido_corto = Helpers::recortarTexto($contenido, 150);
		
		$fecha = strftime(SistemaIdioma::formatoFecha('corta'), strtotime($this->fecha));
		
		$fecha_dia = strftime('%d', strtotime($this->fecha));
		$fecha_mes = strftime('%b', strtotime($this->fecha));
		$fecha_anyo = strftime('%Y', strtotime($this->fecha));
		
		$img = Helpers::generateImageLink($this->icono, 300, 300);
		if (empty($img) && is_object($AppTpl)){
			$img = Helpers::generateImageLink($AppTpl->params['noimage'], 300, 300);
		}
		
        $out = str_replace('##TITULO##', SistemaIdioma::Imprimir($this->titulo), $txt);
        $out = str_replace('##ID##', $this->id, $out);
        $out = str_replace('##CONTENIDO##', $contenido, $out);
        $out = str_replace('##CONTENIDO_CORTO##', $contenido_corto, $out);
        $out = str_replace('##IMAGEN##', $img, $out);
		$out = str_replace('##FECHA##', $fecha, $out);
		$out = str_replace('##FECHA_DIA##', $fecha_dia, $out);
		$out = str_replace('##FECHA_MES##', $fecha_mes, $out);
		$out = str_replace('##FECHA_ANYO##', $fecha_anyo, $out);

        return $out;
    }
}
?>