<?php
defined('CONF_URL_APP') or die;

class MplayOficioUsuario extends EntidadModel {
	
	protected $dbt_const = "DBT_MPLAY_OFICIOS";
    protected $dbt = "mplay_oficios";
    protected $ext_folder = "ext_mplay";
    protected $all_vars = array("id", "nombre", "descripcion", "tipo", "icono", "estado", "creador", "fecha", "propiedades", "idioma");
    protected $idx_vars = array("id");
    protected $update_vars = array("nombre", "descripcion", "tipo", "icono", "estado", "creador", "propiedades", "idioma");
    protected $ignore_vars = array("dbt_const", "dbt", "ext_folder", "ext_vista_categoria", "ext_vista_item", "ext_item_class", "ext_categoria_class", "ext_item_campoextra_class", "all_vars", "idx_vars", "update_vars", "ignore_vars", "campos_multilang", "campos_array");
    protected $campos_multilang = array("nombre", "descripcion");
    protected $campos_array = array("propiedades");
	
	function includes(){
		e_include('ext_mplay/class/mplayOficioTipo','ext_mplay/class/helpers/mplayUsuarioHelper');
	}
	
	private function filtroEntrada($contenido) {
        return (Helpers::mres(Helpers::from_utf8($contenido)));
    }

    private function filtroSalida($contenido) {
        return (Helpers::to_utf8($contenido));
    }
	
	function geticono($ancho = '', $alto = '') {
        if (empty($ancho) || empty($alto)) {
            $ancho = '200';
            $alto = '100';
        }

        if (!empty($this->icono)) {
            return Helpers::generateImageLink($this->icono, $ancho, $alto);
        } else {
            $params_item = Helpers::toArray(json_decode($this->params));

            $contenido = SistemaIdioma::Imprimir($this->descripcion);
            $imagen_destacada = Helpers::extraer_imagenes($contenido);

            if (!empty($imagen_destacada)) {
                return Helpers::generateImageLink($imagen_destacada, $ancho, $alto);
            } else {
                return '';
            }
        }
    }
	
	function getcreador($print = false, $objeto = false) {
        if ($print == false) {
            return $this->creador;
        } else {
            if (!empty($this->creador_alias) && $objeto == false) {
                return $this->creador_alias;
            } else {
                if (substr($this->creador, 0, 1) == '-') {
                    $c = substr($this->creador, 1);
                } else {
                    $c = $this->creador;
                }
                c_include('usuario');

                if (is_object($GLOBALS["site"]["usuarios"][$c])) {
                    if ($objeto == true)
                        return $GLOBALS["site"]["usuarios"][$c];
                    else
                        return $GLOBALS["site"]["usuarios"][$c]->getnombre_completo();
                }

                $c_obj = new Usuario();
                $c_obj->setid($c);

                if ($c_obj = $c_obj->BuscarId()) {
                    $GLOBALS["site"]["usuarios"][$c] = $c_obj;
                    if ($objeto == true)
                        return $c_obj;
                    else
                        return $c_obj->getnombre_completo();
                } else {
                    return $this->creador;
                }
            }
        }
	}
	
	public static function getTypes()
	{
		e_include('ext_mplay/class/mplayOficioTipo');
		
		$dir = dirname(__FILE__) . '/oficios';
		$handlers = Helpers::dir_list($dir,'','.php',false);
		$handlers = $handlers[dirname(__FILE__) . '/oficios'];
		
		$names = array();
		foreach ($handlers as $handler)
		{
			$name = substr($handler, 0, strrpos($handler, '.'));
			$class = 'MplayOficioTipo' . $name;

			if (!class_exists($class))
			{
				include_once dirname(__FILE__) . '/oficios/' . $name . '.php';
			}

			if (call_user_func_array(array(trim($class), 'test'), array()))
			{
				$names[] = $name;
			}
		}

		return $names;
	}
	
	function printDeleteButton($filename = null, $plantilla = '') {
        if (empty($this->id) || $filename == null)
            return false;

        $output = '';

        if (empty($plantilla)) {
            $output .= '<a id="deleteButton_' . $this->id . '" href="javascript:;"><img src="' . CONF_URL_APP_ADMIN . CONF_DIR_THEMES_ADMIN . '/' . TEMPLATE_ADMIN . '/' . 'gfx/icon-delete.gif" alt="' . __('Borrar oficio') . '" title="' . __('Borrar oficio') . '" /></a>';
        } else {
            $aid = "deleteButton_" . $this->id;
            $txt = __('Borrar item');

            $tmp = str_replace('##ID##', $aid, $plantilla);
            $tmp = str_replace('##TXT##', $txt, $tmp);

            $output .= $tmp;
        }


        $output .= '<script>
		$(document).ready(function(){ 
	$("#deleteButton_' . $this->id . '").click(function(){
		jConfirm("' . __('¿Seguro que quiere borrar el oficio de mPlay?') . '", "' . __('Borrar oficio') . '", function(r){
			if(r == true){
				$.post("' . $filename . '", { borrar: "true", id: ' . $this->id . ' }, function(data) {
					if ($.trim(data) == "ok") {
						MideasFunciones.Notificar("' . __('Oficio borrado con éxito') . '");
						setTimeout("location.reload(true)", 1000);
						return false;
					} else { 
						MideasFunciones.Notificar(data);
						return false;
					} 
				});
			}
		});
	});
});
</script>';

        return $output;
    }
	
	function aprendido($usr){
		if (!$usr instanceof Usuario)
			return false;
			
		return false;
		
	}
}