<?php
defined('CONF_URL_APP') or die;

abstract class MplayRecompensaTipo
{
	/**
	 * @var    array  SesionStorage instances container.
	 * @since  11.3
	 */
	protected static $instances = array();
	protected $nombre = '';
	
	public static function getInstance($name = 'none', $options = array())
	{
		$name = strtolower(Helpers::parseaTexto($name, true, '_'));
		
		if (empty($name)){
			$name = 'default';
		}

		if (empty(self::$instances[$name]))
		{
			$class = 'MplayRecompensaTipo' . ucfirst($name);

			if (!class_exists($class))
			{
				$path = __DIR__ . '/recompensas/' . $name . '.php';

				if (file_exists($path))
				{
					require_once $path;
				}
				else
				{
					// No attempt to die gracefully here, as it tries to close the non-existing session
					die('Unable to load reward type class: ' . $name);
				}
			}

			self::$instances[$name] = new $class($options);
		}

		return self::$instances[$name];
	}
	
	public function aplicar($valor=null){
		if (empty($valor))
			return false;
			
		return true;
	}
	
	public function quitar($valor=null){
		if (empty($valor))
			return false;
			
		return true;
	}
	
	public function printInput($nombre, $valor){
		if (empty($nombre))
			return '';
			
		$out = '<input type="text" name="'.$nombre.'" value="'.$valor.'" class="form-control" />';
		
		return $out;
	}
	
	public function printHtml($valor, $cls){
		$out = '<div class="mplay-recompensa-info mplay-recompensa-info-'.strtolower($this->nombre).' '.$cls.'">+'.$valor.' '.$this->nombre.'</div>';
		
		return $out;
	}
	
	
	/**
	 * Test to see if the SessionHandler is available.
	 *
	 * @return  boolean  True on success, false otherwise.
	 *
	 * @since   12.1
	 */
	public static function isSupported()
	{
		return true;
	}

	/**
	 * Test to see if the SessionHandler is available.
	 *
	 * @return  boolean  True on success, false otherwise.
	 *
	 * @since   11.1
	 * @deprecated  12.3 (Platform) & 4.0 (CMS) - Use SesionStorage::isSupported() instead.
	 */
	public static function test()
	{
		return static::isSupported();
	}
	
}