<?php
defined('CONF_URL_APP') or die;

class MplayUsuariosActivos extends EntidadModel {
	
	protected $dbt_const = "DBT_MPLAY_USUARIOS_ACTIVOS";
    protected $dbt = "mplay_usuarios_activos";
    protected $ext_folder = "ext_mplay_usuarios_activos";
    protected $all_vars = array("id", "id_usuario", "ip_usuario", "fecha_ultimo_acceso", "latitud", "longitud", "location", "geolocation", "juegos_activos", "misiones_activas", "juegos_finalizados", "misiones_finalizadas");
    protected $idx_vars = array("id");
    protected $update_vars = array("id_usuario", "ip_usuario", "fecha_ultimo_acceso", "latitud", "longitud", "location", "geolocation", "juegos_activos", "misiones_activas", "juegos_finalizados", "misiones_finalizadas");
    protected $ignore_vars = array("dbt_const", "dbt", "ext_folder", "ext_vista_categoria", "ext_vista_item", "ext_item_class", "ext_categoria_class", "ext_item_campoextra_class", "all_vars", "idx_vars", "update_vars", "ignore_vars", "campos_multilang", "campos_array");
    protected $campos_multilang = array();
    protected $campos_array = array("juegos_activos", "misiones_activas", "juegos_finalizados", "misiones_finalizadas");
	
	private function filtroEntrada($contenido) {
        return (Helpers::mres(Helpers::from_utf8($contenido)));
    }

    private function filtroSalida($contenido) {
        return (Helpers::to_utf8($contenido));
    }
	
	function get_distancia($formateada = false) {
        if (!empty($this->distancia)) {
            $dist = $this->distancia;

            if ($formateada == true) {
                if ($this->distancia < 1) {
                    $dist = number_format($this->distancia * 1000, 0);
                    $dist .= ' ' . __('metros');
                } else {
                    $dist = number_format($this->distancia, 2, ',', '.');
                    $dist .= ' ' . __('kms.');
                }
            }

            return $dist;
        } else {
            return false;
        }
    }
	
	function ListarCountPorLocalizacion($latitud = 40.416812493264125, $longitud = -3.703293800354004, $radio = 1, $limit1 = 0, $limit2 = 0, $extra_where = array()) {
		$append = '';
		
        $where = '';

        if (is_array($extra_where) && sizeof($extra_where) > 0) {
            $where = ' WHERE ';
            $where .= implode(' AND ', $extra_where);
            if (!empty($keyword_where)) {
                $where .= ' AND ' . $keyword_where;
            }
        }

        $link = new DB();
        $sql = "SELECT COUNT(*) AS num, ( 6371 * acos( cos( radians(" . $latitud . ") ) * cos( radians( i.latitud ) ) * cos( radians( i.longitud ) - radians(" . $longitud . ") ) + sin( radians(" . $latitud . ") ) * sin( radians( i.latitud ) ) ) ) AS distancia FROM " . constant($this->dbt_const) . " i " . $where . " HAVING distancia < " . $radio . " ORDER BY distancia";
		
        $res = $link->Query($sql);
        $num = $link->FetchArray($res);
        $num = $num['num'];
        $link->Desconectar();
        return $num;
    }

    function ListarPorLocalizacion($latitud = 40.416812493264125, $longitud = -3.703293800354004, $radio = 1, $limit1 = 0, $limit2 = 0, $extra_where = array(), $extra_append) {
		$append = '';
		
        $where = '';

        if (is_array($extra_where) && sizeof($extra_where) > 0) {
            $where = ' WHERE ';
            $where .= implode(' AND ', $extra_where);
            if (!empty($keyword_where)) {
                $where .= ' AND ' . $keyword_where;
            }
        }

        $append .= $extra_append;
		
        $link = new DB();
        $i = 0;
        $sql = "SELECT *, ( 6371 * acos( cos( radians(" . $latitud . ") ) * cos( radians( i.latitud ) ) * cos( radians( i.longitud ) - radians(" . $longitud . ") ) + sin( radians(" . $latitud . ") ) * sin( radians( i.latitud ) ) ) ) AS distancia" . $append . " FROM " . constant($this->dbt_const) . " i " . $where . " HAVING distancia < " . $radio . " ORDER BY distancia";
        if (!empty($limit1) || !empty($limit2)) {
            $sql .= " LIMIT " . $limit1 . " , " . $limit2 . ";";
        }

        $res = $link->Query($sql);
        while ($x = $link->FetchArray($res)) {
            $aux = new self();
            //$a   = get_class_vars(get_class($this));
            $a = $aux->get_classvars();
            foreach ($a as $clave) {
                if (!in_array($clave, $this->ignore_vars)) {
                    $aux->$clave = $this->filtroSalida($x[$clave]);
                }
            }
			
			$array[$i] = new self();
            $array[$i] = $aux;
			$array[$i]->distancia = $x["distancia"];
			
			if (!empty($array[$i]->id_usuario)){
				$usr_obj = new Usuario();
				$usr_obj->setid($array[$i]->id_usuario);
				
				if ($usr_obj = $usr_obj->BuscarId()){
					$array[$i]->usuario_obj = $usr_obj;
				}
			} else {
				$array[$i]->usuario_obj = null;
			}
			
			$i++;
			
        }
        $link->Desconectar();

        if ($i == 0) {
            return false;
        } else {
            return $array;
        }
    }
	
	public static function esta_conectado($usr){
		if (!$usr instanceof Usuario)
			return false;
			
		$mua = new self();
		$fecha_limite = time() - (5 * 60);
		
		$where_mua = "id_usuario='".$usr->id."' AND fecha_ultimo_acceso > ".$fecha_limite;
		
		$mua_chk = $mua->ListarCount($where_mua);
		
		if ($mua_chk == 0){
			return false;
		} elseif ($mua_chk == 1){
			return true;
		} else {
			return true;
		}
	}
	
	public static function getUsrConectado($usr){
		if (!$usr instanceof Usuario)
			return false;
			
		if (!self::esta_conectado($usr))
			return false;
			
		$mua = new self();
		
		$fecha_limite = time() - (5 * 60);
		
		$where_mua = "id_usuario='".$usr->id."' AND fecha_ultimo_acceso > ".$fecha_limite;
		
		$mua = $mua->Listar($where_mua);
		$mua = $mua[0];
		
		return $mua;
	}
	
}