<?php

defined('CONF_URL_APP') or die;

class MplayRecompensaTipoPuntos extends MplayRecompensaTipo
{
	protected $nombre = 'Puntos';
	
	public function aplicar($valor=null){
		if (empty($valor) || !Usuario::isLoged())
			return false;
			
		$usr = Usuario::getLoged();
		
		if (!$usr instanceof Usuario || empty($usr->id))
			return false;
			
		return $usr->nuevaActividad(__('Sumar puntos: ').$valor, 'hide', (int) $valor, array("tipo"=>"ext_mplay.recompensa_aplicada", "id_tipo"=>"puntos"));
	}
	
	public function quitar($valor=null){
		if (empty($valor) || !Usuario::isLoged())
			return false;
			
		$usr = Usuario::getLoged();
		
		if (!$usr instanceof Usuario || empty($usr->id))
			return false;
			
		$usr->nuevaActividad(__('Quitar puntos: -').$valor, 'hide', '-'.(int) $valor, array("tipo"=>"ext_mplay.recompensa_quitada", "id_tipo"=>"puntos"));
	}
	
	public function printInput($nombre, $valor){
		if (empty($nombre))
			return '';
			
		$out = '<input type="number" name="'.$nombre.'" value="'.$valor.'" class="form-control" />';
		
		return $out;
	}
}