<?php
/**
 * @package     Mideas.mPlay
 * @subpackage  Item
 *
 * @copyright   Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE
 */

defined('CONF_URL_APP') or die;

class MplaySitioTipoFormacion extends MplaySitioTipo
{
	protected $name = 'Centro de formación';
	protected $description = 'Sitio donde puedes aprender habilidades y oficios';
	
	protected $acciones_mapa = array('aprender','comprar','vender','ir');
	
	public function __construct($options = array())
	{
		$this->propiedades = array(
									"valor"	=>	array(
										"nombre"	=>	__("Valor"), 
										"tipo"		=>	"int",
										"input"		=>	"number",
										"icono"		=>	"MO",
										"descripcion"	=>	__("Precio de venta del sitio en Monedas de Oro (MO)"),
										"params"	=>	array("class"=>"form-control")
										),
									"habilidades"	=>	array(
										"nombre"	=>	__("Habilidades disponibles"), 
										"tipo"		=>	"int",
										"input"		=>	"mplayhabilidadeslist",
										"icono"		=>	"HA",
										"descripcion"	=>	__("Habilidades que ofrece el sitio"),
										"visible"	=>	false,
										"params"	=>	array("multiple"=>"true")
										),
									"incluir_hijas"	=>	array(
										"nombre"	=>	__("Incluir habilidades hijas"), 
										"tipo"		=>	"string",
										"input"		=>	"list",
										"icono"		=>	"IH",
										"descripcion"	=>	__("Incluir habilidades hijas"),
										"visible"	=>	false,
										"params"	=>	array("opciones"=>array("1"=>__('Sí'), "0"=>__('No')))
										)
		);
		
		parent::__construct($options);
	}
	
}