<?php
/**
 * @package     Mideas.mPlay
 * @subpackage  Item
 *
 * @copyright   Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE
 */

defined('CONF_URL_APP') or die;

class MplaySitioTipoMuseo extends MplaySitioTipo
{
	protected $name = 'Museo';
	protected $description = 'Sitio donde puedes comprar y vender objetos';
	
	protected $acciones_mapa = array('comerciar','comprar','vender','ir');
	
	public function __construct($options = array())
	{
		$this->propiedades = array(
									"valor"	=>	array(
										"nombre"	=>	__("Valor"), 
										"tipo"		=>	"int",
										"input"		=>	"number",
										"icono"		=>	"MO",
										"descripcion"	=>	__("Precio de venta del sitio en Monedas de Oro (MO)"),
										"params"	=>	array("class"=>"form-control")
										),
									"monedas"	=>	array(
										"nombre"	=>	__("MO máximas"), 
										"tipo"		=>	"int",
										"input"		=>	"number",
										"icono"		=>	"MO+",
										"descripcion"	=>	__("Monedas de Oro (MO) máximas que puede usar para comprar objetos de usuarios"),
										"params"	=>	array("class"=>"form-control")
										),
									"margen_ventas"	=>	array(
										"nombre"	=>	__("Margen de ventas"), 
										"tipo"		=>	"int",
										"input"		=>	"number",
										"icono"		=>	"RPV",
										"descripcion"	=>	__("Porcentaje que se incluye en el precio base de los items cuando se venden"),
										"params"	=>	array("class"=>"form-control"),
										"visible"	=>	false
										),
									"descuento_compras"	=>	array(
										"nombre"	=>	__("Descuento de compras"), 
										"tipo"		=>	"int",
										"input"		=>	"number",
										"icono"		=>	"RPV",
										"descripcion"	=>	__("Porcentaje que se descuenta en el precio base de los items cuando la tienda los compra"),
										"params"	=>	array("class"=>"form-control"),
										"visible"	=>	false
										),
									"tipo_items"	=>	array(
										"nombre"	=>	__("Tipo de items aceptados"), 
										"tipo"		=>	"int",
										"input"		=>	"mplaytipoitems",
										"icono"		=>	"TIA",
										"descripcion"	=>	__("Tipo de items aceptados por la tienda"),
										"params"	=>	array("multicheck"=>"true"),
										"visible"	=>	false
										),
									"items"	=>	array(
										"nombre"	=>	__("Objetos a la venta"), 
										"tipo"		=>	"int",
										"input"		=>	"mplayinventariositio",
										"icono"		=>	"RPV",
										"descripcion"	=>	__("Inventario de objetos a la venta que tiene la tienda"),
										"visible"	=>	false,
										"params"	=>	array("class"=>"col-xs-3"),
										"class_div"	=>	"col-xs-8"
										)
		);
		
		parent::__construct($options);
	}
	
}