<?php
/**
 * @package     Mideas.mPlay
 * @subpackage  Item
 *
 * @copyright   Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE
 */

defined('CONF_URL_APP') or die;

class MplaySitioTipoPortal extends MplaySitioTipo
{
	protected $name = 'Portal';
	protected $description = 'Viaja en el tiempo a través de estos portales. Descubrirás mascotas y objetos únicos en cada época que visites.';
	
	protected $acciones_mapa = array('recolectar','ir');
	
	public function __construct($options = array())
	{
		$this->propiedades = array(
									"valor"	=>	array(
										"nombre"	=>	__("Valor"), 
										"tipo"		=>	"int",
										"input"		=>	"number",
										"icono"		=>	"MO",
										"descripcion"	=>	__("Precio de venta del sitio en Monedas"),
										"params"	=>	array("class"=>"form-control")
										),
									"monedas"	=>	array(
										"nombre"	=>	__("Monedas máximas"), 
										"tipo"		=>	"int",
										"input"		=>	"number",
										"icono"		=>	"MO+",
										"descripcion"	=>	__("Monedas máximas que puede usar para comprar objetos de usuarios"),
										"params"	=>	array("class"=>"form-control")
										),
									"tipo_items"	=>	array(
										"nombre"	=>	__("Tipo de items aceptados"), 
										"tipo"		=>	"int",
										"input"		=>	"mplaytipoitems",
										"icono"		=>	"TIA",
										"descripcion"	=>	__("Tipo de items aceptados por el portal"),
										"params"	=>	array("multicheck"=>"true"),
										"visible"	=>	false
										),
									"items"	=>	array(
										"nombre"	=>	__("Objetos"), 
										"tipo"		=>	"int",
										"input"		=>	"mplayinventariositio",
										"icono"		=>	"RPV",
										"descripcion"	=>	__("Inventario de objetos del portal"),
										"visible"	=>	false,
										"params"	=>	array("class"=>"col-xs-3"),
										"class_div"	=>	"col-xs-8"
										)
		);
		
		parent::__construct($options);
	}
	
}