<?php
/**
 * @package     Mideas.mPlay
 * @subpackage  Item
 *
 * @copyright   Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE
 */

defined('CONF_URL_APP') or die;

class MplaySitioTipoViaje extends MplaySitioTipo
{
	protected $name = 'Viaje';
	protected $description = 'Viaje rápido';
	
	protected $acciones_mapa = array('ir');
	
	public function __construct($options = array())
	{
		$this->propiedades = array(
									"valor"	=>	array(
										"nombre"	=>	__("Valor"), 
										"tipo"		=>	"int",
										"input"		=>	"number",
										"icono"		=>	"MO",
										"descripcion"	=>	__("Precio de venta del sitio en Monedas de Oro (MO)"),
										"params"	=>	array("class"=>"form-control")
										),
									"monedas"	=>	array(
										"nombre"	=>	__("MO máximas"), 
										"tipo"		=>	"int",
										"input"		=>	"number",
										"icono"		=>	"MO+",
										"descripcion"	=>	__("Monedas de Oro (MO) máximas que puede usar para comprar objetos de usuarios"),
										"params"	=>	array("class"=>"form-control")
										),
									"minimo_coste"	=>	array(
										"nombre"	=>	__("Mínimo coste"), 
										"tipo"		=>	"int",
										"input"		=>	"number",
										"icono"		=>	"RPV",
										"descripcion"	=>	__("Porcentaje que se incluye en el precio base de los items cuando se venden"),
										"params"	=>	array("class"=>"form-control"),
										"visible"	=>	false
										),
									"maximo_coste"	=>	array(
										"nombre"	=>	__("Máximo coste"), 
										"tipo"		=>	"int",
										"input"		=>	"number",
										"icono"		=>	"RPV",
										"descripcion"	=>	__("Porcentaje que se descuenta en el precio base de los items cuando la tienda los compra"),
										"params"	=>	array("class"=>"form-control"),
										"visible"	=>	false
										),
									"id_cancion"	=>	array(
										"nombre"	=>	__("ID Canción"), 
										"tipo"		=>	"string",
										"input"		=>	"text",
										"icono"		=>	"RPV",
										"descripcion"	=>	__("Porcentaje que se descuenta en el precio base de los items cuando la tienda los compra"),
										"params"	=>	array("class"=>"form-control"),
										"visible"	=>	false
										)
		);
		
		parent::__construct($options);
	}
	
}