SET FOREIGN_KEY_CHECKS=0;

-- Volcando estructura para tabla mplay.#__mplay_bots
DROP TABLE IF EXISTS `#__mplay_bots`;
CREATE TABLE IF NOT EXISTS `#__mplay_bots` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `nombre` text NOT NULL,
  `descripcion` text NOT NULL,
  `tipo` varchar(50) NOT NULL,
  `icono` text NOT NULL,
  `avatar` text NOT NULL,
  `estado` int(1) NOT NULL DEFAULT '0',
  `creador` int(11) NOT NULL DEFAULT '0',
  `propietario` int(11) NOT NULL DEFAULT '0',
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `propiedades` text NOT NULL,
  `params` text NOT NULL,
  `idioma` varchar(5) NOT NULL,
  `visibilidad` int(1) NOT NULL DEFAULT '1',
  `radio` decimal(10,2) NOT NULL,
  `latitud` text NOT NULL,
  `longitud` text NOT NULL,
  `location` point NOT NULL,
  PRIMARY KEY (`id`),
  SPATIAL KEY `location` (`location`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

-- La exportación de datos fue deseleccionada.


-- Volcando estructura para tabla mplay.#__mplay_categorias
DROP TABLE IF EXISTS `#__mplay_categorias`;
CREATE TABLE IF NOT EXISTS `#__mplay_categorias` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `nombre` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(250) NOT NULL,
  `contenido` text NOT NULL,
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `estado` int(1) NOT NULL DEFAULT '1',
  `padre` varchar(250) NOT NULL DEFAULT '',
  `creador` int(11) NOT NULL,
  `creador_alias` varchar(250) NOT NULL DEFAULT '',
  `imagen_destacada` text NOT NULL,
  `icono` text NOT NULL,
  `params` text,
  `idioma` varchar(5) NOT NULL,
  `acceso` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- La exportación de datos fue deseleccionada.


-- Volcando estructura para tabla mplay.#__mplay_habilidades
DROP TABLE IF EXISTS `#__mplay_habilidades`;
CREATE TABLE IF NOT EXISTS `#__mplay_habilidades` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `nombre` text NOT NULL,
  `descripcion` text NOT NULL,
  `tipo` varchar(50) NOT NULL,
  `icono` text NOT NULL,
  `estado` int(1) NOT NULL DEFAULT '0',
  `creador` int(11) NOT NULL DEFAULT '0',
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `propiedades` text NOT NULL,
  `idioma` varchar(5) NOT NULL,
  `oficio` int(11) NOT NULL DEFAULT '0',
  `coste` int(11) NOT NULL DEFAULT '0',
  `padre` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

-- La exportación de datos fue deseleccionada.


-- Volcando estructura para tabla mplay.#__mplay_habilidades_sitios
DROP TABLE IF EXISTS `#__mplay_habilidades_sitios`;
CREATE TABLE IF NOT EXISTS `#__mplay_habilidades_sitios` (
  `id_sitio` int(11) NOT NULL DEFAULT '0',
  `id_habilidad` int(11) NOT NULL DEFAULT '0',
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id_sitio`,`id_habilidad`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;

-- La exportación de datos fue deseleccionada.


-- Volcando estructura para tabla mplay.#__mplay_habilidades_usuarios
DROP TABLE IF EXISTS `#__mplay_habilidades_usuarios`;
CREATE TABLE IF NOT EXISTS `#__mplay_habilidades_usuarios` (
  `id_usuario` int(11) NOT NULL DEFAULT '0',
  `id_habilidad` int(11) NOT NULL DEFAULT '0',
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id_usuario`,`id_habilidad`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;

-- La exportación de datos fue deseleccionada.


-- Volcando estructura para tabla mplay.#__mplay_items
DROP TABLE IF EXISTS `#__mplay_items`;
CREATE TABLE IF NOT EXISTS `#__mplay_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `nombre` text NOT NULL,
  `descripcion` text NOT NULL,
  `tipo` varchar(50) NOT NULL,
  `icono` text NOT NULL,
  `estado` int(1) NOT NULL DEFAULT '0',
  `creador` int(11) NOT NULL DEFAULT '0',
  `propietario` int(11) NOT NULL DEFAULT '0',
  `sitio` int(11) NOT NULL DEFAULT '0',
  `bot` int(11) NOT NULL DEFAULT '0',
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `fecha_recogido` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `propiedades` text NOT NULL,
  `params` text NOT NULL,
  `idioma` varchar(5) NOT NULL,
  `visibilidad` int(1) NOT NULL DEFAULT '1',
  `radio` decimal(10,2) NOT NULL,
  `latitud` text NOT NULL,
  `longitud` text NOT NULL,
  `location` point NOT NULL,
  `model_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  SPATIAL KEY `location` (`location`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- La exportación de datos fue deseleccionada.


-- Volcando estructura para tabla mplay.#__mplay_juegos
DROP TABLE IF EXISTS `#__mplay_juegos`;
CREATE TABLE IF NOT EXISTS `#__mplay_juegos` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `titulo` text NOT NULL,
  `alias` text NOT NULL,
  `texto_corto` text NOT NULL,
  `contenido` text NOT NULL,
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `fecha_publicacion` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `estado` int(1) NOT NULL DEFAULT '1',
  `imagen_destacada` text NOT NULL,
  `categorias` text NOT NULL,
  `creador` int(11) NOT NULL,
  `creador_alias` varchar(250) NOT NULL DEFAULT '',
  `propietario` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `tags` text NOT NULL,
  `lugar` text NOT NULL,
  `direccion` text NOT NULL,
  `codigo_postal` text NOT NULL,
  `localidad` text NOT NULL,
  `provincia` text NOT NULL,
  `pais` text NOT NULL,
  `latitud` text NOT NULL,
  `longitud` text NOT NULL,
  `idioma` varchar(5) NOT NULL,
  `acceso` int(11) NOT NULL DEFAULT '0',
  `id_original` int(11) NOT NULL DEFAULT '0',
  `location` point NOT NULL,
  `radio` int(11) NOT NULL DEFAULT '10',
  `visibilidad` int(1) NOT NULL DEFAULT '1',
  `tipo` varchar(250) NOT NULL,
  `oficio` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  SPATIAL KEY `location` (`location`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- La exportación de datos fue deseleccionada.


-- Volcando estructura para tabla mplay.#__mplay_juegos_misiones
DROP TABLE IF EXISTS `#__mplay_juegos_misiones`;
CREATE TABLE IF NOT EXISTS `#__mplay_juegos_misiones` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `titulo` text NOT NULL,
  `descripcion` text NOT NULL,
  `descripcion_corta` text NOT NULL,
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `estado` int(1) NOT NULL DEFAULT '1',
  `icono` text NOT NULL,
  `creador` int(11) NOT NULL,
  `propietario` int(11) NOT NULL DEFAULT '0',
  `propiedades` text NOT NULL,
  `params` text NOT NULL,
  `visibilidad` int(1) NOT NULL,
  `latitud` text NOT NULL,
  `longitud` text NOT NULL,
  `idioma` varchar(5) NOT NULL,
  `acceso` int(11) NOT NULL DEFAULT '0',
  `radio` int(11) NOT NULL,
  `location` point NOT NULL,
  `juego` int(11) NOT NULL,
  `orden` int(11) NOT NULL DEFAULT '0',
  `tipo` varchar(150) NOT NULL,
  PRIMARY KEY (`id`),
  SPATIAL KEY `location` (`location`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

-- La exportación de datos fue deseleccionada.


-- Volcando estructura para tabla mplay.#__mplay_juegos_usuarios
DROP TABLE IF EXISTS `#__mplay_juegos_usuarios`;
CREATE TABLE IF NOT EXISTS `#__mplay_juegos_usuarios` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_usuario` int(11) NOT NULL DEFAULT '0',
  `id_juego` int(11) NOT NULL DEFAULT '0',
  `estado` int(1) NOT NULL DEFAULT '0',
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `mision_activa` int(11) NOT NULL DEFAULT '0',
  `misiones_finalizadas` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- La exportación de datos fue deseleccionada.


-- Volcando estructura para tabla mplay.#__mplay_niveles_experiencia
DROP TABLE IF EXISTS `#__mplay_niveles_experiencia`;
CREATE TABLE IF NOT EXISTS `#__mplay_niveles_experiencia` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `titulo` text NOT NULL,
  `contenido` text NOT NULL,
  `puntos` int(11) NOT NULL,
  `icono` text NOT NULL,
  `estado` int(1) NOT NULL,
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `params` text NOT NULL,
  `orden` int(10) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

-- La exportación de datos fue deseleccionada.


-- Volcando estructura para tabla mplay.#__mplay_oficios
DROP TABLE IF EXISTS `#__mplay_oficios`;
CREATE TABLE IF NOT EXISTS `#__mplay_oficios` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `nombre` text NOT NULL,
  `descripcion` text NOT NULL,
  `tipo` varchar(50) NOT NULL,
  `icono` text NOT NULL,
  `estado` int(1) NOT NULL DEFAULT '0',
  `creador` int(11) NOT NULL DEFAULT '0',
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `propiedades` text NOT NULL,
  `idioma` varchar(5) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

-- La exportación de datos fue deseleccionada.


-- Volcando estructura para tabla mplay.#__mplay_usuarios_activos
DROP TABLE IF EXISTS `#__mplay_usuarios_activos`;
CREATE TABLE IF NOT EXISTS `#__mplay_usuarios_activos` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_usuario` int(11) NOT NULL,
  `ip_usuario` varchar(250) NOT NULL,
  `fecha_ultimo_acceso` int(11) NOT NULL,
  `latitud` text NOT NULL,
  `longitud` text NOT NULL,
  `location` point NOT NULL,
  `geolocation` int(1) NOT NULL DEFAULT '0',
  `juegos_activos` text NOT NULL,
  `misiones_activas` text NOT NULL,
  `juegos_finalizados` text NOT NULL,
  `misiones_finalizadas` text NOT NULL,
  PRIMARY KEY (`id`),
  SPATIAL KEY `location` (`location`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- La exportación de datos fue deseleccionada.

INSERT INTO `#__mplay_categorias` (`id`, `nombre`, `alias`, `contenido`, `fecha`, `estado`, `padre`, `creador`, `creador_alias`, `imagen_destacada`, `icono`, `params`, `idioma`, `acceso`) VALUES (1, '{"es":"Juegos","en":"Games"}', '{"es":"Juegos","en":"Games"}', '{"es":"","en":""}', '2014-12-15 05:37:11', 1, '[""]', 0, '', '', 'fa mdsicon-location', '{"estilo":"","hijos_heredan_estilo":"0","color":""}', '', 0);

SET FOREIGN_KEY_CHECKS=1;