<?php
class Mplay extends Controller
{
	protected $ext_folder = 'ext_mplay';
	protected $ext_home_vista = 'home';
	protected $ext_categoria_vista = 'categoria_mplay';
	protected $ext_item_vista = 'juego';
	protected $ext_form_item_vista = 'nuevo_juego';
	
	protected $ext_item_modelo = 'JuegoModel';
	protected $ext_categoria_modelo = 'MplayCategoriaModel';
	protected $ext_home_modelo = 'HomeMplayModel';
	
	protected $ext_categoria_clase = 'MplayCategoria';
	protected $ext_item_clase = 'Juego';
	
	var $extra_vistas_items=array("mision"=>"misionJuegoMplay");
	var $extra_vistas_form_item=array("mision"=>"nueva_mision");
	
	var $juego;
	
	function __construct($pasivo=false){
		parent::__construct($pasivo);
		
		MplayMisionTipo::addScripts();
	}
	
	public function includes(){
		c_include('loc/region','loc/provincia','loc/localidad','loc/pais');
		e_include('ext_mplay/class/juego','ext_mplay/class/mplayCategoria','ext_mplay/class/misionJuegoMplay','ext_mplay/class/mplayMisionTipo','ext_mplay/class/mplayUi');
		e_include('ext_mplay/models/juego','ext_mplay/models/categoria','ext_mplay/models/home');
		if (!class_exists('Juego') || !class_exists('MplayCategoria')) {
			App::setMsg(__("Error 500: No se ha encontrado la clase de la extensión."), 'error');
			return false;
		}
	}
		
	public function get_num_juegos($filtro=''){
		
		$num_eve = new Juego();
		
		$num_eve = $num_eve->ListarCount($filtro);
		
		return $num_eve;
	}
	
	public function add_assets(){
		global $AssetBundles;
		
		if ($AssetBundles instanceof AssetsHelper){
			$AssetBundles->require_bundle('leaflet');
			
			$mplay_bundle = new AssetBundle(array('id'=>'mplay', 'nombre'=>'mPlay'));
				
			$mplay_bundle->register_css('rpg-awesome', CONF_URL_APP.'extensions/ext_mplay/assets/icons/css/rpg-awesome.css');
			$mplay_bundle->register_css('leaflet-label', CONF_URL_APP.'extensions/ext_mplay/assets/js/leaflet-label/leaflet.label.css');
			$mplay_bundle->register_css('leaflet-contextmenu', CONF_URL_APP.'extensions/ext_mplay/assets/js/leaflet-contextmenu/leaflet.contextmenu.css');
			$mplay_bundle->register_css('mplay', CONF_URL_APP.'extensions/ext_mplay/assets/css/mplay.css');
			$mplay_bundle->register_css('mplay-theme', CONF_URL_APP.'extensions/ext_mplay/assets/css/themes/default/css/default.css');
			
			$mplay_bundle->register_js('jquery-actual', CONF_URL_APP.'extensions/ext_mplay/assets/js/extra/jquery.actual.js');
			$mplay_bundle->register_js('d3', CONF_URL_APP.'extensions/ext_mplay/assets/js/d3/d3.v3.min.js');
			$mplay_bundle->register_js('osmbuildings-leaflet', CONF_URL_APP.'extensions/ext_mplay/assets/js/osmbuildings/OSMBuildings-Leaflet.js');
			$mplay_bundle->register_js('leaflet-label', CONF_URL_APP.'extensions/ext_mplay/assets/js/leaflet-label/leaflet.label.js');
			$mplay_bundle->register_js('leaflet-realtime', CONF_URL_APP.'extensions/ext_mplay/assets/js/leaflet-realtime/leaflet-realtime.js');
			$mplay_bundle->register_js('leaflet-contextmenu', CONF_URL_APP.'extensions/ext_mplay/assets/js/leaflet-contextmenu/leaflet.contextmenu.js');
			$mplay_bundle->register_js('leaflet-bouncemarker', CONF_URL_APP.'extensions/ext_mplay/assets/js/leaflet-utils/BounceMarker.js');
			$mplay_bundle->register_js('leaflet-utils-polyline-encoded', CONF_URL_APP.'extensions/ext_mplay/assets/js/leaflet-utils/Polyline.encoded.js');
			$mplay_bundle->register_js('leaflet-utils-animated-marker', CONF_URL_APP.'extensions/ext_mplay/assets/js/leaflet-utils/AnimatedMarker.js');
			$mplay_bundle->register_js('leaflet-google', CONF_URL_APP.'extensions/ext_mplay/assets/js/leaflet-utils/LeafletGoogle.js');
			$mplay_bundle->register_js('mplay-usuario-skilltree', CONF_URL_APP.'extensions/ext_mplay/assets/js/mplay.usuario.skilltree.js');
			$mplay_bundle->register_js('mplay-usuario', CONF_URL_APP.'extensions/ext_mplay/assets/js/mplay.usuario.js');
			$mplay_bundle->register_js('mplay-sitio', CONF_URL_APP.'extensions/ext_mplay/assets/js/mplay.sitio.js');
			$mplay_bundle->register_js('mplay-bot', CONF_URL_APP.'extensions/ext_mplay/assets/js/mplay.bot.js');
			$mplay_bundle->register_js('mplay-bot-dialog', CONF_URL_APP.'extensions/ext_mplay/assets/js/mplay.bot.dialog.js');
			$mplay_bundle->register_js('mplay-bot-battle', CONF_URL_APP.'extensions/ext_mplay/assets/js/mplay.bot.battle.js');
			$mplay_bundle->register_js('mplay-juegos', CONF_URL_APP.'extensions/ext_mplay/assets/js/mplay.juegos.js');
			$mplay_bundle->register_js('mplay-ui', CONF_URL_APP.'extensions/ext_mplay/assets/js/mplay.ui.js');
			$mplay_bundle->register_js('mplay-map', CONF_URL_APP.'extensions/ext_mplay/assets/js/mplay.map.js');
			$mplay_bundle->register_js('mplay', CONF_URL_APP.'extensions/ext_mplay/assets/js/mplay.js');
			
			$AssetBundles->register_bundle($mplay_bundle);
			$AssetBundles->require_bundle('mplay');
		}
	}
}